// TJC implementation of procedure compileproc_args_split
package tjc;
import tcl.lang.*;

public class CompileprocArgsSplitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "proc_args");
        }
        setVarScalar(interp, "proc_args", objv[1], compiledLocals, 0);
        { // Invoke: set non_default_args [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "non_default_args", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set default_args [...]
            TclObject tmp2;
            { // Invoke: list
                TclObject tmp3 = TclList.newInstance();
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarScalar(interp, "default_args", tmp2, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set args [...]
            TclObject tmp4;
            { // Invoke: list false
                TclObject tmp5 = TclList.newInstance();
                TclList.append(interp, tmp5, const0);
                interp.setResult(tmp5);
            } // End Invoke: list
            tmp4 = interp.getResult();
            setVarScalar(interp, "args", tmp4, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set min_num_args 0
            setVarScalar(interp, "min_num_args", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set max_num_args {}
            setVarScalar(interp, "max_num_args", const2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: foreach proc_arg $proc_args ...
            TclObject tmp6 = null;
            try {
                tmp6 = getVarScalar(interp, "proc_args", compiledLocals, 0);
                tmp6.preserve();
                final int tmp6_length = TclList.getLength(interp, tmp6);

                for ( int index7 = 0 ; index7 < tmp6_length ; index7++ ) {
                    TclObject tmp8 = TclList.index(interp, tmp6, index7);
                    try {
                        setVarScalar(interp, "proc_arg", tmp8, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "proc_arg");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ... elseif ... ... else ...
                        // Binary operator: $proc_arg == "args"
                        TclObject tmp9 = getVarScalar(interp, "proc_arg", compiledLocals, 6);
                        boolean tmp10 = tmp9.toString().equals("args");
                        ExprValue tmp11 = evs0;
                        tmp11.setIntValue(tmp10);
                        // End Binary operator: ==
                        boolean tmp12 = ( tmp11.getIntValue() != 0 );
                        if ( tmp12 ) {
                            { // Invoke: set args true
                                setVarScalar(interp, "args", const3, compiledLocals, 3);
                            } // End Invoke: set
                        } else {
                            // Binary operator: [...] == 1
                            { // Invoke: llength $proc_arg
                                TclObject tmp13 = getVarScalar(interp, "proc_arg", compiledLocals, 6);
                                int tmp14 = TclList.getLength(interp, tmp13);
                                interp.setResult(tmp14);
                            } // End Invoke: llength
                            TclObject tmp15 = interp.getResult();
                            ExprValue tmp16 = evs0;
                            TJC.exprInitValue(interp, tmp16, tmp15);
                            ExprValue tmp17 = evs1;
                            tmp17.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp16, tmp17);
                            // End Binary operator: ==
                            boolean tmp18 = ( tmp16.getIntValue() != 0 );
                            if ( tmp18 ) {
                                { // Invoke: lappend non_default_args $proc_arg
                                    TclObject[] objv19 = TJC.grabObjv(interp, 1);
                                    TclObject tmp20;
                                    try {
                                        // Arg 2 variable: $proc_arg
                                        tmp20 = getVarScalar(interp, "proc_arg", compiledLocals, 6);
                                        tmp20.preserve();
                                        objv19[0] = tmp20;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "non_default_args", objv19, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv19, 1);
                                    }
                                } // End Invoke: lappend
                                { // Invoke: incr min_num_args
                                    interp.resetResult();
                                    incrVarScalar(interp, "min_num_args", 1, compiledLocals, 4);
                                } // End Invoke: incr
                            } else {
                                { // Invoke: lappend default_args $proc_arg
                                    TclObject[] objv21 = TJC.grabObjv(interp, 1);
                                    TclObject tmp22;
                                    try {
                                        // Arg 2 variable: $proc_arg
                                        tmp22 = getVarScalar(interp, "proc_arg", compiledLocals, 6);
                                        tmp22.preserve();
                                        objv21[0] = tmp22;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "default_args", objv21, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv21, 1);
                                    }
                                } // End Invoke: lappend
                            }
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp6 != null ) {
                    tmp6.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {!$args} ...
            // Unary operator: ! $args
            TclObject tmp23 = getVarScalar(interp, "args", compiledLocals, 3);
            ExprValue tmp24 = evs0;
            if ( tmp23.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp24, tmp23);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp24, tmp23);
            }
            // End Unary operator: !
            boolean tmp25 = ( tmp24.getIntValue() != 0 );
            if ( tmp25 ) {
                { // Invoke: set max_num_args [...]
                    TclObject tmp26;
                    { // Invoke: expr ...
                        // Binary operator: $min_num_args + [...]
                        TclObject tmp27 = getVarScalar(interp, "min_num_args", compiledLocals, 4);
                        ExprValue tmp28 = evs0;
                        TJC.exprInitValue(interp, tmp28, tmp27);
                        { // Invoke: llength $default_args
                            TclObject tmp29 = getVarScalar(interp, "default_args", compiledLocals, 2);
                            int tmp30 = TclList.getLength(interp, tmp29);
                            interp.setResult(tmp30);
                        } // End Invoke: llength
                        TclObject tmp31 = interp.getResult();
                        ExprValue tmp32 = evs1;
                        TJC.exprInitValue(interp, tmp32, tmp31);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp28, tmp32);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp28);
                    } // End Invoke: expr
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "max_num_args", tmp26, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $non_default_args $default_args $args $min_num_args $max_num_args
                TclObject tmp33 = TclList.newInstance();
                TclObject tmp34;
                try {
                    tmp34 = getVarScalar(interp, "non_default_args", compiledLocals, 1);
                    TclList.append(interp, tmp33, tmp34);
                    tmp34 = getVarScalar(interp, "default_args", compiledLocals, 2);
                    TclList.append(interp, tmp33, tmp34);
                    tmp34 = getVarScalar(interp, "args", compiledLocals, 3);
                    TclList.append(interp, tmp33, tmp34);
                    tmp34 = getVarScalar(interp, "min_num_args", compiledLocals, 4);
                    TclList.append(interp, tmp33, tmp34);
                    tmp34 = getVarScalar(interp, "max_num_args", compiledLocals, 5);
                    TclList.append(interp, tmp33, tmp34);
                } catch (TclException ex) {
                    tmp33.release();
                    throw ex;
                }
                interp.setResult(tmp33);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_args_split");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("false");
        TclBoolean.get(interp, const0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("true");
        TclBoolean.get(interp, const3);
        const3.preserve(); const3.preserve();
    }

    String[] compiledLocalsNames = {
        "proc_args",
        "non_default_args",
        "default_args",
        "args",
        "min_num_args",
        "max_num_args",
        "proc_arg"
    };
} // end class CompileprocArgsSplitCmd

