// TJC implementation of procedure compileproc_can_inline_command_string
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineCommandStringCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$num_args < 3} ...
            // Binary operator: $num_args < 3
            TclObject tmp6 = getVarScalar(interp, "num_args", compiledLocals, 3);
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp7, tmp8);
            // End Binary operator: <
            boolean tmp9 = ( tmp7.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set tuple [...]
            TclObject tmp10;
            { // Invoke: ... $key 1
                TclObject[] objv11 = TJC.grabObjv(interp, 3);
                TclObject tmp12;
                try {
                    // Arg 0 constant: ...
                    objv11[0] = const3;
                    // Arg 1 variable: $key
                    tmp12 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp12.preserve();
                    objv11[1] = tmp12;
                    // Arg 2 constant: 1
                    objv11[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv11, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp12 = objv11[1];
                    if ( tmp12 != null ) {
                        tmp12.release();
                    }
                    TJC.releaseObjv(interp, objv11, 3);
                }
            } // End Invoke: ...
            tmp10 = interp.getResult();
            setVarScalar(interp, "tuple", tmp10, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp13;
            { // Invoke: lindex $tuple 0
                TclObject tmp14 = getVarScalar(interp, "tuple", compiledLocals, 4);
                tmp14 = TclList.index(interp, tmp14, 0);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "type", tmp13, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set subcmdname [...]
            TclObject tmp15;
            { // Invoke: lindex $tuple 1
                TclObject tmp16 = getVarScalar(interp, "tuple", compiledLocals, 4);
                tmp16 = TclList.index(interp, tmp16, 1);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "subcmdname", tmp15, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $type != "constant"
            TclObject tmp17 = getVarScalar(interp, "type", compiledLocals, 5);
            boolean tmp18 = ! tmp17.toString().equals("constant");
            ExprValue tmp19 = evs0;
            tmp19.setIntValue(tmp18);
            // End Binary operator: !=
            boolean tmp20 = ( tmp19.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $subcmdname {compare} - {equal} ... {first} - {last} ... {index} ... {length} ... {range} ... default ...
            TclObject tmp21 = getVarScalar(interp, "subcmdname", compiledLocals, 6);
            String tmp22 = tmp21.toString();
            int tmp22_length = tmp22.length();
            char tmp22_first = '\n';
            if ( tmp22_length > 0 ) {
                tmp22_first = tmp22.charAt(0);
            }
            if ( ( tmp22_length == 7 && tmp22_first == 'c'
                    && tmp22.compareTo("compare") == 0 ) ||
                ( tmp22_length == 5 && tmp22_first == 'e'
                    && tmp22.compareTo("equal") == 0 ) ) {
                // Pattern {equal}
                { // Invoke: if {$num_args != 4} ...
                    // Binary operator: $num_args != 4
                    TclObject tmp23 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp24 = evs0;
                    TJC.exprInitValue(interp, tmp24, tmp23);
                    ExprValue tmp25 = evs1;
                    tmp25.setIntValue(4);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp24, tmp25);
                    // End Binary operator: !=
                    boolean tmp26 = ( tmp24.getIntValue() != 0 );
                    if ( tmp26 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else if ( ( tmp22_length == 5 && tmp22_first == 'f'
                    && tmp22.compareTo("first") == 0 ) ||
                ( tmp22_length == 4 && tmp22_first == 'l'
                    && tmp22.compareTo("last") == 0 ) ) {
                // Pattern {last}
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $num_args != 4
                    TclObject tmp27 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp28 = evs0;
                    TJC.exprInitValue(interp, tmp28, tmp27);
                    ExprValue tmp29 = evs1;
                    tmp29.setIntValue(4);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp28, tmp29);
                    // End Binary operator: !=
                    if (tmp28.getBooleanValue(interp)) {
                    // Binary operator: $num_args != 5
                    TclObject tmp30 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp31 = evs1;
                    TJC.exprInitValue(interp, tmp31, tmp30);
                    ExprValue tmp32 = evs2;
                    tmp32.setIntValue(5);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp31, tmp32);
                    // End Binary operator: !=
                    tmp28.setIntValue(tmp31.getBooleanValue(interp));
                    } else {
                    tmp28.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp33 = ( tmp28.getIntValue() != 0 );
                    if ( tmp33 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else if ( tmp22_length == 5 && tmp22_first == 'i'
                    && tmp22.compareTo("index") == 0 ) {
                // Pattern {index}
                { // Invoke: if {$num_args != 4} ...
                    // Binary operator: $num_args != 4
                    TclObject tmp34 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp35 = evs0;
                    TJC.exprInitValue(interp, tmp35, tmp34);
                    ExprValue tmp36 = evs1;
                    tmp36.setIntValue(4);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp35, tmp36);
                    // End Binary operator: !=
                    boolean tmp37 = ( tmp35.getIntValue() != 0 );
                    if ( tmp37 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else if ( tmp22_length == 6 && tmp22_first == 'l'
                    && tmp22.compareTo("length") == 0 ) {
                // Pattern {length}
                { // Invoke: if {$num_args != 3} ...
                    // Binary operator: $num_args != 3
                    TclObject tmp38 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp39 = evs0;
                    TJC.exprInitValue(interp, tmp39, tmp38);
                    ExprValue tmp40 = evs1;
                    tmp40.setIntValue(3);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp39, tmp40);
                    // End Binary operator: !=
                    boolean tmp41 = ( tmp39.getIntValue() != 0 );
                    if ( tmp41 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else if ( tmp22_length == 5 && tmp22_first == 'r'
                    && tmp22.compareTo("range") == 0 ) {
                // Pattern {range}
                { // Invoke: if {$num_args != 5} ...
                    // Binary operator: $num_args != 5
                    TclObject tmp42 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp43 = evs0;
                    TJC.exprInitValue(interp, tmp43, tmp42);
                    ExprValue tmp44 = evs1;
                    tmp44.setIntValue(5);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp43, tmp44);
                    // End Binary operator: !=
                    boolean tmp45 = ( tmp43.getIntValue() != 0 );
                    if ( tmp45 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const4);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_command_string");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tree");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_get_argument_tuple");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "tree",
        "num_args",
        "tuple",
        "type",
        "subcmdname"
    };
} // end class CompileprocCanInlineCommandStringCmd

