// TJC implementation of procedure compileproc_command_start_callback
package tjc;
import tcl.lang.*;

public class CompileprocCommandStartCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ... elseif {[lindex $result 0]} ... else ...
            { // Invoke: ... $key
                TclObject[] objv3 = TJC.grabObjv(interp, 2);
                TclObject tmp4;
                try {
                    // Arg 0 constant: ...
                    objv3[0] = const1;
                    // Arg 1 variable: $key
                    tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv3, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 2);
                }
            } // End Invoke: ...
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            boolean tmp7 = tmp6.getBooleanValue(interp);
            if ( tmp7 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: lindex $result 0
                    TclObject tmp8 = getVarScalar(interp, "result", compiledLocals, 3);
                    tmp8 = TclList.index(interp, tmp8, 0);
                    if ( tmp8 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp8);
                    }
                } // End Invoke: lindex
                TclObject tmp9 = interp.getResult();
                ExprValue tmp10 = evs0;
                TJC.exprInitValue(interp, tmp10, tmp9);
                boolean tmp11 = tmp10.getBooleanValue(interp);
                if ( tmp11 ) {
                    { // Invoke: set cmdname [...]
                        TclObject tmp12;
                        { // Invoke: lindex $result 1
                            TclObject tmp13 = getVarScalar(interp, "result", compiledLocals, 3);
                            tmp13 = TclList.index(interp, tmp13, 1);
                            if ( tmp13 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp13);
                            }
                        } // End Invoke: lindex
                        tmp12 = interp.getResult();
                        setVarScalar(interp, "cmdname", tmp12, compiledLocals, 4);
                    } // End Invoke: set
                } else {
                    { // Invoke: set cmdname _UNKNOWN
                        setVarScalar(interp, "cmdname", const2, compiledLocals, 4);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: set info_token [...]
            TclObject tmp14;
            { // Invoke: list
                TclObject tmp15 = TclList.newInstance();
                interp.setResult(tmp15);
            } // End Invoke: list
            tmp14 = interp.getResult();
            setVarScalar(interp, "info_token", tmp14, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: lappend info_token $key $cmdname
            TclObject[] objv16 = TJC.grabObjv(interp, 2);
            TclObject tmp17;
            try {
                // Arg 2 variable: $key
                tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp17.preserve();
                objv16[0] = tmp17;
                // Arg 3 variable: $cmdname
                tmp17 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                tmp17.preserve();
                objv16[1] = tmp17;
                interp.resetResult();
                lappendVarScalar(interp, "info_token", objv16, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv16, 2);
            }
        } // End Invoke: lappend
        { // Invoke: lappend ... $info_token
            TclObject[] objv18 = TJC.grabObjv(interp, 1);
            TclObject tmp19;
            try {
                // Arg 2 variable: $info_token
                tmp19 = getVarScalar(interp, "info_token", compiledLocals, 5);
                tmp19.preserve();
                objv18[0] = tmp19;
                interp.resetResult();
                lappendVarArray(interp, "_compileproc_ckeys", "info_keys", objv18, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv18, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set "..." $info_token
            TclObject tmp20;
            String tmp21;
            StringBuffer sbtmp22 = new StringBuffer(64);
            tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp22.append(tmp20.toString());
            sbtmp22.append(",info_key");
            tmp21 = sbtmp22.toString();
            tmp20 = getVarScalar(interp, "info_token", compiledLocals, 5);
            tmp20 = setVarArray(interp, "_compileproc_ckeys", tmp21, tmp20, compiledLocals, 2);
            interp.setResult(tmp20);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_start_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_command_name");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_arguments_undetermined");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_UNKNOWN");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_command_name";
                break;
            }
            case 2: {
                cmdName = "descend_arguments_undetermined";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "result",
        "cmdname",
        "info_token"
    };
} // end class CompileprocCommandStartCallbackCmd

