// TJC implementation of procedure compileproc_constant_cache_generate
package tjc;
import tcl.lang.*;

public class CompileprocConstantCacheGenerateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_constant_cache", "_compileproc_constant_cache", 0);
        } // End Invoke: global
        { // Invoke: set tlist [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "tlist", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: foreach key $... ...
            TclObject tmp2 = null;
            try {
                tmp2 = getVarArray(interp, "_compileproc_constant_cache", "ordered_keys", compiledLocals, 0);
                tmp2.preserve();
                final int tmp2_length = TclList.getLength(interp, tmp2);

                for ( int index3 = 0 ; index3 < tmp2_length ; index3++ ) {
                    TclObject tmp4 = TclList.index(interp, tmp2, index3);
                    try {
                        setVarScalar(interp, "key", tmp4, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple $...
                        TclObject tmp5;
                        tmp5 = getVarScalar(interp, "key", compiledLocals, 2);
                        tmp5 = getVarArray(interp, "_compileproc_constant_cache", tmp5.toString(), compiledLocals, 0);
                        setVarScalar(interp, "tuple", tmp5, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set ident [...]
                        TclObject tmp6;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp7 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp7 = TclList.index(interp, tmp7, 0);
                            if ( tmp7 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp7);
                            }
                        } // End Invoke: lindex
                        tmp6 = interp.getResult();
                        setVarScalar(interp, "ident", tmp6, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: if {$ident == {}} ...
                        // Binary operator: $ident == ""
                        TclObject tmp8 = getVarScalar(interp, "ident", compiledLocals, 4);
                        ExprValue tmp9 = evs0;
                        TJC.exprEqualsEmptyString(tmp9, tmp8, false);
                        // End Binary operator: ==
                        boolean tmp10 = ( tmp9.getIntValue() != 0 );
                        if ( tmp10 ) {
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: lappend tlist $tuple
                        TclObject[] objv11 = TJC.grabObjv(interp, 1);
                        TclObject tmp12;
                        try {
                            // Arg 2 variable: $tuple
                            tmp12 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp12.preserve();
                            objv11[0] = tmp12;
                            interp.resetResult();
                            lappendVarScalar(interp, "tlist", objv11, compiledLocals, 1);
                        } finally {
                            TJC.releaseObjvElems(interp, objv11, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp2 != null ) {
                    tmp2.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$tlist == {}} ...
            // Binary operator: $tlist == ""
            TclObject tmp13 = getVarScalar(interp, "tlist", compiledLocals, 1);
            ExprValue tmp14 = evs0;
            TJC.exprEqualsEmptyString(tmp14, tmp13, false);
            // End Binary operator: ==
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: return {}
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: ... $tlist
                TclObject[] objv16 = TJC.grabObjv(interp, 2);
                TclObject tmp17;
                try {
                    // Arg 0 constant: ...
                    objv16[0] = const1;
                    // Arg 1 variable: $tlist
                    tmp17 = getVarScalar(interp, "tlist", compiledLocals, 1);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv16, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 2);
                }
            } // End Invoke: ...
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_constant_cache_generate");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_init_constants");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_init_constants";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_constant_cache",
        "tlist",
        "key",
        "tuple",
        "ident"
    };
} // end class CompileprocConstantCacheGenerateCmd

