// TJC implementation of procedure compileproc_constant_cache_type
package tjc;
import tcl.lang.*;

public class CompileprocConstantCacheTypeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: if {$tstr == ""} ... elseif ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: $tstr == ""
            TclObject tmp0 = getVarScalar(interp, "tstr", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: return STRING
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Binary operator: () || ()
                // Binary operator: $tstr == "false"
                TclObject tmp3 = getVarScalar(interp, "tstr", compiledLocals, 0);
                boolean tmp4 = tmp3.toString().equals("false");
                ExprValue tmp5 = evs0;
                tmp5.setIntValue(tmp4);
                // End Binary operator: ==
                if (!tmp5.getBooleanValue(interp)) {
                // Binary operator: $tstr == "true"
                TclObject tmp6 = getVarScalar(interp, "tstr", compiledLocals, 0);
                boolean tmp7 = tmp6.toString().equals("true");
                ExprValue tmp8 = evs1;
                tmp8.setIntValue(tmp7);
                // End Binary operator: ==
                tmp5.setIntValue(tmp8.getBooleanValue(interp));
                } else {
                tmp5.setIntValue(1);
                } // End if: !()
                // End Binary operator: ||
                boolean tmp9 = ( tmp5.getIntValue() != 0 );
                if ( tmp9 ) {
                    { // Invoke: return BOOLEAN
                        interp.resetResult();
                        interp.setResult(const1);
                        if ( true ) { return; }
                    } // End Invoke: return
                } else {
                    { // Invoke: ... $tstr
                        TclObject[] objv10 = TJC.grabObjv(interp, 2);
                        TclObject tmp11;
                        try {
                            // Arg 0 constant: ...
                            objv10[0] = const2;
                            // Arg 1 variable: $tstr
                            tmp11 = getVarScalar(interp, "tstr", compiledLocals, 0);
                            tmp11.preserve();
                            objv10[1] = tmp11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv10, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp11 = objv10[1];
                            if ( tmp11 != null ) {
                                tmp11.release();
                            }
                            TJC.releaseObjv(interp, objv10, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp12 = interp.getResult();
                    ExprValue tmp13 = evs0;
                    TJC.exprInitValue(interp, tmp13, tmp12);
                    boolean tmp14 = tmp13.getBooleanValue(interp);
                    if ( tmp14 ) {
                        { // Invoke: return INTEGER
                            interp.resetResult();
                            interp.setResult(const3);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: ... $tstr
                            TclObject[] objv15 = TJC.grabObjv(interp, 2);
                            TclObject tmp16;
                            try {
                                // Arg 0 constant: ...
                                objv15[0] = const4;
                                // Arg 1 variable: $tstr
                                tmp16 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                tmp16.preserve();
                                objv15[1] = tmp16;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv15, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp16 = objv15[1];
                                if ( tmp16 != null ) {
                                    tmp16.release();
                                }
                                TJC.releaseObjv(interp, objv15, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp17 = interp.getResult();
                        ExprValue tmp18 = evs0;
                        TJC.exprInitValue(interp, tmp18, tmp17);
                        boolean tmp19 = tmp18.getBooleanValue(interp);
                        if ( tmp19 ) {
                            { // Invoke: return DOUBLE
                                interp.resetResult();
                                interp.setResult(const5);
                                if ( true ) { return; }
                            } // End Invoke: return
                        } else {
                            { // Invoke: return STRING
                                interp.resetResult();
                                interp.setResult(const0);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    }
                }
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_constant_cache_type");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("STRING");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("BOOLEAN");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_string_is_java_integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("INTEGER");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_string_is_java_double");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("DOUBLE");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 2: {
                cmdName = "compileproc_string_is_java_double";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr"
    };
} // end class CompileprocConstantCacheTypeCmd

