// TJC implementation of procedure compileproc_emit_container_if
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerIfCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 20, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ccmds [...]
            TclObject tmp12;
            { // Invoke: descend_commands $key container
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_commands
                    objv13[0] = const4;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: container
                    objv13[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_commands
            tmp12 = interp.getResult();
            setVarScalar(interp, "ccmds", tmp12, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] < 3
            { // Invoke: llength $ccmds
                TclObject tmp15 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp18, tmp19);
            // End Binary operator: <
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("bad num container commands ");
                        sbtmp23.append("{");
                        tmp22 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv21, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set expr_keys [...]
            TclObject tmp24;
            { // Invoke: lindex $ccmds 0
                TclObject tmp25 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                tmp25 = TclList.index(interp, tmp25, 0);
                if ( tmp25 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp25);
                }
            } // End Invoke: lindex
            tmp24 = interp.getResult();
            setVarScalar(interp, "expr_keys", tmp24, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set true_keys [...]
            TclObject tmp26;
            { // Invoke: lindex $ccmds 1
                TclObject tmp27 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                tmp27 = TclList.index(interp, tmp27, 1);
                if ( tmp27 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp27);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "true_keys", tmp26, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: [...] > 3
            { // Invoke: llength $ccmds
                TclObject tmp28 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                int tmp29 = TclList.getLength(interp, tmp28);
                interp.setResult(tmp29);
            } // End Invoke: llength
            TclObject tmp30 = interp.getResult();
            ExprValue tmp31 = evs0;
            TJC.exprInitValue(interp, tmp31, tmp30);
            ExprValue tmp32 = evs1;
            tmp32.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp31, tmp32);
            // End Binary operator: >
            boolean tmp33 = ( tmp31.getIntValue() != 0 );
            if ( tmp33 ) {
                { // Invoke: set elseif_keys [...]
                    TclObject tmp34;
                    { // Invoke: lrange $ccmds 2 end-1
                        TclObject[] objv35 = TJC.grabObjv(interp, 4);
                        TclObject tmp36;
                        try {
                            // Arg 0 constant: lrange
                            objv35[0] = const6;
                            // Arg 1 variable: $ccmds
                            tmp36 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                            tmp36.preserve();
                            objv35[1] = tmp36;
                            // Arg 2 constant: 2
                            objv35[2] = const7;
                            // Arg 3 constant: end-1
                            objv35[3] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv35, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp36 = objv35[1];
                            if ( tmp36 != null ) {
                                tmp36.release();
                            }
                            TJC.releaseObjv(interp, objv35, 4);
                        }
                    } // End Invoke: lrange
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "elseif_keys", tmp34, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () != 0
                    // Binary operator: [...] % 2
                    { // Invoke: llength $elseif_keys
                        TclObject tmp37 = getVarScalar(interp, "elseif_keys", compiledLocals, 5);
                        int tmp38 = TclList.getLength(interp, tmp37);
                        interp.setResult(tmp38);
                    } // End Invoke: llength
                    TclObject tmp39 = interp.getResult();
                    ExprValue tmp40 = evs0;
                    TJC.exprInitValue(interp, tmp40, tmp39);
                    ExprValue tmp41 = evs1;
                    tmp41.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp40, tmp41);
                    // End Binary operator: %
                    ExprValue tmp42 = evs1;
                    tmp42.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp40, tmp42);
                    // End Binary operator: !=
                    boolean tmp43 = ( tmp40.getIntValue() != 0 );
                    if ( tmp43 ) {
                        { // Invoke: error "..."
                            TclObject[] objv44 = TJC.grabObjv(interp, 2);
                            TclObject tmp45;
                            try {
                                // Arg 0 constant: error
                                objv44[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp46 = new StringBuffer(64);
                                sbtmp46.append("expected even number of elseif keys, got ");
                                sbtmp46.append("{");
                                tmp45 = getVarScalar(interp, "elseif_keys", compiledLocals, 5);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append("}");
                                tmp45 = TclString.newInstance(sbtmp46);
                                tmp45.preserve();
                                objv44[1] = tmp45;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv44, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp45 = objv44[1];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                TJC.releaseObjv(interp, objv44, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set elseif_keys {}
                    setVarScalar(interp, "elseif_keys", const0, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set else_keys [...]
            TclObject tmp47;
            { // Invoke: lindex $ccmds end
                TclObject tmp48 = null;
                TclObject tmp49;
                try {
                    tmp48 = getVarScalar(interp, "ccmds", compiledLocals, 2);
                    tmp48.preserve();
                    tmp49 = const9;
                    TJC.lindexNonconst(interp, tmp48, tmp49);
                } finally {
                    if ( tmp48 != null ) {
                        tmp48.release();
                    }
                }
            } // End Invoke: lindex
            tmp47 = interp.getResult();
            setVarScalar(interp, "else_keys", tmp47, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set expr_index [...]
            TclObject tmp50;
            { // Invoke: lindex [...] 0
                { // Invoke: ... $key
                    TclObject[] objv52 = TJC.grabObjv(interp, 2);
                    TclObject tmp53;
                    try {
                        // Arg 0 constant: ...
                        objv52[0] = const10;
                        // Arg 1 variable: $key
                        tmp53 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp53.preserve();
                        objv52[1] = tmp53;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv52, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp53 = objv52[1];
                        if ( tmp53 != null ) {
                            tmp53.release();
                        }
                        TJC.releaseObjv(interp, objv52, 2);
                    }
                } // End Invoke: ...
                TclObject tmp51 = interp.getResult();
                tmp51 = TclList.index(interp, tmp51, 0);
                if ( tmp51 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp51);
                }
            } // End Invoke: lindex
            tmp50 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp50, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp54;
            { // Invoke: ... $key $expr_index
                TclObject[] objv55 = TJC.grabObjv(interp, 3);
                TclObject tmp56;
                try {
                    // Arg 0 constant: ...
                    objv55[0] = const11;
                    // Arg 1 variable: $key
                    tmp56 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp56.preserve();
                    objv55[1] = tmp56;
                    // Arg 2 variable: $expr_index
                    tmp56 = getVarScalar(interp, "expr_index", compiledLocals, 7);
                    tmp56.preserve();
                    objv55[2] = tmp56;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv55, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp56 = objv55[1];
                    if ( tmp56 != null ) {
                        tmp56.release();
                    }
                    tmp56 = objv55[2];
                    if ( tmp56 != null ) {
                        tmp56.release();
                    }
                    TJC.releaseObjv(interp, objv55, 3);
                }
            } // End Invoke: ...
            tmp54 = interp.getResult();
            setVarScalar(interp, "tuple", tmp54, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set tmpsymbol [...]
            TclObject tmp57;
            { // Invoke: lindex $tuple 0
                TclObject tmp58 = getVarScalar(interp, "tuple", compiledLocals, 8);
                tmp58 = TclList.index(interp, tmp58, 0);
                if ( tmp58 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp58);
                }
            } // End Invoke: lindex
            tmp57 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp57, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv59 = TJC.grabObjv(interp, 1);
            TclObject tmp60;
            try {
                // Arg 2 command: [...]
                { // Invoke: lindex $tuple 1
                    TclObject tmp61 = getVarScalar(interp, "tuple", compiledLocals, 8);
                    tmp61 = TclList.index(interp, tmp61, 1);
                    if ( tmp61 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp61);
                    }
                } // End Invoke: lindex
                tmp60 = interp.getResult();
                tmp60.preserve();
                objv59[0] = tmp60;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv59, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv59, 1);
            }
        } // End Invoke: append
        { // Invoke: set is_constant [...]
            TclObject tmp62;
            { // Invoke: lindex $tuple 2
                TclObject tmp63 = getVarScalar(interp, "tuple", compiledLocals, 8);
                tmp63 = TclList.index(interp, tmp63, 2);
                if ( tmp63 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp63);
                }
            } // End Invoke: lindex
            tmp62 = interp.getResult();
            setVarScalar(interp, "is_constant", tmp62, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv64 = TJC.grabObjv(interp, 1);
            TclObject tmp65;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $tmpsymbol
                    TclObject[] objv66 = TJC.grabObjv(interp, 2);
                    TclObject tmp67;
                    try {
                        // Arg 0 constant: ...
                        objv66[0] = const12;
                        // Arg 1 variable: $tmpsymbol
                        tmp67 = getVarScalar(interp, "tmpsymbol", compiledLocals, 9);
                        tmp67.preserve();
                        objv66[1] = tmp67;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv66, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        tmp67 = objv66[1];
                        if ( tmp67 != null ) {
                            tmp67.release();
                        }
                        TJC.releaseObjv(interp, objv66, 2);
                    }
                } // End Invoke: ...
                tmp65 = interp.getResult();
                tmp65.preserve();
                objv64[0] = tmp65;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv64, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv64, 1);
            }
        } // End Invoke: append
        { // Invoke: set omit_result [...]
            TclObject tmp68;
            { // Invoke: ... $key
                TclObject[] objv69 = TJC.grabObjv(interp, 2);
                TclObject tmp70;
                try {
                    // Arg 0 constant: ...
                    objv69[0] = const13;
                    // Arg 1 variable: $key
                    tmp70 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp70.preserve();
                    objv69[1] = tmp70;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv69, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp70 = objv69[1];
                    if ( tmp70 != null ) {
                        tmp70.release();
                    }
                    TJC.releaseObjv(interp, objv69, 2);
                }
            } // End Invoke: ...
            tmp68 = interp.getResult();
            setVarScalar(interp, "omit_result", tmp68, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {$true_keys == {}} ... else ...
            // Binary operator: $true_keys == ""
            TclObject tmp71 = getVarScalar(interp, "true_keys", compiledLocals, 4);
            ExprValue tmp72 = evs0;
            TJC.exprEqualsEmptyString(tmp72, tmp71, false);
            // End Binary operator: ==
            boolean tmp73 = ( tmp72.getIntValue() != 0 );
            if ( tmp73 ) {
                { // Invoke: if {!$omit_result} ...
                    // Unary operator: ! $omit_result
                    TclObject tmp74 = getVarScalar(interp, "omit_result", compiledLocals, 11);
                    ExprValue tmp75 = evs0;
                    if ( tmp74.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp75, tmp74);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp75, tmp74);
                    }
                    // End Unary operator: !
                    boolean tmp76 = ( tmp75.getIntValue() != 0 );
                    if ( tmp76 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv77 = TJC.grabObjv(interp, 1);
                            TclObject tmp78;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_reset_result
                                    TclObject[] objv79 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_reset_result
                                        objv79[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv79, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv79, 1);
                                    }
                                } // End Invoke: emitter_reset_result
                                tmp78 = interp.getResult();
                                tmp78.preserve();
                                objv77[0] = tmp78;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv77, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv77, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                { // Invoke: foreach true_key $true_keys ...
                    TclObject tmp80 = null;
                    try {
                        tmp80 = getVarScalar(interp, "true_keys", compiledLocals, 4);
                        tmp80.preserve();
                        final int tmp80_length = TclList.getLength(interp, tmp80);

                        for ( int index81 = 0 ; index81 < tmp80_length ; index81++ ) {
                            TclObject tmp82 = TclList.index(interp, tmp80, index81);
                            try {
                                setVarScalar(interp, "true_key", tmp82, compiledLocals, 12);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "true_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv83 = TJC.grabObjv(interp, 1);
                                TclObject tmp84;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $true_key
                                        TclObject[] objv85 = TJC.grabObjv(interp, 2);
                                        TclObject tmp86;
                                        try {
                                            // Arg 0 constant: ...
                                            objv85[0] = const15;
                                            // Arg 1 variable: $true_key
                                            tmp86 = getVarScalar(interp, "true_key", compiledLocals, 12);
                                            tmp86.preserve();
                                            objv85[1] = tmp86;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv85, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            tmp86 = objv85[1];
                                            if ( tmp86 != null ) {
                                                tmp86.release();
                                            }
                                            TJC.releaseObjv(interp, objv85, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp84 = interp.getResult();
                                    tmp84.preserve();
                                    objv83[0] = tmp84;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv83, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv83, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp80 != null ) {
                            tmp80.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: set elseif_depth 0
            setVarScalar(interp, "elseif_depth", const16, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: if {$elseif_keys != {}} ...
            // Binary operator: $elseif_keys != ""
            TclObject tmp87 = getVarScalar(interp, "elseif_keys", compiledLocals, 5);
            ExprValue tmp88 = evs0;
            TJC.exprEqualsEmptyString(tmp88, tmp87, true);
            // End Binary operator: !=
            boolean tmp89 = ( tmp88.getIntValue() != 0 );
            if ( tmp89 ) {
                { // Invoke: foreach ... $elseif_keys ... [...] ...
                    TclObject tmp90 = null;
                    TclObject tmp91 = null;
                    try {
                        tmp90 = getVarScalar(interp, "elseif_keys", compiledLocals, 5);
                        tmp90.preserve();
                        { // Invoke: ... $key
                            TclObject[] objv92 = TJC.grabObjv(interp, 2);
                            TclObject tmp93;
                            try {
                                // Arg 0 constant: ...
                                objv92[0] = const17;
                                // Arg 1 variable: $key
                                tmp93 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp93.preserve();
                                objv92[1] = tmp93;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv92, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp93 = objv92[1];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                TJC.releaseObjv(interp, objv92, 2);
                            }
                        } // End Invoke: ...
                        tmp91 = interp.getResult();
                        tmp91.preserve();
                        final int tmp90_length = TclList.getLength(interp, tmp90);
                        final int tmp91_length = TclList.getLength(interp, tmp91);
                        int num_loops94, max_loops95 = 0;
                        num_loops94 = (tmp90_length + 2 - 1) / 2;
                        if ( num_loops94 > max_loops95 ) {
                            max_loops95 = num_loops94;
                        }
                        num_loops94 = (tmp91_length + 2 - 1) / 2;
                        if ( num_loops94 > max_loops95 ) {
                            max_loops95 = num_loops94;
                        }

                        for ( int index96 = 0 ; index96 < max_loops95 ; index96++ ) {
                            int tmp90_index = index96 * 2;
                            int tmp91_index = index96 * 2;
                            TclObject tmp97 = null;
                            if ( tmp90_index < tmp90_length ) {
                                tmp97 = TclList.index(interp, tmp90, tmp90_index);
                            }
                            TclObject tmp98 = null;
                            if ( tmp90_index + 1 < tmp90_length ) {
                                tmp98 = TclList.index(interp, tmp90, tmp90_index + 1);
                            }
                            TclObject tmp99 = null;
                            if ( tmp91_index < tmp91_length ) {
                                tmp99 = TclList.index(interp, tmp91, tmp91_index);
                            }
                            TclObject tmp100 = null;
                            if ( tmp91_index + 1 < tmp91_length ) {
                                tmp100 = TclList.index(interp, tmp91, tmp91_index + 1);
                            }
                            try {
                                if ( tmp97 == null ) {
                                    setVarScalar(interp, "elseif_expr_keys", "", compiledLocals, 14);
                                } else {
                                    setVarScalar(interp, "elseif_expr_keys", tmp97, compiledLocals, 14);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "elseif_expr_keys");
                            }
                            try {
                                if ( tmp98 == null ) {
                                    setVarScalar(interp, "elseif_body_keys", "", compiledLocals, 15);
                                } else {
                                    setVarScalar(interp, "elseif_body_keys", tmp98, compiledLocals, 15);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "elseif_body_keys");
                            }
                            try {
                                if ( tmp99 == null ) {
                                    setVarScalar(interp, "expr_index", "", compiledLocals, 7);
                                } else {
                                    setVarScalar(interp, "expr_index", tmp99, compiledLocals, 7);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "expr_index");
                            }
                            try {
                                if ( tmp100 == null ) {
                                    setVarScalar(interp, "body_index", "", compiledLocals, 16);
                                } else {
                                    setVarScalar(interp, "body_index", tmp100, compiledLocals, 16);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_index");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set tuple [...]
                                TclObject tmp101;
                                { // Invoke: ... $key $expr_index
                                    TclObject[] objv102 = TJC.grabObjv(interp, 3);
                                    TclObject tmp103;
                                    try {
                                        // Arg 0 constant: ...
                                        objv102[0] = const11;
                                        // Arg 1 variable: $key
                                        tmp103 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp103.preserve();
                                        objv102[1] = tmp103;
                                        // Arg 2 variable: $expr_index
                                        tmp103 = getVarScalar(interp, "expr_index", compiledLocals, 7);
                                        tmp103.preserve();
                                        objv102[2] = tmp103;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv102, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp103 = objv102[1];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        tmp103 = objv102[2];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        TJC.releaseObjv(interp, objv102, 3);
                                    }
                                } // End Invoke: ...
                                tmp101 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp101, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: set tmpsymbol [...]
                                TclObject tmp104;
                                { // Invoke: lindex $tuple 0
                                    TclObject tmp105 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                    tmp105 = TclList.index(interp, tmp105, 0);
                                    if ( tmp105 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp105);
                                    }
                                } // End Invoke: lindex
                                tmp104 = interp.getResult();
                                setVarScalar(interp, "tmpsymbol", tmp104, compiledLocals, 9);
                            } // End Invoke: set
                            { // Invoke: set is_constant [...]
                                TclObject tmp106;
                                { // Invoke: lindex $tuple 2
                                    TclObject tmp107 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                    tmp107 = TclList.index(interp, tmp107, 2);
                                    if ( tmp107 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp107);
                                    }
                                } // End Invoke: lindex
                                tmp106 = interp.getResult();
                                setVarScalar(interp, "is_constant", tmp106, compiledLocals, 10);
                            } // End Invoke: set
                            { // Invoke: if {$is_constant} ... else ...
                                TclObject tmp108 = getVarScalar(interp, "is_constant", compiledLocals, 10);
                                boolean tmp109 = TJC.getBoolean(interp, tmp108);
                                if ( tmp109 ) {
                                    { // Invoke: append buffer [...] [...]
                                        TclObject[] objv110 = TJC.grabObjv(interp, 2);
                                        TclObject tmp111;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $tuple 1
                                                TclObject tmp112 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                                tmp112 = TclList.index(interp, tmp112, 1);
                                                if ( tmp112 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp112);
                                                }
                                            } // End Invoke: lindex
                                            tmp111 = interp.getResult();
                                            tmp111.preserve();
                                            objv110[0] = tmp111;
                                            // Arg 3 command: [...]
                                            { // Invoke: ... $tmpsymbol
                                                TclObject[] objv113 = TJC.grabObjv(interp, 2);
                                                TclObject tmp114;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv113[0] = const18;
                                                    // Arg 1 variable: $tmpsymbol
                                                    tmp114 = getVarScalar(interp, "tmpsymbol", compiledLocals, 9);
                                                    tmp114.preserve();
                                                    objv113[1] = tmp114;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv113, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    tmp114 = objv113[1];
                                                    if ( tmp114 != null ) {
                                                        tmp114.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv113, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp111 = interp.getResult();
                                            tmp111.preserve();
                                            objv110[1] = tmp111;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv110, compiledLocals, 1);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv110, 2);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer [...] [...] [...]
                                        TclObject[] objv115 = TJC.grabObjv(interp, 3);
                                        TclObject tmp116;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ...
                                                TclObject[] objv117 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv117[0] = const19;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                        ? cmdcache14.cmd : null), objv117, 0);
                                                    if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                        updateCmdCache(interp, 14);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv117, 1);
                                                }
                                            } // End Invoke: ...
                                            tmp116 = interp.getResult();
                                            tmp116.preserve();
                                            objv115[0] = tmp116;
                                            // Arg 3 command: [...]
                                            { // Invoke: lindex $tuple 1
                                                TclObject tmp118 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                                tmp118 = TclList.index(interp, tmp118, 1);
                                                if ( tmp118 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp118);
                                                }
                                            } // End Invoke: lindex
                                            tmp116 = interp.getResult();
                                            tmp116.preserve();
                                            objv115[1] = tmp116;
                                            // Arg 4 command: [...]
                                            { // Invoke: ... $tmpsymbol
                                                TclObject[] objv119 = TJC.grabObjv(interp, 2);
                                                TclObject tmp120;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv119[0] = const12;
                                                    // Arg 1 variable: $tmpsymbol
                                                    tmp120 = getVarScalar(interp, "tmpsymbol", compiledLocals, 9);
                                                    tmp120.preserve();
                                                    objv119[1] = tmp120;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                        ? cmdcache8.cmd : null), objv119, 0);
                                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                        updateCmdCache(interp, 8);
                                                    }
                                                } finally {
                                                    tmp120 = objv119[1];
                                                    if ( tmp120 != null ) {
                                                        tmp120.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv119, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp116 = interp.getResult();
                                            tmp116.preserve();
                                            objv115[2] = tmp116;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv115, compiledLocals, 1);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv115, 3);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: incr elseif_depth
                                        interp.resetResult();
                                        incrVarScalar(interp, "elseif_depth", 1, compiledLocals, 13);
                                    } // End Invoke: incr
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ... else ...
                                // Binary operator: $elseif_body_keys == ""
                                TclObject tmp121 = getVarScalar(interp, "elseif_body_keys", compiledLocals, 15);
                                ExprValue tmp122 = evs0;
                                TJC.exprEqualsEmptyString(tmp122, tmp121, false);
                                // End Binary operator: ==
                                boolean tmp123 = ( tmp122.getIntValue() != 0 );
                                if ( tmp123 ) {
                                    { // Invoke: if {!$omit_result} ...
                                        // Unary operator: ! $omit_result
                                        TclObject tmp124 = getVarScalar(interp, "omit_result", compiledLocals, 11);
                                        ExprValue tmp125 = evs0;
                                        if ( tmp124.isIntType() ) {
                                            TJC.exprUnaryNotOperatorKnownInt(tmp125, tmp124);
                                        } else {
                                            TJC.exprUnaryNotOperator(interp, tmp125, tmp124);
                                        }
                                        // End Unary operator: !
                                        boolean tmp126 = ( tmp125.getIntValue() != 0 );
                                        if ( tmp126 ) {
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv127 = TJC.grabObjv(interp, 1);
                                                TclObject tmp128;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: emitter_reset_result
                                                        TclObject[] objv129 = TJC.grabObjv(interp, 1);
                                                        try {
                                                            // Arg 0 constant: emitter_reset_result
                                                            objv129[0] = const14;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                                ? cmdcache10.cmd : null), objv129, 0);
                                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                                updateCmdCache(interp, 10);
                                                            }
                                                        } finally {
                                                            TJC.releaseObjv(interp, objv129, 1);
                                                        }
                                                    } // End Invoke: emitter_reset_result
                                                    tmp128 = interp.getResult();
                                                    tmp128.preserve();
                                                    objv127[0] = tmp128;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv127, compiledLocals, 1);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv127, 1);
                                                }
                                            } // End Invoke: append
                                        }
                                    } // End Invoke: if
                                } else {
                                    { // Invoke: foreach elseif_body_key $elseif_body_keys ...
                                        TclObject tmp130 = null;
                                        try {
                                            tmp130 = getVarScalar(interp, "elseif_body_keys", compiledLocals, 15);
                                            tmp130.preserve();
                                            final int tmp130_length = TclList.getLength(interp, tmp130);

                                            for ( int index131 = 0 ; index131 < tmp130_length ; index131++ ) {
                                                TclObject tmp132 = TclList.index(interp, tmp130, index131);
                                                try {
                                                    setVarScalar(interp, "elseif_body_key", tmp132, compiledLocals, 17);
                                                } catch (TclException ex) {
                                                    TJC.foreachVarErr(interp, "elseif_body_key");
                                                }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: append buffer [...]
                                                    TclObject[] objv133 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp134;
                                                    try {
                                                        // Arg 2 command: [...]
                                                        { // Invoke: ... $elseif_body_key
                                                            TclObject[] objv135 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp136;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv135[0] = const15;
                                                                // Arg 1 variable: $elseif_body_key
                                                                tmp136 = getVarScalar(interp, "elseif_body_key", compiledLocals, 17);
                                                                tmp136.preserve();
                                                                objv135[1] = tmp136;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                                    ? cmdcache11.cmd : null), objv135, 0);
                                                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                                    updateCmdCache(interp, 11);
                                                                }
                                                            } finally {
                                                                tmp136 = objv135[1];
                                                                if ( tmp136 != null ) {
                                                                    tmp136.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv135, 2);
                                                            }
                                                        } // End Invoke: ...
                                                        tmp134 = interp.getResult();
                                                        tmp134.preserve();
                                                        objv133[0] = tmp134;
                                                        interp.resetResult();
                                                        appendVarScalar(interp, "buffer", objv133, compiledLocals, 1);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv133, 1);
                                                    }
                                                } // End Invoke: append
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } finally {
                                            if ( tmp130 != null ) {
                                                tmp130.release();
                                            }
                                        }
                                    } // End Invoke: foreach
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp90 != null ) {
                            tmp90.release();
                        }
                        if ( tmp91 != null ) {
                            tmp91.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: if {$else_keys == {}} ... else ...
            // Binary operator: $else_keys == ""
            TclObject tmp137 = getVarScalar(interp, "else_keys", compiledLocals, 6);
            ExprValue tmp138 = evs0;
            TJC.exprEqualsEmptyString(tmp138, tmp137, false);
            // End Binary operator: ==
            boolean tmp139 = ( tmp138.getIntValue() != 0 );
            if ( tmp139 ) {
                { // Invoke: if {!$omit_result} ...
                    // Unary operator: ! $omit_result
                    TclObject tmp140 = getVarScalar(interp, "omit_result", compiledLocals, 11);
                    ExprValue tmp141 = evs0;
                    if ( tmp140.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp141, tmp140);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp141, tmp140);
                    }
                    // End Unary operator: !
                    boolean tmp142 = ( tmp141.getIntValue() != 0 );
                    if ( tmp142 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv143 = TJC.grabObjv(interp, 1);
                            TclObject tmp144;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ...
                                    TclObject[] objv145 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv145[0] = const19;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                            ? cmdcache14.cmd : null), objv145, 0);
                                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                            updateCmdCache(interp, 14);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv145, 1);
                                    }
                                } // End Invoke: ...
                                tmp144 = interp.getResult();
                                tmp144.preserve();
                                objv143[0] = tmp144;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv143, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv143, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: append buffer [...]
                            TclObject[] objv146 = TJC.grabObjv(interp, 1);
                            TclObject tmp147;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_reset_result
                                    TclObject[] objv148 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_reset_result
                                        objv148[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv148, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv148, 1);
                                    }
                                } // End Invoke: emitter_reset_result
                                tmp147 = interp.getResult();
                                tmp147.preserve();
                                objv146[0] = tmp147;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv146, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv146, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                { // Invoke: append buffer [...]
                    TclObject[] objv149 = TJC.grabObjv(interp, 1);
                    TclObject tmp150;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv151 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv151[0] = const19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv151, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv151, 1);
                            }
                        } // End Invoke: ...
                        tmp150 = interp.getResult();
                        tmp150.preserve();
                        objv149[0] = tmp150;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv149, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv149, 1);
                    }
                } // End Invoke: append
                { // Invoke: foreach else_key $else_keys ...
                    TclObject tmp152 = null;
                    try {
                        tmp152 = getVarScalar(interp, "else_keys", compiledLocals, 6);
                        tmp152.preserve();
                        final int tmp152_length = TclList.getLength(interp, tmp152);

                        for ( int index153 = 0 ; index153 < tmp152_length ; index153++ ) {
                            TclObject tmp154 = TclList.index(interp, tmp152, index153);
                            try {
                                setVarScalar(interp, "else_key", tmp154, compiledLocals, 18);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "else_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv155 = TJC.grabObjv(interp, 1);
                                TclObject tmp156;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $else_key
                                        TclObject[] objv157 = TJC.grabObjv(interp, 2);
                                        TclObject tmp158;
                                        try {
                                            // Arg 0 constant: ...
                                            objv157[0] = const15;
                                            // Arg 1 variable: $else_key
                                            tmp158 = getVarScalar(interp, "else_key", compiledLocals, 18);
                                            tmp158.preserve();
                                            objv157[1] = tmp158;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv157, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            tmp158 = objv157[1];
                                            if ( tmp158 != null ) {
                                                tmp158.release();
                                            }
                                            TJC.releaseObjv(interp, objv157, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp156 = interp.getResult();
                                    tmp156.preserve();
                                    objv155[0] = tmp156;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv155, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv155, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp152 != null ) {
                            tmp152.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: for {set i 0} {$i < $elseif_depth} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const16, compiledLocals, 19);
            } // End Invoke: set
            for ( boolean skip164 = true ; true ; ) {
                if ( skip164 ) {
                    skip164 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 19);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $elseif_depth
                TclObject tmp159 = getVarScalar(interp, "i", compiledLocals, 19);
                ExprValue tmp160 = evs0;
                TJC.exprInitValue(interp, tmp160, tmp159);
                TclObject tmp161 = getVarScalar(interp, "elseif_depth", compiledLocals, 13);
                ExprValue tmp162 = evs1;
                TJC.exprInitValue(interp, tmp162, tmp161);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp160, tmp162);
                // End Binary operator: <
                boolean tmp163 = ( tmp160.getIntValue() != 0 );
                if ( ! tmp163 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: append buffer [...]
                    TclObject[] objv165 = TJC.grabObjv(interp, 1);
                    TclObject tmp166;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv167 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv167[0] = const20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv167, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv167, 1);
                            }
                        } // End Invoke: ...
                        tmp166 = interp.getResult();
                        tmp166.preserve();
                        objv165[0] = tmp166;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv165, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv165, 1);
                    }
                } // End Invoke: append
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...]
            TclObject[] objv168 = TJC.grabObjv(interp, 1);
            TclObject tmp169;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv170 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv170[0] = const20;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                            ? cmdcache15.cmd : null), objv170, 0);
                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                            updateCmdCache(interp, 15);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv170, 1);
                    }
                } // End Invoke: ...
                tmp169 = interp.getResult();
                tmp169.preserve();
                objv168[0] = tmp169;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv168, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv168, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp171 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp171);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_if");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("container");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("lrange");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(2);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("end-1");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("end");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_if_expr_body");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_expr_evaluate_boolean_emit");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_container_if_start");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_omit_set_result");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_reset_result");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_emit_invoke");
        const15.preserve(); const15.preserve();
        const16 = TclInteger.newInstance(0);
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("descend_container_if_iterate_elseif_body");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("emitter_container_if_else_if");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("emitter_container_if_else");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_container_if_end");
        const20.preserve(); const20.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "lrange";
                break;
            }
            case 6: {
                cmdName = "descend_container_if_expr_body";
                break;
            }
            case 7: {
                cmdName = "compileproc_expr_evaluate_boolean_emit";
                break;
            }
            case 8: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 9: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 10: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 11: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 12: {
                cmdName = "descend_container_if_iterate_elseif_body";
                break;
            }
            case 13: {
                cmdName = "emitter_container_if_else_if";
                break;
            }
            case 14: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 15: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "buffer",
        "ccmds",
        "expr_keys",
        "true_keys",
        "elseif_keys",
        "else_keys",
        "expr_index",
        "tuple",
        "tmpsymbol",
        "is_constant",
        "omit_result",
        "true_key",
        "elseif_depth",
        "elseif_expr_keys",
        "elseif_body_keys",
        "body_index",
        "elseif_body_key",
        "else_key",
        "i"
    };
} // end class CompileprocEmitContainerIfCmd

