// TJC implementation of procedure compileproc_emit_container_switch
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerSwitchCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 38, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ... 1
            setVarScalar(interp, "inline_constant_strings", const4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 3);
        } // End Invoke: global
        { // Invoke: set ind [...]
            TclObject tmp12;
            { // Invoke: lsearch -exact $... ...
                TclObject[] objv13 = TJC.grabObjv(interp, 4);
                TclObject tmp14;
                try {
                    // Arg 0 constant: lsearch
                    objv13[0] = const5;
                    // Arg 1 constant: -exact
                    objv13[1] = const6;
                    // Arg 2 variable: $...
                    tmp14 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 3);
                    tmp14.preserve();
                    objv13[2] = tmp14;
                    // Arg 3 constant: ...
                    objv13[3] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[2];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 4);
                }
            } // End Invoke: lsearch
            tmp12 = interp.getResult();
            setVarScalar(interp, "ind", tmp12, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$ind != -1} ...
            // Binary operator: $ind != ()
            TclObject tmp15 = getVarScalar(interp, "ind", compiledLocals, 4);
            ExprValue tmp16 = evs0;
            TJC.exprInitValue(interp, tmp16, tmp15);
            // Unary operator: - 1
            ExprValue tmp17 = evs1;
            tmp17.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp16, tmp17);
            // End Binary operator: !=
            boolean tmp18 = ( tmp16.getIntValue() != 0 );
            if ( tmp18 ) {
                { // Invoke: set ... 0
                    setVarScalar(interp, "inline_constant_strings", const8, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set switch_mode [...]
            TclObject tmp19;
            { // Invoke: ... $key
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                TclObject tmp21;
                try {
                    // Arg 0 constant: ...
                    objv20[0] = const9;
                    // Arg 1 variable: $key
                    tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp21.preserve();
                    objv20[1] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv20, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp21 = objv20[1];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: ...
            tmp19 = interp.getResult();
            setVarScalar(interp, "switch_mode", tmp19, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $switch_mode != "default"
            TclObject tmp22 = getVarScalar(interp, "switch_mode", compiledLocals, 5);
            boolean tmp23 = ! tmp22.toString().equals("default");
            ExprValue tmp24 = evs0;
            tmp24.setIntValue(tmp23);
            // End Binary operator: !=
            if (tmp24.getBooleanValue(interp)) {
            // Binary operator: $switch_mode != "exact"
            TclObject tmp25 = getVarScalar(interp, "switch_mode", compiledLocals, 5);
            boolean tmp26 = ! tmp25.toString().equals("exact");
            ExprValue tmp27 = evs1;
            tmp27.setIntValue(tmp26);
            // End Binary operator: !=
            tmp24.setIntValue(tmp27.getBooleanValue(interp));
            } else {
            tmp24.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp28 = ( tmp24.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: set ... 0
                    setVarScalar(interp, "inline_constant_strings", const8, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set body_keys [...]
            TclObject tmp29;
            { // Invoke: descend_commands $key container
                TclObject[] objv30 = TJC.grabObjv(interp, 3);
                TclObject tmp31;
                try {
                    // Arg 0 constant: descend_commands
                    objv30[0] = const10;
                    // Arg 1 variable: $key
                    tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp31.preserve();
                    objv30[1] = tmp31;
                    // Arg 2 constant: container
                    objv30[2] = const11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv30, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp31 = objv30[1];
                    if ( tmp31 != null ) {
                        tmp31.release();
                    }
                    TJC.releaseObjv(interp, objv30, 3);
                }
            } // End Invoke: descend_commands
            tmp29 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp29, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set pbIndexes [...]
            TclObject tmp32;
            { // Invoke: ... $key
                TclObject[] objv33 = TJC.grabObjv(interp, 2);
                TclObject tmp34;
                try {
                    // Arg 0 constant: ...
                    objv33[0] = const12;
                    // Arg 1 variable: $key
                    tmp34 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp34.preserve();
                    objv33[1] = tmp34;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv33, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp34 = objv33[1];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    TJC.releaseObjv(interp, objv33, 2);
                }
            } // End Invoke: ...
            tmp32 = interp.getResult();
            setVarScalar(interp, "pbIndexes", tmp32, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set pbIndex [...]
            TclObject tmp35;
            { // Invoke: lindex $pbIndexes 0
                TclObject tmp36 = getVarScalar(interp, "pbIndexes", compiledLocals, 7);
                tmp36 = TclList.index(interp, tmp36, 0);
                if ( tmp36 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp36);
                }
            } // End Invoke: lindex
            tmp35 = interp.getResult();
            setVarScalar(interp, "pbIndex", tmp35, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            TclObject tmp37 = getVarScalar(interp, "inline_constant_strings", compiledLocals, 2);
            boolean tmp38 = TJC.getBoolean(interp, tmp37);
            if ( tmp38 ) {
                { // Invoke: foreach {pIndex bIndex} $pbIndexes ...
                    TclObject tmp39 = null;
                    try {
                        tmp39 = getVarScalar(interp, "pbIndexes", compiledLocals, 7);
                        tmp39.preserve();
                        final int tmp39_length = TclList.getLength(interp, tmp39);

                        for ( int index40 = 0 ; index40 < tmp39_length ; index40 += 2 ) {
                            TclObject tmp41 = null;
                            if ( index40 < tmp39_length ) {
                                tmp41 = TclList.index(interp, tmp39, index40);
                            }
                            TclObject tmp42 = null;
                            if ( index40 + 1 < tmp39_length ) {
                                tmp42 = TclList.index(interp, tmp39, index40 + 1);
                            }
                            try {
                                if ( tmp41 == null ) {
                                    setVarScalar(interp, "pIndex", "", compiledLocals, 9);
                                } else {
                                    setVarScalar(interp, "pIndex", tmp41, compiledLocals, 9);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "pIndex");
                            }
                            try {
                                if ( tmp42 == null ) {
                                    setVarScalar(interp, "bIndex", "", compiledLocals, 10);
                                } else {
                                    setVarScalar(interp, "bIndex", tmp42, compiledLocals, 10);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "bIndex");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set tuple [...]
                                TclObject tmp43;
                                { // Invoke: ... $key $pIndex
                                    TclObject[] objv44 = TJC.grabObjv(interp, 3);
                                    TclObject tmp45;
                                    try {
                                        // Arg 0 constant: ...
                                        objv44[0] = const13;
                                        // Arg 1 variable: $key
                                        tmp45 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp45.preserve();
                                        objv44[1] = tmp45;
                                        // Arg 2 variable: $pIndex
                                        tmp45 = getVarScalar(interp, "pIndex", compiledLocals, 9);
                                        tmp45.preserve();
                                        objv44[2] = tmp45;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv44, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp45 = objv44[1];
                                        if ( tmp45 != null ) {
                                            tmp45.release();
                                        }
                                        tmp45 = objv44[2];
                                        if ( tmp45 != null ) {
                                            tmp45.release();
                                        }
                                        TJC.releaseObjv(interp, objv44, 3);
                                    }
                                } // End Invoke: ...
                                tmp43 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp43, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: set type [...]
                                TclObject tmp46;
                                { // Invoke: lindex $tuple 0
                                    TclObject tmp47 = getVarScalar(interp, "tuple", compiledLocals, 11);
                                    tmp47 = TclList.index(interp, tmp47, 0);
                                    if ( tmp47 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp47);
                                    }
                                } // End Invoke: lindex
                                tmp46 = interp.getResult();
                                setVarScalar(interp, "type", tmp46, compiledLocals, 12);
                            } // End Invoke: set
                            { // Invoke: if ... ...
                                // Binary operator: $type != "constant"
                                TclObject tmp48 = getVarScalar(interp, "type", compiledLocals, 12);
                                boolean tmp49 = ! tmp48.toString().equals("constant");
                                ExprValue tmp50 = evs0;
                                tmp50.setIntValue(tmp49);
                                // End Binary operator: !=
                                boolean tmp51 = ( tmp50.getIntValue() != 0 );
                                if ( tmp51 ) {
                                    { // Invoke: set ... 0
                                        setVarScalar(interp, "inline_constant_strings", const8, compiledLocals, 2);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp39 != null ) {
                            tmp39.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: set sIndex [...]
            TclObject tmp52;
            { // Invoke: ... $key
                TclObject[] objv53 = TJC.grabObjv(interp, 2);
                TclObject tmp54;
                try {
                    // Arg 0 constant: ...
                    objv53[0] = const14;
                    // Arg 1 variable: $key
                    tmp54 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp54.preserve();
                    objv53[1] = tmp54;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv53, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp54 = objv53[1];
                    if ( tmp54 != null ) {
                        tmp54.release();
                    }
                    TJC.releaseObjv(interp, objv53, 2);
                }
            } // End Invoke: ...
            tmp52 = interp.getResult();
            setVarScalar(interp, "sIndex", tmp52, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp55;
            { // Invoke: ... $key $sIndex
                TclObject[] objv56 = TJC.grabObjv(interp, 3);
                TclObject tmp57;
                try {
                    // Arg 0 constant: ...
                    objv56[0] = const15;
                    // Arg 1 variable: $key
                    tmp57 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp57.preserve();
                    objv56[1] = tmp57;
                    // Arg 2 variable: $sIndex
                    tmp57 = getVarScalar(interp, "sIndex", compiledLocals, 13);
                    tmp57.preserve();
                    objv56[2] = tmp57;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                        ? cmdcache10.cmd : null), objv56, 0);
                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                        updateCmdCache(interp, 10);
                    }
                } finally {
                    tmp57 = objv56[1];
                    if ( tmp57 != null ) {
                        tmp57.release();
                    }
                    tmp57 = objv56[2];
                    if ( tmp57 != null ) {
                        tmp57.release();
                    }
                    TJC.releaseObjv(interp, objv56, 3);
                }
            } // End Invoke: ...
            tmp55 = interp.getResult();
            setVarScalar(interp, "tuple", tmp55, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set str_type [...]
            TclObject tmp58;
            { // Invoke: lindex $tuple 0
                TclObject tmp59 = getVarScalar(interp, "tuple", compiledLocals, 11);
                tmp59 = TclList.index(interp, tmp59, 0);
                if ( tmp59 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp59);
                }
            } // End Invoke: lindex
            tmp58 = interp.getResult();
            setVarScalar(interp, "str_type", tmp58, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set str_symbol [...]
            TclObject tmp60;
            { // Invoke: lindex $tuple 1
                TclObject tmp61 = getVarScalar(interp, "tuple", compiledLocals, 11);
                tmp61 = TclList.index(interp, tmp61, 1);
                if ( tmp61 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp61);
                }
            } // End Invoke: lindex
            tmp60 = interp.getResult();
            setVarScalar(interp, "str_symbol", tmp60, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set str_buffer [...]
            TclObject tmp62;
            { // Invoke: lindex $tuple 2
                TclObject tmp63 = getVarScalar(interp, "tuple", compiledLocals, 11);
                tmp63 = TclList.index(interp, tmp63, 2);
                if ( tmp63 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp63);
                }
            } // End Invoke: lindex
            tmp62 = interp.getResult();
            setVarScalar(interp, "str_buffer", tmp62, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: append buffer $str_buffer
            TclObject[] objv64 = TJC.grabObjv(interp, 1);
            TclObject tmp65;
            try {
                // Arg 2 variable: $str_buffer
                tmp65 = getVarScalar(interp, "str_buffer", compiledLocals, 16);
                tmp65.preserve();
                objv64[0] = tmp65;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv64, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv64, 1);
            }
        } // End Invoke: append
        { // Invoke: set string_tmpsymbol [...]
            TclObject tmp66;
            { // Invoke: ...
                TclObject[] objv67 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv67[0] = const16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                        ? cmdcache11.cmd : null), objv67, 0);
                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                        updateCmdCache(interp, 11);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv67, 1);
                }
            } // End Invoke: ...
            tmp66 = interp.getResult();
            setVarScalar(interp, "string_tmpsymbol", tmp66, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: append buffer [...] "String " $string_tmpsymbol " = " $str_symbol ...
            TclObject[] objv68 = TJC.grabObjv(interp, 6);
            TclObject tmp69;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv70 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv70[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv70, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv70, 1);
                    }
                } // End Invoke: emitter_indent
                tmp69 = interp.getResult();
                tmp69.preserve();
                objv68[0] = tmp69;
                // Arg 3 constant: "String "
                objv68[1] = const18;
                // Arg 4 variable: $string_tmpsymbol
                tmp69 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 17);
                tmp69.preserve();
                objv68[2] = tmp69;
                // Arg 5 constant: " = "
                objv68[3] = const19;
                // Arg 6 variable: $str_symbol
                tmp69 = getVarScalar(interp, "str_symbol", compiledLocals, 15);
                tmp69.preserve();
                objv68[4] = tmp69;
                // Arg 7 constant: ...
                objv68[5] = const20;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv68, compiledLocals, 1);
            } finally {
                tmp69 = objv68[0];
                if ( tmp69 != null ) {
                    tmp69.release();
                }
                tmp69 = objv68[2];
                if ( tmp69 != null ) {
                    tmp69.release();
                }
                tmp69 = objv68[4];
                if ( tmp69 != null ) {
                    tmp69.release();
                }
                TJC.releaseObjv(interp, objv68, 6);
            }
        } // End Invoke: append
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv71 = TJC.grabObjv(interp, 2);
                TclObject tmp72;
                try {
                    // Arg 0 constant: ...
                    objv71[0] = const21;
                    // Arg 1 variable: $key
                    tmp72 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp72.preserve();
                    objv71[1] = tmp72;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                        ? cmdcache13.cmd : null), objv71, 0);
                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                        updateCmdCache(interp, 13);
                    }
                } finally {
                    tmp72 = objv71[1];
                    if ( tmp72 != null ) {
                        tmp72.release();
                    }
                    TJC.releaseObjv(interp, objv71, 2);
                }
            } // End Invoke: ...
            TclObject tmp73 = interp.getResult();
            ExprValue tmp74 = evs0;
            if ( tmp73.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp74, tmp73);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp74, tmp73);
            }
            // End Unary operator: !
            boolean tmp75 = ( tmp74.getIntValue() != 0 );
            if ( tmp75 ) {
                { // Invoke: append buffer [...] ... $string_tmpsymbol ...
                    TclObject[] objv76 = TJC.grabObjv(interp, 4);
                    TclObject tmp77;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv78 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv78[0] = const17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv78, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv78, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp77 = interp.getResult();
                        tmp77.preserve();
                        objv76[0] = tmp77;
                        // Arg 3 constant: ...
                        objv76[1] = const22;
                        // Arg 4 variable: $string_tmpsymbol
                        tmp77 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 17);
                        tmp77.preserve();
                        objv76[2] = tmp77;
                        // Arg 5 constant: ...
                        objv76[3] = const23;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv76, compiledLocals, 1);
                    } finally {
                        tmp77 = objv76[0];
                        if ( tmp77 != null ) {
                            tmp77.release();
                        }
                        tmp77 = objv76[2];
                        if ( tmp77 != null ) {
                            tmp77.release();
                        }
                        TJC.releaseObjv(interp, objv76, 4);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp79 = getVarScalar(interp, "inline_constant_strings", compiledLocals, 2);
            boolean tmp80 = TJC.getBoolean(interp, tmp79);
            if ( tmp80 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv81 = TJC.grabObjv(interp, 1);
                    TclObject tmp82;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $key $string_tmpsymbol
                            TclObject[] objv83 = TJC.grabObjv(interp, 3);
                            TclObject tmp84;
                            try {
                                // Arg 0 constant: ...
                                objv83[0] = const24;
                                // Arg 1 variable: $key
                                tmp84 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp84.preserve();
                                objv83[1] = tmp84;
                                // Arg 2 variable: $string_tmpsymbol
                                tmp84 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 17);
                                tmp84.preserve();
                                objv83[2] = tmp84;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv83, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp84 = objv83[1];
                                if ( tmp84 != null ) {
                                    tmp84.release();
                                }
                                tmp84 = objv83[2];
                                if ( tmp84 != null ) {
                                    tmp84.release();
                                }
                                TJC.releaseObjv(interp, objv83, 3);
                            }
                        } // End Invoke: ...
                        tmp82 = interp.getResult();
                        tmp82.preserve();
                        objv81[0] = tmp82;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv81, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv81, 1);
                    }
                } // End Invoke: append
                { // Invoke: return $buffer
                    TclObject tmp85 = getVarScalar(interp, "buffer", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp85);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set offset_tmpsymbol [...]
            TclObject tmp86;
            { // Invoke: ...
                TclObject[] objv87 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv87[0] = const16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                        ? cmdcache11.cmd : null), objv87, 0);
                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                        updateCmdCache(interp, 11);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv87, 1);
                }
            } // End Invoke: ...
            tmp86 = interp.getResult();
            setVarScalar(interp, "offset_tmpsymbol", tmp86, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: append buffer [...] "int " $offset_tmpsymbol ...
            TclObject[] objv88 = TJC.grabObjv(interp, 4);
            TclObject tmp89;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv90 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv90[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv90, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv90, 1);
                    }
                } // End Invoke: emitter_indent
                tmp89 = interp.getResult();
                tmp89.preserve();
                objv88[0] = tmp89;
                // Arg 3 constant: "int "
                objv88[1] = const25;
                // Arg 4 variable: $offset_tmpsymbol
                tmp89 = getVarScalar(interp, "offset_tmpsymbol", compiledLocals, 18);
                tmp89.preserve();
                objv88[2] = tmp89;
                // Arg 5 constant: ...
                objv88[3] = const26;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv88, compiledLocals, 1);
            } finally {
                tmp89 = objv88[0];
                if ( tmp89 != null ) {
                    tmp89.release();
                }
                tmp89 = objv88[2];
                if ( tmp89 != null ) {
                    tmp89.release();
                }
                TJC.releaseObjv(interp, objv88, 4);
            }
        } // End Invoke: append
        { // Invoke: set array_tmpsymbol [...]
            TclObject tmp91;
            { // Invoke: ... objv
                TclObject[] objv92 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: ...
                    objv92[0] = const16;
                    // Arg 1 constant: objv
                    objv92[1] = const27;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                        ? cmdcache11.cmd : null), objv92, 0);
                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                        updateCmdCache(interp, 11);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv92, 2);
                }
            } // End Invoke: ...
            tmp91 = interp.getResult();
            setVarScalar(interp, "array_tmpsymbol", tmp91, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set size [...]
            TclObject tmp93;
            { // Invoke: llength $pbIndexes
                TclObject tmp94 = getVarScalar(interp, "pbIndexes", compiledLocals, 7);
                int tmp95 = TclList.getLength(interp, tmp94);
                interp.setResult(tmp95);
            } // End Invoke: llength
            tmp93 = interp.getResult();
            setVarScalar(interp, "size", tmp93, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: append buffer [...] [...]
            TclObject[] objv96 = TJC.grabObjv(interp, 2);
            TclObject tmp97;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $array_tmpsymbol $size
                    TclObject[] objv98 = TJC.grabObjv(interp, 3);
                    TclObject tmp99;
                    try {
                        // Arg 0 constant: ...
                        objv98[0] = const28;
                        // Arg 1 variable: $array_tmpsymbol
                        tmp99 = getVarScalar(interp, "array_tmpsymbol", compiledLocals, 19);
                        tmp99.preserve();
                        objv98[1] = tmp99;
                        // Arg 2 variable: $size
                        tmp99 = getVarScalar(interp, "size", compiledLocals, 20);
                        tmp99.preserve();
                        objv98[2] = tmp99;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                            ? cmdcache15.cmd : null), objv98, 0);
                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                            updateCmdCache(interp, 15);
                        }
                    } finally {
                        tmp99 = objv98[1];
                        if ( tmp99 != null ) {
                            tmp99.release();
                        }
                        tmp99 = objv98[2];
                        if ( tmp99 != null ) {
                            tmp99.release();
                        }
                        TJC.releaseObjv(interp, objv98, 3);
                    }
                } // End Invoke: ...
                tmp97 = interp.getResult();
                tmp97.preserve();
                objv96[0] = tmp97;
                // Arg 3 command: [...]
                { // Invoke: ...
                    TclObject[] objv100 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv100[0] = const29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                            ? cmdcache16.cmd : null), objv100, 0);
                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                            updateCmdCache(interp, 16);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv100, 1);
                    }
                } // End Invoke: ...
                tmp97 = interp.getResult();
                tmp97.preserve();
                objv96[1] = tmp97;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv96, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv96, 2);
            }
        } // End Invoke: append
        { // Invoke: set tmpsymbol [...]
            TclObject tmp101;
            { // Invoke: ...
                TclObject[] objv102 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv102[0] = const16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                        ? cmdcache11.cmd : null), objv102, 0);
                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                        updateCmdCache(interp, 11);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv102, 1);
                }
            } // End Invoke: ...
            tmp101 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp101, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: append buffer [...] "TclObject " $tmpsymbol ...
            TclObject[] objv103 = TJC.grabObjv(interp, 4);
            TclObject tmp104;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv105 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv105[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv105, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv105, 1);
                    }
                } // End Invoke: emitter_indent
                tmp104 = interp.getResult();
                tmp104.preserve();
                objv103[0] = tmp104;
                // Arg 3 constant: "TclObject "
                objv103[1] = const30;
                // Arg 4 variable: $tmpsymbol
                tmp104 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                tmp104.preserve();
                objv103[2] = tmp104;
                // Arg 5 constant: ...
                objv103[3] = const26;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv103, compiledLocals, 1);
            } finally {
                tmp104 = objv103[0];
                if ( tmp104 != null ) {
                    tmp104.release();
                }
                tmp104 = objv103[2];
                if ( tmp104 != null ) {
                    tmp104.release();
                }
                TJC.releaseObjv(interp, objv103, 4);
            }
        } // End Invoke: append
        { // Invoke: set pattern_comments [...]
            TclObject tmp106;
            { // Invoke: list
                TclObject tmp107 = TclList.newInstance();
                interp.setResult(tmp107);
            } // End Invoke: list
            tmp106 = interp.getResult();
            setVarScalar(interp, "pattern_comments", tmp106, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: set i 0
            setVarScalar(interp, "i", const8, compiledLocals, 23);
        } // End Invoke: set
        { // Invoke: foreach {patIndex bodyIndex} $pbIndexes ...
            TclObject tmp108 = null;
            try {
                tmp108 = getVarScalar(interp, "pbIndexes", compiledLocals, 7);
                tmp108.preserve();
                final int tmp108_length = TclList.getLength(interp, tmp108);

                for ( int index109 = 0 ; index109 < tmp108_length ; index109 += 2 ) {
                    TclObject tmp110 = null;
                    if ( index109 < tmp108_length ) {
                        tmp110 = TclList.index(interp, tmp108, index109);
                    }
                    TclObject tmp111 = null;
                    if ( index109 + 1 < tmp108_length ) {
                        tmp111 = TclList.index(interp, tmp108, index109 + 1);
                    }
                    try {
                        if ( tmp110 == null ) {
                            setVarScalar(interp, "patIndex", "", compiledLocals, 24);
                        } else {
                            setVarScalar(interp, "patIndex", tmp110, compiledLocals, 24);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "patIndex");
                    }
                    try {
                        if ( tmp111 == null ) {
                            setVarScalar(interp, "bodyIndex", "", compiledLocals, 25);
                        } else {
                            setVarScalar(interp, "bodyIndex", tmp111, compiledLocals, 25);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "bodyIndex");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple [...]
                        TclObject tmp112;
                        { // Invoke: ... $key $patIndex
                            TclObject[] objv113 = TJC.grabObjv(interp, 3);
                            TclObject tmp114;
                            try {
                                // Arg 0 constant: ...
                                objv113[0] = const31;
                                // Arg 1 variable: $key
                                tmp114 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp114.preserve();
                                objv113[1] = tmp114;
                                // Arg 2 variable: $patIndex
                                tmp114 = getVarScalar(interp, "patIndex", compiledLocals, 24);
                                tmp114.preserve();
                                objv113[2] = tmp114;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv113, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                tmp114 = objv113[1];
                                if ( tmp114 != null ) {
                                    tmp114.release();
                                }
                                tmp114 = objv113[2];
                                if ( tmp114 != null ) {
                                    tmp114.release();
                                }
                                TJC.releaseObjv(interp, objv113, 3);
                            }
                        } // End Invoke: ...
                        tmp112 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp112, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: set str [...]
                        TclObject tmp115;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp116 = getVarScalar(interp, "tuple", compiledLocals, 11);
                            tmp116 = TclList.index(interp, tmp116, 1);
                            if ( tmp116 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp116);
                            }
                        } // End Invoke: lindex
                        tmp115 = interp.getResult();
                        setVarScalar(interp, "str", tmp115, compiledLocals, 26);
                    } // End Invoke: set
                    { // Invoke: set comment "Pattern $str"
                        TclObject tmp117;
                        StringBuffer sbtmp118 = new StringBuffer(64);
                        sbtmp118.append("Pattern ");
                        tmp117 = getVarScalar(interp, "str", compiledLocals, 26);
                        sbtmp118.append(tmp117.toString());
                        tmp117 = TclString.newInstance(sbtmp118);
                        setVarScalar(interp, "comment", tmp117, compiledLocals, 27);
                    } // End Invoke: set
                    { // Invoke: lappend pattern_comments $comment
                        TclObject[] objv119 = TJC.grabObjv(interp, 1);
                        TclObject tmp120;
                        try {
                            // Arg 2 variable: $comment
                            tmp120 = getVarScalar(interp, "comment", compiledLocals, 27);
                            tmp120.preserve();
                            objv119[0] = tmp120;
                            interp.resetResult();
                            lappendVarScalar(interp, "pattern_comments", objv119, compiledLocals, 22);
                        } finally {
                            TJC.releaseObjvElems(interp, objv119, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: append buffer [...]
                        TclObject[] objv121 = TJC.grabObjv(interp, 1);
                        TclObject tmp122;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_comment $comment
                                TclObject[] objv123 = TJC.grabObjv(interp, 2);
                                TclObject tmp124;
                                try {
                                    // Arg 0 constant: emitter_comment
                                    objv123[0] = const32;
                                    // Arg 1 variable: $comment
                                    tmp124 = getVarScalar(interp, "comment", compiledLocals, 27);
                                    tmp124.preserve();
                                    objv123[1] = tmp124;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                        ? cmdcache18.cmd : null), objv123, 0);
                                    if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                        updateCmdCache(interp, 18);
                                    }
                                } finally {
                                    tmp124 = objv123[1];
                                    if ( tmp124 != null ) {
                                        tmp124.release();
                                    }
                                    TJC.releaseObjv(interp, objv123, 2);
                                }
                            } // End Invoke: emitter_comment
                            tmp122 = interp.getResult();
                            tmp122.preserve();
                            objv121[0] = tmp122;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv121, compiledLocals, 1);
                        } finally {
                            TJC.releaseObjvElems(interp, objv121, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: set tuple [...]
                        TclObject tmp125;
                        { // Invoke: ... $key $patIndex 0 $tmpsymbol
                            TclObject[] objv126 = TJC.grabObjv(interp, 5);
                            TclObject tmp127;
                            try {
                                // Arg 0 constant: ...
                                objv126[0] = const15;
                                // Arg 1 variable: $key
                                tmp127 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp127.preserve();
                                objv126[1] = tmp127;
                                // Arg 2 variable: $patIndex
                                tmp127 = getVarScalar(interp, "patIndex", compiledLocals, 24);
                                tmp127.preserve();
                                objv126[2] = tmp127;
                                // Arg 3 constant: 0
                                objv126[3] = const8;
                                // Arg 4 variable: $tmpsymbol
                                tmp127 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                                tmp127.preserve();
                                objv126[4] = tmp127;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv126, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp127 = objv126[1];
                                if ( tmp127 != null ) {
                                    tmp127.release();
                                }
                                tmp127 = objv126[2];
                                if ( tmp127 != null ) {
                                    tmp127.release();
                                }
                                tmp127 = objv126[4];
                                if ( tmp127 != null ) {
                                    tmp127.release();
                                }
                                TJC.releaseObjv(interp, objv126, 5);
                            }
                        } // End Invoke: ...
                        tmp125 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp125, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: set pat_type [...]
                        TclObject tmp128;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp129 = getVarScalar(interp, "tuple", compiledLocals, 11);
                            tmp129 = TclList.index(interp, tmp129, 0);
                            if ( tmp129 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp129);
                            }
                        } // End Invoke: lindex
                        tmp128 = interp.getResult();
                        setVarScalar(interp, "pat_type", tmp128, compiledLocals, 28);
                    } // End Invoke: set
                    { // Invoke: set pat_symbol [...]
                        TclObject tmp130;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp131 = getVarScalar(interp, "tuple", compiledLocals, 11);
                            tmp131 = TclList.index(interp, tmp131, 1);
                            if ( tmp131 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp131);
                            }
                        } // End Invoke: lindex
                        tmp130 = interp.getResult();
                        setVarScalar(interp, "pat_symbol", tmp130, compiledLocals, 29);
                    } // End Invoke: set
                    { // Invoke: set pat_buffer [...]
                        TclObject tmp132;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp133 = getVarScalar(interp, "tuple", compiledLocals, 11);
                            tmp133 = TclList.index(interp, tmp133, 2);
                            if ( tmp133 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp133);
                            }
                        } // End Invoke: lindex
                        tmp132 = interp.getResult();
                        setVarScalar(interp, "pat_buffer", tmp132, compiledLocals, 30);
                    } // End Invoke: set
                    { // Invoke: append buffer $pat_buffer [...]
                        TclObject[] objv134 = TJC.grabObjv(interp, 2);
                        TclObject tmp135;
                        try {
                            // Arg 2 variable: $pat_buffer
                            tmp135 = getVarScalar(interp, "pat_buffer", compiledLocals, 30);
                            tmp135.preserve();
                            objv134[0] = tmp135;
                            // Arg 3 command: [...]
                            { // Invoke: ... $array_tmpsymbol $i $tmpsymbol $pat_symbol
                                TclObject[] objv136 = TJC.grabObjv(interp, 5);
                                TclObject tmp137;
                                try {
                                    // Arg 0 constant: ...
                                    objv136[0] = const33;
                                    // Arg 1 variable: $array_tmpsymbol
                                    tmp137 = getVarScalar(interp, "array_tmpsymbol", compiledLocals, 19);
                                    tmp137.preserve();
                                    objv136[1] = tmp137;
                                    // Arg 2 variable: $i
                                    tmp137 = getVarScalar(interp, "i", compiledLocals, 23);
                                    tmp137.preserve();
                                    objv136[2] = tmp137;
                                    // Arg 3 variable: $tmpsymbol
                                    tmp137 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                                    tmp137.preserve();
                                    objv136[3] = tmp137;
                                    // Arg 4 variable: $pat_symbol
                                    tmp137 = getVarScalar(interp, "pat_symbol", compiledLocals, 29);
                                    tmp137.preserve();
                                    objv136[4] = tmp137;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                        ? cmdcache19.cmd : null), objv136, 0);
                                    if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                        updateCmdCache(interp, 19);
                                    }
                                } finally {
                                    tmp137 = objv136[1];
                                    if ( tmp137 != null ) {
                                        tmp137.release();
                                    }
                                    tmp137 = objv136[2];
                                    if ( tmp137 != null ) {
                                        tmp137.release();
                                    }
                                    tmp137 = objv136[3];
                                    if ( tmp137 != null ) {
                                        tmp137.release();
                                    }
                                    tmp137 = objv136[4];
                                    if ( tmp137 != null ) {
                                        tmp137.release();
                                    }
                                    TJC.releaseObjv(interp, objv136, 5);
                                }
                            } // End Invoke: ...
                            tmp135 = interp.getResult();
                            tmp135.preserve();
                            objv134[1] = tmp135;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv134, compiledLocals, 1);
                        } finally {
                            TJC.releaseObjvElems(interp, objv134, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: incr i 1
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 23);
                    } // End Invoke: incr
                    { // Invoke: if ... ...
                        { // Invoke: ... $key $bodyIndex
                            TclObject[] objv138 = TJC.grabObjv(interp, 3);
                            TclObject tmp139;
                            try {
                                // Arg 0 constant: ...
                                objv138[0] = const34;
                                // Arg 1 variable: $key
                                tmp139 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp139.preserve();
                                objv138[1] = tmp139;
                                // Arg 2 variable: $bodyIndex
                                tmp139 = getVarScalar(interp, "bodyIndex", compiledLocals, 25);
                                tmp139.preserve();
                                objv138[2] = tmp139;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                    ? cmdcache20.cmd : null), objv138, 0);
                                if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                    updateCmdCache(interp, 20);
                                }
                            } finally {
                                tmp139 = objv138[1];
                                if ( tmp139 != null ) {
                                    tmp139.release();
                                }
                                tmp139 = objv138[2];
                                if ( tmp139 != null ) {
                                    tmp139.release();
                                }
                                TJC.releaseObjv(interp, objv138, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp140 = interp.getResult();
                        ExprValue tmp141 = evs0;
                        TJC.exprInitValue(interp, tmp141, tmp140);
                        boolean tmp142 = tmp141.getBooleanValue(interp);
                        if ( tmp142 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv143 = TJC.grabObjv(interp, 1);
                                TclObject tmp144;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_comment "- fallthrough"
                                        TclObject[] objv145 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: emitter_comment
                                            objv145[0] = const32;
                                            // Arg 1 constant: "- fallthrough"
                                            objv145[1] = const35;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                                ? cmdcache18.cmd : null), objv145, 0);
                                            if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                                updateCmdCache(interp, 18);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv145, 2);
                                        }
                                    } // End Invoke: emitter_comment
                                    tmp144 = interp.getResult();
                                    tmp144.preserve();
                                    objv143[0] = tmp144;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv143, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv143, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: set tuple [...]
                                TclObject tmp146;
                                { // Invoke: ... $key $bodyIndex
                                    TclObject[] objv147 = TJC.grabObjv(interp, 3);
                                    TclObject tmp148;
                                    try {
                                        // Arg 0 constant: ...
                                        objv147[0] = const15;
                                        // Arg 1 variable: $key
                                        tmp148 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp148.preserve();
                                        objv147[1] = tmp148;
                                        // Arg 2 variable: $bodyIndex
                                        tmp148 = getVarScalar(interp, "bodyIndex", compiledLocals, 25);
                                        tmp148.preserve();
                                        objv147[2] = tmp148;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv147, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp148 = objv147[1];
                                        if ( tmp148 != null ) {
                                            tmp148.release();
                                        }
                                        tmp148 = objv147[2];
                                        if ( tmp148 != null ) {
                                            tmp148.release();
                                        }
                                        TJC.releaseObjv(interp, objv147, 3);
                                    }
                                } // End Invoke: ...
                                tmp146 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp146, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: set body_type [...]
                                TclObject tmp149;
                                { // Invoke: lindex $tuple 0
                                    TclObject tmp150 = getVarScalar(interp, "tuple", compiledLocals, 11);
                                    tmp150 = TclList.index(interp, tmp150, 0);
                                    if ( tmp150 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp150);
                                    }
                                } // End Invoke: lindex
                                tmp149 = interp.getResult();
                                setVarScalar(interp, "body_type", tmp149, compiledLocals, 31);
                            } // End Invoke: set
                            { // Invoke: if ... ...
                                // Binary operator: $body_type != "constant"
                                TclObject tmp151 = getVarScalar(interp, "body_type", compiledLocals, 31);
                                boolean tmp152 = ! tmp151.toString().equals("constant");
                                ExprValue tmp153 = evs0;
                                tmp153.setIntValue(tmp152);
                                // End Binary operator: !=
                                boolean tmp154 = ( tmp153.getIntValue() != 0 );
                                if ( tmp154 ) {
                                    { // Invoke: error "..."
                                        TclObject[] objv155 = TJC.grabObjv(interp, 2);
                                        TclObject tmp156;
                                        try {
                                            // Arg 0 constant: error
                                            objv155[0] = const3;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp157 = new StringBuffer(64);
                                            sbtmp157.append("expected body to be constant type, got ");
                                            tmp156 = getVarScalar(interp, "body_type", compiledLocals, 31);
                                            sbtmp157.append(tmp156.toString());
                                            tmp156 = TclString.newInstance(sbtmp157);
                                            tmp156.preserve();
                                            objv155[1] = tmp156;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv155, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            tmp156 = objv155[1];
                                            if ( tmp156 != null ) {
                                                tmp156.release();
                                            }
                                            TJC.releaseObjv(interp, objv155, 2);
                                        }
                                    } // End Invoke: error
                                }
                            } // End Invoke: if
                            { // Invoke: set body_symbol [...]
                                TclObject tmp158;
                                { // Invoke: lindex $tuple 1
                                    TclObject tmp159 = getVarScalar(interp, "tuple", compiledLocals, 11);
                                    tmp159 = TclList.index(interp, tmp159, 1);
                                    if ( tmp159 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp159);
                                    }
                                } // End Invoke: lindex
                                tmp158 = interp.getResult();
                                setVarScalar(interp, "body_symbol", tmp158, compiledLocals, 32);
                            } // End Invoke: set
                            { // Invoke: set body_buffer [...]
                                TclObject tmp160;
                                { // Invoke: lindex $tuple 2
                                    TclObject tmp161 = getVarScalar(interp, "tuple", compiledLocals, 11);
                                    tmp161 = TclList.index(interp, tmp161, 2);
                                    if ( tmp161 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp161);
                                    }
                                } // End Invoke: lindex
                                tmp160 = interp.getResult();
                                setVarScalar(interp, "body_buffer", tmp160, compiledLocals, 33);
                            } // End Invoke: set
                            { // Invoke: append buffer $body_buffer [...]
                                TclObject[] objv162 = TJC.grabObjv(interp, 2);
                                TclObject tmp163;
                                try {
                                    // Arg 2 variable: $body_buffer
                                    tmp163 = getVarScalar(interp, "body_buffer", compiledLocals, 33);
                                    tmp163.preserve();
                                    objv162[0] = tmp163;
                                    // Arg 3 command: [...]
                                    { // Invoke: ... $array_tmpsymbol $i $tmpsymbol $body_symbol
                                        TclObject[] objv164 = TJC.grabObjv(interp, 5);
                                        TclObject tmp165;
                                        try {
                                            // Arg 0 constant: ...
                                            objv164[0] = const33;
                                            // Arg 1 variable: $array_tmpsymbol
                                            tmp165 = getVarScalar(interp, "array_tmpsymbol", compiledLocals, 19);
                                            tmp165.preserve();
                                            objv164[1] = tmp165;
                                            // Arg 2 variable: $i
                                            tmp165 = getVarScalar(interp, "i", compiledLocals, 23);
                                            tmp165.preserve();
                                            objv164[2] = tmp165;
                                            // Arg 3 variable: $tmpsymbol
                                            tmp165 = getVarScalar(interp, "tmpsymbol", compiledLocals, 21);
                                            tmp165.preserve();
                                            objv164[3] = tmp165;
                                            // Arg 4 variable: $body_symbol
                                            tmp165 = getVarScalar(interp, "body_symbol", compiledLocals, 32);
                                            tmp165.preserve();
                                            objv164[4] = tmp165;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                                ? cmdcache19.cmd : null), objv164, 0);
                                            if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                                updateCmdCache(interp, 19);
                                            }
                                        } finally {
                                            tmp165 = objv164[1];
                                            if ( tmp165 != null ) {
                                                tmp165.release();
                                            }
                                            tmp165 = objv164[2];
                                            if ( tmp165 != null ) {
                                                tmp165.release();
                                            }
                                            tmp165 = objv164[3];
                                            if ( tmp165 != null ) {
                                                tmp165.release();
                                            }
                                            tmp165 = objv164[4];
                                            if ( tmp165 != null ) {
                                                tmp165.release();
                                            }
                                            TJC.releaseObjv(interp, objv164, 5);
                                        }
                                    } // End Invoke: ...
                                    tmp163 = interp.getResult();
                                    tmp163.preserve();
                                    objv162[1] = tmp163;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv162, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv162, 2);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: incr i 1
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 23);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp108 != null ) {
                    tmp108.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer [...]
            TclObject[] objv166 = TJC.grabObjv(interp, 1);
            TclObject tmp167;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $offset_tmpsymbol $array_tmpsymbol 0 $size $string_tmpsymbol $switch_mode
                    TclObject[] objv168 = TJC.grabObjv(interp, 7);
                    TclObject tmp169;
                    try {
                        // Arg 0 constant: ...
                        objv168[0] = const36;
                        // Arg 1 variable: $offset_tmpsymbol
                        tmp169 = getVarScalar(interp, "offset_tmpsymbol", compiledLocals, 18);
                        tmp169.preserve();
                        objv168[1] = tmp169;
                        // Arg 2 variable: $array_tmpsymbol
                        tmp169 = getVarScalar(interp, "array_tmpsymbol", compiledLocals, 19);
                        tmp169.preserve();
                        objv168[2] = tmp169;
                        // Arg 3 constant: 0
                        objv168[3] = const8;
                        // Arg 4 variable: $size
                        tmp169 = getVarScalar(interp, "size", compiledLocals, 20);
                        tmp169.preserve();
                        objv168[4] = tmp169;
                        // Arg 5 variable: $string_tmpsymbol
                        tmp169 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 17);
                        tmp169.preserve();
                        objv168[5] = tmp169;
                        // Arg 6 variable: $switch_mode
                        tmp169 = getVarScalar(interp, "switch_mode", compiledLocals, 5);
                        tmp169.preserve();
                        objv168[6] = tmp169;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                            ? cmdcache21.cmd : null), objv168, 0);
                        if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                            updateCmdCache(interp, 21);
                        }
                    } finally {
                        objv168[0] = null;
                        objv168[3] = null;
                        TJC.releaseObjvElems(interp, objv168, 7);
                    }
                } // End Invoke: ...
                tmp167 = interp.getResult();
                tmp167.preserve();
                objv166[0] = tmp167;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv166, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv166, 1);
            }
        } // End Invoke: append
        { // Invoke: set offsets [...]
            TclObject tmp170;
            { // Invoke: list
                TclObject tmp171 = TclList.newInstance();
                interp.setResult(tmp171);
            } // End Invoke: list
            tmp170 = interp.getResult();
            setVarScalar(interp, "offsets", tmp170, compiledLocals, 34);
        } // End Invoke: set
        { // Invoke: foreach {patIndex bodyIndex} $pbIndexes ...
            TclObject tmp172 = null;
            try {
                tmp172 = getVarScalar(interp, "pbIndexes", compiledLocals, 7);
                tmp172.preserve();
                final int tmp172_length = TclList.getLength(interp, tmp172);

                for ( int index173 = 0 ; index173 < tmp172_length ; index173 += 2 ) {
                    TclObject tmp174 = null;
                    if ( index173 < tmp172_length ) {
                        tmp174 = TclList.index(interp, tmp172, index173);
                    }
                    TclObject tmp175 = null;
                    if ( index173 + 1 < tmp172_length ) {
                        tmp175 = TclList.index(interp, tmp172, index173 + 1);
                    }
                    try {
                        if ( tmp174 == null ) {
                            setVarScalar(interp, "patIndex", "", compiledLocals, 24);
                        } else {
                            setVarScalar(interp, "patIndex", tmp174, compiledLocals, 24);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "patIndex");
                    }
                    try {
                        if ( tmp175 == null ) {
                            setVarScalar(interp, "bodyIndex", "", compiledLocals, 25);
                        } else {
                            setVarScalar(interp, "bodyIndex", tmp175, compiledLocals, 25);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "bodyIndex");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ... else ...
                        { // Invoke: ... $key $bodyIndex
                            TclObject[] objv176 = TJC.grabObjv(interp, 3);
                            TclObject tmp177;
                            try {
                                // Arg 0 constant: ...
                                objv176[0] = const34;
                                // Arg 1 variable: $key
                                tmp177 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp177.preserve();
                                objv176[1] = tmp177;
                                // Arg 2 variable: $bodyIndex
                                tmp177 = getVarScalar(interp, "bodyIndex", compiledLocals, 25);
                                tmp177.preserve();
                                objv176[2] = tmp177;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                    ? cmdcache20.cmd : null), objv176, 0);
                                if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                    updateCmdCache(interp, 20);
                                }
                            } finally {
                                tmp177 = objv176[1];
                                if ( tmp177 != null ) {
                                    tmp177.release();
                                }
                                tmp177 = objv176[2];
                                if ( tmp177 != null ) {
                                    tmp177.release();
                                }
                                TJC.releaseObjv(interp, objv176, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp178 = interp.getResult();
                        ExprValue tmp179 = evs0;
                        TJC.exprInitValue(interp, tmp179, tmp178);
                        boolean tmp180 = tmp179.getBooleanValue(interp);
                        if ( tmp180 ) {
                            { // Invoke: lappend offsets ""
                                TclObject[] objv181 = TJC.grabObjv(interp, 1);
                                TclObject tmp182;
                                try {
                                    // Arg 2 constant: ""
                                    objv181[0] = const0;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "offsets", objv181, compiledLocals, 34);
                                } finally {
                                    TJC.releaseObjv(interp, objv181, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            { // Invoke: set offset [...]
                                TclObject tmp183;
                                { // Invoke: expr ...
                                    // Binary operator: $bodyIndex - $pbIndex
                                    TclObject tmp184 = getVarScalar(interp, "bodyIndex", compiledLocals, 25);
                                    ExprValue tmp185 = evs0;
                                    TJC.exprInitValue(interp, tmp185, tmp184);
                                    TclObject tmp186 = getVarScalar(interp, "pbIndex", compiledLocals, 8);
                                    ExprValue tmp187 = evs1;
                                    TJC.exprInitValue(interp, tmp187, tmp186);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp185, tmp187);
                                    // End Binary operator: -
                                    TJC.exprSetResult(interp, tmp185);
                                } // End Invoke: expr
                                tmp183 = interp.getResult();
                                setVarScalar(interp, "offset", tmp183, compiledLocals, 35);
                            } // End Invoke: set
                            { // Invoke: lappend offsets $offset
                                TclObject[] objv188 = TJC.grabObjv(interp, 1);
                                TclObject tmp189;
                                try {
                                    // Arg 2 variable: $offset
                                    tmp189 = getVarScalar(interp, "offset", compiledLocals, 35);
                                    tmp189.preserve();
                                    objv188[0] = tmp189;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "offsets", objv188, compiledLocals, 34);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv188, 1);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp172 != null ) {
                    tmp172.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $offsets
                TclObject tmp190 = getVarScalar(interp, "offsets", compiledLocals, 34);
                int tmp191 = TclList.getLength(interp, tmp190);
                interp.setResult(tmp191);
            } // End Invoke: llength
            TclObject tmp192 = interp.getResult();
            ExprValue tmp193 = evs0;
            TJC.exprInitValue(interp, tmp193, tmp192);
            ExprValue tmp194 = evs1;
            tmp194.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp193, tmp194);
            // End Binary operator: ==
            boolean tmp195 = ( tmp193.getIntValue() != 0 );
            if ( tmp195 ) {
                { // Invoke: error "empty offsets list"
                    TclObject[] objv196 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv196[0] = const3;
                        // Arg 1 constant: "empty offsets list"
                        objv196[1] = const37;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv196, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv196, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] [...] [...] ...
            TclObject[] objv197 = TJC.grabObjv(interp, 4);
            TclObject tmp198;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_reset_result
                    TclObject[] objv199 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_reset_result
                        objv199[0] = const38;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache22_cmdEpoch == cmdcache22.cmdEpoch)
                            ? cmdcache22.cmd : null), objv199, 0);
                        if ( cmdcache22_cmdEpoch != cmdcache22.cmdEpoch ) {
                            updateCmdCache(interp, 22);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv199, 1);
                    }
                } // End Invoke: emitter_reset_result
                tmp198 = interp.getResult();
                tmp198.preserve();
                objv197[0] = tmp198;
                // Arg 3 command: [...]
                { // Invoke: ... "..."
                    TclObject[] objv200 = TJC.grabObjv(interp, 2);
                    TclObject tmp201;
                    try {
                        // Arg 0 constant: ...
                        objv200[0] = const39;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp202 = new StringBuffer(64);
                        tmp201 = getVarScalar(interp, "offset_tmpsymbol", compiledLocals, 18);
                        sbtmp202.append(tmp201.toString());
                        sbtmp202.append(" == -1");
                        tmp201 = TclString.newInstance(sbtmp202);
                        tmp201.preserve();
                        objv200[1] = tmp201;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache23_cmdEpoch == cmdcache23.cmdEpoch)
                            ? cmdcache23.cmd : null), objv200, 0);
                        if ( cmdcache23_cmdEpoch != cmdcache23.cmdEpoch ) {
                            updateCmdCache(interp, 23);
                        }
                    } finally {
                        tmp201 = objv200[1];
                        if ( tmp201 != null ) {
                            tmp201.release();
                        }
                        TJC.releaseObjv(interp, objv200, 2);
                    }
                } // End Invoke: ...
                tmp198 = interp.getResult();
                tmp198.preserve();
                objv197[1] = tmp198;
                // Arg 4 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv203 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv203[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv203, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv203, 1);
                    }
                } // End Invoke: emitter_indent
                tmp198 = interp.getResult();
                tmp198.preserve();
                objv197[2] = tmp198;
                // Arg 5 constant: ...
                objv197[3] = const40;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv197, compiledLocals, 1);
            } finally {
                tmp198 = objv197[0];
                if ( tmp198 != null ) {
                    tmp198.release();
                }
                tmp198 = objv197[1];
                if ( tmp198 != null ) {
                    tmp198.release();
                }
                tmp198 = objv197[2];
                if ( tmp198 != null ) {
                    tmp198.release();
                }
                TJC.releaseObjv(interp, objv197, 4);
            }
        } // End Invoke: append
        { // Invoke: for {set i 0} ... {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const8, compiledLocals, 23);
            } // End Invoke: set
            for ( boolean skip211 = true ; true ; ) {
                if ( skip211 ) {
                    skip211 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 23);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < [...]
                TclObject tmp204 = getVarScalar(interp, "i", compiledLocals, 23);
                ExprValue tmp205 = evs0;
                TJC.exprInitValue(interp, tmp205, tmp204);
                { // Invoke: llength $offsets
                    TclObject tmp206 = getVarScalar(interp, "offsets", compiledLocals, 34);
                    int tmp207 = TclList.getLength(interp, tmp206);
                    interp.setResult(tmp207);
                } // End Invoke: llength
                TclObject tmp208 = interp.getResult();
                ExprValue tmp209 = evs1;
                TJC.exprInitValue(interp, tmp209, tmp208);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp205, tmp209);
                // End Binary operator: <
                boolean tmp210 = ( tmp205.getIntValue() != 0 );
                if ( ! tmp210 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set offset [...]
                    TclObject tmp212;
                    { // Invoke: lindex $offsets $i
                        TclObject tmp213 = null;
                        TclObject tmp214;
                        try {
                            tmp213 = getVarScalar(interp, "offsets", compiledLocals, 34);
                            tmp213.preserve();
                            tmp214 = getVarScalar(interp, "i", compiledLocals, 23);
                            TJC.lindexNonconst(interp, tmp213, tmp214);
                        } finally {
                            if ( tmp213 != null ) {
                                tmp213.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp212 = interp.getResult();
                    setVarScalar(interp, "offset", tmp212, compiledLocals, 35);
                } // End Invoke: set
                { // Invoke: if {$offset == ""} ...
                    // Binary operator: $offset == ""
                    TclObject tmp215 = getVarScalar(interp, "offset", compiledLocals, 35);
                    ExprValue tmp216 = evs0;
                    TJC.exprEqualsEmptyString(tmp216, tmp215, false);
                    // End Binary operator: ==
                    boolean tmp217 = ( tmp216.getIntValue() != 0 );
                    if ( tmp217 ) {
                        { // Invoke: continue
                            if ( true ) { continue; }
                        } // End Invoke: continue
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv218 = TJC.grabObjv(interp, 1);
                    TclObject tmp219;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... "..."
                            TclObject[] objv220 = TJC.grabObjv(interp, 2);
                            TclObject tmp221;
                            try {
                                // Arg 0 constant: ...
                                objv220[0] = const41;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp222 = new StringBuffer(64);
                                tmp221 = getVarScalar(interp, "offset_tmpsymbol", compiledLocals, 18);
                                sbtmp222.append(tmp221.toString());
                                sbtmp222.append(" == ");
                                tmp221 = getVarScalar(interp, "offset", compiledLocals, 35);
                                sbtmp222.append(tmp221.toString());
                                tmp221 = TclString.newInstance(sbtmp222);
                                tmp221.preserve();
                                objv220[1] = tmp221;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache24_cmdEpoch == cmdcache24.cmdEpoch)
                                    ? cmdcache24.cmd : null), objv220, 0);
                                if ( cmdcache24_cmdEpoch != cmdcache24.cmdEpoch ) {
                                    updateCmdCache(interp, 24);
                                }
                            } finally {
                                tmp221 = objv220[1];
                                if ( tmp221 != null ) {
                                    tmp221.release();
                                }
                                TJC.releaseObjv(interp, objv220, 2);
                            }
                        } // End Invoke: ...
                        tmp219 = interp.getResult();
                        tmp219.preserve();
                        objv218[0] = tmp219;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv218, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv218, 1);
                    }
                } // End Invoke: append
                { // Invoke: set pattern_comment [...]
                    TclObject tmp223;
                    { // Invoke: lindex $pattern_comments $i
                        TclObject tmp224 = null;
                        TclObject tmp225;
                        try {
                            tmp224 = getVarScalar(interp, "pattern_comments", compiledLocals, 22);
                            tmp224.preserve();
                            tmp225 = getVarScalar(interp, "i", compiledLocals, 23);
                            TJC.lindexNonconst(interp, tmp224, tmp225);
                        } finally {
                            if ( tmp224 != null ) {
                                tmp224.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp223 = interp.getResult();
                    setVarScalar(interp, "pattern_comment", tmp223, compiledLocals, 36);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $pattern_comment != ""
                    TclObject tmp226 = getVarScalar(interp, "pattern_comment", compiledLocals, 36);
                    ExprValue tmp227 = evs0;
                    TJC.exprEqualsEmptyString(tmp227, tmp226, true);
                    // End Binary operator: !=
                    boolean tmp228 = ( tmp227.getIntValue() != 0 );
                    if ( tmp228 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv229 = TJC.grabObjv(interp, 1);
                            TclObject tmp230;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_comment $pattern_comment
                                    TclObject[] objv231 = TJC.grabObjv(interp, 2);
                                    TclObject tmp232;
                                    try {
                                        // Arg 0 constant: emitter_comment
                                        objv231[0] = const32;
                                        // Arg 1 variable: $pattern_comment
                                        tmp232 = getVarScalar(interp, "pattern_comment", compiledLocals, 36);
                                        tmp232.preserve();
                                        objv231[1] = tmp232;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                            ? cmdcache18.cmd : null), objv231, 0);
                                        if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                            updateCmdCache(interp, 18);
                                        }
                                    } finally {
                                        tmp232 = objv231[1];
                                        if ( tmp232 != null ) {
                                            tmp232.release();
                                        }
                                        TJC.releaseObjv(interp, objv231, 2);
                                    }
                                } // End Invoke: emitter_comment
                                tmp230 = interp.getResult();
                                tmp230.preserve();
                                objv229[0] = tmp230;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv229, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv229, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: foreach body_key [...] ...
                    TclObject tmp233 = null;
                    try {
                        { // Invoke: lindex $body_keys $i
                            TclObject tmp234 = null;
                            TclObject tmp235;
                            try {
                                tmp234 = getVarScalar(interp, "body_keys", compiledLocals, 6);
                                tmp234.preserve();
                                tmp235 = getVarScalar(interp, "i", compiledLocals, 23);
                                TJC.lindexNonconst(interp, tmp234, tmp235);
                            } finally {
                                if ( tmp234 != null ) {
                                    tmp234.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp233 = interp.getResult();
                        tmp233.preserve();
                        final int tmp233_length = TclList.getLength(interp, tmp233);

                        for ( int index236 = 0 ; index236 < tmp233_length ; index236++ ) {
                            TclObject tmp237 = TclList.index(interp, tmp233, index236);
                            try {
                                setVarScalar(interp, "body_key", tmp237, compiledLocals, 37);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv238 = TJC.grabObjv(interp, 1);
                                TclObject tmp239;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $body_key
                                        TclObject[] objv240 = TJC.grabObjv(interp, 2);
                                        TclObject tmp241;
                                        try {
                                            // Arg 0 constant: ...
                                            objv240[0] = const42;
                                            // Arg 1 variable: $body_key
                                            tmp241 = getVarScalar(interp, "body_key", compiledLocals, 37);
                                            tmp241.preserve();
                                            objv240[1] = tmp241;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache25_cmdEpoch == cmdcache25.cmdEpoch)
                                                ? cmdcache25.cmd : null), objv240, 0);
                                            if ( cmdcache25_cmdEpoch != cmdcache25.cmdEpoch ) {
                                                updateCmdCache(interp, 25);
                                            }
                                        } finally {
                                            tmp241 = objv240[1];
                                            if ( tmp241 != null ) {
                                                tmp241.release();
                                            }
                                            TJC.releaseObjv(interp, objv240, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp239 = interp.getResult();
                                    tmp239.preserve();
                                    objv238[0] = tmp239;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv238, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv238, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp233 != null ) {
                            tmp233.release();
                        }
                    }
                } // End Invoke: foreach
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...] [...] ...
            TclObject[] objv242 = TJC.grabObjv(interp, 3);
            TclObject tmp243;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv244 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv244[0] = const43;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache26_cmdEpoch == cmdcache26.cmdEpoch)
                            ? cmdcache26.cmd : null), objv244, 0);
                        if ( cmdcache26_cmdEpoch != cmdcache26.cmdEpoch ) {
                            updateCmdCache(interp, 26);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv244, 1);
                    }
                } // End Invoke: ...
                tmp243 = interp.getResult();
                tmp243.preserve();
                objv242[0] = tmp243;
                // Arg 3 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv245 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv245[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv245, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv245, 1);
                    }
                } // End Invoke: emitter_indent
                tmp243 = interp.getResult();
                tmp243.preserve();
                objv242[1] = tmp243;
                // Arg 4 constant: ...
                objv242[2] = const44;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv242, compiledLocals, 1);
            } finally {
                tmp243 = objv242[0];
                if ( tmp243 != null ) {
                    tmp243.release();
                }
                tmp243 = objv242[1];
                if ( tmp243 != null ) {
                    tmp243.release();
                }
                TJC.releaseObjv(interp, objv242, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv246 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv246[0] = const45;
                // Arg 1 constant: +1
                objv246[1] = const46;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache27_cmdEpoch == cmdcache27.cmdEpoch)
                    ? cmdcache27.cmd : null), objv246, 0);
                if ( cmdcache27_cmdEpoch != cmdcache27.cmdEpoch ) {
                    updateCmdCache(interp, 27);
                }
            } finally {
                TJC.releaseObjv(interp, objv246, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...]
            TclObject[] objv247 = TJC.grabObjv(interp, 1);
            TclObject tmp248;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv249 = TJC.grabObjv(interp, 2);
                    TclObject tmp250;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv249[0] = const47;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp251 = new StringBuffer(64);
                        sbtmp251.append("String.valueOf(");
                        tmp250 = getVarScalar(interp, "offset_tmpsymbol", compiledLocals, 18);
                        sbtmp251.append(tmp250.toString());
                        sbtmp251.append("))");
                        tmp250 = TclString.newInstance(sbtmp251);
                        tmp250.preserve();
                        objv249[1] = tmp250;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache28_cmdEpoch == cmdcache28.cmdEpoch)
                            ? cmdcache28.cmd : null), objv249, 0);
                        if ( cmdcache28_cmdEpoch != cmdcache28.cmdEpoch ) {
                            updateCmdCache(interp, 28);
                        }
                    } finally {
                        tmp250 = objv249[1];
                        if ( tmp250 != null ) {
                            tmp250.release();
                        }
                        TJC.releaseObjv(interp, objv249, 2);
                    }
                } // End Invoke: emitter_statement
                tmp248 = interp.getResult();
                tmp248.preserve();
                objv247[0] = tmp248;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv247, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv247, 1);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv252 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv252[0] = const45;
                // Arg 1 constant: -1
                objv252[1] = const48;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache27_cmdEpoch == cmdcache27.cmdEpoch)
                    ? cmdcache27.cmd : null), objv252, 0);
                if ( cmdcache27_cmdEpoch != cmdcache27.cmdEpoch ) {
                    updateCmdCache(interp, 27);
                }
            } finally {
                TJC.releaseObjv(interp, objv252, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...]
            TclObject[] objv253 = TJC.grabObjv(interp, 1);
            TclObject tmp254;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv255 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv255[0] = const49;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache29_cmdEpoch == cmdcache29.cmdEpoch)
                            ? cmdcache29.cmd : null), objv255, 0);
                        if ( cmdcache29_cmdEpoch != cmdcache29.cmdEpoch ) {
                            updateCmdCache(interp, 29);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv255, 1);
                    }
                } // End Invoke: ...
                tmp254 = interp.getResult();
                tmp254.preserve();
                objv253[0] = tmp254;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv253, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv253, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp256 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp256);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_switch");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;
    TclObject const43;
    TclObject const44;
    TclObject const45;
    TclObject const46;
    TclObject const47;
    TclObject const48;
    TclObject const49;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lsearch");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("-exact");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("switch_no_constant_strings");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_switch_mode");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_commands");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("container");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_container_switch_patbody_indexes");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_get_argument_tuple");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("descend_container_switch_string");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_emit_argument");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_tmpvar_next");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("emitter_indent");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("String ");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance(" = ");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance(".toString();\n");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("descend_container_switch_has_last");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("TJC.switchStringIsNotOption(interp, ");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance(");\n");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("compileproc_emit_container_switch_constant");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("int ");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance(";\n");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("objv");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_container_switch_start");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("emitter_container_try_start");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("TclObject ");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("compileproc_argument_printable");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("emitter_comment");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("emitter_container_switch_assign");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("descend_container_switch_is_fallthrough");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("- fallthrough");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("emitter_container_switch_invoke");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("empty offsets list");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("emitter_reset_result");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("emitter_container_if_start");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("// No match\n");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("emitter_container_if_else_if");
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance("compileproc_emit_invoke");
        const42.preserve(); const42.preserve();
        const43 = TclString.newInstance("emitter_container_if_else");
        const43.preserve(); const43.preserve();
        const44 = TclString.newInstance("throw new TclRuntimeError(\"bad switch body offset \" +\n");
        const44.preserve(); const44.preserve();
        const45 = TclString.newInstance("emitter_indent_level");
        const45.preserve(); const45.preserve();
        const46 = TclString.newInstance("+1");
        TclInteger.get(interp, const46);
        const46.preserve(); const46.preserve();
        const47 = TclString.newInstance("emitter_statement");
        const47.preserve(); const47.preserve();
        const48 = TclInteger.newInstance(-1);
        const48.preserve(); const48.preserve();
        const49 = TclString.newInstance("emitter_container_if_end");
        const49.preserve(); const49.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;
    WrappedCommand cmdcache22;
    int cmdcache22_cmdEpoch;
    WrappedCommand cmdcache23;
    int cmdcache23_cmdEpoch;
    WrappedCommand cmdcache24;
    int cmdcache24_cmdEpoch;
    WrappedCommand cmdcache25;
    int cmdcache25_cmdEpoch;
    WrappedCommand cmdcache26;
    int cmdcache26_cmdEpoch;
    WrappedCommand cmdcache27;
    int cmdcache27_cmdEpoch;
    WrappedCommand cmdcache28;
    int cmdcache28_cmdEpoch;
    WrappedCommand cmdcache29;
    int cmdcache29_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                cmdcache22 = TJC.INVALID_COMMAND_CACHE;
                cmdcache22_cmdEpoch = 0;
                cmdcache23 = TJC.INVALID_COMMAND_CACHE;
                cmdcache23_cmdEpoch = 0;
                cmdcache24 = TJC.INVALID_COMMAND_CACHE;
                cmdcache24_cmdEpoch = 0;
                cmdcache25 = TJC.INVALID_COMMAND_CACHE;
                cmdcache25_cmdEpoch = 0;
                cmdcache26 = TJC.INVALID_COMMAND_CACHE;
                cmdcache26_cmdEpoch = 0;
                cmdcache27 = TJC.INVALID_COMMAND_CACHE;
                cmdcache27_cmdEpoch = 0;
                cmdcache28 = TJC.INVALID_COMMAND_CACHE;
                cmdcache28_cmdEpoch = 0;
                cmdcache29 = TJC.INVALID_COMMAND_CACHE;
                cmdcache29_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "lsearch";
                break;
            }
            case 5: {
                cmdName = "descend_container_switch_mode";
                break;
            }
            case 6: {
                cmdName = "descend_commands";
                break;
            }
            case 7: {
                cmdName = "descend_container_switch_patbody_indexes";
                break;
            }
            case 8: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 9: {
                cmdName = "descend_container_switch_string";
                break;
            }
            case 10: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 11: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 12: {
                cmdName = "emitter_indent";
                break;
            }
            case 13: {
                cmdName = "descend_container_switch_has_last";
                break;
            }
            case 14: {
                cmdName = "compileproc_emit_container_switch_constant";
                break;
            }
            case 15: {
                cmdName = "emitter_container_switch_start";
                break;
            }
            case 16: {
                cmdName = "emitter_container_try_start";
                break;
            }
            case 17: {
                cmdName = "compileproc_argument_printable";
                break;
            }
            case 18: {
                cmdName = "emitter_comment";
                break;
            }
            case 19: {
                cmdName = "emitter_container_switch_assign";
                break;
            }
            case 20: {
                cmdName = "descend_container_switch_is_fallthrough";
                break;
            }
            case 21: {
                cmdName = "emitter_container_switch_invoke";
                break;
            }
            case 22: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 23: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 24: {
                cmdName = "emitter_container_if_else_if";
                break;
            }
            case 25: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 26: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 27: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 28: {
                cmdName = "emitter_statement";
                break;
            }
            case 29: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
            case 22: {
                cmdcache22 = lwcmd;
                cmdcache22_cmdEpoch = cmdEpoch;
                break;
            }
            case 23: {
                cmdcache23 = lwcmd;
                cmdcache23_cmdEpoch = cmdEpoch;
                break;
            }
            case 24: {
                cmdcache24 = lwcmd;
                cmdcache24_cmdEpoch = cmdEpoch;
                break;
            }
            case 25: {
                cmdcache25 = lwcmd;
                cmdcache25_cmdEpoch = cmdEpoch;
                break;
            }
            case 26: {
                cmdcache26 = lwcmd;
                cmdcache26_cmdEpoch = cmdEpoch;
                break;
            }
            case 27: {
                cmdcache27 = lwcmd;
                cmdcache27_cmdEpoch = cmdEpoch;
                break;
            }
            case 28: {
                cmdcache28 = lwcmd;
                cmdcache28_cmdEpoch = cmdEpoch;
                break;
            }
            case 29: {
                cmdcache29 = lwcmd;
                cmdcache29_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "buffer",
        "inline_constant_strings",
        "_compileproc",
        "ind",
        "switch_mode",
        "body_keys",
        "pbIndexes",
        "pbIndex",
        "pIndex",
        "bIndex",
        "tuple",
        "type",
        "sIndex",
        "str_type",
        "str_symbol",
        "str_buffer",
        "string_tmpsymbol",
        "offset_tmpsymbol",
        "array_tmpsymbol",
        "size",
        "tmpsymbol",
        "pattern_comments",
        "i",
        "patIndex",
        "bodyIndex",
        "str",
        "comment",
        "pat_type",
        "pat_symbol",
        "pat_buffer",
        "body_type",
        "body_symbol",
        "body_buffer",
        "offsets",
        "offset",
        "pattern_comment",
        "body_key"
    };
} // end class CompileprocEmitContainerSwitchCmd

