// TJC implementation of procedure compileproc_expr_evaluate_callback
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 19, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script etree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "etree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 5);
        } // End Invoke: global
        { // Invoke: switch -exact -- $type {literal operand} ... {command operand} ... {variable operand} ... {word operand} ... {unary operator} ... {binary operator} ... {ternary operator} ... {math function} ... {subexpression} ... {value} ... default ...
            TclObject tmp0 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( tmp1_length == 15 && tmp1_first == 'l'
                    && tmp1.compareTo("literal operand") == 0 ) {
                // Pattern {literal operand}
                { // Invoke: set type [...]
                    TclObject tmp2;
                    { // Invoke: lindex $values 0 0
                        TclObject[] objv3 = TJC.grabObjv(interp, 4);
                        TclObject tmp4;
                        try {
                            // Arg 0 constant: lindex
                            objv3[0] = const0;
                            // Arg 1 variable: $values
                            tmp4 = getVarScalar(interp, "values", compiledLocals, 3);
                            tmp4.preserve();
                            objv3[1] = tmp4;
                            // Arg 2 constant: 0
                            objv3[2] = const1;
                            // Arg 3 constant: 0
                            objv3[3] = const1;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp4 = objv3[1];
                            if ( tmp4 != null ) {
                                tmp4.release();
                            }
                            TJC.releaseObjv(interp, objv3, 4);
                        }
                    } // End Invoke: lindex
                    tmp2 = interp.getResult();
                    setVarScalar(interp, "type", tmp2, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set literal [...]
                    TclObject tmp5;
                    { // Invoke: lindex $values 0 1
                        TclObject[] objv6 = TJC.grabObjv(interp, 4);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: lindex
                            objv6[0] = const0;
                            // Arg 1 variable: $values
                            tmp7 = getVarScalar(interp, "values", compiledLocals, 3);
                            tmp7.preserve();
                            objv6[1] = tmp7;
                            // Arg 2 constant: 0
                            objv6[2] = const1;
                            // Arg 3 constant: 1
                            objv6[3] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv6, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp7 = objv6[1];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 4);
                        }
                    } // End Invoke: lindex
                    tmp5 = interp.getResult();
                    setVarScalar(interp, "literal", tmp5, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if {$type == {text}} ... elseif {$type == {string}} ... elseif ... ... else ...
                    // Binary operator: $type == "text"
                    TclObject tmp8 = getVarScalar(interp, "type", compiledLocals, 2);
                    boolean tmp9 = tmp8.toString().equals("text");
                    ExprValue tmp10 = evs0;
                    tmp10.setIntValue(tmp9);
                    // End Binary operator: ==
                    boolean tmp11 = ( tmp10.getIntValue() != 0 );
                    if ( tmp11 ) {
                        { // Invoke: ... constant $literal
                            TclObject[] objv12 = TJC.grabObjv(interp, 3);
                            TclObject tmp13;
                            try {
                                // Arg 0 constant: ...
                                objv12[0] = const3;
                                // Arg 1 constant: constant
                                objv12[1] = const4;
                                // Arg 2 variable: $literal
                                tmp13 = getVarScalar(interp, "literal", compiledLocals, 6);
                                tmp13.preserve();
                                objv12[2] = tmp13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv12, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp13 = objv12[2];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                TJC.releaseObjv(interp, objv12, 3);
                            }
                        } // End Invoke: ...
                    } else {
                        // Binary operator: $type == "string"
                        TclObject tmp14 = getVarScalar(interp, "type", compiledLocals, 2);
                        boolean tmp15 = tmp14.toString().equals("string");
                        ExprValue tmp16 = evs0;
                        tmp16.setIntValue(tmp15);
                        // End Binary operator: ==
                        boolean tmp17 = ( tmp16.getIntValue() != 0 );
                        if ( tmp17 ) {
                            { // Invoke: ... {constant string} $literal
                                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                                TclObject tmp19;
                                try {
                                    // Arg 0 constant: ...
                                    objv18[0] = const3;
                                    // Arg 1 constant: {constant string}
                                    objv18[1] = const5;
                                    // Arg 2 variable: $literal
                                    tmp19 = getVarScalar(interp, "literal", compiledLocals, 6);
                                    tmp19.preserve();
                                    objv18[2] = tmp19;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv18, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp19 = objv18[2];
                                    if ( tmp19 != null ) {
                                        tmp19.release();
                                    }
                                    TJC.releaseObjv(interp, objv18, 3);
                                }
                            } // End Invoke: ...
                        } else {
                            // Binary operator: $type == "braced string"
                            TclObject tmp20 = getVarScalar(interp, "type", compiledLocals, 2);
                            boolean tmp21 = tmp20.toString().equals("braced string");
                            ExprValue tmp22 = evs0;
                            tmp22.setIntValue(tmp21);
                            // End Binary operator: ==
                            boolean tmp23 = ( tmp22.getIntValue() != 0 );
                            if ( tmp23 ) {
                                { // Invoke: if ... ...
                                    // Binary operator: [...] != ()
                                    { // Invoke: string first ... $literal
                                        char tmp24 = '\\';
                                        TclObject tmp25 = getVarScalar(interp, "literal", compiledLocals, 6);
                                        String tmp26 = tmp25.toString();
                                        int tmp27 = tmp26.indexOf(tmp24);
                                        interp.setResult(tmp27);
                                    } // End Invoke: string
                                    TclObject tmp28 = interp.getResult();
                                    ExprValue tmp29 = evs0;
                                    TJC.exprInitValue(interp, tmp29, tmp28);
                                    // Unary operator: - 1
                                    ExprValue tmp30 = evs1;
                                    tmp30.setIntValue(-1);
                                    // End Unary operator: -
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp29, tmp30);
                                    // End Binary operator: !=
                                    boolean tmp31 = ( tmp29.getIntValue() != 0 );
                                    if ( tmp31 ) {
                                        { // Invoke: set dbs_str ""
                                            setVarScalar(interp, "dbs_str", const6, compiledLocals, 7);
                                        } // End Invoke: set
                                        { // Invoke: set len [...]
                                            TclObject tmp32;
                                            { // Invoke: string length $literal
                                                TclObject tmp33 = getVarScalar(interp, "literal", compiledLocals, 6);
                                                int tmp34 = tmp33.toString().length();
                                                interp.setResult(tmp34);
                                            } // End Invoke: string
                                            tmp32 = interp.getResult();
                                            setVarScalar(interp, "len", tmp32, compiledLocals, 8);
                                        } // End Invoke: set
                                        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
                                            { // Invoke: set i 0
                                                setVarScalar(interp, "i", const1, compiledLocals, 9);
                                            } // End Invoke: set
                                            for ( boolean skip40 = true ; true ; ) {
                                                if ( skip40 ) {
                                                    skip40 = false;
                                                } else {
                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: incr i
                                                        interp.resetResult();
                                                        incrVarScalar(interp, "i", 1, compiledLocals, 9);
                                                    } // End Invoke: incr
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }

                                                // Binary operator: $i < $len
                                                TclObject tmp35 = getVarScalar(interp, "i", compiledLocals, 9);
                                                ExprValue tmp36 = evs0;
                                                TJC.exprInitValue(interp, tmp36, tmp35);
                                                TclObject tmp37 = getVarScalar(interp, "len", compiledLocals, 8);
                                                ExprValue tmp38 = evs1;
                                                TJC.exprInitValue(interp, tmp38, tmp37);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp36, tmp38);
                                                // End Binary operator: <
                                                boolean tmp39 = ( tmp36.getIntValue() != 0 );
                                                if ( ! tmp39 ) { break; }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: set c [...]
                                                    TclObject tmp41;
                                                    { // Invoke: string index $literal $i
                                                        TclObject tmp42 = getVarScalar(interp, "literal", compiledLocals, 6);
                                                        String tmp43 = tmp42.toString();
                                                        TclObject tmp44 = getVarScalar(interp, "i", compiledLocals, 9);
                                                        TclObject tmp45 = TJC.stringIndex(interp, tmp43, tmp44);
                                                        interp.setResult(tmp45);
                                                    } // End Invoke: string
                                                    tmp41 = interp.getResult();
                                                    setVarScalar(interp, "c", tmp41, compiledLocals, 10);
                                                } // End Invoke: set
                                                { // Invoke: if ... ... else ...
                                                    // Binary operator: $c == "\\"
                                                    TclObject tmp46 = getVarScalar(interp, "c", compiledLocals, 10);
                                                    boolean tmp47 = tmp46.toString().equals("\\");
                                                    ExprValue tmp48 = evs0;
                                                    tmp48.setIntValue(tmp47);
                                                    // End Binary operator: ==
                                                    boolean tmp49 = ( tmp48.getIntValue() != 0 );
                                                    if ( tmp49 ) {
                                                        { // Invoke: append dbs_str ...
                                                            TclObject[] objv50 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp51;
                                                            try {
                                                                // Arg 2 constant: ...
                                                                objv50[0] = const7;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "dbs_str", objv50, compiledLocals, 7);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv50, 1);
                                                            }
                                                        } // End Invoke: append
                                                    } else {
                                                        { // Invoke: append dbs_str $c
                                                            TclObject[] objv52 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp53;
                                                            try {
                                                                // Arg 2 variable: $c
                                                                tmp53 = getVarScalar(interp, "c", compiledLocals, 10);
                                                                tmp53.preserve();
                                                                objv52[0] = tmp53;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "dbs_str", objv52, compiledLocals, 7);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv52, 1);
                                                            }
                                                        } // End Invoke: append
                                                    }
                                                } // End Invoke: if
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } // End Invoke: for
                                        { // Invoke: set literal $dbs_str
                                            TclObject tmp54;
                                            tmp54 = getVarScalar(interp, "dbs_str", compiledLocals, 7);
                                            setVarScalar(interp, "literal", tmp54, compiledLocals, 6);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: ... ... $literal
                                    TclObject[] objv55 = TJC.grabObjv(interp, 3);
                                    TclObject tmp56;
                                    try {
                                        // Arg 0 constant: ...
                                        objv55[0] = const3;
                                        // Arg 1 constant: ...
                                        objv55[1] = const8;
                                        // Arg 2 variable: $literal
                                        tmp56 = getVarScalar(interp, "literal", compiledLocals, 6);
                                        tmp56.preserve();
                                        objv55[2] = tmp56;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv55, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp56 = objv55[2];
                                        if ( tmp56 != null ) {
                                            tmp56.release();
                                        }
                                        TJC.releaseObjv(interp, objv55, 3);
                                    }
                                } // End Invoke: ...
                            } else {
                                { // Invoke: error "..."
                                    TclObject[] objv57 = TJC.grabObjv(interp, 2);
                                    TclObject tmp58;
                                    try {
                                        // Arg 0 constant: error
                                        objv57[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp59 = new StringBuffer(64);
                                        sbtmp59.append("unhandled literal operand type ");
                                        sbtmp59.append("\"");
                                        tmp58 = getVarScalar(interp, "type", compiledLocals, 2);
                                        sbtmp59.append(tmp58.toString());
                                        sbtmp59.append("\"");
                                        tmp58 = TclString.newInstance(sbtmp59);
                                        tmp58.preserve();
                                        objv57[1] = tmp58;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv57, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp58 = objv57[1];
                                        if ( tmp58 != null ) {
                                            tmp58.release();
                                        }
                                        TJC.releaseObjv(interp, objv57, 2);
                                    }
                                } // End Invoke: error
                            }
                        }
                    }
                } // End Invoke: if
            } else if ( tmp1_length == 15 && tmp1_first == 'c'
                    && tmp1.compareTo("command operand") == 0 ) {
                // Pattern {command operand}
                { // Invoke: set key $...
                    TclObject tmp60;
                    tmp60 = getVarArray(interp, "_compileproc", "expr_eval_key", compiledLocals, 5);
                    setVarScalar(interp, "key", tmp60, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set ccmds [...]
                    TclObject tmp61;
                    { // Invoke: ... $key
                        TclObject[] objv62 = TJC.grabObjv(interp, 2);
                        TclObject tmp63;
                        try {
                            // Arg 0 constant: ...
                            objv62[0] = const10;
                            // Arg 1 variable: $key
                            tmp63 = getVarScalar(interp, "key", compiledLocals, 11);
                            tmp63.preserve();
                            objv62[1] = tmp63;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv62, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp63 = objv62[1];
                            if ( tmp63 != null ) {
                                tmp63.release();
                            }
                            TJC.releaseObjv(interp, objv62, 2);
                        }
                    } // End Invoke: ...
                    tmp61 = interp.getResult();
                    setVarScalar(interp, "ccmds", tmp61, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: ... {command operand} $ccmds
                    TclObject[] objv64 = TJC.grabObjv(interp, 3);
                    TclObject tmp65;
                    try {
                        // Arg 0 constant: ...
                        objv64[0] = const3;
                        // Arg 1 constant: {command operand}
                        objv64[1] = const11;
                        // Arg 2 variable: $ccmds
                        tmp65 = getVarScalar(interp, "ccmds", compiledLocals, 12);
                        tmp65.preserve();
                        objv64[2] = tmp65;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv64, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp65 = objv64[2];
                        if ( tmp65 != null ) {
                            tmp65.release();
                        }
                        TJC.releaseObjv(interp, objv64, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 16 && tmp1_first == 'v'
                    && tmp1.compareTo("variable operand") == 0 ) {
                // Pattern {variable operand}
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $etree
                        TclObject[] objv66 = TJC.grabObjv(interp, 2);
                        TclObject tmp67;
                        try {
                            // Arg 0 constant: ...
                            objv66[0] = const12;
                            // Arg 1 variable: $etree
                            tmp67 = getVarScalar(interp, "etree", compiledLocals, 1);
                            tmp67.preserve();
                            objv66[1] = tmp67;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv66, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp67 = objv66[1];
                            if ( tmp67 != null ) {
                                tmp67.release();
                            }
                            TJC.releaseObjv(interp, objv66, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp68 = interp.getResult();
                    ExprValue tmp69 = evs0;
                    TJC.exprInitValue(interp, tmp69, tmp68);
                    boolean tmp70 = tmp69.getBooleanValue(interp);
                    if ( tmp70 ) {
                        { // Invoke: set scalar [...]
                            TclObject tmp71;
                            { // Invoke: ... $script $etree
                                TclObject[] objv72 = TJC.grabObjv(interp, 3);
                                TclObject tmp73;
                                try {
                                    // Arg 0 constant: ...
                                    objv72[0] = const13;
                                    // Arg 1 variable: $script
                                    tmp73 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp73.preserve();
                                    objv72[1] = tmp73;
                                    // Arg 2 variable: $etree
                                    tmp73 = getVarScalar(interp, "etree", compiledLocals, 1);
                                    tmp73.preserve();
                                    objv72[2] = tmp73;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv72, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp73 = objv72[1];
                                    if ( tmp73 != null ) {
                                        tmp73.release();
                                    }
                                    tmp73 = objv72[2];
                                    if ( tmp73 != null ) {
                                        tmp73.release();
                                    }
                                    TJC.releaseObjv(interp, objv72, 3);
                                }
                            } // End Invoke: ...
                            tmp71 = interp.getResult();
                            setVarScalar(interp, "scalar", tmp71, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: ... {variable scalar} $scalar
                            TclObject[] objv74 = TJC.grabObjv(interp, 3);
                            TclObject tmp75;
                            try {
                                // Arg 0 constant: ...
                                objv74[0] = const3;
                                // Arg 1 constant: {variable scalar}
                                objv74[1] = const14;
                                // Arg 2 variable: $scalar
                                tmp75 = getVarScalar(interp, "scalar", compiledLocals, 13);
                                tmp75.preserve();
                                objv74[2] = tmp75;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv74, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp75 = objv74[2];
                                if ( tmp75 != null ) {
                                    tmp75.release();
                                }
                                TJC.releaseObjv(interp, objv74, 3);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: set key $...
                            TclObject tmp76;
                            tmp76 = getVarArray(interp, "_compileproc", "expr_eval_key", compiledLocals, 5);
                            setVarScalar(interp, "key", tmp76, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: set script [...]
                            TclObject tmp77;
                            { // Invoke: descend_get_data $key script
                                TclObject[] objv78 = TJC.grabObjv(interp, 3);
                                TclObject tmp79;
                                try {
                                    // Arg 0 constant: descend_get_data
                                    objv78[0] = const15;
                                    // Arg 1 variable: $key
                                    tmp79 = getVarScalar(interp, "key", compiledLocals, 11);
                                    tmp79.preserve();
                                    objv78[1] = tmp79;
                                    // Arg 2 constant: script
                                    objv78[2] = const16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv78, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp79 = objv78[1];
                                    if ( tmp79 != null ) {
                                        tmp79.release();
                                    }
                                    TJC.releaseObjv(interp, objv78, 3);
                                }
                            } // End Invoke: descend_get_data
                            tmp77 = interp.getResult();
                            setVarScalar(interp, "script", tmp77, compiledLocals, 0);
                        } // End Invoke: set
                        { // Invoke: set vinfo [...]
                            TclObject tmp80;
                            { // Invoke: ... $key $script $etree
                                TclObject[] objv81 = TJC.grabObjv(interp, 4);
                                TclObject tmp82;
                                try {
                                    // Arg 0 constant: ...
                                    objv81[0] = const17;
                                    // Arg 1 variable: $key
                                    tmp82 = getVarScalar(interp, "key", compiledLocals, 11);
                                    tmp82.preserve();
                                    objv81[1] = tmp82;
                                    // Arg 2 variable: $script
                                    tmp82 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp82.preserve();
                                    objv81[2] = tmp82;
                                    // Arg 3 variable: $etree
                                    tmp82 = getVarScalar(interp, "etree", compiledLocals, 1);
                                    tmp82.preserve();
                                    objv81[3] = tmp82;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv81, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp82 = objv81[1];
                                    if ( tmp82 != null ) {
                                        tmp82.release();
                                    }
                                    tmp82 = objv81[2];
                                    if ( tmp82 != null ) {
                                        tmp82.release();
                                    }
                                    tmp82 = objv81[3];
                                    if ( tmp82 != null ) {
                                        tmp82.release();
                                    }
                                    TJC.releaseObjv(interp, objv81, 4);
                                }
                            } // End Invoke: ...
                            tmp80 = interp.getResult();
                            setVarScalar(interp, "vinfo", tmp80, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: ... {variable array} $vinfo
                            TclObject[] objv83 = TJC.grabObjv(interp, 3);
                            TclObject tmp84;
                            try {
                                // Arg 0 constant: ...
                                objv83[0] = const3;
                                // Arg 1 constant: {variable array}
                                objv83[1] = const18;
                                // Arg 2 variable: $vinfo
                                tmp84 = getVarScalar(interp, "vinfo", compiledLocals, 14);
                                tmp84.preserve();
                                objv83[2] = tmp84;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv83, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp84 = objv83[2];
                                if ( tmp84 != null ) {
                                    tmp84.release();
                                }
                                TJC.releaseObjv(interp, objv83, 3);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
            } else if ( tmp1_length == 12 && tmp1_first == 'w'
                    && tmp1.compareTo("word operand") == 0 ) {
                // Pattern {word operand}
                { // Invoke: set key $...
                    TclObject tmp85;
                    tmp85 = getVarArray(interp, "_compileproc", "expr_eval_key", compiledLocals, 5);
                    setVarScalar(interp, "key", tmp85, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set wstree $etree
                    TclObject tmp86;
                    tmp86 = getVarScalar(interp, "etree", compiledLocals, 1);
                    setVarScalar(interp, "wstree", tmp86, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set type_winfo [...]
                    TclObject tmp87;
                    { // Invoke: ... $key $script $wstree
                        TclObject[] objv88 = TJC.grabObjv(interp, 4);
                        TclObject tmp89;
                        try {
                            // Arg 0 constant: ...
                            objv88[0] = const19;
                            // Arg 1 variable: $key
                            tmp89 = getVarScalar(interp, "key", compiledLocals, 11);
                            tmp89.preserve();
                            objv88[1] = tmp89;
                            // Arg 2 variable: $script
                            tmp89 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp89.preserve();
                            objv88[2] = tmp89;
                            // Arg 3 variable: $wstree
                            tmp89 = getVarScalar(interp, "wstree", compiledLocals, 15);
                            tmp89.preserve();
                            objv88[3] = tmp89;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv88, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            tmp89 = objv88[1];
                            if ( tmp89 != null ) {
                                tmp89.release();
                            }
                            tmp89 = objv88[2];
                            if ( tmp89 != null ) {
                                tmp89.release();
                            }
                            tmp89 = objv88[3];
                            if ( tmp89 != null ) {
                                tmp89.release();
                            }
                            TJC.releaseObjv(interp, objv88, 4);
                        }
                    } // End Invoke: ...
                    tmp87 = interp.getResult();
                    setVarScalar(interp, "type_winfo", tmp87, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp90;
                    { // Invoke: lindex $type_winfo 0
                        TclObject tmp91 = getVarScalar(interp, "type_winfo", compiledLocals, 16);
                        tmp91 = TclList.index(interp, tmp91, 0);
                        if ( tmp91 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp91);
                        }
                    } // End Invoke: lindex
                    tmp90 = interp.getResult();
                    setVarScalar(interp, "type", tmp90, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set value [...]
                    TclObject tmp92;
                    { // Invoke: lindex $type_winfo 1
                        TclObject tmp93 = getVarScalar(interp, "type_winfo", compiledLocals, 16);
                        tmp93 = TclList.index(interp, tmp93, 1);
                        if ( tmp93 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp93);
                        }
                    } // End Invoke: lindex
                    tmp92 = interp.getResult();
                    setVarScalar(interp, "value", tmp92, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set cmap [...]
                    TclObject tmp94;
                    { // Invoke: lindex $type_winfo 2
                        TclObject tmp95 = getVarScalar(interp, "type_winfo", compiledLocals, 16);
                        tmp95 = TclList.index(interp, tmp95, 2);
                        if ( tmp95 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp95);
                        }
                    } // End Invoke: lindex
                    tmp94 = interp.getResult();
                    setVarScalar(interp, "cmap", tmp94, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $type == "constant"
                    TclObject tmp96 = getVarScalar(interp, "type", compiledLocals, 2);
                    boolean tmp97 = tmp96.toString().equals("constant");
                    ExprValue tmp98 = evs0;
                    tmp98.setIntValue(tmp97);
                    // End Binary operator: ==
                    boolean tmp99 = ( tmp98.getIntValue() != 0 );
                    if ( tmp99 ) {
                        { // Invoke: ... {constant string} $value
                            TclObject[] objv100 = TJC.grabObjv(interp, 3);
                            TclObject tmp101;
                            try {
                                // Arg 0 constant: ...
                                objv100[0] = const3;
                                // Arg 1 constant: {constant string}
                                objv100[1] = const5;
                                // Arg 2 variable: $value
                                tmp101 = getVarScalar(interp, "value", compiledLocals, 17);
                                tmp101.preserve();
                                objv100[2] = tmp101;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv100, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp101 = objv100[2];
                                if ( tmp101 != null ) {
                                    tmp101.release();
                                }
                                TJC.releaseObjv(interp, objv100, 3);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: set value [...]
                            TclObject tmp102;
                            { // Invoke: list $type $values $cmap
                                TclObject tmp103 = TclList.newInstance();
                                TclObject tmp104;
                                try {
                                    tmp104 = getVarScalar(interp, "type", compiledLocals, 2);
                                    TclList.append(interp, tmp103, tmp104);
                                    tmp104 = getVarScalar(interp, "values", compiledLocals, 3);
                                    TclList.append(interp, tmp103, tmp104);
                                    tmp104 = getVarScalar(interp, "cmap", compiledLocals, 18);
                                    TclList.append(interp, tmp103, tmp104);
                                } catch (TclException ex) {
                                    tmp103.release();
                                    throw ex;
                                }
                                interp.setResult(tmp103);
                            } // End Invoke: list
                            tmp102 = interp.getResult();
                            setVarScalar(interp, "value", tmp102, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: ... {word operand} $type_winfo
                            TclObject[] objv105 = TJC.grabObjv(interp, 3);
                            TclObject tmp106;
                            try {
                                // Arg 0 constant: ...
                                objv105[0] = const3;
                                // Arg 1 constant: {word operand}
                                objv105[1] = const20;
                                // Arg 2 variable: $type_winfo
                                tmp106 = getVarScalar(interp, "type_winfo", compiledLocals, 16);
                                tmp106.preserve();
                                objv105[2] = tmp106;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv105, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp106 = objv105[2];
                                if ( tmp106 != null ) {
                                    tmp106.release();
                                }
                                TJC.releaseObjv(interp, objv105, 3);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
            } else if ( tmp1_length == 14 && tmp1_first == 'u'
                    && tmp1.compareTo("unary operator") == 0 ) {
                // Pattern {unary operator}
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc", "expr_eval_expressions", 1, compiledLocals, 5);
                } // End Invoke: incr
                { // Invoke: ... {unary operator} $values
                    TclObject[] objv107 = TJC.grabObjv(interp, 3);
                    TclObject tmp108;
                    try {
                        // Arg 0 constant: ...
                        objv107[0] = const3;
                        // Arg 1 constant: {unary operator}
                        objv107[1] = const21;
                        // Arg 2 variable: $values
                        tmp108 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp108.preserve();
                        objv107[2] = tmp108;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv107, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp108 = objv107[2];
                        if ( tmp108 != null ) {
                            tmp108.release();
                        }
                        TJC.releaseObjv(interp, objv107, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 15 && tmp1_first == 'b'
                    && tmp1.compareTo("binary operator") == 0 ) {
                // Pattern {binary operator}
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc", "expr_eval_expressions", 1, compiledLocals, 5);
                } // End Invoke: incr
                { // Invoke: ... {binary operator} $values
                    TclObject[] objv109 = TJC.grabObjv(interp, 3);
                    TclObject tmp110;
                    try {
                        // Arg 0 constant: ...
                        objv109[0] = const3;
                        // Arg 1 constant: {binary operator}
                        objv109[1] = const22;
                        // Arg 2 variable: $values
                        tmp110 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp110.preserve();
                        objv109[2] = tmp110;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv109, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp110 = objv109[2];
                        if ( tmp110 != null ) {
                            tmp110.release();
                        }
                        TJC.releaseObjv(interp, objv109, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 16 && tmp1_first == 't'
                    && tmp1.compareTo("ternary operator") == 0 ) {
                // Pattern {ternary operator}
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc", "expr_eval_expressions", 1, compiledLocals, 5);
                } // End Invoke: incr
                { // Invoke: ... {ternary operator} $values
                    TclObject[] objv111 = TJC.grabObjv(interp, 3);
                    TclObject tmp112;
                    try {
                        // Arg 0 constant: ...
                        objv111[0] = const3;
                        // Arg 1 constant: {ternary operator}
                        objv111[1] = const23;
                        // Arg 2 variable: $values
                        tmp112 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp112.preserve();
                        objv111[2] = tmp112;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv111, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp112 = objv111[2];
                        if ( tmp112 != null ) {
                            tmp112.release();
                        }
                        TJC.releaseObjv(interp, objv111, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 13 && tmp1_first == 'm'
                    && tmp1.compareTo("math function") == 0 ) {
                // Pattern {math function}
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc", "expr_eval_expressions", 1, compiledLocals, 5);
                } // End Invoke: incr
                { // Invoke: ... {math function} $values
                    TclObject[] objv113 = TJC.grabObjv(interp, 3);
                    TclObject tmp114;
                    try {
                        // Arg 0 constant: ...
                        objv113[0] = const3;
                        // Arg 1 constant: {math function}
                        objv113[1] = const24;
                        // Arg 2 variable: $values
                        tmp114 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp114.preserve();
                        objv113[2] = tmp114;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv113, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp114 = objv113[2];
                        if ( tmp114 != null ) {
                            tmp114.release();
                        }
                        TJC.releaseObjv(interp, objv113, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 13 && tmp1_first == 's'
                    && tmp1.compareTo("subexpression") == 0 ) {
                // Pattern {subexpression}
            } else if ( tmp1_length == 5 && tmp1_first == 'v'
                    && tmp1.compareTo("value") == 0 ) {
                // Pattern {value}
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv115 = TJC.grabObjv(interp, 2);
                    TclObject tmp116;
                    try {
                        // Arg 0 constant: error
                        objv115[0] = const9;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp117 = new StringBuffer(64);
                        sbtmp117.append("unknown type ");
                        sbtmp117.append("\"");
                        tmp116 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp117.append(tmp116.toString());
                        sbtmp117.append("\"");
                        tmp116 = TclString.newInstance(sbtmp117);
                        tmp116.preserve();
                        objv115[1] = tmp116;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv115, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp116 = objv115[1];
                        if ( tmp116 != null ) {
                            tmp116.release();
                        }
                        TJC.releaseObjv(interp, objv115, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("lindex");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_expr_iterate_type_value");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("constant");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("constant string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\\\\");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("constant braced string");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("error");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_childkey_next");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("command operand");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("parse_is_scalar_variable");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("parse_get_scalar_variable");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("variable scalar");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("descend_get_data");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("script");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("compileproc_scan_variable");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("variable array");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("compileproc_scan_word");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("word operand");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("unary operator");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("binary operator");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("ternary operator");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("math function");
        const24.preserve(); const24.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "parse_expr_iterate_type_value";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "compileproc_childkey_next";
                break;
            }
            case 5: {
                cmdName = "parse_is_scalar_variable";
                break;
            }
            case 6: {
                cmdName = "parse_get_scalar_variable";
                break;
            }
            case 7: {
                cmdName = "descend_get_data";
                break;
            }
            case 8: {
                cmdName = "compileproc_scan_variable";
                break;
            }
            case 9: {
                cmdName = "compileproc_scan_word";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "etree",
        "type",
        "values",
        "ranges",
        "_compileproc",
        "literal",
        "dbs_str",
        "len",
        "i",
        "c",
        "key",
        "ccmds",
        "scalar",
        "vinfo",
        "wstree",
        "type_winfo",
        "value",
        "cmap"
    };
} // end class CompileprocExprEvaluateCallbackCmd

