// TJC implementation of procedure compileproc_expr_evaluate_emit_math_function
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitMathFunctionCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 26, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "op_tuple");
        }
        setVarScalar(interp, "op_tuple", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ev_types {}
            setVarScalar(interp, "ev_types", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set vtuple [...]
            TclObject tmp0;
            { // Invoke: lindex $op_tuple 1
                TclObject tmp1 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 1);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "vtuple", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set funcname [...]
            TclObject tmp2;
            { // Invoke: lindex $vtuple 0
                TclObject tmp3 = getVarScalar(interp, "vtuple", compiledLocals, 3);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "funcname", tmp2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set values [...]
            TclObject tmp4;
            { // Invoke: lindex $vtuple 1
                TclObject tmp5 = getVarScalar(interp, "vtuple", compiledLocals, 3);
                tmp5 = TclList.index(interp, tmp5, 1);
                if ( tmp5 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp5);
                }
            } // End Invoke: lindex
            tmp4 = interp.getResult();
            setVarScalar(interp, "values", tmp4, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set infostrs [...]
            TclObject tmp6;
            { // Invoke: list
                TclObject tmp7 = TclList.newInstance();
                interp.setResult(tmp7);
            } // End Invoke: list
            tmp6 = interp.getResult();
            setVarScalar(interp, "infostrs", tmp6, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set evsyms [...]
            TclObject tmp8;
            { // Invoke: list
                TclObject tmp9 = TclList.newInstance();
                interp.setResult(tmp9);
            } // End Invoke: list
            tmp8 = interp.getResult();
            setVarScalar(interp, "evsyms", tmp8, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set buffers [...]
            TclObject tmp10;
            { // Invoke: list
                TclObject tmp11 = TclList.newInstance();
                interp.setResult(tmp11);
            } // End Invoke: list
            tmp10 = interp.getResult();
            setVarScalar(interp, "buffers", tmp10, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set rtuples [...]
            TclObject tmp12;
            { // Invoke: list
                TclObject tmp13 = TclList.newInstance();
                interp.setResult(tmp13);
            } // End Invoke: list
            tmp12 = interp.getResult();
            setVarScalar(interp, "rtuples", tmp12, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp14;
            { // Invoke: llength $values
                TclObject tmp15 = getVarScalar(interp, "values", compiledLocals, 5);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            tmp14 = interp.getResult();
            setVarScalar(interp, "len", tmp14, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const1, compiledLocals, 11);
            } // End Invoke: set
            for ( boolean skip22 = true ; true ; ) {
                if ( skip22 ) {
                    skip22 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 11);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp17 = getVarScalar(interp, "i", compiledLocals, 11);
                ExprValue tmp18 = evs0;
                TJC.exprInitValue(interp, tmp18, tmp17);
                TclObject tmp19 = getVarScalar(interp, "len", compiledLocals, 10);
                ExprValue tmp20 = evs1;
                TJC.exprInitValue(interp, tmp20, tmp19);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp18, tmp20);
                // End Binary operator: <
                boolean tmp21 = ( tmp18.getIntValue() != 0 );
                if ( ! tmp21 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp23;
                    { // Invoke: lindex $values $i
                        TclObject tmp24 = null;
                        TclObject tmp25;
                        try {
                            tmp24 = getVarScalar(interp, "values", compiledLocals, 5);
                            tmp24.preserve();
                            tmp25 = getVarScalar(interp, "i", compiledLocals, 11);
                            TJC.lindexNonconst(interp, tmp24, tmp25);
                        } finally {
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp23, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set eval_tuple [...]
                    TclObject tmp26;
                    { // Invoke: ... $tuple
                        TclObject[] objv27 = TJC.grabObjv(interp, 2);
                        TclObject tmp28;
                        try {
                            // Arg 0 constant: ...
                            objv27[0] = const2;
                            // Arg 1 variable: $tuple
                            tmp28 = getVarScalar(interp, "tuple", compiledLocals, 12);
                            tmp28.preserve();
                            objv27[1] = tmp28;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv27, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp28 = objv27[1];
                            if ( tmp28 != null ) {
                                tmp28.release();
                            }
                            TJC.releaseObjv(interp, objv27, 2);
                        }
                    } // End Invoke: ...
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "eval_tuple", tmp26, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: foreach ... $eval_tuple {break}
                    TclObject tmp29 = null;
                    try {
                        tmp29 = getVarScalar(interp, "eval_tuple", compiledLocals, 13);
                        tmp29.preserve();
                        final int tmp29_length = TclList.getLength(interp, tmp29);

                        for ( int index30 = 0 ; index30 < tmp29_length ; index30 += 4 ) {
                            TclObject tmp31 = null;
                            if ( index30 < tmp29_length ) {
                                tmp31 = TclList.index(interp, tmp29, index30);
                            }
                            TclObject tmp32 = null;
                            if ( index30 + 1 < tmp29_length ) {
                                tmp32 = TclList.index(interp, tmp29, index30 + 1);
                            }
                            TclObject tmp33 = null;
                            if ( index30 + 2 < tmp29_length ) {
                                tmp33 = TclList.index(interp, tmp29, index30 + 2);
                            }
                            TclObject tmp34 = null;
                            if ( index30 + 3 < tmp29_length ) {
                                tmp34 = TclList.index(interp, tmp29, index30 + 3);
                            }
                            try {
                                if ( tmp31 == null ) {
                                    setVarScalar(interp, "infostr", "", compiledLocals, 14);
                                } else {
                                    setVarScalar(interp, "infostr", tmp31, compiledLocals, 14);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "infostr");
                            }
                            try {
                                if ( tmp32 == null ) {
                                    setVarScalar(interp, "ev", "", compiledLocals, 15);
                                } else {
                                    setVarScalar(interp, "ev", tmp32, compiledLocals, 15);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "ev");
                            }
                            try {
                                if ( tmp33 == null ) {
                                    setVarScalar(interp, "eval_buffer", "", compiledLocals, 16);
                                } else {
                                    setVarScalar(interp, "eval_buffer", tmp33, compiledLocals, 16);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "eval_buffer");
                            }
                            try {
                                if ( tmp34 == null ) {
                                    setVarScalar(interp, "rtuple", "", compiledLocals, 17);
                                } else {
                                    setVarScalar(interp, "rtuple", tmp34, compiledLocals, 17);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "rtuple");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: break
                                if ( true ) { break; }
                            } // End Invoke: break
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp29 != null ) {
                            tmp29.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: lappend infostrs $infostr
                    TclObject[] objv35 = TJC.grabObjv(interp, 1);
                    TclObject tmp36;
                    try {
                        // Arg 2 variable: $infostr
                        tmp36 = getVarScalar(interp, "infostr", compiledLocals, 14);
                        tmp36.preserve();
                        objv35[0] = tmp36;
                        interp.resetResult();
                        lappendVarScalar(interp, "infostrs", objv35, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv35, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend evsyms $ev
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    TclObject tmp38;
                    try {
                        // Arg 2 variable: $ev
                        tmp38 = getVarScalar(interp, "ev", compiledLocals, 15);
                        tmp38.preserve();
                        objv37[0] = tmp38;
                        interp.resetResult();
                        lappendVarScalar(interp, "evsyms", objv37, compiledLocals, 7);
                    } finally {
                        TJC.releaseObjvElems(interp, objv37, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend buffers $eval_buffer
                    TclObject[] objv39 = TJC.grabObjv(interp, 1);
                    TclObject tmp40;
                    try {
                        // Arg 2 variable: $eval_buffer
                        tmp40 = getVarScalar(interp, "eval_buffer", compiledLocals, 16);
                        tmp40.preserve();
                        objv39[0] = tmp40;
                        interp.resetResult();
                        lappendVarScalar(interp, "buffers", objv39, compiledLocals, 8);
                    } finally {
                        TJC.releaseObjvElems(interp, objv39, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend rtuples $rtuple
                    TclObject[] objv41 = TJC.grabObjv(interp, 1);
                    TclObject tmp42;
                    try {
                        // Arg 2 variable: $rtuple
                        tmp42 = getVarScalar(interp, "rtuple", compiledLocals, 17);
                        tmp42.preserve();
                        objv41[0] = tmp42;
                        interp.resetResult();
                        lappendVarScalar(interp, "rtuples", objv41, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv41, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...] "// Math function: " $funcname
            TclObject[] objv43 = TJC.grabObjv(interp, 3);
            TclObject tmp44;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv45[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv45, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv45, 1);
                    }
                } // End Invoke: emitter_indent
                tmp44 = interp.getResult();
                tmp44.preserve();
                objv43[0] = tmp44;
                // Arg 3 constant: "// Math function: "
                objv43[1] = const4;
                // Arg 4 variable: $funcname
                tmp44 = getVarScalar(interp, "funcname", compiledLocals, 4);
                tmp44.preserve();
                objv43[2] = tmp44;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv43, compiledLocals, 1);
            } finally {
                tmp44 = objv43[0];
                if ( tmp44 != null ) {
                    tmp44.release();
                }
                tmp44 = objv43[2];
                if ( tmp44 != null ) {
                    tmp44.release();
                }
                TJC.releaseObjv(interp, objv43, 3);
            }
        } // End Invoke: append
        { // Invoke: foreach infostr $infostrs ...
            TclObject tmp46 = null;
            try {
                tmp46 = getVarScalar(interp, "infostrs", compiledLocals, 6);
                tmp46.preserve();
                final int tmp46_length = TclList.getLength(interp, tmp46);

                for ( int index47 = 0 ; index47 < tmp46_length ; index47++ ) {
                    TclObject tmp48 = TclList.index(interp, tmp46, index47);
                    try {
                        setVarScalar(interp, "infostr", tmp48, compiledLocals, 14);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "infostr");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: append buffer " " $infostr
                        TclObject[] objv49 = TJC.grabObjv(interp, 2);
                        TclObject tmp50;
                        try {
                            // Arg 2 constant: " "
                            objv49[0] = const5;
                            // Arg 3 variable: $infostr
                            tmp50 = getVarScalar(interp, "infostr", compiledLocals, 14);
                            tmp50.preserve();
                            objv49[1] = tmp50;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv49, compiledLocals, 1);
                        } finally {
                            tmp50 = objv49[1];
                            if ( tmp50 != null ) {
                                tmp50.release();
                            }
                            TJC.releaseObjv(interp, objv49, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp46 != null ) {
                    tmp46.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer ...
            TclObject[] objv51 = TJC.grabObjv(interp, 1);
            TclObject tmp52;
            try {
                // Arg 2 constant: ...
                objv51[0] = const6;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv51, compiledLocals, 1);
            } finally {
                TJC.releaseObjv(interp, objv51, 1);
            }
        } // End Invoke: append
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const1, compiledLocals, 11);
            } // End Invoke: set
            for ( boolean skip58 = true ; true ; ) {
                if ( skip58 ) {
                    skip58 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 11);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp53 = getVarScalar(interp, "i", compiledLocals, 11);
                ExprValue tmp54 = evs0;
                TJC.exprInitValue(interp, tmp54, tmp53);
                TclObject tmp55 = getVarScalar(interp, "len", compiledLocals, 10);
                ExprValue tmp56 = evs1;
                TJC.exprInitValue(interp, tmp56, tmp55);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp54, tmp56);
                // End Binary operator: <
                boolean tmp57 = ( tmp54.getIntValue() != 0 );
                if ( ! tmp57 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set eval_buffer [...]
                    TclObject tmp59;
                    { // Invoke: lindex $buffers $i
                        TclObject tmp60 = null;
                        TclObject tmp61;
                        try {
                            tmp60 = getVarScalar(interp, "buffers", compiledLocals, 8);
                            tmp60.preserve();
                            tmp61 = getVarScalar(interp, "i", compiledLocals, 11);
                            TJC.lindexNonconst(interp, tmp60, tmp61);
                        } finally {
                            if ( tmp60 != null ) {
                                tmp60.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp59 = interp.getResult();
                    setVarScalar(interp, "eval_buffer", tmp59, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: append buffer $eval_buffer
                    TclObject[] objv62 = TJC.grabObjv(interp, 1);
                    TclObject tmp63;
                    try {
                        // Arg 2 variable: $eval_buffer
                        tmp63 = getVarScalar(interp, "eval_buffer", compiledLocals, 16);
                        tmp63.preserve();
                        objv62[0] = tmp63;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv62, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv62, 1);
                    }
                } // End Invoke: append
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: $len == 1
            TclObject tmp64 = getVarScalar(interp, "len", compiledLocals, 10);
            ExprValue tmp65 = evs0;
            TJC.exprInitValue(interp, tmp65, tmp64);
            ExprValue tmp66 = evs1;
            tmp66.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp65, tmp66);
            // End Binary operator: ==
            if (tmp65.getBooleanValue(interp)) {
            // Binary operator: () || ()
            // Binary operator: $funcname == "int"
            TclObject tmp67 = getVarScalar(interp, "funcname", compiledLocals, 4);
            boolean tmp68 = tmp67.toString().equals("int");
            ExprValue tmp69 = evs1;
            tmp69.setIntValue(tmp68);
            // End Binary operator: ==
            if (!tmp69.getBooleanValue(interp)) {
            // Binary operator: $funcname == "double"
            TclObject tmp70 = getVarScalar(interp, "funcname", compiledLocals, 4);
            boolean tmp71 = tmp70.toString().equals("double");
            ExprValue tmp72 = evs2;
            tmp72.setIntValue(tmp71);
            // End Binary operator: ==
            tmp69.setIntValue(tmp72.getBooleanValue(interp));
            } else {
            tmp69.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            tmp65.setIntValue(tmp69.getBooleanValue(interp));
            } else {
            tmp65.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp73 = ( tmp65.getIntValue() != 0 );
            if ( tmp73 ) {
                { // Invoke: set ev [...]
                    TclObject tmp74;
                    { // Invoke: lindex $evsyms 0
                        TclObject tmp75 = getVarScalar(interp, "evsyms", compiledLocals, 7);
                        tmp75 = TclList.index(interp, tmp75, 0);
                        if ( tmp75 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp75);
                        }
                    } // End Invoke: lindex
                    tmp74 = interp.getResult();
                    setVarScalar(interp, "ev", tmp74, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: if {$funcname == "int"} ... else ...
                    // Binary operator: $funcname == "int"
                    TclObject tmp76 = getVarScalar(interp, "funcname", compiledLocals, 4);
                    boolean tmp77 = tmp76.toString().equals("int");
                    ExprValue tmp78 = evs0;
                    tmp78.setIntValue(tmp77);
                    // End Binary operator: ==
                    boolean tmp79 = ( tmp78.getIntValue() != 0 );
                    if ( tmp79 ) {
                        { // Invoke: set tjc_func ...
                            setVarScalar(interp, "tjc_func", const7, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: set ev_types int
                            setVarScalar(interp, "ev_types", const8, compiledLocals, 2);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set tjc_func ...
                            setVarScalar(interp, "tjc_func", const9, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: set ev_types double
                            setVarScalar(interp, "ev_types", const10, compiledLocals, 2);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...] ${tjc_func} "(interp, " $ev ...
                    TclObject[] objv80 = TJC.grabObjv(interp, 5);
                    TclObject tmp81;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv82 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv82[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv82, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv82, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp81 = interp.getResult();
                        tmp81.preserve();
                        objv80[0] = tmp81;
                        // Arg 3 variable: ${tjc_func}
                        tmp81 = getVarScalar(interp, "tjc_func", compiledLocals, 18);
                        tmp81.preserve();
                        objv80[1] = tmp81;
                        // Arg 4 constant: "(interp, "
                        objv80[2] = const11;
                        // Arg 5 variable: $ev
                        tmp81 = getVarScalar(interp, "ev", compiledLocals, 15);
                        tmp81.preserve();
                        objv80[3] = tmp81;
                        // Arg 6 constant: ...
                        objv80[4] = const12;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv80, compiledLocals, 1);
                    } finally {
                        tmp81 = objv80[0];
                        if ( tmp81 != null ) {
                            tmp81.release();
                        }
                        tmp81 = objv80[1];
                        if ( tmp81 != null ) {
                            tmp81.release();
                        }
                        tmp81 = objv80[3];
                        if ( tmp81 != null ) {
                            tmp81.release();
                        }
                        TJC.releaseObjv(interp, objv80, 5);
                    }
                } // End Invoke: append
                { // Invoke: set result_tmpsymbol $ev
                    TclObject tmp83;
                    tmp83 = getVarScalar(interp, "ev", compiledLocals, 15);
                    setVarScalar(interp, "result_tmpsymbol", tmp83, compiledLocals, 19);
                } // End Invoke: set
            } else {
                { // Invoke: if {$len > 0} ... else ...
                    // Binary operator: $len > 0
                    TclObject tmp84 = getVarScalar(interp, "len", compiledLocals, 10);
                    ExprValue tmp85 = evs0;
                    TJC.exprInitValue(interp, tmp85, tmp84);
                    ExprValue tmp86 = evs1;
                    tmp86.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp85, tmp86);
                    // End Binary operator: >
                    boolean tmp87 = ( tmp85.getIntValue() != 0 );
                    if ( tmp87 ) {
                        { // Invoke: set values_tmpsymbol [...]
                            TclObject tmp88;
                            { // Invoke: ...
                                TclObject[] objv89 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv89[0] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv89, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv89, 1);
                                }
                            } // End Invoke: ...
                            tmp88 = interp.getResult();
                            setVarScalar(interp, "values_tmpsymbol", tmp88, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: append buffer [...] ... $values_tmpsymbol ... $len ...
                            TclObject[] objv90 = TJC.grabObjv(interp, 6);
                            TclObject tmp91;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv92 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv92[0] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv92, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv92, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp91 = interp.getResult();
                                tmp91.preserve();
                                objv90[0] = tmp91;
                                // Arg 3 constant: ...
                                objv90[1] = const14;
                                // Arg 4 variable: $values_tmpsymbol
                                tmp91 = getVarScalar(interp, "values_tmpsymbol", compiledLocals, 20);
                                tmp91.preserve();
                                objv90[2] = tmp91;
                                // Arg 5 constant: ...
                                objv90[3] = const15;
                                // Arg 6 variable: $len
                                tmp91 = getVarScalar(interp, "len", compiledLocals, 10);
                                tmp91.preserve();
                                objv90[4] = tmp91;
                                // Arg 7 constant: ...
                                objv90[5] = const16;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv90, compiledLocals, 1);
                            } finally {
                                tmp91 = objv90[0];
                                if ( tmp91 != null ) {
                                    tmp91.release();
                                }
                                tmp91 = objv90[2];
                                if ( tmp91 != null ) {
                                    tmp91.release();
                                }
                                tmp91 = objv90[4];
                                if ( tmp91 != null ) {
                                    tmp91.release();
                                }
                                TJC.releaseObjv(interp, objv90, 6);
                            }
                        } // End Invoke: append
                        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
                            { // Invoke: set i 0
                                setVarScalar(interp, "i", const1, compiledLocals, 11);
                            } // End Invoke: set
                            for ( boolean skip98 = true ; true ; ) {
                                if ( skip98 ) {
                                    skip98 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr i
                                        interp.resetResult();
                                        incrVarScalar(interp, "i", 1, compiledLocals, 11);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $i < $len
                                TclObject tmp93 = getVarScalar(interp, "i", compiledLocals, 11);
                                ExprValue tmp94 = evs0;
                                TJC.exprInitValue(interp, tmp94, tmp93);
                                TclObject tmp95 = getVarScalar(interp, "len", compiledLocals, 10);
                                ExprValue tmp96 = evs1;
                                TJC.exprInitValue(interp, tmp96, tmp95);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp94, tmp96);
                                // End Binary operator: <
                                boolean tmp97 = ( tmp94.getIntValue() != 0 );
                                if ( ! tmp97 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set ev [...]
                                    TclObject tmp99;
                                    { // Invoke: lindex $evsyms $i
                                        TclObject tmp100 = null;
                                        TclObject tmp101;
                                        try {
                                            tmp100 = getVarScalar(interp, "evsyms", compiledLocals, 7);
                                            tmp100.preserve();
                                            tmp101 = getVarScalar(interp, "i", compiledLocals, 11);
                                            TJC.lindexNonconst(interp, tmp100, tmp101);
                                        } finally {
                                            if ( tmp100 != null ) {
                                                tmp100.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp99 = interp.getResult();
                                    setVarScalar(interp, "ev", tmp99, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: append buffer [...] $values_tmpsymbol ... $i ... $ev ...
                                    TclObject[] objv102 = TJC.grabObjv(interp, 7);
                                    TclObject tmp103;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv104 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv104[0] = const3;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv104, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv104, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp103 = interp.getResult();
                                        tmp103.preserve();
                                        objv102[0] = tmp103;
                                        // Arg 3 variable: $values_tmpsymbol
                                        tmp103 = getVarScalar(interp, "values_tmpsymbol", compiledLocals, 20);
                                        tmp103.preserve();
                                        objv102[1] = tmp103;
                                        // Arg 4 constant: ...
                                        objv102[2] = const17;
                                        // Arg 5 variable: $i
                                        tmp103 = getVarScalar(interp, "i", compiledLocals, 11);
                                        tmp103.preserve();
                                        objv102[3] = tmp103;
                                        // Arg 6 constant: ...
                                        objv102[4] = const18;
                                        // Arg 7 variable: $ev
                                        tmp103 = getVarScalar(interp, "ev", compiledLocals, 15);
                                        tmp103.preserve();
                                        objv102[5] = tmp103;
                                        // Arg 8 constant: ...
                                        objv102[6] = const19;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv102, compiledLocals, 1);
                                    } finally {
                                        tmp103 = objv102[0];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        tmp103 = objv102[1];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        tmp103 = objv102[3];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        tmp103 = objv102[5];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        TJC.releaseObjv(interp, objv102, 7);
                                    }
                                } // End Invoke: append
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                    } else {
                        { // Invoke: set values_tmpsymbol null
                            setVarScalar(interp, "values_tmpsymbol", const20, compiledLocals, 20);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set expr_value_stack $...
                    TclObject tmp105;
                    initVarScoped(interp, "::_compileproc", compiledLocals, 21);
                    tmp105 = getVarArray(interp, "::_compileproc", "options,expr_value_stack", compiledLocals, 21);
                    setVarScalar(interp, "expr_value_stack", tmp105, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $expr_value_stack && ()
                    TclObject tmp106 = getVarScalar(interp, "expr_value_stack", compiledLocals, 22);
                    ExprValue tmp107 = evs0;
                    TJC.exprInitValue(interp, tmp107, tmp106);
                    if (tmp107.getBooleanValue(interp)) {
                    // Binary operator: $len > 0
                    TclObject tmp108 = getVarScalar(interp, "len", compiledLocals, 10);
                    ExprValue tmp109 = evs1;
                    TJC.exprInitValue(interp, tmp109, tmp108);
                    ExprValue tmp110 = evs2;
                    tmp110.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp109, tmp110);
                    // End Binary operator: >
                    tmp107.setIntValue(tmp109.getBooleanValue(interp));
                    } else {
                    tmp107.setIntValue(0);
                    } // End if: $expr_value_stack
                    // End Binary operator: &&
                    boolean tmp111 = ( tmp107.getIntValue() != 0 );
                    if ( tmp111 ) {
                        { // Invoke: set result_tmpsymbol null
                            setVarScalar(interp, "result_tmpsymbol", const20, compiledLocals, 19);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set result_tmpsymbol [...]
                            TclObject tmp112;
                            { // Invoke: ...
                                TclObject[] objv113 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv113[0] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv113, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv113, 1);
                                }
                            } // End Invoke: ...
                            tmp112 = interp.getResult();
                            setVarScalar(interp, "result_tmpsymbol", tmp112, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv114 = TJC.grabObjv(interp, 1);
                            TclObject tmp115;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $result_tmpsymbol "" ""
                                    TclObject[] objv116 = TJC.grabObjv(interp, 4);
                                    TclObject tmp117;
                                    try {
                                        // Arg 0 constant: ...
                                        objv116[0] = const21;
                                        // Arg 1 variable: $result_tmpsymbol
                                        tmp117 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 19);
                                        tmp117.preserve();
                                        objv116[1] = tmp117;
                                        // Arg 2 constant: ""
                                        objv116[2] = const0;
                                        // Arg 3 constant: ""
                                        objv116[3] = const0;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv116, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp117 = objv116[1];
                                        if ( tmp117 != null ) {
                                            tmp117.release();
                                        }
                                        TJC.releaseObjv(interp, objv116, 4);
                                    }
                                } // End Invoke: ...
                                tmp115 = interp.getResult();
                                tmp115.preserve();
                                objv114[0] = tmp115;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv114, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv114, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: set jstr [...]
                    TclObject tmp118;
                    { // Invoke: ... $funcname
                        TclObject[] objv119 = TJC.grabObjv(interp, 2);
                        TclObject tmp120;
                        try {
                            // Arg 0 constant: ...
                            objv119[0] = const22;
                            // Arg 1 variable: $funcname
                            tmp120 = getVarScalar(interp, "funcname", compiledLocals, 4);
                            tmp120.preserve();
                            objv119[1] = tmp120;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv119, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp120 = objv119[1];
                            if ( tmp120 != null ) {
                                tmp120.release();
                            }
                            TJC.releaseObjv(interp, objv119, 2);
                        }
                    } // End Invoke: ...
                    tmp118 = interp.getResult();
                    setVarScalar(interp, "jstr", tmp118, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: append buffer [...] ... $jstr ... $values_tmpsymbol ", " $result_tmpsymbol ")" ...
                    TclObject[] objv121 = TJC.grabObjv(interp, 9);
                    TclObject tmp122;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv123 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv123[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv123, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv123, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp122 = interp.getResult();
                        tmp122.preserve();
                        objv121[0] = tmp122;
                        // Arg 3 constant: ...
                        objv121[1] = const23;
                        // Arg 4 variable: $jstr
                        tmp122 = getVarScalar(interp, "jstr", compiledLocals, 23);
                        tmp122.preserve();
                        objv121[2] = tmp122;
                        // Arg 5 constant: ...
                        objv121[3] = const24;
                        // Arg 6 variable: $values_tmpsymbol
                        tmp122 = getVarScalar(interp, "values_tmpsymbol", compiledLocals, 20);
                        tmp122.preserve();
                        objv121[4] = tmp122;
                        // Arg 7 constant: ", "
                        objv121[5] = const25;
                        // Arg 8 variable: $result_tmpsymbol
                        tmp122 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 19);
                        tmp122.preserve();
                        objv121[6] = tmp122;
                        // Arg 9 constant: ")"
                        objv121[7] = const26;
                        // Arg 10 constant: ...
                        objv121[8] = const19;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv121, compiledLocals, 1);
                    } finally {
                        tmp122 = objv121[0];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        tmp122 = objv121[2];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        tmp122 = objv121[4];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        tmp122 = objv121[6];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        TJC.releaseObjv(interp, objv121, 9);
                    }
                } // End Invoke: append
                { // Invoke: if {$len > 0} ...
                    // Binary operator: $len > 0
                    TclObject tmp124 = getVarScalar(interp, "len", compiledLocals, 10);
                    ExprValue tmp125 = evs0;
                    TJC.exprInitValue(interp, tmp125, tmp124);
                    ExprValue tmp126 = evs1;
                    tmp126.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp125, tmp126);
                    // End Binary operator: >
                    boolean tmp127 = ( tmp125.getIntValue() != 0 );
                    if ( tmp127 ) {
                        { // Invoke: set i $len
                            TclObject tmp128;
                            tmp128 = getVarScalar(interp, "len", compiledLocals, 10);
                            setVarScalar(interp, "i", tmp128, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: incr i -1
                            interp.resetResult();
                            incrVarScalar(interp, "i", -1, compiledLocals, 11);
                        } // End Invoke: incr
                        { // Invoke: for {} {$i >= 0} {incr i -1} ...
                            for ( boolean skip133 = true ; true ; ) {
                                if ( skip133 ) {
                                    skip133 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr i -1
                                        interp.resetResult();
                                        incrVarScalar(interp, "i", -1, compiledLocals, 11);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $i >= 0
                                TclObject tmp129 = getVarScalar(interp, "i", compiledLocals, 11);
                                ExprValue tmp130 = evs0;
                                TJC.exprInitValue(interp, tmp130, tmp129);
                                ExprValue tmp131 = evs1;
                                tmp131.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp130, tmp131);
                                // End Binary operator: >=
                                boolean tmp132 = ( tmp130.getIntValue() != 0 );
                                if ( ! tmp132 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set ev [...]
                                    TclObject tmp134;
                                    { // Invoke: lindex $evsyms $i
                                        TclObject tmp135 = null;
                                        TclObject tmp136;
                                        try {
                                            tmp135 = getVarScalar(interp, "evsyms", compiledLocals, 7);
                                            tmp135.preserve();
                                            tmp136 = getVarScalar(interp, "i", compiledLocals, 11);
                                            TJC.lindexNonconst(interp, tmp135, tmp136);
                                        } finally {
                                            if ( tmp135 != null ) {
                                                tmp135.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp134 = interp.getResult();
                                    setVarScalar(interp, "ev", tmp134, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: () && ()
                                    // Binary operator: $i == 0
                                    TclObject tmp137 = getVarScalar(interp, "i", compiledLocals, 11);
                                    ExprValue tmp138 = evs0;
                                    TJC.exprInitValue(interp, tmp138, tmp137);
                                    ExprValue tmp139 = evs1;
                                    tmp139.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp138, tmp139);
                                    // End Binary operator: ==
                                    if (tmp138.getBooleanValue(interp)) {
                                    // Binary operator: $result_tmpsymbol == "null"
                                    TclObject tmp140 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 19);
                                    boolean tmp141 = tmp140.toString().equals("null");
                                    ExprValue tmp142 = evs1;
                                    tmp142.setIntValue(tmp141);
                                    // End Binary operator: ==
                                    tmp138.setIntValue(tmp142.getBooleanValue(interp));
                                    } else {
                                    tmp138.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    boolean tmp143 = ( tmp138.getIntValue() != 0 );
                                    if ( tmp143 ) {
                                        { // Invoke: set result_tmpsymbol $ev
                                            TclObject tmp144;
                                            tmp144 = getVarScalar(interp, "ev", compiledLocals, 15);
                                            setVarScalar(interp, "result_tmpsymbol", tmp144, compiledLocals, 19);
                                        } // End Invoke: set
                                        { // Invoke: break
                                            if ( true ) { break; }
                                        } // End Invoke: break
                                    }
                                } // End Invoke: if
                                { // Invoke: append buffer [...]
                                    TclObject[] objv145 = TJC.grabObjv(interp, 1);
                                    TclObject tmp146;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $ev
                                            TclObject[] objv147 = TJC.grabObjv(interp, 2);
                                            TclObject tmp148;
                                            try {
                                                // Arg 0 constant: ...
                                                objv147[0] = const27;
                                                // Arg 1 variable: $ev
                                                tmp148 = getVarScalar(interp, "ev", compiledLocals, 15);
                                                tmp148.preserve();
                                                objv147[1] = tmp148;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                    ? cmdcache6.cmd : null), objv147, 0);
                                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                    updateCmdCache(interp, 6);
                                                }
                                            } finally {
                                                tmp148 = objv147[1];
                                                if ( tmp148 != null ) {
                                                    tmp148.release();
                                                }
                                                TJC.releaseObjv(interp, objv147, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp146 = interp.getResult();
                                        tmp146.preserve();
                                        objv145[0] = tmp146;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv145, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv145, 1);
                                    }
                                } // End Invoke: append
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                    }
                } // End Invoke: if
                { // Invoke: switch -- $funcname {abs} ... {round} ... {acos} - {asin} - {atan} - {atan2} - {ceil} - {cos} - {cosh} - {exp} - {floor} - {fmod} - {hypot} - {log} - {log10} - {pow} - {rand} - {sin} - {sinh} - {sqrt} - {srand} - {tan} - {tanh} ... default ...
                    TclObject tmp149 = getVarScalar(interp, "funcname", compiledLocals, 4);
                    String tmp150 = tmp149.toString();
                    int tmp150_length = tmp150.length();
                    char tmp150_first = '\n';
                    if ( tmp150_length > 0 ) {
                        tmp150_first = tmp150.charAt(0);
                    }
                    if ( tmp150_length == 3 && tmp150_first == 'a'
                            && tmp150.compareTo("abs") == 0 ) {
                        // Pattern {abs}
                        { // Invoke: if {$len == 1} ...
                            // Binary operator: $len == 1
                            TclObject tmp151 = getVarScalar(interp, "len", compiledLocals, 10);
                            ExprValue tmp152 = evs0;
                            TJC.exprInitValue(interp, tmp152, tmp151);
                            ExprValue tmp153 = evs1;
                            tmp153.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp152, tmp153);
                            // End Binary operator: ==
                            boolean tmp154 = ( tmp152.getIntValue() != 0 );
                            if ( tmp154 ) {
                                { // Invoke: set rtuple [...]
                                    TclObject tmp155;
                                    { // Invoke: lindex $rtuples 0
                                        TclObject tmp156 = getVarScalar(interp, "rtuples", compiledLocals, 9);
                                        tmp156 = TclList.index(interp, tmp156, 0);
                                        if ( tmp156 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp156);
                                        }
                                    } // End Invoke: lindex
                                    tmp155 = interp.getResult();
                                    setVarScalar(interp, "rtuple", tmp155, compiledLocals, 17);
                                } // End Invoke: set
                                { // Invoke: set result_type [...]
                                    TclObject tmp157;
                                    { // Invoke: lindex $rtuple 0
                                        TclObject tmp158 = getVarScalar(interp, "rtuple", compiledLocals, 17);
                                        tmp158 = TclList.index(interp, tmp158, 0);
                                        if ( tmp158 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp158);
                                        }
                                    } // End Invoke: lindex
                                    tmp157 = interp.getResult();
                                    setVarScalar(interp, "result_type", tmp157, compiledLocals, 24);
                                } // End Invoke: set
                                { // Invoke: set result_ev_types [...]
                                    TclObject tmp159;
                                    { // Invoke: lindex $rtuple 3
                                        TclObject tmp160 = getVarScalar(interp, "rtuple", compiledLocals, 17);
                                        tmp160 = TclList.index(interp, tmp160, 3);
                                        if ( tmp160 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp160);
                                        }
                                    } // End Invoke: lindex
                                    tmp159 = interp.getResult();
                                    setVarScalar(interp, "result_ev_types", tmp159, compiledLocals, 25);
                                } // End Invoke: set
                                { // Invoke: if ... ... elseif ... ... else ...
                                    // Binary operator: () || ()
                                    // Binary operator: $result_type == "int literal"
                                    TclObject tmp161 = getVarScalar(interp, "result_type", compiledLocals, 24);
                                    boolean tmp162 = tmp161.toString().equals("int literal");
                                    ExprValue tmp163 = evs0;
                                    tmp163.setIntValue(tmp162);
                                    // End Binary operator: ==
                                    if (!tmp163.getBooleanValue(interp)) {
                                    // Binary operator: () && ()
                                    // Binary operator: $result_type == "ExprValue"
                                    TclObject tmp164 = getVarScalar(interp, "result_type", compiledLocals, 24);
                                    boolean tmp165 = tmp164.toString().equals("ExprValue");
                                    ExprValue tmp166 = evs1;
                                    tmp166.setIntValue(tmp165);
                                    // End Binary operator: ==
                                    if (tmp166.getBooleanValue(interp)) {
                                    // Binary operator: $result_ev_types == "int"
                                    TclObject tmp167 = getVarScalar(interp, "result_ev_types", compiledLocals, 25);
                                    boolean tmp168 = tmp167.toString().equals("int");
                                    ExprValue tmp169 = evs2;
                                    tmp169.setIntValue(tmp168);
                                    // End Binary operator: ==
                                    tmp166.setIntValue(tmp169.getBooleanValue(interp));
                                    } else {
                                    tmp166.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    tmp163.setIntValue(tmp166.getBooleanValue(interp));
                                    } else {
                                    tmp163.setIntValue(1);
                                    } // End if: !()
                                    // End Binary operator: ||
                                    boolean tmp170 = ( tmp163.getIntValue() != 0 );
                                    if ( tmp170 ) {
                                        { // Invoke: set ev_types int
                                            setVarScalar(interp, "ev_types", const8, compiledLocals, 2);
                                        } // End Invoke: set
                                    } else {
                                        // Binary operator: () || ()
                                        // Binary operator: $result_type == "double literal"
                                        TclObject tmp171 = getVarScalar(interp, "result_type", compiledLocals, 24);
                                        boolean tmp172 = tmp171.toString().equals("double literal");
                                        ExprValue tmp173 = evs0;
                                        tmp173.setIntValue(tmp172);
                                        // End Binary operator: ==
                                        if (!tmp173.getBooleanValue(interp)) {
                                        // Binary operator: () && ()
                                        // Binary operator: $result_type == "ExprValue"
                                        TclObject tmp174 = getVarScalar(interp, "result_type", compiledLocals, 24);
                                        boolean tmp175 = tmp174.toString().equals("ExprValue");
                                        ExprValue tmp176 = evs1;
                                        tmp176.setIntValue(tmp175);
                                        // End Binary operator: ==
                                        if (tmp176.getBooleanValue(interp)) {
                                        // Binary operator: $result_ev_types == "double"
                                        TclObject tmp177 = getVarScalar(interp, "result_ev_types", compiledLocals, 25);
                                        boolean tmp178 = tmp177.toString().equals("double");
                                        ExprValue tmp179 = evs2;
                                        tmp179.setIntValue(tmp178);
                                        // End Binary operator: ==
                                        tmp176.setIntValue(tmp179.getBooleanValue(interp));
                                        } else {
                                        tmp176.setIntValue(0);
                                        } // End if: ()
                                        // End Binary operator: &&
                                        tmp173.setIntValue(tmp176.getBooleanValue(interp));
                                        } else {
                                        tmp173.setIntValue(1);
                                        } // End if: !()
                                        // End Binary operator: ||
                                        boolean tmp180 = ( tmp173.getIntValue() != 0 );
                                        if ( tmp180 ) {
                                            { // Invoke: set ev_types double
                                                setVarScalar(interp, "ev_types", const10, compiledLocals, 2);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: set ev_types {int double}
                                                setVarScalar(interp, "ev_types", const28, compiledLocals, 2);
                                            } // End Invoke: set
                                        }
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                    } else if ( tmp150_length == 5 && tmp150_first == 'r'
                            && tmp150.compareTo("round") == 0 ) {
                        // Pattern {round}
                        { // Invoke: set ev_types int
                            setVarScalar(interp, "ev_types", const8, compiledLocals, 2);
                        } // End Invoke: set
                    } else if ( ( tmp150_length == 4 && tmp150_first == 'a'
                            && tmp150.compareTo("acos") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'a'
                            && tmp150.compareTo("asin") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'a'
                            && tmp150.compareTo("atan") == 0 ) ||
                        ( tmp150_length == 5 && tmp150_first == 'a'
                            && tmp150.compareTo("atan2") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'c'
                            && tmp150.compareTo("ceil") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 'c'
                            && tmp150.compareTo("cos") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'c'
                            && tmp150.compareTo("cosh") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 'e'
                            && tmp150.compareTo("exp") == 0 ) ||
                        ( tmp150_length == 5 && tmp150_first == 'f'
                            && tmp150.compareTo("floor") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'f'
                            && tmp150.compareTo("fmod") == 0 ) ||
                        ( tmp150_length == 5 && tmp150_first == 'h'
                            && tmp150.compareTo("hypot") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 'l'
                            && tmp150.compareTo("log") == 0 ) ||
                        ( tmp150_length == 5 && tmp150_first == 'l'
                            && tmp150.compareTo("log10") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 'p'
                            && tmp150.compareTo("pow") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 'r'
                            && tmp150.compareTo("rand") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 's'
                            && tmp150.compareTo("sin") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 's'
                            && tmp150.compareTo("sinh") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 's'
                            && tmp150.compareTo("sqrt") == 0 ) ||
                        ( tmp150_length == 5 && tmp150_first == 's'
                            && tmp150.compareTo("srand") == 0 ) ||
                        ( tmp150_length == 3 && tmp150_first == 't'
                            && tmp150.compareTo("tan") == 0 ) ||
                        ( tmp150_length == 4 && tmp150_first == 't'
                            && tmp150.compareTo("tanh") == 0 ) ) {
                        // Pattern {tanh}
                        { // Invoke: set ev_types double
                            setVarScalar(interp, "ev_types", const10, compiledLocals, 2);
                        } // End Invoke: set
                    } else {
                        // Pattern default
                    }
                } // End Invoke: switch
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ... $funcname ...
            TclObject[] objv181 = TJC.grabObjv(interp, 4);
            TclObject tmp182;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv183 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv183[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv183, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv183, 1);
                    }
                } // End Invoke: emitter_indent
                tmp182 = interp.getResult();
                tmp182.preserve();
                objv181[0] = tmp182;
                // Arg 3 constant: ...
                objv181[1] = const29;
                // Arg 4 variable: $funcname
                tmp182 = getVarScalar(interp, "funcname", compiledLocals, 4);
                tmp182.preserve();
                objv181[2] = tmp182;
                // Arg 5 constant: ...
                objv181[3] = const6;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv181, compiledLocals, 1);
            } finally {
                tmp182 = objv181[0];
                if ( tmp182 != null ) {
                    tmp182.release();
                }
                tmp182 = objv181[2];
                if ( tmp182 != null ) {
                    tmp182.release();
                }
                TJC.releaseObjv(interp, objv181, 4);
            }
        } // End Invoke: append
        { // Invoke: return [...]
            { // Invoke: list $result_tmpsymbol $buffer $ev_types
                TclObject tmp184 = TclList.newInstance();
                TclObject tmp185;
                try {
                    tmp185 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 19);
                    TclList.append(interp, tmp184, tmp185);
                    tmp185 = getVarScalar(interp, "buffer", compiledLocals, 1);
                    TclList.append(interp, tmp184, tmp185);
                    tmp185 = getVarScalar(interp, "ev_types", compiledLocals, 2);
                    TclList.append(interp, tmp184, tmp185);
                } catch (TclException ex) {
                    tmp184.release();
                    throw ex;
                }
                interp.setResult(tmp184);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_math_function");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("// Math function: ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(" ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TJC.exprIntMathFunction");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("int");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("TJC.exprDoubleMathFunction");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("double");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("(interp, ");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(");\n");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_tmpvar_next");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("ExprValue[] ");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(" = new ExprValue[");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("];\n");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("[");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("] = ");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance(";\n");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("null");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_emit_exprvalue_get");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_backslash_tcl_string");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("TJC.exprMathFunction(interp, \"");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("\", ");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance(", ");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance(")");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("int double");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("// End Math function: ");
        const29.preserve(); const29.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_exprvalue_get";
                break;
            }
            case 5: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op_tuple",
        "buffer",
        "ev_types",
        "vtuple",
        "funcname",
        "values",
        "infostrs",
        "evsyms",
        "buffers",
        "rtuples",
        "len",
        "i",
        "tuple",
        "eval_tuple",
        "infostr",
        "ev",
        "eval_buffer",
        "rtuple",
        "tjc_func",
        "result_tmpsymbol",
        "values_tmpsymbol",
        "::_compileproc",
        "expr_value_stack",
        "jstr",
        "result_type",
        "result_ev_types"
    };
} // end class CompileprocExprEvaluateEmitMathFunctionCmd

