// TJC implementation of procedure compileproc_expr_value_stack_generate
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackGenerateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 0);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: foreach symbol $... ...
            TclObject tmp0 = null;
            try {
                tmp0 = getVarArray(interp, "_compileproc_expr_value_stack", "ordered_symbols", compiledLocals, 0);
                tmp0.preserve();
                final int tmp0_length = TclList.getLength(interp, tmp0);

                for ( int index1 = 0 ; index1 < tmp0_length ; index1++ ) {
                    TclObject tmp2 = TclList.index(interp, tmp0, index1);
                    try {
                        setVarScalar(interp, "symbol", tmp2, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "symbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: append buffer [...] "..."
                        TclObject[] objv3 = TJC.grabObjv(interp, 2);
                        TclObject tmp4;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv5 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv5[0] = const1;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv5, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv5, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp4 = interp.getResult();
                            tmp4.preserve();
                            objv3[0] = tmp4;
                            // Arg 3 word: "..."
                            StringBuffer sbtmp6 = new StringBuffer(64);
                            sbtmp6.append("ExprValue ");
                            tmp4 = getVarScalar(interp, "symbol", compiledLocals, 2);
                            sbtmp6.append(tmp4.toString());
                            sbtmp6.append(" = TJC.exprGetValue(interp)");
                            sbtmp6.append(";");
                            sbtmp6.append("\n");
                            tmp4 = TclString.newInstance(sbtmp6);
                            tmp4.preserve();
                            objv3[1] = tmp4;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv3, compiledLocals, 1);
                        } finally {
                            TJC.releaseObjvElems(interp, objv3, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp0 != null ) {
                    tmp0.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $buffer
            TclObject tmp7 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp7);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_generate");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_expr_value_stack",
        "buffer",
        "symbol"
    };
} // end class CompileprocExprValueStackGenerateCmd

