// TJC implementation of procedure compileproc_scan_keys_in_container_sublist
package tjc;
import tcl.lang.*;

public class CompileprocScanKeysInContainerSublistCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key klists");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "klists", objv[2], compiledLocals, 1);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: foreach klist $klists ...
            TclObject tmp0 = null;
            try {
                tmp0 = getVarScalar(interp, "klists", compiledLocals, 1);
                tmp0.preserve();
                final int tmp0_length = TclList.getLength(interp, tmp0);

                for ( int index1 = 0 ; index1 < tmp0_length ; index1++ ) {
                    TclObject tmp2 = TclList.index(interp, tmp0, index1);
                    try {
                        setVarScalar(interp, "klist", tmp2, compiledLocals, 3);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "klist");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$klist == {}} ...
                        // Binary operator: $klist == ""
                        TclObject tmp3 = getVarScalar(interp, "klist", compiledLocals, 3);
                        ExprValue tmp4 = evs0;
                        TJC.exprEqualsEmptyString(tmp4, tmp3, false);
                        // End Binary operator: ==
                        boolean tmp5 = ( tmp4.getIntValue() != 0 );
                        if ( tmp5 ) {
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: set trimmed_klist [...]
                        TclObject tmp6;
                        { // Invoke: list
                            TclObject tmp7 = TclList.newInstance();
                            interp.setResult(tmp7);
                        } // End Invoke: list
                        tmp6 = interp.getResult();
                        setVarScalar(interp, "trimmed_klist", tmp6, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: foreach ckey $klist ...
                        TclObject tmp8 = null;
                        try {
                            tmp8 = getVarScalar(interp, "klist", compiledLocals, 3);
                            tmp8.preserve();
                            final int tmp8_length = TclList.getLength(interp, tmp8);

                            for ( int index9 = 0 ; index9 < tmp8_length ; index9++ ) {
                                TclObject tmp10 = TclList.index(interp, tmp8, index9);
                                try {
                                    setVarScalar(interp, "ckey", tmp10, compiledLocals, 5);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "ckey");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set len [...]
                                    TclObject tmp11;
                                    { // Invoke: llength $ckey
                                        TclObject tmp12 = getVarScalar(interp, "ckey", compiledLocals, 5);
                                        int tmp13 = TclList.getLength(interp, tmp12);
                                        interp.setResult(tmp13);
                                    } // End Invoke: llength
                                    tmp11 = interp.getResult();
                                    setVarScalar(interp, "len", tmp11, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: if {$len == 0} ... elseif {$len > 1} ... else ...
                                    // Binary operator: $len == 0
                                    TclObject tmp14 = getVarScalar(interp, "len", compiledLocals, 6);
                                    ExprValue tmp15 = evs0;
                                    TJC.exprInitValue(interp, tmp15, tmp14);
                                    ExprValue tmp16 = evs1;
                                    tmp16.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp15, tmp16);
                                    // End Binary operator: ==
                                    boolean tmp17 = ( tmp15.getIntValue() != 0 );
                                    if ( tmp17 ) {
                                    } else {
                                        // Binary operator: $len > 1
                                        TclObject tmp18 = getVarScalar(interp, "len", compiledLocals, 6);
                                        ExprValue tmp19 = evs0;
                                        TJC.exprInitValue(interp, tmp19, tmp18);
                                        ExprValue tmp20 = evs1;
                                        tmp20.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp19, tmp20);
                                        // End Binary operator: >
                                        boolean tmp21 = ( tmp19.getIntValue() != 0 );
                                        if ( tmp21 ) {
                                            { // Invoke: ... $key [...]
                                                TclObject[] objv22 = TJC.grabObjv(interp, 3);
                                                TclObject tmp23;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv22[0] = const0;
                                                    // Arg 1 variable: $key
                                                    tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                                                    tmp23.preserve();
                                                    objv22[1] = tmp23;
                                                    // Arg 2 command: [...]
                                                    { // Invoke: list $ckey
                                                        TclObject tmp24 = TclList.newInstance();
                                                        TclObject tmp25;
                                                        tmp25 = getVarScalar(interp, "ckey", compiledLocals, 5);
                                                        TclList.append(interp, tmp24, tmp25);
                                                        interp.setResult(tmp24);
                                                    } // End Invoke: list
                                                    tmp23 = interp.getResult();
                                                    tmp23.preserve();
                                                    objv22[2] = tmp23;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                        ? cmdcache1.cmd : null), objv22, 0);
                                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                        updateCmdCache(interp, 1);
                                                    }
                                                } finally {
                                                    tmp23 = objv22[1];
                                                    if ( tmp23 != null ) {
                                                        tmp23.release();
                                                    }
                                                    tmp23 = objv22[2];
                                                    if ( tmp23 != null ) {
                                                        tmp23.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv22, 3);
                                                }
                                            } // End Invoke: ...
                                        } else {
                                            { // Invoke: lappend trimmed_klist $ckey
                                                TclObject[] objv26 = TJC.grabObjv(interp, 1);
                                                TclObject tmp27;
                                                try {
                                                    // Arg 2 variable: $ckey
                                                    tmp27 = getVarScalar(interp, "ckey", compiledLocals, 5);
                                                    tmp27.preserve();
                                                    objv26[0] = tmp27;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "trimmed_klist", objv26, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv26, 1);
                                                }
                                            } // End Invoke: lappend
                                        }
                                    }
                                } // End Invoke: if
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: set klist $trimmed_klist
                        TclObject tmp28;
                        tmp28 = getVarScalar(interp, "trimmed_klist", compiledLocals, 4);
                        setVarScalar(interp, "klist", tmp28, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: if {$klist == {}} ...
                        // Binary operator: $klist == ""
                        TclObject tmp29 = getVarScalar(interp, "klist", compiledLocals, 3);
                        ExprValue tmp30 = evs0;
                        TJC.exprEqualsEmptyString(tmp30, tmp29, false);
                        // End Binary operator: ==
                        boolean tmp31 = ( tmp30.getIntValue() != 0 );
                        if ( tmp31 ) {
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: foreach ckey $klist ...
                        TclObject tmp32 = null;
                        try {
                            tmp32 = getVarScalar(interp, "klist", compiledLocals, 3);
                            tmp32.preserve();
                            final int tmp32_length = TclList.getLength(interp, tmp32);

                            for ( int index33 = 0 ; index33 < tmp32_length ; index33++ ) {
                                TclObject tmp34 = TclList.index(interp, tmp32, index33);
                                try {
                                    setVarScalar(interp, "ckey", tmp34, compiledLocals, 5);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "ckey");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set "..." $key
                                    TclObject tmp35;
                                    String tmp36;
                                    StringBuffer sbtmp37 = new StringBuffer(64);
                                    tmp35 = getVarScalar(interp, "ckey", compiledLocals, 5);
                                    sbtmp37.append(tmp35.toString());
                                    sbtmp37.append(",container");
                                    tmp36 = sbtmp37.toString();
                                    tmp35 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp35 = setVarArray(interp, "_compileproc_key_info", tmp36, tmp35, compiledLocals, 2);
                                } // End Invoke: set
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: ... $klist
                        TclObject[] objv38 = TJC.grabObjv(interp, 2);
                        TclObject tmp39;
                        try {
                            // Arg 0 constant: ...
                            objv38[0] = const1;
                            // Arg 1 variable: $klist
                            tmp39 = getVarScalar(interp, "klist", compiledLocals, 3);
                            tmp39.preserve();
                            objv38[1] = tmp39;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv38, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp39 = objv38[1];
                            if ( tmp39 != null ) {
                                tmp39.release();
                            }
                            TJC.releaseObjv(interp, objv38, 2);
                        }
                    } // End Invoke: ...
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp0 != null ) {
                    tmp0.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_scan_keys_in_container_sublist");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_scan_keys_in_container_sublist");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_scan_keys");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_scan_keys_in_container_sublist";
                break;
            }
            case 2: {
                cmdName = "compileproc_scan_keys";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "klists",
        "_compileproc_key_info",
        "klist",
        "trimmed_klist",
        "ckey",
        "len"
    };
} // end class CompileprocScanKeysInContainerSublistCmd

