// TJC implementation of procedure compileproc_split_classname
package tjc;
import tcl.lang.*;

public class CompileprocSplitClassnameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "class_name");
        }
        setVarScalar(interp, "class_name", objv[1], compiledLocals, 0);
        { // Invoke: set elems [...]
            TclObject tmp0;
            { // Invoke: split $class_name .
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: split
                    objv1[0] = const0;
                    // Arg 1 variable: $class_name
                    tmp2 = getVarScalar(interp, "class_name", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: .
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: split
            tmp0 = interp.getResult();
            setVarScalar(interp, "elems", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: [...] == 1
            { // Invoke: llength $elems
                TclObject tmp3 = getVarScalar(interp, "elems", compiledLocals, 1);
                int tmp4 = TclList.getLength(interp, tmp3);
                interp.setResult(tmp4);
            } // End Invoke: llength
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            ExprValue tmp7 = evs1;
            tmp7.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp6, tmp7);
            // End Binary operator: ==
            boolean tmp8 = ( tmp6.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return [...]
                    { // Invoke: list default $class_name
                        TclObject tmp9 = TclList.newInstance();
                        TclObject tmp10;
                        try {
                            TclList.append(interp, tmp9, const2);
                            tmp10 = getVarScalar(interp, "class_name", compiledLocals, 0);
                            TclList.append(interp, tmp9, tmp10);
                        } catch (TclException ex) {
                            tmp9.release();
                            throw ex;
                        }
                        interp.setResult(tmp9);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return [...]
                    { // Invoke: list [...] [...]
                        TclObject tmp11 = TclList.newInstance();
                        TclObject tmp12;
                        try {
                            { // Invoke: join [...] .
                                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                                TclObject tmp14;
                                try {
                                    // Arg 0 constant: join
                                    objv13[0] = const3;
                                    // Arg 1 command: [...]
                                    { // Invoke: lrange $elems 0 end-1
                                        TclObject[] objv15 = TJC.grabObjv(interp, 4);
                                        TclObject tmp16;
                                        try {
                                            // Arg 0 constant: lrange
                                            objv15[0] = const4;
                                            // Arg 1 variable: $elems
                                            tmp16 = getVarScalar(interp, "elems", compiledLocals, 1);
                                            tmp16.preserve();
                                            objv15[1] = tmp16;
                                            // Arg 2 constant: 0
                                            objv15[2] = const5;
                                            // Arg 3 constant: end-1
                                            objv15[3] = const6;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv15, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp16 = objv15[1];
                                            if ( tmp16 != null ) {
                                                tmp16.release();
                                            }
                                            TJC.releaseObjv(interp, objv15, 4);
                                        }
                                    } // End Invoke: lrange
                                    tmp14 = interp.getResult();
                                    tmp14.preserve();
                                    objv13[1] = tmp14;
                                    // Arg 2 constant: .
                                    objv13[2] = const1;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv13, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp14 = objv13[1];
                                    if ( tmp14 != null ) {
                                        tmp14.release();
                                    }
                                    TJC.releaseObjv(interp, objv13, 3);
                                }
                            } // End Invoke: join
                            tmp12 = interp.getResult();
                            TclList.append(interp, tmp11, tmp12);
                            { // Invoke: lindex $elems end
                                TclObject tmp17 = null;
                                TclObject tmp18;
                                try {
                                    tmp17 = getVarScalar(interp, "elems", compiledLocals, 1);
                                    tmp17.preserve();
                                    tmp18 = const7;
                                    TJC.lindexNonconst(interp, tmp17, tmp18);
                                } finally {
                                    if ( tmp17 != null ) {
                                        tmp17.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp12 = interp.getResult();
                            TclList.append(interp, tmp11, tmp12);
                        } catch (TclException ex) {
                            tmp11.release();
                            throw ex;
                        }
                        interp.setResult(tmp11);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_split_classname");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("split");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance(".");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("default");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("join");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lrange");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("end-1");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("end");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "split";
                break;
            }
            case 2: {
                cmdName = "lrange";
                break;
            }
            case 3: {
                cmdName = "join";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "class_name",
        "elems"
    };
} // end class CompileprocSplitClassnameCmd

