// TJC implementation of procedure descend_check_word_for_nested_commands_iterator
package tjc;
import tcl.lang.*;

public class DescendCheckWordForNestedCommandsIteratorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: switch -exact -- $type {backslash} ... {command} ... {text} ... {variable} ... {word begin} - {word end} - {word} ... default ...
            TclObject tmp0 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( tmp1_length == 9 && tmp1_first == 'b'
                    && tmp1.compareTo("backslash") == 0 ) {
                // Pattern {backslash}
            } else if ( tmp1_length == 7 && tmp1_first == 'c'
                    && tmp1.compareTo("command") == 0 ) {
                // Pattern {command}
                { // Invoke: ...
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv2[0] = const0;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $script $stree
                    TclObject[] objv3 = TJC.grabObjv(interp, 3);
                    TclObject tmp4;
                    try {
                        // Arg 0 constant: ...
                        objv3[0] = const1;
                        // Arg 1 variable: $script
                        tmp4 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp4.preserve();
                        objv3[1] = tmp4;
                        // Arg 2 variable: $stree
                        tmp4 = getVarScalar(interp, "stree", compiledLocals, 1);
                        tmp4.preserve();
                        objv3[2] = tmp4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp4 = objv3[1];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        tmp4 = objv3[2];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 3);
                    }
                } // End Invoke: ...
                { // Invoke: ... [...]
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: ...
                        objv5[0] = const2;
                        // Arg 1 command: [...]
                        { // Invoke: ...
                            TclObject[] objv7 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv7[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv7, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv7, 1);
                            }
                        } // End Invoke: ...
                        tmp6 = interp.getResult();
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv5, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 4 && tmp1_first == 't'
                    && tmp1.compareTo("text") == 0 ) {
                // Pattern {text}
            } else if ( tmp1_length == 8 && tmp1_first == 'v'
                    && tmp1.compareTo("variable") == 0 ) {
                // Pattern {variable}
                { // Invoke: ... $script $stree
                    TclObject[] objv8 = TJC.grabObjv(interp, 3);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: ...
                        objv8[0] = const4;
                        // Arg 1 variable: $script
                        tmp9 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        // Arg 2 variable: $stree
                        tmp9 = getVarScalar(interp, "stree", compiledLocals, 1);
                        tmp9.preserve();
                        objv8[2] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv8, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        tmp9 = objv8[2];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 3);
                    }
                } // End Invoke: ...
            } else if ( ( tmp1_length == 10 && tmp1_first == 'w'
                    && tmp1.compareTo("word begin") == 0 ) ||
                ( tmp1_length == 8 && tmp1_first == 'w'
                    && tmp1.compareTo("word end") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'w'
                    && tmp1.compareTo("word") == 0 ) ) {
                // Pattern {word}
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("unknown type ");
                        sbtmp12.append("\"");
                        tmp11 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("\"");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv10, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_check_word_for_nested_commands_iterator");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("_descend_commands_push");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_nested_subtree");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_descend_commands_add");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_descend_commands_pop");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_check_variable_for_nested_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 2: {
                cmdName = "descend_nested_subtree";
                break;
            }
            case 3: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 4: {
                cmdName = "_descend_commands_add";
                break;
            }
            case 5: {
                cmdName = "descend_check_variable_for_nested_commands";
                break;
            }
            case 6: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges"
    };
} // end class DescendCheckWordForNestedCommandsIteratorCmd

