// TJC implementation of procedure descend_container_expr_argument_iterate_callback
package tjc;
import tcl.lang.*;

public class DescendContainerExprArgumentIterateCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script etree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "etree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: switch -exact -- $type {literal operand} ... {command operand} ... {variable operand} ... {word operand} ... {unary operator} ... {binary operator} ... {ternary operator} ... {math function} ... {subexpression} ... {value} ... default ...
            TclObject tmp0 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( tmp1_length == 15 && tmp1_first == 'l'
                    && tmp1.compareTo("literal operand") == 0 ) {
                // Pattern {literal operand}
            } else if ( tmp1_length == 15 && tmp1_first == 'c'
                    && tmp1.compareTo("command operand") == 0 ) {
                // Pattern {command operand}
                { // Invoke: set cmd_script $script
                    TclObject tmp2;
                    tmp2 = getVarScalar(interp, "script", compiledLocals, 0);
                    setVarScalar(interp, "cmd_script", tmp2, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set cmd_range [...]
                    TclObject tmp3;
                    { // Invoke: lindex $ranges 0
                        TclObject tmp4 = getVarScalar(interp, "ranges", compiledLocals, 4);
                        tmp4 = TclList.index(interp, tmp4, 0);
                        if ( tmp4 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp4);
                        }
                    } // End Invoke: lindex
                    tmp3 = interp.getResult();
                    setVarScalar(interp, "cmd_range", tmp3, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: ...
                    TclObject[] objv5 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv5[0] = const0;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv5, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv5, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $script $etree
                    TclObject[] objv6 = TJC.grabObjv(interp, 3);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: ...
                        objv6[0] = const1;
                        // Arg 1 variable: $script
                        tmp7 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        // Arg 2 variable: $etree
                        tmp7 = getVarScalar(interp, "etree", compiledLocals, 1);
                        tmp7.preserve();
                        objv6[2] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        tmp7 = objv6[2];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 3);
                    }
                } // End Invoke: ...
                { // Invoke: ... [...]
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: ...
                        objv8[0] = const2;
                        // Arg 1 command: [...]
                        { // Invoke: ...
                            TclObject[] objv10 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv10[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv10, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv10, 1);
                            }
                        } // End Invoke: ...
                        tmp9 = interp.getResult();
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv8, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 16 && tmp1_first == 'v'
                    && tmp1.compareTo("variable operand") == 0 ) {
                // Pattern {variable operand}
                { // Invoke: ... $script $etree
                    TclObject[] objv11 = TJC.grabObjv(interp, 3);
                    TclObject tmp12;
                    try {
                        // Arg 0 constant: ...
                        objv11[0] = const4;
                        // Arg 1 variable: $script
                        tmp12 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        // Arg 2 variable: $etree
                        tmp12 = getVarScalar(interp, "etree", compiledLocals, 1);
                        tmp12.preserve();
                        objv11[2] = tmp12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv11, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        tmp12 = objv11[2];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 12 && tmp1_first == 'w'
                    && tmp1.compareTo("word operand") == 0 ) {
                // Pattern {word operand}
                { // Invoke: ... $script $etree
                    TclObject[] objv13 = TJC.grabObjv(interp, 3);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: ...
                        objv13[0] = const5;
                        // Arg 1 variable: $script
                        tmp14 = getVarScalar(interp, "script", compiledLocals, 0);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        // Arg 2 variable: $etree
                        tmp14 = getVarScalar(interp, "etree", compiledLocals, 1);
                        tmp14.preserve();
                        objv13[2] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv13, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        tmp14 = objv13[2];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 3);
                    }
                } // End Invoke: ...
            } else if ( tmp1_length == 14 && tmp1_first == 'u'
                    && tmp1.compareTo("unary operator") == 0 ) {
                // Pattern {unary operator}
            } else if ( tmp1_length == 15 && tmp1_first == 'b'
                    && tmp1.compareTo("binary operator") == 0 ) {
                // Pattern {binary operator}
            } else if ( tmp1_length == 16 && tmp1_first == 't'
                    && tmp1.compareTo("ternary operator") == 0 ) {
                // Pattern {ternary operator}
            } else if ( tmp1_length == 13 && tmp1_first == 'm'
                    && tmp1.compareTo("math function") == 0 ) {
                // Pattern {math function}
            } else if ( tmp1_length == 13 && tmp1_first == 's'
                    && tmp1.compareTo("subexpression") == 0 ) {
                // Pattern {subexpression}
            } else if ( tmp1_length == 5 && tmp1_first == 'v'
                    && tmp1.compareTo("value") == 0 ) {
                // Pattern {value}
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv15 = TJC.grabObjv(interp, 2);
                    TclObject tmp16;
                    try {
                        // Arg 0 constant: error
                        objv15[0] = const6;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp17 = new StringBuffer(64);
                        sbtmp17.append("unknown type ");
                        sbtmp17.append("\"");
                        tmp16 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp17.append(tmp16.toString());
                        sbtmp17.append("\"");
                        tmp16 = TclString.newInstance(sbtmp17);
                        tmp16.preserve();
                        objv15[1] = tmp16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv15, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp16 = objv15[1];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_expr_argument_iterate_callback");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("_descend_commands_push");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_nested_subtree");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_descend_commands_add");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_descend_commands_pop");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_check_variable_for_nested_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_check_word_for_nested_commands");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 2: {
                cmdName = "descend_nested_subtree";
                break;
            }
            case 3: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 4: {
                cmdName = "_descend_commands_add";
                break;
            }
            case 5: {
                cmdName = "descend_check_variable_for_nested_commands";
                break;
            }
            case 6: {
                cmdName = "descend_check_word_for_nested_commands";
                break;
            }
            case 7: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "etree",
        "type",
        "values",
        "ranges",
        "cmd_script",
        "cmd_range"
    };
} // end class DescendContainerExprArgumentIterateCallbackCmd

