// TJC implementation of procedure descend_container_if_else_body
package tjc;
import tcl.lang.*;

public class DescendContainerIfElseBodyCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set validated [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key validated
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: validated
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "validated", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$validated == {}} ...
            // Binary operator: $validated == ""
            TclObject tmp3 = getVarScalar(interp, "validated", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, false);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "not validated"
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const2;
                        // Arg 1 constant: "not validated"
                        objv6[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set body [...]
            TclObject tmp7;
            { // Invoke: lindex $validated 2
                TclObject tmp8 = getVarScalar(interp, "validated", compiledLocals, 1);
                tmp8 = TclList.index(interp, tmp8, 2);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "body", tmp7, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $body
                TclObject tmp9 = getVarScalar(interp, "body", compiledLocals, 2);
                int tmp10 = TclList.getLength(interp, tmp9);
                interp.setResult(tmp10);
            } // End Invoke: llength
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            TJC.exprInitValue(interp, tmp12, tmp11);
            ExprValue tmp13 = evs1;
            tmp13.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp12, tmp13);
            // End Binary operator: ==
            boolean tmp14 = ( tmp12.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: error "no else body"
                    TclObject[] objv15 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv15[0] = const2;
                        // Arg 1 constant: "no else body"
                        objv15[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv15, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv15, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] > 1
            { // Invoke: llength $body
                TclObject tmp16 = getVarScalar(interp, "body", compiledLocals, 2);
                int tmp17 = TclList.getLength(interp, tmp16);
                interp.setResult(tmp17);
            } // End Invoke: llength
            TclObject tmp18 = interp.getResult();
            ExprValue tmp19 = evs0;
            TJC.exprInitValue(interp, tmp19, tmp18);
            ExprValue tmp20 = evs1;
            tmp20.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp19, tmp20);
            // End Binary operator: >
            boolean tmp21 = ( tmp19.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: error ...
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv22[0] = const2;
                        // Arg 1 constant: ...
                        objv22[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv22, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return $body
            TclObject tmp23 = getVarScalar(interp, "body", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp23);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_if_else_body");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("validated");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("not validated");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("no else body");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("too many else body elements");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "validated",
        "body"
    };
} // end class DescendContainerIfElseBodyCmd

