// TJC implementation of procedure descend_range_quoted
package tjc;
import tcl.lang.*;

public class DescendRangeQuotedCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "script subtree range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "subtree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "range", objv[3], compiledLocals, 2);
        { // Invoke: set range_text [...]
            TclObject tmp0;
            { // Invoke: parse getstring $script $range
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: parse
                    objv1[0] = const0;
                    // Arg 1 constant: getstring
                    objv1[1] = const1;
                    // Arg 2 variable: $script
                    tmp2 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 variable: $range
                    tmp2 = getVarScalar(interp, "range", compiledLocals, 2);
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: parse
            tmp0 = interp.getResult();
            setVarScalar(interp, "range_text", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set first [...]
            TclObject tmp3;
            { // Invoke: string index $range_text 0
                TclObject tmp4 = getVarScalar(interp, "range_text", compiledLocals, 3);
                String tmp5 = tmp4.toString();
                TclObject tmp6 = TJC.stringIndex(interp, tmp5, const2);
                interp.setResult(tmp6);
            } // End Invoke: string
            tmp3 = interp.getResult();
            setVarScalar(interp, "first", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp7;
            { // Invoke: string index $range_text end
                TclObject tmp8 = getVarScalar(interp, "range_text", compiledLocals, 3);
                String tmp9 = tmp8.toString();
                TclObject tmp10 = TJC.stringIndex(interp, tmp9, const3);
                interp.setResult(tmp10);
            } // End Invoke: string
            tmp7 = interp.getResult();
            setVarScalar(interp, "last", tmp7, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set trim 0
            setVarScalar(interp, "trim", const2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set err 0
            setVarScalar(interp, "err", const2, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set isbraced 0
            setVarScalar(interp, "isbraced", const2, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ...
            // Binary operator: $first == "{"
            TclObject tmp11 = getVarScalar(interp, "first", compiledLocals, 4);
            boolean tmp12 = tmp11.toString().equals("{");
            ExprValue tmp13 = evs0;
            tmp13.setIntValue(tmp12);
            // End Binary operator: ==
            boolean tmp14 = ( tmp13.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: if ... ... else ...
                    // Binary operator: $last == "}"
                    TclObject tmp15 = getVarScalar(interp, "last", compiledLocals, 5);
                    boolean tmp16 = tmp15.toString().equals("}");
                    ExprValue tmp17 = evs0;
                    tmp17.setIntValue(tmp16);
                    // End Binary operator: ==
                    boolean tmp18 = ( tmp17.getIntValue() != 0 );
                    if ( tmp18 ) {
                        { // Invoke: set trim 1
                            setVarScalar(interp, "trim", const4, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set isbraced 1
                            setVarScalar(interp, "isbraced", const4, compiledLocals, 8);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set err 1
                            setVarScalar(interp, "err", const4, compiledLocals, 7);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else {
                // Binary operator: $last == "}"
                TclObject tmp19 = getVarScalar(interp, "last", compiledLocals, 5);
                boolean tmp20 = tmp19.toString().equals("}");
                ExprValue tmp21 = evs0;
                tmp21.setIntValue(tmp20);
                // End Binary operator: ==
                boolean tmp22 = ( tmp21.getIntValue() != 0 );
                if ( tmp22 ) {
                    { // Invoke: set err 1
                        setVarScalar(interp, "err", const4, compiledLocals, 7);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif ... ...
            // Binary operator: $first == "\""
            TclObject tmp23 = getVarScalar(interp, "first", compiledLocals, 4);
            boolean tmp24 = tmp23.toString().equals("\"");
            ExprValue tmp25 = evs0;
            tmp25.setIntValue(tmp24);
            // End Binary operator: ==
            boolean tmp26 = ( tmp25.getIntValue() != 0 );
            if ( tmp26 ) {
                { // Invoke: if ... ... else ...
                    // Binary operator: $last == "\""
                    TclObject tmp27 = getVarScalar(interp, "last", compiledLocals, 5);
                    boolean tmp28 = tmp27.toString().equals("\"");
                    ExprValue tmp29 = evs0;
                    tmp29.setIntValue(tmp28);
                    // End Binary operator: ==
                    boolean tmp30 = ( tmp29.getIntValue() != 0 );
                    if ( tmp30 ) {
                        { // Invoke: set trim 1
                            setVarScalar(interp, "trim", const4, compiledLocals, 6);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set err 1
                            setVarScalar(interp, "err", const4, compiledLocals, 7);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else {
                // Binary operator: $last == "\""
                TclObject tmp31 = getVarScalar(interp, "last", compiledLocals, 5);
                boolean tmp32 = tmp31.toString().equals("\"");
                ExprValue tmp33 = evs0;
                tmp33.setIntValue(tmp32);
                // End Binary operator: ==
                boolean tmp34 = ( tmp33.getIntValue() != 0 );
                if ( tmp34 ) {
                    { // Invoke: set err 1
                        setVarScalar(interp, "err", const4, compiledLocals, 7);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if {$err} ...
            TclObject tmp35 = getVarScalar(interp, "err", compiledLocals, 7);
            boolean tmp36 = TJC.getBoolean(interp, tmp35);
            if ( tmp36 ) {
                { // Invoke: error "..."
                    TclObject[] objv37 = TJC.grabObjv(interp, 2);
                    TclObject tmp38;
                    try {
                        // Arg 0 constant: error
                        objv37[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp39 = new StringBuffer(64);
                        sbtmp39.append("mismatched quoting for quoted text ");
                        sbtmp39.append("\"");
                        tmp38 = getVarScalar(interp, "range_text", compiledLocals, 3);
                        sbtmp39.append(tmp38.toString());
                        sbtmp39.append("\"");
                        tmp38 = TclString.newInstance(sbtmp39);
                        tmp38.preserve();
                        objv37[1] = tmp38;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv37, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp38 = objv37[1];
                        if ( tmp38 != null ) {
                            tmp38.release();
                        }
                        TJC.releaseObjv(interp, objv37, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {!$trim} ...
            // Unary operator: ! $trim
            TclObject tmp40 = getVarScalar(interp, "trim", compiledLocals, 6);
            ExprValue tmp41 = evs0;
            if ( tmp40.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp41, tmp40);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp41, tmp40);
            }
            // End Unary operator: !
            boolean tmp42 = ( tmp41.getIntValue() != 0 );
            if ( tmp42 ) {
                { // Invoke: return [...]
                    { // Invoke: list $range 0
                        TclObject tmp43 = TclList.newInstance();
                        TclObject tmp44;
                        try {
                            tmp44 = getVarScalar(interp, "range", compiledLocals, 2);
                            TclList.append(interp, tmp43, tmp44);
                            TclList.append(interp, tmp43, const2);
                        } catch (TclException ex) {
                            tmp43.release();
                            throw ex;
                        }
                        interp.setResult(tmp43);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set range_start [...]
            TclObject tmp45;
            { // Invoke: lindex $range 0
                TclObject tmp46 = getVarScalar(interp, "range", compiledLocals, 2);
                tmp46 = TclList.index(interp, tmp46, 0);
                if ( tmp46 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp46);
                }
            } // End Invoke: lindex
            tmp45 = interp.getResult();
            setVarScalar(interp, "range_start", tmp45, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set range_len [...]
            TclObject tmp47;
            { // Invoke: lindex $range 1
                TclObject tmp48 = getVarScalar(interp, "range", compiledLocals, 2);
                tmp48 = TclList.index(interp, tmp48, 1);
                if ( tmp48 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp48);
                }
            } // End Invoke: lindex
            tmp47 = interp.getResult();
            setVarScalar(interp, "range_len", tmp47, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: list [...] $isbraced
                TclObject tmp49 = TclList.newInstance();
                TclObject tmp50;
                try {
                    { // Invoke: list [...] [...]
                        TclObject tmp51 = TclList.newInstance();
                        TclObject tmp52;
                        try {
                            { // Invoke: expr {$range_start + 1}
                                // Binary operator: $range_start + 1
                                TclObject tmp53 = getVarScalar(interp, "range_start", compiledLocals, 9);
                                ExprValue tmp54 = evs0;
                                TJC.exprInitValue(interp, tmp54, tmp53);
                                ExprValue tmp55 = evs1;
                                tmp55.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp54, tmp55);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp54);
                            } // End Invoke: expr
                            tmp52 = interp.getResult();
                            TclList.append(interp, tmp51, tmp52);
                            { // Invoke: expr {$range_len - 2}
                                // Binary operator: $range_len - 2
                                TclObject tmp56 = getVarScalar(interp, "range_len", compiledLocals, 10);
                                ExprValue tmp57 = evs0;
                                TJC.exprInitValue(interp, tmp57, tmp56);
                                ExprValue tmp58 = evs1;
                                tmp58.setIntValue(2);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp57, tmp58);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp57);
                            } // End Invoke: expr
                            tmp52 = interp.getResult();
                            TclList.append(interp, tmp51, tmp52);
                        } catch (TclException ex) {
                            tmp51.release();
                            throw ex;
                        }
                        interp.setResult(tmp51);
                    } // End Invoke: list
                    tmp50 = interp.getResult();
                    TclList.append(interp, tmp49, tmp50);
                    tmp50 = getVarScalar(interp, "isbraced", compiledLocals, 8);
                    TclList.append(interp, tmp49, tmp50);
                } catch (TclException ex) {
                    tmp49.release();
                    throw ex;
                }
                interp.setResult(tmp49);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_range_quoted");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("getstring");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "subtree",
        "range",
        "range_text",
        "first",
        "last",
        "trim",
        "err",
        "isbraced",
        "range_start",
        "range_len"
    };
} // end class DescendRangeQuotedCmd

