// TJC implementation of procedure descend_report_command
package tjc;
import tcl.lang.*;

public class DescendReportCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend_callbacks
            TJC.makeGlobalLinkVar(interp, "_descend_callbacks", "_descend_callbacks", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: ...
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            boolean tmp3 = tmp2.getBooleanValue(interp);
            if ( tmp3 ) {
                { // Invoke: set cmd $...
                    TclObject tmp4;
                    tmp4 = getVarArray(interp, "_descend_callbacks", "report_command", compiledLocals, 1);
                    setVarScalar(interp, "cmd", tmp4, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: namespace eval :: [...]
                    TclObject[] objv5 = TJC.grabObjv(interp, 4);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: namespace
                        objv5[0] = const3;
                        // Arg 1 constant: eval
                        objv5[1] = const4;
                        // Arg 2 constant: ::
                        objv5[2] = const5;
                        // Arg 3 command: [...]
                        { // Invoke: list $cmd $key
                            TclObject tmp7 = TclList.newInstance();
                            TclObject tmp8;
                            try {
                                tmp8 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                TclList.append(interp, tmp7, tmp8);
                                tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                                TclList.append(interp, tmp7, tmp8);
                            } catch (TclException ex) {
                                tmp7.release();
                                throw ex;
                            }
                            interp.setResult(tmp7);
                        } // End Invoke: list
                        tmp6 = interp.getResult();
                        tmp6.preserve();
                        objv5[3] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[3];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 4);
                    }
                } // End Invoke: namespace
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_report_command");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_descend_callbacks(report_command)");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("namespace");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("eval");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("::");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "namespace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend_callbacks",
        "cmd"
    };
} // end class DescendReportCommandCmd

