// TJC implementation of procedure emitter_callframe_pop
package tjc;
import tcl.lang.*;

public class EmitterCallframePopCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "proc_name ?finally_buffer?");
        }
        setVarScalar(interp, "proc_name", objv[1], compiledLocals, 0);
        setVarScalar(interp, "finally_buffer", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...] ...
            TclObject[] objv0 = TJC.grabObjv(interp, 2);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 constant: ...
                objv0[1] = const2;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 2);
            } finally {
                tmp1 = objv0[0];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv3 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv3[0] = const3;
                // Arg 1 constant: +1
                objv3[1] = const4;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv3, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv3, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set proc_name_symbol [...]
            TclObject tmp4;
            { // Invoke: ... $proc_name
                TclObject[] objv5 = TJC.grabObjv(interp, 2);
                TclObject tmp6;
                try {
                    // Arg 0 constant: ...
                    objv5[0] = const5;
                    // Arg 1 variable: $proc_name
                    tmp6 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                    tmp6.preserve();
                    objv5[1] = tmp6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv5, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp6 = objv5[1];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    TJC.releaseObjv(interp, objv5, 2);
                }
            } // End Invoke: ...
            tmp4 = interp.getResult();
            setVarScalar(interp, "proc_name_symbol", tmp4, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... $proc_name_symbol ")" ...
            TclObject[] objv7 = TJC.grabObjv(interp, 5);
            TclObject tmp8;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv9 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv9[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv9, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv9, 1);
                    }
                } // End Invoke: emitter_indent
                tmp8 = interp.getResult();
                tmp8.preserve();
                objv7[0] = tmp8;
                // Arg 3 constant: ...
                objv7[1] = const6;
                // Arg 4 variable: $proc_name_symbol
                tmp8 = getVarScalar(interp, "proc_name_symbol", compiledLocals, 3);
                tmp8.preserve();
                objv7[2] = tmp8;
                // Arg 5 constant: ")"
                objv7[3] = const7;
                // Arg 6 constant: ...
                objv7[4] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv7, compiledLocals, 2);
            } finally {
                tmp8 = objv7[0];
                if ( tmp8 != null ) {
                    tmp8.release();
                }
                tmp8 = objv7[2];
                if ( tmp8 != null ) {
                    tmp8.release();
                }
                TJC.releaseObjv(interp, objv7, 5);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv10 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv10[0] = const3;
                // Arg 1 constant: -1
                objv10[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv10, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv10, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv11 = TJC.grabObjv(interp, 2);
            TclObject tmp12;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv13 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv13[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv13, 1);
                    }
                } // End Invoke: emitter_indent
                tmp12 = interp.getResult();
                tmp12.preserve();
                objv11[0] = tmp12;
                // Arg 3 constant: ...
                objv11[1] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv11, compiledLocals, 2);
            } finally {
                tmp12 = objv11[0];
                if ( tmp12 != null ) {
                    tmp12.release();
                }
                TJC.releaseObjv(interp, objv11, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv14 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv14[0] = const3;
                // Arg 1 constant: +1
                objv14[1] = const4;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv14, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv14, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            // Binary operator: $finally_buffer != ""
            TclObject tmp15 = getVarScalar(interp, "finally_buffer", compiledLocals, 1);
            ExprValue tmp16 = evs0;
            TJC.exprEqualsEmptyString(tmp16, tmp15, true);
            // End Binary operator: !=
            boolean tmp17 = ( tmp16.getIntValue() != 0 );
            if ( tmp17 ) {
                { // Invoke: append buffer $finally_buffer
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    TclObject tmp19;
                    try {
                        // Arg 2 variable: $finally_buffer
                        tmp19 = getVarScalar(interp, "finally_buffer", compiledLocals, 1);
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv18, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv18, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ... ...
            TclObject[] objv20 = TJC.grabObjv(interp, 3);
            TclObject tmp21;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv22 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv22[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv22, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv22, 1);
                    }
                } // End Invoke: emitter_indent
                tmp21 = interp.getResult();
                tmp21.preserve();
                objv20[0] = tmp21;
                // Arg 3 constant: ...
                objv20[1] = const11;
                // Arg 4 constant: ...
                objv20[2] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv20, compiledLocals, 2);
            } finally {
                tmp21 = objv20[0];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                TJC.releaseObjv(interp, objv20, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv23 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv23[0] = const3;
                // Arg 1 constant: -1
                objv23[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv23, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv23, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv24 = TJC.grabObjv(interp, 2);
            TclObject tmp25;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv26 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv26[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv26, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv26, 1);
                    }
                } // End Invoke: emitter_indent
                tmp25 = interp.getResult();
                tmp25.preserve();
                objv24[0] = tmp25;
                // Arg 3 constant: ...
                objv24[1] = const12;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv24, compiledLocals, 2);
            } finally {
                tmp25 = objv24[0];
                if ( tmp25 != null ) {
                    tmp25.release();
                }
                TJC.releaseObjv(interp, objv24, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp27 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp27);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_callframe_pop");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("} catch (TclException te) {\n");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent_level");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("+1");
        TclInteger.get(interp, const4);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_double_quote_tcl_string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("TJC.checkTclException(interp, te, ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(")");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(";\n");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("} finally {\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("TJC.popLocalCallFrame(interp, callFrame)");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("}\n");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 3: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_name",
        "finally_buffer",
        "buffer",
        "proc_name_symbol"
    };
} // end class EmitterCallframePopCmd

