// TJC implementation of procedure emitter_eval_proc_body
package tjc;
import tcl.lang.*;

public class EmitterEvalProcBodyCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "body");
        }
        setVarScalar(interp, "body", objv[1], compiledLocals, 0);
        { // Invoke: regsub -all ... $body ... body
            TclObject[] objv0 = TJC.grabObjv(interp, 6);
            TclObject tmp1;
            try {
                // Arg 0 constant: regsub
                objv0[0] = const0;
                // Arg 1 constant: -all
                objv0[1] = const1;
                // Arg 2 constant: ...
                objv0[2] = const2;
                // Arg 3 variable: $body
                tmp1 = getVarScalar(interp, "body", compiledLocals, 0);
                tmp1.preserve();
                objv0[3] = tmp1;
                // Arg 4 constant: ...
                objv0[4] = const3;
                // Arg 5 constant: body
                objv0[5] = const4;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp1 = objv0[3];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 6);
            }
        } // End Invoke: regsub
        { // Invoke: set body_symbol [...]
            TclObject tmp2;
            { // Invoke: ... $body
                TclObject[] objv3 = TJC.grabObjv(interp, 2);
                TclObject tmp4;
                try {
                    // Arg 0 constant: ...
                    objv3[0] = const5;
                    // Arg 1 variable: $body
                    tmp4 = getVarScalar(interp, "body", compiledLocals, 0);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv3, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 2);
                }
            } // End Invoke: ...
            tmp2 = interp.getResult();
            setVarScalar(interp, "body_symbol", tmp2, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const6, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...] "String body = " $body_symbol ... [...] ... ... [...] "return" ...
            TclObject[] objv5 = TJC.grabObjv(interp, 10);
            TclObject tmp6;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv7 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv7[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv7, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv7, 1);
                    }
                } // End Invoke: emitter_indent
                tmp6 = interp.getResult();
                tmp6.preserve();
                objv5[0] = tmp6;
                // Arg 3 constant: "String body = "
                objv5[1] = const8;
                // Arg 4 variable: $body_symbol
                tmp6 = getVarScalar(interp, "body_symbol", compiledLocals, 1);
                tmp6.preserve();
                objv5[2] = tmp6;
                // Arg 5 constant: ...
                objv5[3] = const9;
                // Arg 6 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv8 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv8[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv8, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv8, 1);
                    }
                } // End Invoke: emitter_indent
                tmp6 = interp.getResult();
                tmp6.preserve();
                objv5[4] = tmp6;
                // Arg 7 constant: ...
                objv5[5] = const10;
                // Arg 8 constant: ...
                objv5[6] = const9;
                // Arg 9 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv9 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv9[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv9, 1);
                    }
                } // End Invoke: emitter_indent
                tmp6 = interp.getResult();
                tmp6.preserve();
                objv5[7] = tmp6;
                // Arg 10 constant: "return"
                objv5[8] = const11;
                // Arg 11 constant: ...
                objv5[9] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv5, compiledLocals, 2);
            } finally {
                tmp6 = objv5[0];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                tmp6 = objv5[2];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                tmp6 = objv5[4];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                tmp6 = objv5[7];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                TJC.releaseObjv(interp, objv5, 10);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp10 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_eval_proc_body");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("regsub");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("-all");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("\\\\");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("\\\\\\\\");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("body");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_double_quote_tcl_string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_indent");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("String body = ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(";\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("TJC.evalProcBody(interp, body)");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("return");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regsub";
                break;
            }
            case 2: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "body",
        "body_symbol",
        "buffer"
    };
} // end class EmitterEvalProcBodyCmd

