// TJC implementation of procedure emitter_get_compiled_local_array_var
package tjc;
import tcl.lang.*;

public class EmitterGetCompiledLocalArrayVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        try {
        if (objv.length != 7) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname key key_is_string clocal_array_symbol index");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "key", objv[3], compiledLocals, 2);
        setVarScalar(interp, "key_is_string", objv[4], compiledLocals, 3);
        setVarScalar(interp, "clocal_array_symbol", objv[5], compiledLocals, 4);
        setVarScalar(interp, "index", objv[6], compiledLocals, 5);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: append buffer [...] $tmpsymbol " = " ... [...] ...
            TclObject[] objv0 = TJC.grabObjv(interp, 6);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 variable: $tmpsymbol
                tmp1 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                tmp1.preserve();
                objv0[1] = tmp1;
                // Arg 4 constant: " = "
                objv0[2] = const2;
                // Arg 5 constant: ...
                objv0[3] = const3;
                // Arg 6 command: [...]
                { // Invoke: ... $varname
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 0 constant: ...
                        objv3[0] = const4;
                        // Arg 1 variable: $varname
                        tmp4 = getVarScalar(interp, "varname", compiledLocals, 1);
                        tmp4.preserve();
                        objv3[1] = tmp4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp4 = objv3[1];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[4] = tmp1;
                // Arg 7 constant: ...
                objv0[5] = const5;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 6);
            } finally {
                tmp1 = objv0[0];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                tmp1 = objv0[1];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                tmp1 = objv0[4];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 6);
            }
        } // End Invoke: append
        { // Invoke: if {$key_is_string} ... else ...
            TclObject tmp5 = getVarScalar(interp, "key_is_string", compiledLocals, 3);
            boolean tmp6 = TJC.getBoolean(interp, tmp5);
            if ( tmp6 ) {
                { // Invoke: append buffer ... [...] ...
                    TclObject[] objv7 = TJC.grabObjv(interp, 3);
                    TclObject tmp8;
                    try {
                        // Arg 2 constant: ...
                        objv7[0] = const6;
                        // Arg 3 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv9 = TJC.grabObjv(interp, 2);
                            TclObject tmp10;
                            try {
                                // Arg 0 constant: ...
                                objv9[0] = const4;
                                // Arg 1 variable: $key
                                tmp10 = getVarScalar(interp, "key", compiledLocals, 2);
                                tmp10.preserve();
                                objv9[1] = tmp10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv9, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp10 = objv9[1];
                                if ( tmp10 != null ) {
                                    tmp10.release();
                                }
                                TJC.releaseObjv(interp, objv9, 2);
                            }
                        } // End Invoke: ...
                        tmp8 = interp.getResult();
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        // Arg 4 constant: ...
                        objv7[2] = const5;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv7, compiledLocals, 6);
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 3);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer $key ", "
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    TclObject tmp12;
                    try {
                        // Arg 2 variable: $key
                        tmp12 = getVarScalar(interp, "key", compiledLocals, 2);
                        tmp12.preserve();
                        objv11[0] = tmp12;
                        // Arg 3 constant: ", "
                        objv11[1] = const7;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv11, compiledLocals, 6);
                    } finally {
                        tmp12 = objv11[0];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer $clocal_array_symbol ", " $index ...
            TclObject[] objv13 = TJC.grabObjv(interp, 4);
            TclObject tmp14;
            try {
                // Arg 2 variable: $clocal_array_symbol
                tmp14 = getVarScalar(interp, "clocal_array_symbol", compiledLocals, 4);
                tmp14.preserve();
                objv13[0] = tmp14;
                // Arg 3 constant: ", "
                objv13[1] = const7;
                // Arg 4 variable: $index
                tmp14 = getVarScalar(interp, "index", compiledLocals, 5);
                tmp14.preserve();
                objv13[2] = tmp14;
                // Arg 5 constant: ...
                objv13[3] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv13, compiledLocals, 6);
            } finally {
                tmp14 = objv13[0];
                if ( tmp14 != null ) {
                    tmp14.release();
                }
                tmp14 = objv13[2];
                if ( tmp14 != null ) {
                    tmp14.release();
                }
                TJC.releaseObjv(interp, objv13, 4);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp15 = getVarScalar(interp, "buffer", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp15);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_get_compiled_local_array_var");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" = ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("getVarArray(interp, \"");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_backslash_tcl_string");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\", ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\"");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(", ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(");\n");
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "key",
        "key_is_string",
        "clocal_array_symbol",
        "index",
        "buffer"
    };
} // end class EmitterGetCompiledLocalArrayVarCmd

