// TJC implementation of procedure emitter_get_compiled_local_scalar_var
package tjc;
import tcl.lang.*;

public class EmitterGetCompiledLocalScalarVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname clocal_array_symbol index");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "clocal_array_symbol", objv[3], compiledLocals, 2);
        setVarScalar(interp, "index", objv[4], compiledLocals, 3);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: append buffer [...] $tmpsymbol " = " ... [...] ... $clocal_array_symbol ", " $index ...
            TclObject[] objv0 = TJC.grabObjv(interp, 10);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 variable: $tmpsymbol
                tmp1 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                tmp1.preserve();
                objv0[1] = tmp1;
                // Arg 4 constant: " = "
                objv0[2] = const2;
                // Arg 5 constant: ...
                objv0[3] = const3;
                // Arg 6 command: [...]
                { // Invoke: ... $varname
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 0 constant: ...
                        objv3[0] = const4;
                        // Arg 1 variable: $varname
                        tmp4 = getVarScalar(interp, "varname", compiledLocals, 1);
                        tmp4.preserve();
                        objv3[1] = tmp4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp4 = objv3[1];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: ...
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[4] = tmp1;
                // Arg 7 constant: ...
                objv0[5] = const5;
                // Arg 8 variable: $clocal_array_symbol
                tmp1 = getVarScalar(interp, "clocal_array_symbol", compiledLocals, 2);
                tmp1.preserve();
                objv0[6] = tmp1;
                // Arg 9 constant: ", "
                objv0[7] = const6;
                // Arg 10 variable: $index
                tmp1 = getVarScalar(interp, "index", compiledLocals, 3);
                tmp1.preserve();
                objv0[8] = tmp1;
                // Arg 11 constant: ...
                objv0[9] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 4);
            } finally {
                objv0[2] = null;
                objv0[3] = null;
                objv0[5] = null;
                objv0[7] = null;
                objv0[9] = null;
                TJC.releaseObjvElems(interp, objv0, 10);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp5 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp5);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_get_compiled_local_scalar_var");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" = ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("getVarScalar(interp, \"");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_backslash_tcl_string");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\", ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(", ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(");\n");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "clocal_array_symbol",
        "index",
        "buffer"
    };
} // end class EmitterGetCompiledLocalScalarVarCmd

