// TJC implementation of procedure emitter_invoke_command_assign
package tjc;
import tcl.lang.*;

public class EmitterInvokeCommandAssignCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym index tmpsym valsym");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tmpsym", objv[3], compiledLocals, 2);
        setVarScalar(interp, "valsym", objv[4], compiledLocals, 3);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$tmpsym ne $valsym} ...
            // Binary operator: $tmpsym ne $valsym
            TclObject tmp0 = getVarScalar(interp, "tmpsym", compiledLocals, 2);
            String tmp1 = tmp0.toString();
            TclObject tmp2 = getVarScalar(interp, "valsym", compiledLocals, 3);
            String tmp3 = tmp2.toString();
            boolean tmp4 = ! tmp1.equals(tmp3);
            ExprValue tmp5 = evs0;
            tmp5.setIntValue(tmp4);
            // End Binary operator: ne
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: append buffer [...] $tmpsym " = " $valsym ...
                    TclObject[] objv7 = TJC.grabObjv(interp, 5);
                    TclObject tmp8;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv9 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv9[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv9, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv9, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp8 = interp.getResult();
                        tmp8.preserve();
                        objv7[0] = tmp8;
                        // Arg 3 variable: $tmpsym
                        tmp8 = getVarScalar(interp, "tmpsym", compiledLocals, 2);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        // Arg 4 constant: " = "
                        objv7[2] = const2;
                        // Arg 5 variable: $valsym
                        tmp8 = getVarScalar(interp, "valsym", compiledLocals, 3);
                        tmp8.preserve();
                        objv7[3] = tmp8;
                        // Arg 6 constant: ...
                        objv7[4] = const3;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv7, compiledLocals, 4);
                    } finally {
                        tmp8 = objv7[0];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        tmp8 = objv7[3];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 5);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] [...]
            TclObject[] objv10 = TJC.grabObjv(interp, 2);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $tmpsym
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: ...
                        objv12[0] = const4;
                        // Arg 1 variable: $tmpsym
                        tmp13 = getVarScalar(interp, "tmpsym", compiledLocals, 2);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: ...
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 command: [...]
                { // Invoke: emitter_array_assign $arraysym $index $tmpsym
                    TclObject[] objv14 = TJC.grabObjv(interp, 4);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: emitter_array_assign
                        objv14[0] = const5;
                        // Arg 1 variable: $arraysym
                        tmp15 = getVarScalar(interp, "arraysym", compiledLocals, 0);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        // Arg 2 variable: $index
                        tmp15 = getVarScalar(interp, "index", compiledLocals, 1);
                        tmp15.preserve();
                        objv14[2] = tmp15;
                        // Arg 3 variable: $tmpsym
                        tmp15 = getVarScalar(interp, "tmpsym", compiledLocals, 2);
                        tmp15.preserve();
                        objv14[3] = tmp15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv14, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        tmp15 = objv14[2];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        tmp15 = objv14[3];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 4);
                    }
                } // End Invoke: emitter_array_assign
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[1] = tmp11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 4);
            } finally {
                TJC.releaseObjvElems(interp, objv10, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp16 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_invoke_command_assign");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" = ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(";\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_tclobject_preserve");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_array_assign");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_tclobject_preserve";
                break;
            }
            case 3: {
                cmdName = "emitter_array_assign";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "index",
        "tmpsym",
        "valsym",
        "buffer"
    };
} // end class EmitterInvokeCommandAssignCmd

