// TJC implementation of procedure emitter_invoke_start
package tjc;
import tcl.lang.*;

public class EmitterInvokeStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "start_cmd_str");
        }
        setVarScalar(interp, "start_cmd_str", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... ${start_cmd_str} ...
            TclObject[] objv0 = TJC.grabObjv(interp, 4);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 constant: ...
                objv0[1] = const2;
                // Arg 4 variable: ${start_cmd_str}
                tmp1 = getVarScalar(interp, "start_cmd_str", compiledLocals, 0);
                tmp1.preserve();
                objv0[2] = tmp1;
                // Arg 5 constant: ...
                objv0[3] = const3;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 1);
            } finally {
                tmp1 = objv0[0];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                tmp1 = objv0[2];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv3 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv3[0] = const4;
                // Arg 1 constant: +1
                objv3[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv3, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv3, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp4 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp4);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_invoke_start");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("{ // Invoke: ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "start_cmd_str",
        "buffer"
    };
} // end class EmitterInvokeStartCmd

