// TJC implementation of procedure emitter_set_compiled_local_array_var
package tjc;
import tcl.lang.*;

public class EmitterSetCompiledLocalArrayVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 8) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname key key_is_string valsym clocal_array_symbol index");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "key", objv[3], compiledLocals, 2);
        setVarScalar(interp, "key_is_string", objv[4], compiledLocals, 3);
        setVarScalar(interp, "valsym", objv[5], compiledLocals, 4);
        setVarScalar(interp, "clocal_array_symbol", objv[6], compiledLocals, 5);
        setVarScalar(interp, "index", objv[7], compiledLocals, 6);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 1);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv0, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$tmpsymbol != {}} ...
            // Binary operator: $tmpsymbol != ""
            TclObject tmp3 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, true);
            // End Binary operator: !=
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: append buffer $tmpsymbol " = "
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 2 variable: $tmpsymbol
                        tmp7 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                        tmp7.preserve();
                        objv6[0] = tmp7;
                        // Arg 3 constant: " = "
                        objv6[1] = const2;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv6, compiledLocals, 7);
                    } finally {
                        tmp7 = objv6[0];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer ... [...] ...
            TclObject[] objv8 = TJC.grabObjv(interp, 3);
            TclObject tmp9;
            try {
                // Arg 2 constant: ...
                objv8[0] = const3;
                // Arg 3 command: [...]
                { // Invoke: ... $varname
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: ...
                        objv10[0] = const4;
                        // Arg 1 variable: $varname
                        tmp11 = getVarScalar(interp, "varname", compiledLocals, 1);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: ...
                tmp9 = interp.getResult();
                tmp9.preserve();
                objv8[1] = tmp9;
                // Arg 4 constant: ...
                objv8[2] = const5;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv8, compiledLocals, 7);
            } finally {
                tmp9 = objv8[1];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                TJC.releaseObjv(interp, objv8, 3);
            }
        } // End Invoke: append
        { // Invoke: if {$key_is_string} ... else ...
            TclObject tmp12 = getVarScalar(interp, "key_is_string", compiledLocals, 3);
            boolean tmp13 = TJC.getBoolean(interp, tmp12);
            if ( tmp13 ) {
                { // Invoke: append buffer ... [...] ...
                    TclObject[] objv14 = TJC.grabObjv(interp, 3);
                    TclObject tmp15;
                    try {
                        // Arg 2 constant: ...
                        objv14[0] = const6;
                        // Arg 3 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv16 = TJC.grabObjv(interp, 2);
                            TclObject tmp17;
                            try {
                                // Arg 0 constant: ...
                                objv16[0] = const4;
                                // Arg 1 variable: $key
                                tmp17 = getVarScalar(interp, "key", compiledLocals, 2);
                                tmp17.preserve();
                                objv16[1] = tmp17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv16, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp17 = objv16[1];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                TJC.releaseObjv(interp, objv16, 2);
                            }
                        } // End Invoke: ...
                        tmp15 = interp.getResult();
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        // Arg 4 constant: ...
                        objv14[2] = const5;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv14, compiledLocals, 7);
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 3);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer $key ", "
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 2 variable: $key
                        tmp19 = getVarScalar(interp, "key", compiledLocals, 2);
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        // Arg 3 constant: ", "
                        objv18[1] = const7;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv18, compiledLocals, 7);
                    } finally {
                        tmp19 = objv18[0];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer $valsym ", " $clocal_array_symbol ", " $index ...
            TclObject[] objv20 = TJC.grabObjv(interp, 6);
            TclObject tmp21;
            try {
                // Arg 2 variable: $valsym
                tmp21 = getVarScalar(interp, "valsym", compiledLocals, 4);
                tmp21.preserve();
                objv20[0] = tmp21;
                // Arg 3 constant: ", "
                objv20[1] = const7;
                // Arg 4 variable: $clocal_array_symbol
                tmp21 = getVarScalar(interp, "clocal_array_symbol", compiledLocals, 5);
                tmp21.preserve();
                objv20[2] = tmp21;
                // Arg 5 constant: ", "
                objv20[3] = const7;
                // Arg 6 variable: $index
                tmp21 = getVarScalar(interp, "index", compiledLocals, 6);
                tmp21.preserve();
                objv20[4] = tmp21;
                // Arg 7 constant: ...
                objv20[5] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv20, compiledLocals, 7);
            } finally {
                tmp21 = objv20[0];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                tmp21 = objv20[2];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                tmp21 = objv20[4];
                if ( tmp21 != null ) {
                    tmp21.release();
                }
                TJC.releaseObjv(interp, objv20, 6);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp22 = getVarScalar(interp, "buffer", compiledLocals, 7);
            interp.resetResult();
            interp.setResult(tmp22);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_set_compiled_local_array_var");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" = ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("setVarArray(interp, \"");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_backslash_tcl_string");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\", ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\"");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(", ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(");\n");
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "key",
        "key_is_string",
        "valsym",
        "clocal_array_symbol",
        "index",
        "buffer"
    };
} // end class EmitterSetCompiledLocalArrayVarCmd

