// TJC implementation of procedure jdk_config_parse_file
package tjc;
import tcl.lang.*;

public class JdkConfigParseFileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 21, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "filename");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        { // Invoke: set buffer [...]
            TclObject tmp0;
            { // Invoke: tjc_util_file_read $filename
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: tjc_util_file_read
                    objv1[0] = const0;
                    // Arg 1 variable: $filename
                    tmp2 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: tjc_util_file_read
            tmp0 = interp.getResult();
            setVarScalar(interp, "buffer", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code3 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set parsed [...]
                    TclObject tmp4;
                    { // Invoke: jdk_config_parse $buffer
                        TclObject[] objv5 = TJC.grabObjv(interp, 2);
                        TclObject tmp6;
                        try {
                            // Arg 0 constant: jdk_config_parse
                            objv5[0] = const1;
                            // Arg 1 variable: $buffer
                            tmp6 = getVarScalar(interp, "buffer", compiledLocals, 1);
                            tmp6.preserve();
                            objv5[1] = tmp6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv5, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp6 = objv5[1];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            TJC.releaseObjv(interp, objv5, 2);
                        }
                    } // End Invoke: jdk_config_parse
                    tmp4 = interp.getResult();
                    tmp4 = setVarScalar(interp, "parsed", tmp4, compiledLocals, 2);
                    interp.setResult(tmp4);
                } // End Invoke: set
                } catch (TclException ex) {
                    code3 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 3);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code3);
            } // End Invoke: catch
            TclObject tmp7 = interp.getResult();
            ExprValue tmp8 = evs0;
            TJC.exprInitValue(interp, tmp8, tmp7);
            boolean tmp9 = tmp8.getBooleanValue(interp);
            if ( tmp9 ) {
                { // Invoke: return [...]
                    { // Invoke: list 0 $err
                        TclObject tmp10 = TclList.newInstance();
                        TclObject tmp11;
                        try {
                            TclList.append(interp, tmp10, const2);
                            tmp11 = getVarScalar(interp, "err", compiledLocals, 3);
                            TclList.append(interp, tmp10, tmp11);
                        } catch (TclException ex) {
                            tmp10.release();
                            throw ex;
                        }
                        interp.setResult(tmp10);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set valid 1
            setVarScalar(interp, "valid", const3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set reason ""
            setVarScalar(interp, "reason", const4, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set javac [...]
            TclObject tmp12;
            { // Invoke: jdk_config_var JAVAC
                TclObject[] objv13 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_config_var
                    objv13[0] = const5;
                    // Arg 1 constant: JAVAC
                    objv13[1] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv13, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv13, 2);
                }
            } // End Invoke: jdk_config_var
            tmp12 = interp.getResult();
            setVarScalar(interp, "javac", tmp12, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set jar [...]
            TclObject tmp14;
            { // Invoke: jdk_config_var JAR
                TclObject[] objv15 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_config_var
                    objv15[0] = const5;
                    // Arg 1 constant: JAR
                    objv15[1] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv15, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv15, 2);
                }
            } // End Invoke: jdk_config_var
            tmp14 = interp.getResult();
            setVarScalar(interp, "jar", tmp14, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set classpath [...]
            TclObject tmp16;
            { // Invoke: jdk_config_var CLASSPATH
                TclObject[] objv17 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_config_var
                    objv17[0] = const5;
                    // Arg 1 constant: CLASSPATH
                    objv17[1] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv17, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv17, 2);
                }
            } // End Invoke: jdk_config_var
            tmp16 = interp.getResult();
            setVarScalar(interp, "classpath", tmp16, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set javac_exists 0
            setVarScalar(interp, "javac_exists", const2, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: file exists $javac
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: file
                    objv18[0] = const9;
                    // Arg 1 constant: exists
                    objv18[1] = const10;
                    // Arg 2 variable: $javac
                    tmp19 = getVarScalar(interp, "javac", compiledLocals, 6);
                    tmp19.preserve();
                    objv18[2] = tmp19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv18, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp19 = objv18[2];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: file
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            boolean tmp22 = tmp21.getBooleanValue(interp);
            if ( tmp22 ) {
                { // Invoke: set javac_exists 1
                    setVarScalar(interp, "javac_exists", const3, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set ext [...]
                    TclObject tmp23;
                    { // Invoke: file extension $javac
                        TclObject[] objv24 = TJC.grabObjv(interp, 3);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: file
                            objv24[0] = const9;
                            // Arg 1 constant: extension
                            objv24[1] = const11;
                            // Arg 2 variable: $javac
                            tmp25 = getVarScalar(interp, "javac", compiledLocals, 6);
                            tmp25.preserve();
                            objv24[2] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv24, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp25 = objv24[2];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 3);
                        }
                    } // End Invoke: file
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "ext", tmp23, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && [...]
                    // Binary operator: $ext == ""
                    TclObject tmp26 = getVarScalar(interp, "ext", compiledLocals, 10);
                    ExprValue tmp27 = evs0;
                    TJC.exprEqualsEmptyString(tmp27, tmp26, false);
                    // End Binary operator: ==
                    if (tmp27.getBooleanValue(interp)) {
                    { // Invoke: file exists ${javac}.exe
                        TclObject[] objv28 = TJC.grabObjv(interp, 3);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: file
                            objv28[0] = const9;
                            // Arg 1 constant: exists
                            objv28[1] = const10;
                            // Arg 2 word: ${javac}.exe
                            StringBuffer sbtmp30 = new StringBuffer(64);
                            tmp29 = getVarScalar(interp, "javac", compiledLocals, 6);
                            sbtmp30.append(tmp29.toString());
                            sbtmp30.append(".exe");
                            tmp29 = TclString.newInstance(sbtmp30);
                            tmp29.preserve();
                            objv28[2] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv28, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp29 = objv28[2];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 3);
                        }
                    } // End Invoke: file
                    TclObject tmp31 = interp.getResult();
                    ExprValue tmp32 = evs1;
                    TJC.exprInitValue(interp, tmp32, tmp31);
                    tmp27.setIntValue(tmp32.getBooleanValue(interp));
                    } else {
                    tmp27.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp33 = ( tmp27.getIntValue() != 0 );
                    if ( tmp33 ) {
                        { // Invoke: set javac_exists 1
                            setVarScalar(interp, "javac_exists", const3, compiledLocals, 9);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set jar_exists 0
            setVarScalar(interp, "jar_exists", const2, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {[file exists $jar]} ... else ...
            { // Invoke: file exists $jar
                TclObject[] objv34 = TJC.grabObjv(interp, 3);
                TclObject tmp35;
                try {
                    // Arg 0 constant: file
                    objv34[0] = const9;
                    // Arg 1 constant: exists
                    objv34[1] = const10;
                    // Arg 2 variable: $jar
                    tmp35 = getVarScalar(interp, "jar", compiledLocals, 7);
                    tmp35.preserve();
                    objv34[2] = tmp35;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv34, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp35 = objv34[2];
                    if ( tmp35 != null ) {
                        tmp35.release();
                    }
                    TJC.releaseObjv(interp, objv34, 3);
                }
            } // End Invoke: file
            TclObject tmp36 = interp.getResult();
            ExprValue tmp37 = evs0;
            TJC.exprInitValue(interp, tmp37, tmp36);
            boolean tmp38 = tmp37.getBooleanValue(interp);
            if ( tmp38 ) {
                { // Invoke: set jar_exists 1
                    setVarScalar(interp, "jar_exists", const3, compiledLocals, 11);
                } // End Invoke: set
            } else {
                { // Invoke: set ext [...]
                    TclObject tmp39;
                    { // Invoke: file extension $jar
                        TclObject[] objv40 = TJC.grabObjv(interp, 3);
                        TclObject tmp41;
                        try {
                            // Arg 0 constant: file
                            objv40[0] = const9;
                            // Arg 1 constant: extension
                            objv40[1] = const11;
                            // Arg 2 variable: $jar
                            tmp41 = getVarScalar(interp, "jar", compiledLocals, 7);
                            tmp41.preserve();
                            objv40[2] = tmp41;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv40, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp41 = objv40[2];
                            if ( tmp41 != null ) {
                                tmp41.release();
                            }
                            TJC.releaseObjv(interp, objv40, 3);
                        }
                    } // End Invoke: file
                    tmp39 = interp.getResult();
                    setVarScalar(interp, "ext", tmp39, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && [...]
                    // Binary operator: $ext == ""
                    TclObject tmp42 = getVarScalar(interp, "ext", compiledLocals, 10);
                    ExprValue tmp43 = evs0;
                    TJC.exprEqualsEmptyString(tmp43, tmp42, false);
                    // End Binary operator: ==
                    if (tmp43.getBooleanValue(interp)) {
                    { // Invoke: file exists ${jar}.exe
                        TclObject[] objv44 = TJC.grabObjv(interp, 3);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: file
                            objv44[0] = const9;
                            // Arg 1 constant: exists
                            objv44[1] = const10;
                            // Arg 2 word: ${jar}.exe
                            StringBuffer sbtmp46 = new StringBuffer(64);
                            tmp45 = getVarScalar(interp, "jar", compiledLocals, 7);
                            sbtmp46.append(tmp45.toString());
                            sbtmp46.append(".exe");
                            tmp45 = TclString.newInstance(sbtmp46);
                            tmp45.preserve();
                            objv44[2] = tmp45;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv44, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp45 = objv44[2];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 3);
                        }
                    } // End Invoke: file
                    TclObject tmp47 = interp.getResult();
                    ExprValue tmp48 = evs1;
                    TJC.exprInitValue(interp, tmp48, tmp47);
                    tmp43.setIntValue(tmp48.getBooleanValue(interp));
                    } else {
                    tmp43.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp49 = ( tmp43.getIntValue() != 0 );
                    if ( tmp49 ) {
                        { // Invoke: set jar_exists 1
                            setVarScalar(interp, "jar_exists", const3, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {$javac == ""} ... elseif {!$javac_exists} ... elseif {$jar == ""} ... elseif {!$jar_exists} ... elseif {$classpath == ""} ...
            // Binary operator: $javac == ""
            TclObject tmp50 = getVarScalar(interp, "javac", compiledLocals, 6);
            ExprValue tmp51 = evs0;
            TJC.exprEqualsEmptyString(tmp51, tmp50, false);
            // End Binary operator: ==
            boolean tmp52 = ( tmp51.getIntValue() != 0 );
            if ( tmp52 ) {
                { // Invoke: set reason ...
                    setVarScalar(interp, "reason", const12, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set valid 0
                    setVarScalar(interp, "valid", const2, compiledLocals, 4);
                } // End Invoke: set
            } else {
                // Unary operator: ! $javac_exists
                TclObject tmp53 = getVarScalar(interp, "javac_exists", compiledLocals, 9);
                ExprValue tmp54 = evs0;
                if ( tmp53.isIntType() ) {
                    TJC.exprUnaryNotOperatorKnownInt(tmp54, tmp53);
                } else {
                    TJC.exprUnaryNotOperator(interp, tmp54, tmp53);
                }
                // End Unary operator: !
                boolean tmp55 = ( tmp54.getIntValue() != 0 );
                if ( tmp55 ) {
                    { // Invoke: set reason ...
                        setVarScalar(interp, "reason", const13, compiledLocals, 5);
                    } // End Invoke: set
                    { // Invoke: set valid 0
                        setVarScalar(interp, "valid", const2, compiledLocals, 4);
                    } // End Invoke: set
                } else {
                    // Binary operator: $jar == ""
                    TclObject tmp56 = getVarScalar(interp, "jar", compiledLocals, 7);
                    ExprValue tmp57 = evs0;
                    TJC.exprEqualsEmptyString(tmp57, tmp56, false);
                    // End Binary operator: ==
                    boolean tmp58 = ( tmp57.getIntValue() != 0 );
                    if ( tmp58 ) {
                        { // Invoke: set reason ...
                            setVarScalar(interp, "reason", const14, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set valid 0
                            setVarScalar(interp, "valid", const2, compiledLocals, 4);
                        } // End Invoke: set
                    } else {
                        // Unary operator: ! $jar_exists
                        TclObject tmp59 = getVarScalar(interp, "jar_exists", compiledLocals, 11);
                        ExprValue tmp60 = evs0;
                        if ( tmp59.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp60, tmp59);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp60, tmp59);
                        }
                        // End Unary operator: !
                        boolean tmp61 = ( tmp60.getIntValue() != 0 );
                        if ( tmp61 ) {
                            { // Invoke: set reason ...
                                setVarScalar(interp, "reason", const15, compiledLocals, 5);
                            } // End Invoke: set
                            { // Invoke: set valid 0
                                setVarScalar(interp, "valid", const2, compiledLocals, 4);
                            } // End Invoke: set
                        } else {
                            // Binary operator: $classpath == ""
                            TclObject tmp62 = getVarScalar(interp, "classpath", compiledLocals, 8);
                            ExprValue tmp63 = evs0;
                            TJC.exprEqualsEmptyString(tmp63, tmp62, false);
                            // End Binary operator: ==
                            boolean tmp64 = ( tmp63.getIntValue() != 0 );
                            if ( tmp64 ) {
                                { // Invoke: set reason ...
                                    setVarScalar(interp, "reason", const16, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set valid 0
                                    setVarScalar(interp, "valid", const2, compiledLocals, 4);
                                } // End Invoke: set
                            }
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: if {$valid} ...
            TclObject tmp65 = getVarScalar(interp, "valid", compiledLocals, 4);
            boolean tmp66 = TJC.getBoolean(interp, tmp65);
            if ( tmp66 ) {
                { // Invoke: set found_tcljava 0
                    setVarScalar(interp, "found_tcljava", const2, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set found_jacl 0
                    setVarScalar(interp, "found_jacl", const2, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set found_tjc 0
                    setVarScalar(interp, "found_tjc", const2, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set libdir ""
                    setVarScalar(interp, "libdir", const4, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set reason ""
                    setVarScalar(interp, "reason", const4, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $::tcl_platform(...) == "windows"
                    initVarScoped(interp, "::tcl_platform", compiledLocals, 16);
                    TclObject tmp67 = getVarArray(interp, "::tcl_platform", "host_platform", compiledLocals, 16);
                    boolean tmp68 = tmp67.toString().equals("windows");
                    ExprValue tmp69 = evs0;
                    tmp69.setIntValue(tmp68);
                    // End Binary operator: ==
                    boolean tmp70 = ( tmp69.getIntValue() != 0 );
                    if ( tmp70 ) {
                        { // Invoke: set sep ...
                            setVarScalar(interp, "sep", const17, compiledLocals, 17);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set sep :
                            setVarScalar(interp, "sep", const18, compiledLocals, 17);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: foreach path [...] ...
                    TclObject tmp71 = null;
                    try {
                        { // Invoke: split $classpath $sep
                            TclObject[] objv72 = TJC.grabObjv(interp, 3);
                            TclObject tmp73;
                            try {
                                // Arg 0 constant: split
                                objv72[0] = const19;
                                // Arg 1 variable: $classpath
                                tmp73 = getVarScalar(interp, "classpath", compiledLocals, 8);
                                tmp73.preserve();
                                objv72[1] = tmp73;
                                // Arg 2 variable: $sep
                                tmp73 = getVarScalar(interp, "sep", compiledLocals, 17);
                                tmp73.preserve();
                                objv72[2] = tmp73;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv72, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp73 = objv72[1];
                                if ( tmp73 != null ) {
                                    tmp73.release();
                                }
                                tmp73 = objv72[2];
                                if ( tmp73 != null ) {
                                    tmp73.release();
                                }
                                TJC.releaseObjv(interp, objv72, 3);
                            }
                        } // End Invoke: split
                        tmp71 = interp.getResult();
                        tmp71.preserve();
                        final int tmp71_length = TclList.getLength(interp, tmp71);

                        for ( int index74 = 0 ; index74 < tmp71_length ; index74++ ) {
                            TclObject tmp75 = TclList.index(interp, tmp71, index74);
                            try {
                                setVarScalar(interp, "path", tmp75, compiledLocals, 18);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "path");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: if {$path == {}} ...
                                // Binary operator: $path == ""
                                TclObject tmp76 = getVarScalar(interp, "path", compiledLocals, 18);
                                ExprValue tmp77 = evs0;
                                TJC.exprEqualsEmptyString(tmp77, tmp76, false);
                                // End Binary operator: ==
                                boolean tmp78 = ( tmp77.getIntValue() != 0 );
                                if ( tmp78 ) {
                                    { // Invoke: continue
                                        if ( true ) { continue; }
                                    } // End Invoke: continue
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ...
                                // Binary operator: [...] == "tcljava.jar"
                                { // Invoke: file tail $path
                                    TclObject[] objv79 = TJC.grabObjv(interp, 3);
                                    TclObject tmp80;
                                    try {
                                        // Arg 0 constant: file
                                        objv79[0] = const9;
                                        // Arg 1 constant: tail
                                        objv79[1] = const20;
                                        // Arg 2 variable: $path
                                        tmp80 = getVarScalar(interp, "path", compiledLocals, 18);
                                        tmp80.preserve();
                                        objv79[2] = tmp80;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv79, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp80 = objv79[2];
                                        if ( tmp80 != null ) {
                                            tmp80.release();
                                        }
                                        TJC.releaseObjv(interp, objv79, 3);
                                    }
                                } // End Invoke: file
                                TclObject tmp81 = interp.getResult();
                                boolean tmp82 = tmp81.toString().equals("tcljava.jar");
                                ExprValue tmp83 = evs0;
                                tmp83.setIntValue(tmp82);
                                // End Binary operator: ==
                                boolean tmp84 = ( tmp83.getIntValue() != 0 );
                                if ( tmp84 ) {
                                    { // Invoke: set dir [...]
                                        TclObject tmp85;
                                        { // Invoke: file dirname $path
                                            TclObject[] objv86 = TJC.grabObjv(interp, 3);
                                            TclObject tmp87;
                                            try {
                                                // Arg 0 constant: file
                                                objv86[0] = const9;
                                                // Arg 1 constant: dirname
                                                objv86[1] = const21;
                                                // Arg 2 variable: $path
                                                tmp87 = getVarScalar(interp, "path", compiledLocals, 18);
                                                tmp87.preserve();
                                                objv86[2] = tmp87;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv86, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp87 = objv86[2];
                                                if ( tmp87 != null ) {
                                                    tmp87.release();
                                                }
                                                TJC.releaseObjv(interp, objv86, 3);
                                            }
                                        } // End Invoke: file
                                        tmp85 = interp.getResult();
                                        setVarScalar(interp, "dir", tmp85, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: if {$libdir == ""} ... else ...
                                        // Binary operator: $libdir == ""
                                        TclObject tmp88 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                        ExprValue tmp89 = evs0;
                                        TJC.exprEqualsEmptyString(tmp89, tmp88, false);
                                        // End Binary operator: ==
                                        boolean tmp90 = ( tmp89.getIntValue() != 0 );
                                        if ( tmp90 ) {
                                            { // Invoke: set libdir $dir
                                                TclObject tmp91;
                                                tmp91 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                setVarScalar(interp, "libdir", tmp91, compiledLocals, 15);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: if {$libdir != $dir} ...
                                                // Binary operator: $libdir != $dir
                                                TclObject tmp92 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                                ExprValue tmp93 = evs0;
                                                TJC.exprInitValue(interp, tmp93, tmp92);
                                                TclObject tmp94 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                ExprValue tmp95 = evs1;
                                                TJC.exprInitValue(interp, tmp95, tmp94);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp93, tmp95);
                                                // End Binary operator: !=
                                                boolean tmp96 = ( tmp93.getIntValue() != 0 );
                                                if ( tmp96 ) {
                                                    { // Invoke: set reason ...
                                                        setVarScalar(interp, "reason", const22, compiledLocals, 5);
                                                    } // End Invoke: set
                                                }
                                            } // End Invoke: if
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if {$reason == ""} ...
                                        // Binary operator: $reason == ""
                                        TclObject tmp97 = getVarScalar(interp, "reason", compiledLocals, 5);
                                        ExprValue tmp98 = evs0;
                                        TJC.exprEqualsEmptyString(tmp98, tmp97, false);
                                        // End Binary operator: ==
                                        boolean tmp99 = ( tmp98.getIntValue() != 0 );
                                        if ( tmp99 ) {
                                            { // Invoke: set found_tcljava 1
                                                setVarScalar(interp, "found_tcljava", const3, compiledLocals, 12);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ...
                                // Binary operator: [...] == "jacl.jar"
                                { // Invoke: file tail $path
                                    TclObject[] objv100 = TJC.grabObjv(interp, 3);
                                    TclObject tmp101;
                                    try {
                                        // Arg 0 constant: file
                                        objv100[0] = const9;
                                        // Arg 1 constant: tail
                                        objv100[1] = const20;
                                        // Arg 2 variable: $path
                                        tmp101 = getVarScalar(interp, "path", compiledLocals, 18);
                                        tmp101.preserve();
                                        objv100[2] = tmp101;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv100, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp101 = objv100[2];
                                        if ( tmp101 != null ) {
                                            tmp101.release();
                                        }
                                        TJC.releaseObjv(interp, objv100, 3);
                                    }
                                } // End Invoke: file
                                TclObject tmp102 = interp.getResult();
                                boolean tmp103 = tmp102.toString().equals("jacl.jar");
                                ExprValue tmp104 = evs0;
                                tmp104.setIntValue(tmp103);
                                // End Binary operator: ==
                                boolean tmp105 = ( tmp104.getIntValue() != 0 );
                                if ( tmp105 ) {
                                    { // Invoke: set dir [...]
                                        TclObject tmp106;
                                        { // Invoke: file dirname $path
                                            TclObject[] objv107 = TJC.grabObjv(interp, 3);
                                            TclObject tmp108;
                                            try {
                                                // Arg 0 constant: file
                                                objv107[0] = const9;
                                                // Arg 1 constant: dirname
                                                objv107[1] = const21;
                                                // Arg 2 variable: $path
                                                tmp108 = getVarScalar(interp, "path", compiledLocals, 18);
                                                tmp108.preserve();
                                                objv107[2] = tmp108;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv107, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp108 = objv107[2];
                                                if ( tmp108 != null ) {
                                                    tmp108.release();
                                                }
                                                TJC.releaseObjv(interp, objv107, 3);
                                            }
                                        } // End Invoke: file
                                        tmp106 = interp.getResult();
                                        setVarScalar(interp, "dir", tmp106, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: if {$libdir == ""} ... else ...
                                        // Binary operator: $libdir == ""
                                        TclObject tmp109 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                        ExprValue tmp110 = evs0;
                                        TJC.exprEqualsEmptyString(tmp110, tmp109, false);
                                        // End Binary operator: ==
                                        boolean tmp111 = ( tmp110.getIntValue() != 0 );
                                        if ( tmp111 ) {
                                            { // Invoke: set libdir $dir
                                                TclObject tmp112;
                                                tmp112 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                setVarScalar(interp, "libdir", tmp112, compiledLocals, 15);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: if {$libdir != $dir} ...
                                                // Binary operator: $libdir != $dir
                                                TclObject tmp113 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                                ExprValue tmp114 = evs0;
                                                TJC.exprInitValue(interp, tmp114, tmp113);
                                                TclObject tmp115 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                ExprValue tmp116 = evs1;
                                                TJC.exprInitValue(interp, tmp116, tmp115);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp114, tmp116);
                                                // End Binary operator: !=
                                                boolean tmp117 = ( tmp114.getIntValue() != 0 );
                                                if ( tmp117 ) {
                                                    { // Invoke: set reason ...
                                                        setVarScalar(interp, "reason", const22, compiledLocals, 5);
                                                    } // End Invoke: set
                                                }
                                            } // End Invoke: if
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if {$reason == ""} ...
                                        // Binary operator: $reason == ""
                                        TclObject tmp118 = getVarScalar(interp, "reason", compiledLocals, 5);
                                        ExprValue tmp119 = evs0;
                                        TJC.exprEqualsEmptyString(tmp119, tmp118, false);
                                        // End Binary operator: ==
                                        boolean tmp120 = ( tmp119.getIntValue() != 0 );
                                        if ( tmp120 ) {
                                            { // Invoke: set found_jacl 1
                                                setVarScalar(interp, "found_jacl", const3, compiledLocals, 13);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ...
                                // Binary operator: [...] == "tjc.jar"
                                { // Invoke: file tail $path
                                    TclObject[] objv121 = TJC.grabObjv(interp, 3);
                                    TclObject tmp122;
                                    try {
                                        // Arg 0 constant: file
                                        objv121[0] = const9;
                                        // Arg 1 constant: tail
                                        objv121[1] = const20;
                                        // Arg 2 variable: $path
                                        tmp122 = getVarScalar(interp, "path", compiledLocals, 18);
                                        tmp122.preserve();
                                        objv121[2] = tmp122;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv121, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp122 = objv121[2];
                                        if ( tmp122 != null ) {
                                            tmp122.release();
                                        }
                                        TJC.releaseObjv(interp, objv121, 3);
                                    }
                                } // End Invoke: file
                                TclObject tmp123 = interp.getResult();
                                boolean tmp124 = tmp123.toString().equals("tjc.jar");
                                ExprValue tmp125 = evs0;
                                tmp125.setIntValue(tmp124);
                                // End Binary operator: ==
                                boolean tmp126 = ( tmp125.getIntValue() != 0 );
                                if ( tmp126 ) {
                                    { // Invoke: set dir [...]
                                        TclObject tmp127;
                                        { // Invoke: file dirname $path
                                            TclObject[] objv128 = TJC.grabObjv(interp, 3);
                                            TclObject tmp129;
                                            try {
                                                // Arg 0 constant: file
                                                objv128[0] = const9;
                                                // Arg 1 constant: dirname
                                                objv128[1] = const21;
                                                // Arg 2 variable: $path
                                                tmp129 = getVarScalar(interp, "path", compiledLocals, 18);
                                                tmp129.preserve();
                                                objv128[2] = tmp129;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv128, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp129 = objv128[2];
                                                if ( tmp129 != null ) {
                                                    tmp129.release();
                                                }
                                                TJC.releaseObjv(interp, objv128, 3);
                                            }
                                        } // End Invoke: file
                                        tmp127 = interp.getResult();
                                        setVarScalar(interp, "dir", tmp127, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: if {$libdir == ""} ... else ...
                                        // Binary operator: $libdir == ""
                                        TclObject tmp130 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                        ExprValue tmp131 = evs0;
                                        TJC.exprEqualsEmptyString(tmp131, tmp130, false);
                                        // End Binary operator: ==
                                        boolean tmp132 = ( tmp131.getIntValue() != 0 );
                                        if ( tmp132 ) {
                                            { // Invoke: set libdir $dir
                                                TclObject tmp133;
                                                tmp133 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                setVarScalar(interp, "libdir", tmp133, compiledLocals, 15);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: if {$libdir != $dir} ...
                                                // Binary operator: $libdir != $dir
                                                TclObject tmp134 = getVarScalar(interp, "libdir", compiledLocals, 15);
                                                ExprValue tmp135 = evs0;
                                                TJC.exprInitValue(interp, tmp135, tmp134);
                                                TclObject tmp136 = getVarScalar(interp, "dir", compiledLocals, 19);
                                                ExprValue tmp137 = evs1;
                                                TJC.exprInitValue(interp, tmp137, tmp136);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp135, tmp137);
                                                // End Binary operator: !=
                                                boolean tmp138 = ( tmp135.getIntValue() != 0 );
                                                if ( tmp138 ) {
                                                    { // Invoke: set reason ...
                                                        setVarScalar(interp, "reason", const22, compiledLocals, 5);
                                                    } // End Invoke: set
                                                }
                                            } // End Invoke: if
                                        }
                                    } // End Invoke: if
                                    { // Invoke: if {$reason == ""} ...
                                        // Binary operator: $reason == ""
                                        TclObject tmp139 = getVarScalar(interp, "reason", compiledLocals, 5);
                                        ExprValue tmp140 = evs0;
                                        TJC.exprEqualsEmptyString(tmp140, tmp139, false);
                                        // End Binary operator: ==
                                        boolean tmp141 = ( tmp140.getIntValue() != 0 );
                                        if ( tmp141 ) {
                                            { // Invoke: set found_tjc 1
                                                setVarScalar(interp, "found_tjc", const3, compiledLocals, 14);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Unary operator: ! $found_tcljava
                    TclObject tmp142 = getVarScalar(interp, "found_tcljava", compiledLocals, 12);
                    ExprValue tmp143 = evs0;
                    if ( tmp142.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp143, tmp142);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp143, tmp142);
                    }
                    // End Unary operator: !
                    if (!tmp143.getBooleanValue(interp)) {
                    // Unary operator: ! $found_jacl
                    TclObject tmp144 = getVarScalar(interp, "found_jacl", compiledLocals, 13);
                    ExprValue tmp145 = evs1;
                    if ( tmp144.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp145, tmp144);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp145, tmp144);
                    }
                    // End Unary operator: !
                    tmp143.setIntValue(tmp145.getBooleanValue(interp));
                    } else {
                    tmp143.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp143.getBooleanValue(interp)) {
                    // Unary operator: ! $found_tjc
                    TclObject tmp146 = getVarScalar(interp, "found_tjc", compiledLocals, 14);
                    ExprValue tmp147 = evs1;
                    if ( tmp146.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp147, tmp146);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp147, tmp146);
                    }
                    // End Unary operator: !
                    tmp143.setIntValue(tmp147.getBooleanValue(interp));
                    } else {
                    tmp143.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp148 = ( tmp143.getIntValue() != 0 );
                    if ( tmp148 ) {
                        { // Invoke: if {$reason == ""} ...
                            // Binary operator: $reason == ""
                            TclObject tmp149 = getVarScalar(interp, "reason", compiledLocals, 5);
                            ExprValue tmp150 = evs0;
                            TJC.exprEqualsEmptyString(tmp150, tmp149, false);
                            // End Binary operator: ==
                            boolean tmp151 = ( tmp150.getIntValue() != 0 );
                            if ( tmp151 ) {
                                { // Invoke: set reason ...
                                    setVarScalar(interp, "reason", const23, compiledLocals, 5);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set valid 0
                            setVarScalar(interp, "valid", const2, compiledLocals, 4);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set ::env(CLASSPATH) $classpath
            TclObject tmp152;
            tmp152 = getVarScalar(interp, "classpath", compiledLocals, 8);
            initVarScoped(interp, "::env", compiledLocals, 20);
            setVarArray(interp, "::env", "CLASSPATH", tmp152, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: list $valid $reason
                TclObject tmp153 = TclList.newInstance();
                TclObject tmp154;
                try {
                    tmp154 = getVarScalar(interp, "valid", compiledLocals, 4);
                    TclList.append(interp, tmp153, tmp154);
                    tmp154 = getVarScalar(interp, "reason", compiledLocals, 5);
                    TclList.append(interp, tmp153, tmp154);
                } catch (TclException ex) {
                    tmp153.release();
                    throw ex;
                }
                interp.setResult(tmp153);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_config_parse_file");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("tjc_util_file_read");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("jdk_config_parse");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("jdk_config_var");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("JAVAC");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("JAR");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("CLASSPATH");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("file");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("exists");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("extension");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("JAVAC not found or is empty");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("JAVAC path is not valid");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("JAR not found or is empty");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("JAR path is not valid");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("CLASSPATH not found or is not valid");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(";");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance(":");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("split");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("tail");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("dirname");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("Jars tcljava.jar, jacl.jar, and tjc.jar must exist in same dir");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("CLASSPATH is not valid: tcljava.jar, jacl.jar, and tjc.jar must appear");
        const23.preserve(); const23.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "tjc_util_file_read";
                break;
            }
            case 2: {
                cmdName = "jdk_config_parse";
                break;
            }
            case 3: {
                cmdName = "jdk_config_var";
                break;
            }
            case 4: {
                cmdName = "file";
                break;
            }
            case 5: {
                cmdName = "split";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "buffer",
        "parsed",
        "err",
        "valid",
        "reason",
        "javac",
        "jar",
        "classpath",
        "javac_exists",
        "ext",
        "jar_exists",
        "found_tcljava",
        "found_jacl",
        "found_tjc",
        "libdir",
        "::tcl_platform",
        "sep",
        "path",
        "dir",
        "::env"
    };
} // end class JdkConfigParseFileCmd

