// TJC implementation of procedure module_expand
package tjc;
import tcl.lang.*;

public class ModuleExpandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "cmd");
        }
        setVarScalar(interp, "cmd", objv[1], compiledLocals, 0);
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set lower [...]
            TclObject tmp0;
            { // Invoke: string tolower $cmd
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: string
                    objv1[0] = const1;
                    // Arg 1 constant: tolower
                    objv1[1] = const2;
                    // Arg 2 variable: $cmd
                    tmp2 = getVarScalar(interp, "cmd", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: string
            tmp0 = interp.getResult();
            setVarScalar(interp, "lower", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: info exists "..."
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                TclObject tmp4;
                try {
                    // Arg 0 constant: info
                    objv3[0] = const3;
                    // Arg 1 constant: exists
                    objv3[1] = const4;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("_module(expanded_");
                    tmp4 = getVarScalar(interp, "lower", compiledLocals, 3);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(")");
                    tmp4 = TclString.newInstance(sbtmp5);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv3, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            boolean tmp8 = tmp7.getBooleanValue(interp);
            if ( tmp8 ) {
                { // Invoke: return $...
                    TclObject tmp9;
                    StringBuffer sbtmp10 = new StringBuffer(64);
                    sbtmp10.append("expanded_");
                    tmp9 = getVarScalar(interp, "lower", compiledLocals, 3);
                    sbtmp10.append(tmp9.toString());
                    tmp9 = getVarArray(interp, "_module", sbtmp10.toString(), compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp9);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set vals [...]
            TclObject tmp11;
            { // Invoke: module_query $cmd
                TclObject[] objv12 = TJC.grabObjv(interp, 2);
                TclObject tmp13;
                try {
                    // Arg 0 constant: module_query
                    objv12[0] = const5;
                    // Arg 1 variable: $cmd
                    tmp13 = getVarScalar(interp, "cmd", compiledLocals, 0);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 2);
                }
            } // End Invoke: module_query
            tmp11 = interp.getResult();
            setVarScalar(interp, "vals", tmp11, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set evals [...]
            TclObject tmp14;
            { // Invoke: list
                TclObject tmp15 = TclList.newInstance();
                interp.setResult(tmp15);
            } // End Invoke: list
            tmp14 = interp.getResult();
            setVarScalar(interp, "evals", tmp14, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp16 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp17 = TJC.getBoolean(interp, tmp16);
            if ( tmp17 ) {
                { // Invoke: puts ...
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: puts
                        objv18[0] = const6;
                        // Arg 1 word: ...
                        StringBuffer sbtmp20 = new StringBuffer(64);
                        sbtmp20.append("vals is ");
                        sbtmp20.append("{");
                        tmp19 = getVarScalar(interp, "vals", compiledLocals, 4);
                        sbtmp20.append(tmp19.toString());
                        sbtmp20.append("}");
                        tmp19 = TclString.newInstance(sbtmp20);
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv18, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp19 = objv18[1];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: foreach val $vals ...
            TclObject tmp21 = null;
            try {
                tmp21 = getVarScalar(interp, "vals", compiledLocals, 4);
                tmp21.preserve();
                final int tmp21_length = TclList.getLength(interp, tmp21);

                for ( int index22 = 0 ; index22 < tmp21_length ; index22++ ) {
                    TclObject tmp23 = TclList.index(interp, tmp21, index22);
                    try {
                        setVarScalar(interp, "val", tmp23, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "val");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$debug} ...
                        TclObject tmp24 = getVarScalar(interp, "debug", compiledLocals, 2);
                        boolean tmp25 = TJC.getBoolean(interp, tmp24);
                        if ( tmp25 ) {
                            { // Invoke: puts ...
                                TclObject[] objv26 = TJC.grabObjv(interp, 2);
                                TclObject tmp27;
                                try {
                                    // Arg 0 constant: puts
                                    objv26[0] = const6;
                                    // Arg 1 word: ...
                                    StringBuffer sbtmp28 = new StringBuffer(64);
                                    sbtmp28.append("val is ");
                                    sbtmp28.append("\"");
                                    tmp27 = getVarScalar(interp, "val", compiledLocals, 6);
                                    sbtmp28.append(tmp27.toString());
                                    sbtmp28.append("\"");
                                    tmp27 = TclString.newInstance(sbtmp28);
                                    tmp27.preserve();
                                    objv26[1] = tmp27;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv26, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp27 = objv26[1];
                                    if ( tmp27 != null ) {
                                        tmp27.release();
                                    }
                                    TJC.releaseObjv(interp, objv26, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ... else ...
                        // Unary operator: ! [...]
                        { // Invoke: ... $val
                            TclObject[] objv29 = TJC.grabObjv(interp, 2);
                            TclObject tmp30;
                            try {
                                // Arg 0 constant: ...
                                objv29[0] = const7;
                                // Arg 1 variable: $val
                                tmp30 = getVarScalar(interp, "val", compiledLocals, 6);
                                tmp30.preserve();
                                objv29[1] = tmp30;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv29, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp30 = objv29[1];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp31 = interp.getResult();
                        ExprValue tmp32 = evs0;
                        if ( tmp31.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp32, tmp31);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp32, tmp31);
                        }
                        // End Unary operator: !
                        boolean tmp33 = ( tmp32.getIntValue() != 0 );
                        if ( tmp33 ) {
                            { // Invoke: if ... ...
                                // Unary operator: ! [...]
                                { // Invoke: file exists $val
                                    TclObject[] objv34 = TJC.grabObjv(interp, 3);
                                    TclObject tmp35;
                                    try {
                                        // Arg 0 constant: file
                                        objv34[0] = const8;
                                        // Arg 1 constant: exists
                                        objv34[1] = const4;
                                        // Arg 2 variable: $val
                                        tmp35 = getVarScalar(interp, "val", compiledLocals, 6);
                                        tmp35.preserve();
                                        objv34[2] = tmp35;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv34, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp35 = objv34[2];
                                        if ( tmp35 != null ) {
                                            tmp35.release();
                                        }
                                        TJC.releaseObjv(interp, objv34, 3);
                                    }
                                } // End Invoke: file
                                TclObject tmp36 = interp.getResult();
                                ExprValue tmp37 = evs0;
                                if ( tmp36.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp37, tmp36);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp37, tmp36);
                                }
                                // End Unary operator: !
                                boolean tmp38 = ( tmp37.getIntValue() != 0 );
                                if ( tmp38 ) {
                                    { // Invoke: error "..."
                                        TclObject[] objv39 = TJC.grabObjv(interp, 2);
                                        TclObject tmp40;
                                        try {
                                            // Arg 0 constant: error
                                            objv39[0] = const9;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp41 = new StringBuffer(64);
                                            tmp40 = getVarScalar(interp, "cmd", compiledLocals, 0);
                                            sbtmp41.append(tmp40.toString());
                                            sbtmp41.append(" declaration contains file named ");
                                            sbtmp41.append("\"");
                                            tmp40 = getVarScalar(interp, "val", compiledLocals, 6);
                                            sbtmp41.append(tmp40.toString());
                                            sbtmp41.append("\"");
                                            sbtmp41.append(" that does not exist");
                                            tmp40 = TclString.newInstance(sbtmp41);
                                            tmp40.preserve();
                                            objv39[1] = tmp40;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv39, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            tmp40 = objv39[1];
                                            if ( tmp40 != null ) {
                                                tmp40.release();
                                            }
                                            TJC.releaseObjv(interp, objv39, 2);
                                        }
                                    } // End Invoke: error
                                }
                            } // End Invoke: if
                            { // Invoke: if {$debug} ...
                                TclObject tmp42 = getVarScalar(interp, "debug", compiledLocals, 2);
                                boolean tmp43 = TJC.getBoolean(interp, tmp42);
                                if ( tmp43 ) {
                                    { // Invoke: puts "..."
                                        TclObject[] objv44 = TJC.grabObjv(interp, 2);
                                        TclObject tmp45;
                                        try {
                                            // Arg 0 constant: puts
                                            objv44[0] = const6;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp46 = new StringBuffer(64);
                                            sbtmp46.append("appending existing filename val ");
                                            sbtmp46.append("\"");
                                            tmp45 = getVarScalar(interp, "val", compiledLocals, 6);
                                            sbtmp46.append(tmp45.toString());
                                            sbtmp46.append("\"");
                                            tmp45 = TclString.newInstance(sbtmp46);
                                            tmp45.preserve();
                                            objv44[1] = tmp45;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv44, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp45 = objv44[1];
                                            if ( tmp45 != null ) {
                                                tmp45.release();
                                            }
                                            TJC.releaseObjv(interp, objv44, 2);
                                        }
                                    } // End Invoke: puts
                                }
                            } // End Invoke: if
                            { // Invoke: lappend evals $val
                                TclObject[] objv47 = TJC.grabObjv(interp, 1);
                                TclObject tmp48;
                                try {
                                    // Arg 2 variable: $val
                                    tmp48 = getVarScalar(interp, "val", compiledLocals, 6);
                                    tmp48.preserve();
                                    objv47[0] = tmp48;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "evals", objv47, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv47, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            { // Invoke: set fnames [...]
                                TclObject tmp49;
                                { // Invoke: glob -nocomplain $val
                                    TclObject[] objv50 = TJC.grabObjv(interp, 3);
                                    TclObject tmp51;
                                    try {
                                        // Arg 0 constant: glob
                                        objv50[0] = const10;
                                        // Arg 1 constant: -nocomplain
                                        objv50[1] = const11;
                                        // Arg 2 variable: $val
                                        tmp51 = getVarScalar(interp, "val", compiledLocals, 6);
                                        tmp51.preserve();
                                        objv50[2] = tmp51;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv50, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp51 = objv50[2];
                                        if ( tmp51 != null ) {
                                            tmp51.release();
                                        }
                                        TJC.releaseObjv(interp, objv50, 3);
                                    }
                                } // End Invoke: glob
                                tmp49 = interp.getResult();
                                setVarScalar(interp, "fnames", tmp49, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: if {$debug} ...
                                TclObject tmp52 = getVarScalar(interp, "debug", compiledLocals, 2);
                                boolean tmp53 = TJC.getBoolean(interp, tmp52);
                                if ( tmp53 ) {
                                    { // Invoke: puts "..."
                                        TclObject[] objv54 = TJC.grabObjv(interp, 2);
                                        TclObject tmp55;
                                        try {
                                            // Arg 0 constant: puts
                                            objv54[0] = const6;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp56 = new StringBuffer(64);
                                            sbtmp56.append("glob pattern ");
                                            sbtmp56.append("\"");
                                            tmp55 = getVarScalar(interp, "val", compiledLocals, 6);
                                            sbtmp56.append(tmp55.toString());
                                            sbtmp56.append("\"");
                                            sbtmp56.append(" expands to ");
                                            sbtmp56.append("{");
                                            tmp55 = getVarScalar(interp, "fnames", compiledLocals, 7);
                                            sbtmp56.append(tmp55.toString());
                                            sbtmp56.append("}");
                                            tmp55 = TclString.newInstance(sbtmp56);
                                            tmp55.preserve();
                                            objv54[1] = tmp55;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv54, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp55 = objv54[1];
                                            if ( tmp55 != null ) {
                                                tmp55.release();
                                            }
                                            TJC.releaseObjv(interp, objv54, 2);
                                        }
                                    } // End Invoke: puts
                                }
                            } // End Invoke: if
                            { // Invoke: foreach fname $fnames ...
                                TclObject tmp57 = null;
                                try {
                                    tmp57 = getVarScalar(interp, "fnames", compiledLocals, 7);
                                    tmp57.preserve();
                                    final int tmp57_length = TclList.getLength(interp, tmp57);

                                    for ( int index58 = 0 ; index58 < tmp57_length ; index58++ ) {
                                        TclObject tmp59 = TclList.index(interp, tmp57, index58);
                                        try {
                                            setVarScalar(interp, "fname", tmp59, compiledLocals, 8);
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "fname");
                                        }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: lappend evals $fname
                                            TclObject[] objv60 = TJC.grabObjv(interp, 1);
                                            TclObject tmp61;
                                            try {
                                                // Arg 2 variable: $fname
                                                tmp61 = getVarScalar(interp, "fname", compiledLocals, 8);
                                                tmp61.preserve();
                                                objv60[0] = tmp61;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "evals", objv60, compiledLocals, 5);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv60, 1);
                                            }
                                        } // End Invoke: lappend
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } finally {
                                    if ( tmp57 != null ) {
                                        tmp57.release();
                                    }
                                }
                            } // End Invoke: foreach
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp21 != null ) {
                    tmp21.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set svals [...]
            TclObject tmp62;
            { // Invoke: lsort -dictionary $evals
                TclObject[] objv63 = TJC.grabObjv(interp, 3);
                TclObject tmp64;
                try {
                    // Arg 0 constant: lsort
                    objv63[0] = const12;
                    // Arg 1 constant: -dictionary
                    objv63[1] = const13;
                    // Arg 2 variable: $evals
                    tmp64 = getVarScalar(interp, "evals", compiledLocals, 5);
                    tmp64.preserve();
                    objv63[2] = tmp64;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv63, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp64 = objv63[2];
                    if ( tmp64 != null ) {
                        tmp64.release();
                    }
                    TJC.releaseObjv(interp, objv63, 3);
                }
            } // End Invoke: lsort
            tmp62 = interp.getResult();
            setVarScalar(interp, "svals", tmp62, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set "..." $svals
            TclObject tmp65;
            String tmp66;
            StringBuffer sbtmp67 = new StringBuffer(64);
            sbtmp67.append("expanded_");
            tmp65 = getVarScalar(interp, "lower", compiledLocals, 3);
            sbtmp67.append(tmp65.toString());
            tmp66 = sbtmp67.toString();
            tmp65 = getVarScalar(interp, "svals", compiledLocals, 9);
            tmp65 = setVarArray(interp, "_module", tmp66, tmp65, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp68 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp69 = TJC.getBoolean(interp, tmp68);
            if ( tmp69 ) {
                { // Invoke: puts "..."
                    TclObject[] objv70 = TJC.grabObjv(interp, 2);
                    TclObject tmp71;
                    try {
                        // Arg 0 constant: puts
                        objv70[0] = const6;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp72 = new StringBuffer(64);
                        sbtmp72.append("set _module(expanded_");
                        tmp71 = getVarScalar(interp, "lower", compiledLocals, 3);
                        sbtmp72.append(tmp71.toString());
                        sbtmp72.append(") to ");
                        sbtmp72.append("{");
                        tmp71 = getVarScalar(interp, "svals", compiledLocals, 9);
                        sbtmp72.append(tmp71.toString());
                        sbtmp72.append("}");
                        tmp71 = TclString.newInstance(sbtmp72);
                        tmp71.preserve();
                        objv70[1] = tmp71;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv70, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp71 = objv70[1];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        TJC.releaseObjv(interp, objv70, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: return $svals
            TclObject tmp73 = getVarScalar(interp, "svals", compiledLocals, 9);
            interp.resetResult();
            interp.setResult(tmp73);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_expand");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("string");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tolower");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("info");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("exists");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("module_query");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("puts");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("module_looks_like_glob");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("file");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("error");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("glob");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("-nocomplain");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("lsort");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("-dictionary");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            case 3: {
                cmdName = "module_query";
                break;
            }
            case 4: {
                cmdName = "puts";
                break;
            }
            case 5: {
                cmdName = "module_looks_like_glob";
                break;
            }
            case 6: {
                cmdName = "file";
                break;
            }
            case 7: {
                cmdName = "error";
                break;
            }
            case 8: {
                cmdName = "glob";
                break;
            }
            case 9: {
                cmdName = "lsort";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmd",
        "_module",
        "debug",
        "lower",
        "vals",
        "evals",
        "val",
        "fnames",
        "fname",
        "svals"
    };
} // end class ModuleExpandCmd

