// TJC implementation of procedure module_option_validate
package tjc;
import tcl.lang.*;

public class ModuleOptionValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "op val index num_options options");
        }
        setVarScalar(interp, "op", objv[1], compiledLocals, 0);
        setVarScalar(interp, "val", objv[2], compiledLocals, 1);
        setVarScalar(interp, "index", objv[3], compiledLocals, 2);
        setVarScalar(interp, "num_options", objv[4], compiledLocals, 3);
        setVarScalar(interp, "options", objv[5], compiledLocals, 4);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 5);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("module_option_validate ");
                        sbtmp4.append("{");
                        tmp3 = getVarScalar(interp, "op", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append(" ");
                        tmp3 = getVarScalar(interp, "val", compiledLocals, 1);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("}");
                        sbtmp4.append(" ");
                        tmp3 = getVarScalar(interp, "index", compiledLocals, 2);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append(" ");
                        tmp3 = getVarScalar(interp, "num_options", compiledLocals, 3);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append(" ");
                        sbtmp4.append("{");
                        tmp3 = getVarScalar(interp, "options", compiledLocals, 4);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("}");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: $num_options > 1
            TclObject tmp5 = getVarScalar(interp, "num_options", compiledLocals, 3);
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            ExprValue tmp7 = evs1;
            tmp7.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp6, tmp7);
            // End Binary operator: >
            if (tmp6.getBooleanValue(interp)) {
            // Binary operator: $index >= 2
            TclObject tmp8 = getVarScalar(interp, "index", compiledLocals, 2);
            ExprValue tmp9 = evs1;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs2;
            tmp10.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp9, tmp10);
            // End Binary operator: >=
            tmp6.setIntValue(tmp9.getBooleanValue(interp));
            } else {
            tmp6.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp11 = ( tmp6.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: set rstart 0
                    setVarScalar(interp, "rstart", const0, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set rend [...]
                    TclObject tmp12;
                    { // Invoke: expr ...
                        // Binary operator: () - 1
                        // Binary operator: () - 2
                        // Binary operator: 2 * $index
                        ExprValue tmp13 = evs0;
                        tmp13.setIntValue(2);
                        TclObject tmp14 = getVarScalar(interp, "index", compiledLocals, 2);
                        ExprValue tmp15 = evs1;
                        TJC.exprInitValue(interp, tmp15, tmp14);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MULT, tmp13, tmp15);
                        // End Binary operator: *
                        ExprValue tmp16 = evs1;
                        tmp16.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp13, tmp16);
                        // End Binary operator: -
                        ExprValue tmp17 = evs1;
                        tmp17.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp13, tmp17);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp13);
                    } // End Invoke: expr
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "rend", tmp12, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set options_before [...]
                    TclObject tmp18;
                    { // Invoke: lrange $options $rstart $rend
                        TclObject[] objv19 = TJC.grabObjv(interp, 4);
                        TclObject tmp20;
                        try {
                            // Arg 0 constant: lrange
                            objv19[0] = const2;
                            // Arg 1 variable: $options
                            tmp20 = getVarScalar(interp, "options", compiledLocals, 4);
                            tmp20.preserve();
                            objv19[1] = tmp20;
                            // Arg 2 variable: $rstart
                            tmp20 = getVarScalar(interp, "rstart", compiledLocals, 6);
                            tmp20.preserve();
                            objv19[2] = tmp20;
                            // Arg 3 variable: $rend
                            tmp20 = getVarScalar(interp, "rend", compiledLocals, 7);
                            tmp20.preserve();
                            objv19[3] = tmp20;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv19, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp20 = objv19[1];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            tmp20 = objv19[2];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            tmp20 = objv19[3];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            TJC.releaseObjv(interp, objv19, 4);
                        }
                    } // End Invoke: lrange
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "options_before", tmp18, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp21 = getVarScalar(interp, "debug", compiledLocals, 5);
                    boolean tmp22 = TJC.getBoolean(interp, tmp21);
                    if ( tmp22 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv23 = TJC.grabObjv(interp, 2);
                            TclObject tmp24;
                            try {
                                // Arg 0 constant: puts
                                objv23[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp25 = new StringBuffer(64);
                                sbtmp25.append("options_before range ");
                                tmp24 = getVarScalar(interp, "rstart", compiledLocals, 6);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append(" ");
                                tmp24 = getVarScalar(interp, "rend", compiledLocals, 7);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append(" ");
                                sbtmp25.append("{");
                                tmp24 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                sbtmp25.append(tmp24.toString());
                                sbtmp25.append("}");
                                tmp24 = TclString.newInstance(sbtmp25);
                                tmp24.preserve();
                                objv23[1] = tmp24;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv23, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp24 = objv23[1];
                                if ( tmp24 != null ) {
                                    tmp24.release();
                                }
                                TJC.releaseObjv(interp, objv23, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Binary operator: () != 0
                    // Binary operator: [...] % 2
                    { // Invoke: llength $options_before
                        TclObject tmp26 = getVarScalar(interp, "options_before", compiledLocals, 8);
                        int tmp27 = TclList.getLength(interp, tmp26);
                        interp.setResult(tmp27);
                    } // End Invoke: llength
                    TclObject tmp28 = interp.getResult();
                    ExprValue tmp29 = evs0;
                    TJC.exprInitValue(interp, tmp29, tmp28);
                    ExprValue tmp30 = evs1;
                    tmp30.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp29, tmp30);
                    // End Binary operator: %
                    ExprValue tmp31 = evs1;
                    tmp31.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp29, tmp31);
                    // End Binary operator: !=
                    boolean tmp32 = ( tmp29.getIntValue() != 0 );
                    if ( tmp32 ) {
                        { // Invoke: error "..."
                            TclObject[] objv33 = TJC.grabObjv(interp, 2);
                            TclObject tmp34;
                            try {
                                // Arg 0 constant: error
                                objv33[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp35 = new StringBuffer(64);
                                sbtmp35.append("uneven options_before ");
                                sbtmp35.append("{");
                                tmp34 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                sbtmp35.append(tmp34.toString());
                                sbtmp35.append("}");
                                sbtmp35.append(": options ");
                                sbtmp35.append("{");
                                tmp34 = getVarScalar(interp, "options", compiledLocals, 4);
                                sbtmp35.append(tmp34.toString());
                                sbtmp35.append("}");
                                sbtmp35.append(" : range 0 ");
                                { // Invoke: expr {$index - 1}
                                    // Binary operator: $index - 1
                                    TclObject tmp36 = getVarScalar(interp, "index", compiledLocals, 2);
                                    ExprValue tmp37 = evs0;
                                    TJC.exprInitValue(interp, tmp37, tmp36);
                                    ExprValue tmp38 = evs1;
                                    tmp38.setIntValue(1);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp37, tmp38);
                                    // End Binary operator: -
                                    TJC.exprSetResult(interp, tmp37);
                                } // End Invoke: expr
                                tmp34 = interp.getResult();
                                sbtmp35.append(tmp34.toString());
                                tmp34 = TclString.newInstance(sbtmp35);
                                tmp34.preserve();
                                objv33[1] = tmp34;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv33, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp34 = objv33[1];
                                if ( tmp34 != null ) {
                                    tmp34.release();
                                }
                                TJC.releaseObjv(interp, objv33, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set options_before {}
                    setVarScalar(interp, "options_before", const4, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp39 = getVarScalar(interp, "debug", compiledLocals, 5);
                    boolean tmp40 = TJC.getBoolean(interp, tmp39);
                    if ( tmp40 ) {
                        { // Invoke: puts ...
                            TclObject[] objv41 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: puts
                                objv41[0] = const1;
                                // Arg 1 constant: ...
                                objv41[1] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv41, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv41, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $op {cache-commands} ... {cache-variables} ... {compile} ... {constant-increment} ... {dummy} ... {inline-expr} ... ... ... ... ... {inline-commands} ... {inline-containers} ... {inline-controls} ... {O} ... {omit-results} ... default ...
            TclObject tmp42 = getVarScalar(interp, "op", compiledLocals, 0);
            String tmp43 = tmp42.toString();
            int tmp43_length = tmp43.length();
            char tmp43_first = '\n';
            if ( tmp43_length > 0 ) {
                tmp43_first = tmp43.charAt(0);
            }
            if ( tmp43_length == 14 && tmp43_first == 'c'
                    && tmp43.compareTo("cache-commands") == 0 ) {
                // Pattern {cache-commands}
            } else if ( tmp43_length == 15 && tmp43_first == 'c'
                    && tmp43.compareTo("cache-variables") == 0 ) {
                // Pattern {cache-variables}
            } else if ( tmp43_length == 7 && tmp43_first == 'c'
                    && tmp43.compareTo("compile") == 0 ) {
                // Pattern {compile}
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $val == 0
                    TclObject tmp44 = getVarScalar(interp, "val", compiledLocals, 1);
                    ExprValue tmp45 = evs0;
                    TJC.exprInitValue(interp, tmp45, tmp44);
                    ExprValue tmp46 = evs1;
                    tmp46.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp45, tmp46);
                    // End Binary operator: ==
                    if (tmp45.getBooleanValue(interp)) {
                    // Binary operator: $num_options != 1
                    TclObject tmp47 = getVarScalar(interp, "num_options", compiledLocals, 3);
                    ExprValue tmp48 = evs1;
                    TJC.exprInitValue(interp, tmp48, tmp47);
                    ExprValue tmp49 = evs2;
                    tmp49.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp48, tmp49);
                    // End Binary operator: !=
                    tmp45.setIntValue(tmp48.getBooleanValue(interp));
                    } else {
                    tmp45.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp50 = ( tmp45.getIntValue() != 0 );
                    if ( tmp50 ) {
                        { // Invoke: error ...
                            TclObject[] objv51 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv51[0] = const3;
                                // Arg 1 constant: ...
                                objv51[1] = const6;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv51, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv51, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 18 && tmp43_first == 'c'
                    && tmp43.compareTo("constant-increment") == 0 ) {
                // Pattern {constant-increment}
                { // Invoke: if {$val == 1} ...
                    // Binary operator: $val == 1
                    TclObject tmp52 = getVarScalar(interp, "val", compiledLocals, 1);
                    ExprValue tmp53 = evs0;
                    TJC.exprInitValue(interp, tmp53, tmp52);
                    ExprValue tmp54 = evs1;
                    tmp54.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp53, tmp54);
                    // End Binary operator: ==
                    boolean tmp55 = ( tmp53.getIntValue() != 0 );
                    if ( tmp55 ) {
                        { // Invoke: error ...
                            TclObject[] objv56 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv56[0] = const3;
                                // Arg 1 constant: ...
                                objv56[1] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv56, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv56, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 5 && tmp43_first == 'd'
                    && tmp43.compareTo("dummy") == 0 ) {
                // Pattern {dummy}
            } else if ( tmp43_length == 11 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-expr") == 0 ) {
                // Pattern {inline-expr}
                { // Invoke: if {$val} ...
                    TclObject tmp57 = getVarScalar(interp, "val", compiledLocals, 1);
                    boolean tmp58 = TJC.getBoolean(interp, tmp57);
                    if ( tmp58 ) {
                        { // Invoke: array set options_before_map $options_before
                            TclObject[] objv59 = TJC.grabObjv(interp, 4);
                            TclObject tmp60;
                            try {
                                // Arg 0 constant: array
                                objv59[0] = const8;
                                // Arg 1 constant: set
                                objv59[1] = const9;
                                // Arg 2 constant: options_before_map
                                objv59[2] = const10;
                                // Arg 3 variable: $options_before
                                tmp60 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                tmp60.preserve();
                                objv59[3] = tmp60;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv59, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp60 = objv59[3];
                                if ( tmp60 != null ) {
                                    tmp60.release();
                                }
                                TJC.releaseObjv(interp, objv59, 4);
                            }
                        } // End Invoke: array
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv61 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv61[0] = const11;
                                    // Arg 1 constant: exists
                                    objv61[1] = const12;
                                    // Arg 2 constant: ...
                                    objv61[2] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv61, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv61, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp62 = interp.getResult();
                            ExprValue tmp63 = evs0;
                            if ( tmp62.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp63, tmp62);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp63, tmp62);
                            }
                            // End Unary operator: !
                            if (!tmp63.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp64 = getVarArray(interp, "options_before_map", "inline-containers", compiledLocals, 9);
                            ExprValue tmp65 = evs1;
                            TJC.exprInitValue(interp, tmp65, tmp64);
                            ExprValue tmp66 = evs2;
                            tmp66.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp65, tmp66);
                            // End Binary operator: ==
                            tmp63.setIntValue(tmp65.getBooleanValue(interp));
                            } else {
                            tmp63.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp67 = ( tmp63.getIntValue() != 0 );
                            if ( tmp67 ) {
                                { // Invoke: error ...
                                    TclObject[] objv68 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv68[0] = const3;
                                        // Arg 1 constant: ...
                                        objv68[1] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv68, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv68, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 23 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-expr-value-stack") == 0 ) {
                // Pattern ...
                { // Invoke: if {$val} ... else ...
                    TclObject tmp69 = getVarScalar(interp, "val", compiledLocals, 1);
                    boolean tmp70 = TJC.getBoolean(interp, tmp69);
                    if ( tmp70 ) {
                        { // Invoke: error ...
                            TclObject[] objv71 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv71[0] = const3;
                                // Arg 1 constant: ...
                                objv71[1] = const15;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv71, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv71, 2);
                            }
                        } // End Invoke: error
                    } else {
                        { // Invoke: array set options_before_map $options_before
                            TclObject[] objv72 = TJC.grabObjv(interp, 4);
                            TclObject tmp73;
                            try {
                                // Arg 0 constant: array
                                objv72[0] = const8;
                                // Arg 1 constant: set
                                objv72[1] = const9;
                                // Arg 2 constant: options_before_map
                                objv72[2] = const10;
                                // Arg 3 variable: $options_before
                                tmp73 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                tmp73.preserve();
                                objv72[3] = tmp73;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv72, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp73 = objv72[3];
                                if ( tmp73 != null ) {
                                    tmp73.release();
                                }
                                TJC.releaseObjv(interp, objv72, 4);
                            }
                        } // End Invoke: array
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv74 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv74[0] = const11;
                                    // Arg 1 constant: exists
                                    objv74[1] = const12;
                                    // Arg 2 constant: ...
                                    objv74[2] = const16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv74, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv74, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp75 = interp.getResult();
                            ExprValue tmp76 = evs0;
                            if ( tmp75.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp76, tmp75);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp76, tmp75);
                            }
                            // End Unary operator: !
                            if (!tmp76.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp77 = getVarArray(interp, "options_before_map", "inline-expr", compiledLocals, 9);
                            ExprValue tmp78 = evs1;
                            TJC.exprInitValue(interp, tmp78, tmp77);
                            ExprValue tmp79 = evs2;
                            tmp79.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp78, tmp79);
                            // End Binary operator: ==
                            tmp76.setIntValue(tmp78.getBooleanValue(interp));
                            } else {
                            tmp76.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp80 = ( tmp76.getIntValue() != 0 );
                            if ( tmp80 ) {
                                { // Invoke: error ...
                                    TclObject[] objv81 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv81[0] = const3;
                                        // Arg 1 constant: ...
                                        objv81[1] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv81, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv81, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: if ... ...
                            // Binary operator: [...] && ()
                            { // Invoke: info exists ...
                                TclObject[] objv82 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv82[0] = const11;
                                    // Arg 1 constant: exists
                                    objv82[1] = const12;
                                    // Arg 2 constant: ...
                                    objv82[2] = const18;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv82, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv82, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp83 = interp.getResult();
                            ExprValue tmp84 = evs0;
                            TJC.exprInitValue(interp, tmp84, tmp83);
                            if (tmp84.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp85 = getVarArray(interp, "options_before_map", "inline-expr-value-stack-null", compiledLocals, 9);
                            ExprValue tmp86 = evs1;
                            TJC.exprInitValue(interp, tmp86, tmp85);
                            ExprValue tmp87 = evs2;
                            tmp87.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp86, tmp87);
                            // End Binary operator: ==
                            tmp84.setIntValue(tmp86.getBooleanValue(interp));
                            } else {
                            tmp84.setIntValue(0);
                            } // End if: [...]
                            // End Binary operator: &&
                            boolean tmp88 = ( tmp84.getIntValue() != 0 );
                            if ( tmp88 ) {
                                { // Invoke: error ...
                                    TclObject[] objv89 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv89[0] = const3;
                                        // Arg 1 constant: ...
                                        objv89[1] = const19;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv89, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv89, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 28 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-expr-value-stack-null") == 0 ) {
                // Pattern ...
                { // Invoke: if {!$val} ... else ...
                    // Unary operator: ! $val
                    TclObject tmp90 = getVarScalar(interp, "val", compiledLocals, 1);
                    ExprValue tmp91 = evs0;
                    if ( tmp90.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp91, tmp90);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp91, tmp90);
                    }
                    // End Unary operator: !
                    boolean tmp92 = ( tmp91.getIntValue() != 0 );
                    if ( tmp92 ) {
                        { // Invoke: error ...
                            TclObject[] objv93 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv93[0] = const3;
                                // Arg 1 constant: ...
                                objv93[1] = const20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv93, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv93, 2);
                            }
                        } // End Invoke: error
                    } else {
                        { // Invoke: array set options_before_map $options_before
                            TclObject[] objv94 = TJC.grabObjv(interp, 4);
                            TclObject tmp95;
                            try {
                                // Arg 0 constant: array
                                objv94[0] = const8;
                                // Arg 1 constant: set
                                objv94[1] = const9;
                                // Arg 2 constant: options_before_map
                                objv94[2] = const10;
                                // Arg 3 variable: $options_before
                                tmp95 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                tmp95.preserve();
                                objv94[3] = tmp95;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv94, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp95 = objv94[3];
                                if ( tmp95 != null ) {
                                    tmp95.release();
                                }
                                TJC.releaseObjv(interp, objv94, 4);
                            }
                        } // End Invoke: array
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv96 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv96[0] = const11;
                                    // Arg 1 constant: exists
                                    objv96[1] = const12;
                                    // Arg 2 constant: ...
                                    objv96[2] = const16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv96, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv96, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp97 = interp.getResult();
                            ExprValue tmp98 = evs0;
                            if ( tmp97.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp98, tmp97);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp98, tmp97);
                            }
                            // End Unary operator: !
                            if (!tmp98.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp99 = getVarArray(interp, "options_before_map", "inline-expr", compiledLocals, 9);
                            ExprValue tmp100 = evs1;
                            TJC.exprInitValue(interp, tmp100, tmp99);
                            ExprValue tmp101 = evs2;
                            tmp101.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp100, tmp101);
                            // End Binary operator: ==
                            tmp98.setIntValue(tmp100.getBooleanValue(interp));
                            } else {
                            tmp98.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp102 = ( tmp98.getIntValue() != 0 );
                            if ( tmp102 ) {
                                { // Invoke: error ...
                                    TclObject[] objv103 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv103[0] = const3;
                                        // Arg 1 constant: ...
                                        objv103[1] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv103, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv103, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 15 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-commands") == 0 ) {
                // Pattern {inline-commands}
            } else if ( tmp43_length == 17 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-containers") == 0 ) {
                // Pattern {inline-containers}
            } else if ( tmp43_length == 15 && tmp43_first == 'i'
                    && tmp43.compareTo("inline-controls") == 0 ) {
                // Pattern {inline-controls}
                { // Invoke: if {$val} ...
                    TclObject tmp104 = getVarScalar(interp, "val", compiledLocals, 1);
                    boolean tmp105 = TJC.getBoolean(interp, tmp104);
                    if ( tmp105 ) {
                        { // Invoke: array set options_before_map $options_before
                            TclObject[] objv106 = TJC.grabObjv(interp, 4);
                            TclObject tmp107;
                            try {
                                // Arg 0 constant: array
                                objv106[0] = const8;
                                // Arg 1 constant: set
                                objv106[1] = const9;
                                // Arg 2 constant: options_before_map
                                objv106[2] = const10;
                                // Arg 3 variable: $options_before
                                tmp107 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                tmp107.preserve();
                                objv106[3] = tmp107;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv106, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp107 = objv106[3];
                                if ( tmp107 != null ) {
                                    tmp107.release();
                                }
                                TJC.releaseObjv(interp, objv106, 4);
                            }
                        } // End Invoke: array
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv108 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv108[0] = const11;
                                    // Arg 1 constant: exists
                                    objv108[1] = const12;
                                    // Arg 2 constant: ...
                                    objv108[2] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv108, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv108, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp109 = interp.getResult();
                            ExprValue tmp110 = evs0;
                            if ( tmp109.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp110, tmp109);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp110, tmp109);
                            }
                            // End Unary operator: !
                            if (!tmp110.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp111 = getVarArray(interp, "options_before_map", "inline-containers", compiledLocals, 9);
                            ExprValue tmp112 = evs1;
                            TJC.exprInitValue(interp, tmp112, tmp111);
                            ExprValue tmp113 = evs2;
                            tmp113.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp112, tmp113);
                            // End Binary operator: ==
                            tmp110.setIntValue(tmp112.getBooleanValue(interp));
                            } else {
                            tmp110.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp114 = ( tmp110.getIntValue() != 0 );
                            if ( tmp114 ) {
                                { // Invoke: error ...
                                    TclObject[] objv115 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv115[0] = const3;
                                        // Arg 1 constant: ...
                                        objv115[1] = const21;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv115, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv115, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else if ( tmp43_length == 1 && tmp43_first == 'O' ) {
                // Pattern {O}
                { // Invoke: error ...
                    TclObject[] objv116 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv116[0] = const3;
                        // Arg 1 constant: ...
                        objv116[1] = const22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv116, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv116, 2);
                    }
                } // End Invoke: error
            } else if ( tmp43_length == 12 && tmp43_first == 'o'
                    && tmp43.compareTo("omit-results") == 0 ) {
                // Pattern {omit-results}
                { // Invoke: if {$val} ...
                    TclObject tmp117 = getVarScalar(interp, "val", compiledLocals, 1);
                    boolean tmp118 = TJC.getBoolean(interp, tmp117);
                    if ( tmp118 ) {
                        { // Invoke: array set options_before_map $options_before
                            TclObject[] objv119 = TJC.grabObjv(interp, 4);
                            TclObject tmp120;
                            try {
                                // Arg 0 constant: array
                                objv119[0] = const8;
                                // Arg 1 constant: set
                                objv119[1] = const9;
                                // Arg 2 constant: options_before_map
                                objv119[2] = const10;
                                // Arg 3 variable: $options_before
                                tmp120 = getVarScalar(interp, "options_before", compiledLocals, 8);
                                tmp120.preserve();
                                objv119[3] = tmp120;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv119, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp120 = objv119[3];
                                if ( tmp120 != null ) {
                                    tmp120.release();
                                }
                                TJC.releaseObjv(interp, objv119, 4);
                            }
                        } // End Invoke: array
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv121 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv121[0] = const11;
                                    // Arg 1 constant: exists
                                    objv121[1] = const12;
                                    // Arg 2 constant: ...
                                    objv121[2] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv121, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv121, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp122 = interp.getResult();
                            ExprValue tmp123 = evs0;
                            if ( tmp122.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp123, tmp122);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp123, tmp122);
                            }
                            // End Unary operator: !
                            if (!tmp123.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp124 = getVarArray(interp, "options_before_map", "inline-containers", compiledLocals, 9);
                            ExprValue tmp125 = evs1;
                            TJC.exprInitValue(interp, tmp125, tmp124);
                            ExprValue tmp126 = evs2;
                            tmp126.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp125, tmp126);
                            // End Binary operator: ==
                            tmp123.setIntValue(tmp125.getBooleanValue(interp));
                            } else {
                            tmp123.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp127 = ( tmp123.getIntValue() != 0 );
                            if ( tmp127 ) {
                                { // Invoke: error ...
                                    TclObject[] objv128 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv128[0] = const3;
                                        // Arg 1 constant: ...
                                        objv128[1] = const23;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv128, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv128, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: if ... ...
                            // Binary operator: () || ()
                            // Unary operator: ! [...]
                            { // Invoke: info exists ...
                                TclObject[] objv129 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: info
                                    objv129[0] = const11;
                                    // Arg 1 constant: exists
                                    objv129[1] = const12;
                                    // Arg 2 constant: ...
                                    objv129[2] = const24;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv129, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv129, 3);
                                }
                            } // End Invoke: info
                            TclObject tmp130 = interp.getResult();
                            ExprValue tmp131 = evs0;
                            if ( tmp130.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp131, tmp130);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp131, tmp130);
                            }
                            // End Unary operator: !
                            if (!tmp131.getBooleanValue(interp)) {
                            // Binary operator: $options_before_map(...) == 0
                            TclObject tmp132 = getVarArray(interp, "options_before_map", "inline-commands", compiledLocals, 9);
                            ExprValue tmp133 = evs1;
                            TJC.exprInitValue(interp, tmp133, tmp132);
                            ExprValue tmp134 = evs2;
                            tmp134.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp133, tmp134);
                            // End Binary operator: ==
                            tmp131.setIntValue(tmp133.getBooleanValue(interp));
                            } else {
                            tmp131.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp135 = ( tmp131.getIntValue() != 0 );
                            if ( tmp135 ) {
                                { // Invoke: error ...
                                    TclObject[] objv136 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv136[0] = const3;
                                        // Arg 1 constant: ...
                                        objv136[1] = const25;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv136, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv136, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv137 = TJC.grabObjv(interp, 2);
                    TclObject tmp138;
                    try {
                        // Arg 0 constant: error
                        objv137[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp139 = new StringBuffer(64);
                        sbtmp139.append("unknown option ");
                        sbtmp139.append("\"");
                        tmp138 = getVarScalar(interp, "op", compiledLocals, 0);
                        sbtmp139.append(tmp138.toString());
                        sbtmp139.append("\"");
                        tmp138 = TclString.newInstance(sbtmp139);
                        tmp138.preserve();
                        objv137[1] = tmp138;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv137, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp138 = objv137[1];
                        if ( tmp138 != null ) {
                            tmp138.release();
                        }
                        TJC.releaseObjv(interp, objv137, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_option_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("lrange");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("options_before {}");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("-compile option must appear with no other options");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("+constant-increment not supported");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("array");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("set");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("options_before_map");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("info");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("exists");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("options_before_map(inline-containers)");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("+inline-expr option must appear after +inline-containers");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("only -inline-expr-value-stack is allowed");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("options_before_map(inline-expr)");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("+inline-expr-value-stack option must appear after +inline-expr");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("options_before_map(inline-expr-value-stack-null)");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("-inline-expr-value-stack option can't appear after +inline-expr-value-stack-null");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("only +inline-expr-value-stack-null is allowed");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("+inline-controls option must appear after +inline-containers");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("O option should not be validated");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("+omit-results option must appear after +inline-containers");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("options_before_map(inline-commands)");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("+omit-results option must appear after +inline-commands");
        const25.preserve(); const25.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "lrange";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "array";
                break;
            }
            case 5: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op",
        "val",
        "index",
        "num_options",
        "options",
        "debug",
        "rstart",
        "rend",
        "options_before",
        "options_before_map"
    };
} // end class ModuleOptionValidateCmd

