// TJC implementation of procedure module_options_parse
package tjc;
import tcl.lang.*;

public class ModuleOptionsParseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "cargs oname linenum");
        }
        setVarScalar(interp, "cargs", objv[1], compiledLocals, 0);
        setVarScalar(interp, "oname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "linenum", objv[3], compiledLocals, 2);
        { // Invoke: set options [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "options", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: foreach arg $cargs ...
            TclObject tmp2 = null;
            try {
                tmp2 = getVarScalar(interp, "cargs", compiledLocals, 0);
                tmp2.preserve();
                final int tmp2_length = TclList.getLength(interp, tmp2);

                for ( int index3 = 0 ; index3 < tmp2_length ; index3++ ) {
                    TclObject tmp4 = TclList.index(interp, tmp2, index3);
                    try {
                        setVarScalar(interp, "arg", tmp4, compiledLocals, 4);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "arg");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set pat ...
                        setVarScalar(interp, "pat", const0, compiledLocals, 5);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: regexp $pat $arg whole sub1 sub2
                            TclObject[] objv5 = TJC.grabObjv(interp, 6);
                            TclObject tmp6;
                            try {
                                // Arg 0 constant: regexp
                                objv5[0] = const1;
                                // Arg 1 variable: $pat
                                tmp6 = getVarScalar(interp, "pat", compiledLocals, 5);
                                tmp6.preserve();
                                objv5[1] = tmp6;
                                // Arg 2 variable: $arg
                                tmp6 = getVarScalar(interp, "arg", compiledLocals, 4);
                                tmp6.preserve();
                                objv5[2] = tmp6;
                                // Arg 3 constant: whole
                                objv5[3] = const2;
                                // Arg 4 constant: sub1
                                objv5[4] = const3;
                                // Arg 5 constant: sub2
                                objv5[5] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv5, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp6 = objv5[1];
                                if ( tmp6 != null ) {
                                    tmp6.release();
                                }
                                tmp6 = objv5[2];
                                if ( tmp6 != null ) {
                                    tmp6.release();
                                }
                                TJC.releaseObjv(interp, objv5, 6);
                            }
                        } // End Invoke: regexp
                        TclObject tmp7 = interp.getResult();
                        ExprValue tmp8 = evs0;
                        if ( tmp7.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp8, tmp7);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp8, tmp7);
                        }
                        // End Unary operator: !
                        boolean tmp9 = ( tmp8.getIntValue() != 0 );
                        if ( tmp9 ) {
                            { // Invoke: error "..."
                                TclObject[] objv10 = TJC.grabObjv(interp, 2);
                                TclObject tmp11;
                                try {
                                    // Arg 0 constant: error
                                    objv10[0] = const5;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp12 = new StringBuffer(64);
                                    sbtmp12.append("Module command ");
                                    tmp11 = getVarScalar(interp, "oname", compiledLocals, 1);
                                    sbtmp12.append(tmp11.toString());
                                    sbtmp12.append(" argument ");
                                    sbtmp12.append("\"");
                                    tmp11 = getVarScalar(interp, "arg", compiledLocals, 4);
                                    sbtmp12.append(tmp11.toString());
                                    sbtmp12.append("\"");
                                    sbtmp12.append(" is invalid, at line ");
                                    tmp11 = getVarScalar(interp, "linenum", compiledLocals, 2);
                                    sbtmp12.append(tmp11.toString());
                                    tmp11 = TclString.newInstance(sbtmp12);
                                    tmp11.preserve();
                                    objv10[1] = tmp11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv10, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp11 = objv10[1];
                                    if ( tmp11 != null ) {
                                        tmp11.release();
                                    }
                                    TJC.releaseObjv(interp, objv10, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set option $sub2
                        TclObject tmp13;
                        tmp13 = getVarScalar(interp, "sub2", compiledLocals, 6);
                        setVarScalar(interp, "option", tmp13, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: set enabled [...]
                        TclObject tmp14;
                        { // Invoke: expr ...
                            // Ternary operator: () ? 1 : 0
                            // Binary operator: $sub1 == "+"
                            TclObject tmp15 = getVarScalar(interp, "sub1", compiledLocals, 8);
                            boolean tmp16 = tmp15.toString().equals("+");
                            ExprValue tmp17 = evs0;
                            tmp17.setIntValue(tmp16);
                            // End Binary operator: ==
                            if (tmp17.getBooleanValue(interp)) {
                            ExprValue tmp18 = evs1;
                            tmp18.setIntValue(1);
                            tmp17.setValue(tmp18);
                            } else {
                            ExprValue tmp19 = evs1;
                            tmp19.setIntValue(0);
                            tmp17.setValue(tmp19);
                            }
                            // End Ternary operator: ?
                            interp.setResult( tmp17.getIntValue() );
                        } // End Invoke: expr
                        tmp14 = interp.getResult();
                        setVarScalar(interp, "enabled", tmp14, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        { // Invoke: ... $option
                            TclObject[] objv20 = TJC.grabObjv(interp, 2);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: ...
                                objv20[0] = const6;
                                // Arg 1 variable: $option
                                tmp21 = getVarScalar(interp, "option", compiledLocals, 7);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv20, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp22 = interp.getResult();
                        ExprValue tmp23 = evs0;
                        TJC.exprInitValue(interp, tmp23, tmp22);
                        boolean tmp24 = tmp23.getBooleanValue(interp);
                        if ( tmp24 ) {
                            { // Invoke: foreach elem [...] ...
                                TclObject tmp25 = null;
                                try {
                                    { // Invoke: ... $option $enabled
                                        TclObject[] objv26 = TJC.grabObjv(interp, 3);
                                        TclObject tmp27;
                                        try {
                                            // Arg 0 constant: ...
                                            objv26[0] = const7;
                                            // Arg 1 variable: $option
                                            tmp27 = getVarScalar(interp, "option", compiledLocals, 7);
                                            tmp27.preserve();
                                            objv26[1] = tmp27;
                                            // Arg 2 variable: $enabled
                                            tmp27 = getVarScalar(interp, "enabled", compiledLocals, 9);
                                            tmp27.preserve();
                                            objv26[2] = tmp27;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv26, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp27 = objv26[1];
                                            if ( tmp27 != null ) {
                                                tmp27.release();
                                            }
                                            tmp27 = objv26[2];
                                            if ( tmp27 != null ) {
                                                tmp27.release();
                                            }
                                            TJC.releaseObjv(interp, objv26, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp25 = interp.getResult();
                                    tmp25.preserve();
                                    final int tmp25_length = TclList.getLength(interp, tmp25);

                                    for ( int index28 = 0 ; index28 < tmp25_length ; index28++ ) {
                                        TclObject tmp29 = TclList.index(interp, tmp25, index28);
                                        try {
                                            setVarScalar(interp, "elem", tmp29, compiledLocals, 10);
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "elem");
                                        }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: lappend options $elem
                                            TclObject[] objv30 = TJC.grabObjv(interp, 1);
                                            TclObject tmp31;
                                            try {
                                                // Arg 2 variable: $elem
                                                tmp31 = getVarScalar(interp, "elem", compiledLocals, 10);
                                                tmp31.preserve();
                                                objv30[0] = tmp31;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "options", objv30, compiledLocals, 3);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv30, 1);
                                            }
                                        } // End Invoke: lappend
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } finally {
                                    if ( tmp25 != null ) {
                                        tmp25.release();
                                    }
                                }
                            } // End Invoke: foreach
                        } else {
                            { // Invoke: lappend options $option $enabled
                                TclObject[] objv32 = TJC.grabObjv(interp, 2);
                                TclObject tmp33;
                                try {
                                    // Arg 2 variable: $option
                                    tmp33 = getVarScalar(interp, "option", compiledLocals, 7);
                                    tmp33.preserve();
                                    objv32[0] = tmp33;
                                    // Arg 3 variable: $enabled
                                    tmp33 = getVarScalar(interp, "enabled", compiledLocals, 9);
                                    tmp33.preserve();
                                    objv32[1] = tmp33;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "options", objv32, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv32, 2);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp2 != null ) {
                    tmp2.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $options
            TclObject tmp34 = getVarScalar(interp, "options", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp34);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_options_parse");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("^(\\+|\\-)([a-z|O|_|\\-]+)$");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("whole");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("sub1");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("sub2");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("module_option_is_psudo_option");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("module_option_replace_psudo_option");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "module_option_is_psudo_option";
                break;
            }
            case 4: {
                cmdName = "module_option_replace_psudo_option";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cargs",
        "oname",
        "linenum",
        "options",
        "arg",
        "pat",
        "sub2",
        "option",
        "sub1",
        "enabled",
        "elem"
    };
} // end class ModuleOptionsParseCmd

