// TJC implementation of procedure module_options_validate
package tjc;
import tcl.lang.*;

public class ModuleOptionsValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 0);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts ...
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 constant: ...
                        objv2[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set options [...]
            TclObject tmp3;
            { // Invoke: module_query OPTIONS
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv4[0] = const3;
                    // Arg 1 constant: OPTIONS
                    objv4[1] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: module_query
            tmp3 = interp.getResult();
            setVarScalar(interp, "options", tmp3, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp5 = getVarScalar(interp, "debug", compiledLocals, 0);
            boolean tmp6 = TJC.getBoolean(interp, tmp5);
            if ( tmp6 ) {
                { // Invoke: puts "OPTIONS $options"
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: puts
                        objv7[0] = const1;
                        // Arg 1 word: "OPTIONS $options"
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("OPTIONS ");
                        tmp8 = getVarScalar(interp, "options", compiledLocals, 1);
                        sbtmp9.append(tmp8.toString());
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set len [...]
            TclObject tmp10;
            { // Invoke: llength $options
                TclObject tmp11 = getVarScalar(interp, "options", compiledLocals, 1);
                int tmp12 = TclList.getLength(interp, tmp11);
                interp.setResult(tmp12);
            } // End Invoke: llength
            tmp10 = interp.getResult();
            setVarScalar(interp, "len", tmp10, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {($len % 2) != 0} ...
            // Binary operator: () != 0
            // Binary operator: $len % 2
            TclObject tmp13 = getVarScalar(interp, "len", compiledLocals, 2);
            ExprValue tmp14 = evs0;
            TJC.exprInitValue(interp, tmp14, tmp13);
            ExprValue tmp15 = evs1;
            tmp15.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp14, tmp15);
            // End Binary operator: %
            ExprValue tmp16 = evs1;
            tmp16.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp14, tmp16);
            // End Binary operator: !=
            boolean tmp17 = ( tmp14.getIntValue() != 0 );
            if ( tmp17 ) {
                { // Invoke: error "..."
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: error
                        objv18[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp20 = new StringBuffer(64);
                        sbtmp20.append("expected even num options, got ");
                        tmp19 = getVarScalar(interp, "len", compiledLocals, 2);
                        sbtmp20.append(tmp19.toString());
                        tmp19 = TclString.newInstance(sbtmp20);
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv18, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp19 = objv18[1];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set num_options [...]
            TclObject tmp21;
            { // Invoke: expr {$len / 2}
                // Binary operator: $len / 2
                TclObject tmp22 = getVarScalar(interp, "len", compiledLocals, 2);
                ExprValue tmp23 = evs0;
                TJC.exprInitValue(interp, tmp23, tmp22);
                ExprValue tmp24 = evs1;
                tmp24.setIntValue(2);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_DIVIDE, tmp23, tmp24);
                // End Binary operator: /
                TJC.exprSetResult(interp, tmp23);
            } // End Invoke: expr
            tmp21 = interp.getResult();
            setVarScalar(interp, "num_options", tmp21, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set index 0
            setVarScalar(interp, "index", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i 2} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const0, compiledLocals, 5);
            } // End Invoke: set
            for ( boolean skip30 = true ; true ; ) {
                if ( skip30 ) {
                    skip30 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i 2
                        interp.resetResult();
                        incrVarScalar(interp, "i", 2, compiledLocals, 5);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp25 = getVarScalar(interp, "i", compiledLocals, 5);
                ExprValue tmp26 = evs0;
                TJC.exprInitValue(interp, tmp26, tmp25);
                TclObject tmp27 = getVarScalar(interp, "len", compiledLocals, 2);
                ExprValue tmp28 = evs1;
                TJC.exprInitValue(interp, tmp28, tmp27);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp26, tmp28);
                // End Binary operator: <
                boolean tmp29 = ( tmp26.getIntValue() != 0 );
                if ( ! tmp29 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set op [...]
                    TclObject tmp31;
                    { // Invoke: lindex $options $i
                        TclObject tmp32 = null;
                        TclObject tmp33;
                        try {
                            tmp32 = getVarScalar(interp, "options", compiledLocals, 1);
                            tmp32.preserve();
                            tmp33 = getVarScalar(interp, "i", compiledLocals, 5);
                            TJC.lindexNonconst(interp, tmp32, tmp33);
                        } finally {
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "op", tmp31, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set val [...]
                    TclObject tmp34;
                    { // Invoke: lindex $options [...]
                        TclObject tmp35 = null;
                        TclObject tmp36;
                        try {
                            tmp35 = getVarScalar(interp, "options", compiledLocals, 1);
                            tmp35.preserve();
                            { // Invoke: expr {$i + 1}
                                // Binary operator: $i + 1
                                TclObject tmp37 = getVarScalar(interp, "i", compiledLocals, 5);
                                ExprValue tmp38 = evs0;
                                TJC.exprInitValue(interp, tmp38, tmp37);
                                ExprValue tmp39 = evs1;
                                tmp39.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp38, tmp39);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp38);
                            } // End Invoke: expr
                            tmp36 = interp.getResult();
                            TJC.lindexNonconst(interp, tmp35, tmp36);
                        } finally {
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "val", tmp34, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: incr index
                    interp.resetResult();
                    incrVarScalar(interp, "index", 1, compiledLocals, 4);
                } // End Invoke: incr
                { // Invoke: ... $op $val $index $num_options $options
                    TclObject[] objv40 = TJC.grabObjv(interp, 6);
                    TclObject tmp41;
                    try {
                        // Arg 0 constant: ...
                        objv40[0] = const6;
                        // Arg 1 variable: $op
                        tmp41 = getVarScalar(interp, "op", compiledLocals, 6);
                        tmp41.preserve();
                        objv40[1] = tmp41;
                        // Arg 2 variable: $val
                        tmp41 = getVarScalar(interp, "val", compiledLocals, 7);
                        tmp41.preserve();
                        objv40[2] = tmp41;
                        // Arg 3 variable: $index
                        tmp41 = getVarScalar(interp, "index", compiledLocals, 4);
                        tmp41.preserve();
                        objv40[3] = tmp41;
                        // Arg 4 variable: $num_options
                        tmp41 = getVarScalar(interp, "num_options", compiledLocals, 3);
                        tmp41.preserve();
                        objv40[4] = tmp41;
                        // Arg 5 variable: $options
                        tmp41 = getVarScalar(interp, "options", compiledLocals, 1);
                        tmp41.preserve();
                        objv40[5] = tmp41;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv40, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        objv40[0] = null;
                        TJC.releaseObjvElems(interp, objv40, 6);
                    }
                } // End Invoke: ...
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set proc_options [...]
            TclObject tmp42;
            { // Invoke: module_query PROC_OPTIONS
                TclObject[] objv43 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv43[0] = const3;
                    // Arg 1 constant: PROC_OPTIONS
                    objv43[1] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv43, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv43, 2);
                }
            } // End Invoke: module_query
            tmp42 = interp.getResult();
            setVarScalar(interp, "proc_options", tmp42, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: foreach pair $proc_options ...
            TclObject tmp44 = null;
            try {
                tmp44 = getVarScalar(interp, "proc_options", compiledLocals, 8);
                tmp44.preserve();
                final int tmp44_length = TclList.getLength(interp, tmp44);

                for ( int index45 = 0 ; index45 < tmp44_length ; index45++ ) {
                    TclObject tmp46 = TclList.index(interp, tmp44, index45);
                    try {
                        setVarScalar(interp, "pair", tmp46, compiledLocals, 9);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "pair");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set p_name [...]
                        TclObject tmp47;
                        { // Invoke: lindex $pair 0
                            TclObject tmp48 = getVarScalar(interp, "pair", compiledLocals, 9);
                            tmp48 = TclList.index(interp, tmp48, 0);
                            if ( tmp48 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp48);
                            }
                        } // End Invoke: lindex
                        tmp47 = interp.getResult();
                        setVarScalar(interp, "p_name", tmp47, compiledLocals, 10);
                    } // End Invoke: set
                    { // Invoke: set p_options [...]
                        TclObject tmp49;
                        { // Invoke: lindex $pair 1
                            TclObject tmp50 = getVarScalar(interp, "pair", compiledLocals, 9);
                            tmp50 = TclList.index(interp, tmp50, 1);
                            if ( tmp50 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp50);
                            }
                        } // End Invoke: lindex
                        tmp49 = interp.getResult();
                        setVarScalar(interp, "p_options", tmp49, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: set len [...]
                        TclObject tmp51;
                        { // Invoke: llength $p_options
                            TclObject tmp52 = getVarScalar(interp, "p_options", compiledLocals, 11);
                            int tmp53 = TclList.getLength(interp, tmp52);
                            interp.setResult(tmp53);
                        } // End Invoke: llength
                        tmp51 = interp.getResult();
                        setVarScalar(interp, "len", tmp51, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: if {($len % 2) != 0} ...
                        // Binary operator: () != 0
                        // Binary operator: $len % 2
                        TclObject tmp54 = getVarScalar(interp, "len", compiledLocals, 2);
                        ExprValue tmp55 = evs0;
                        TJC.exprInitValue(interp, tmp55, tmp54);
                        ExprValue tmp56 = evs1;
                        tmp56.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp55, tmp56);
                        // End Binary operator: %
                        ExprValue tmp57 = evs1;
                        tmp57.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp55, tmp57);
                        // End Binary operator: !=
                        boolean tmp58 = ( tmp55.getIntValue() != 0 );
                        if ( tmp58 ) {
                            { // Invoke: error "..."
                                TclObject[] objv59 = TJC.grabObjv(interp, 2);
                                TclObject tmp60;
                                try {
                                    // Arg 0 constant: error
                                    objv59[0] = const5;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp61 = new StringBuffer(64);
                                    sbtmp61.append("expected even num options, got ");
                                    tmp60 = getVarScalar(interp, "len", compiledLocals, 2);
                                    sbtmp61.append(tmp60.toString());
                                    tmp60 = TclString.newInstance(sbtmp61);
                                    tmp60.preserve();
                                    objv59[1] = tmp60;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv59, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp60 = objv59[1];
                                    if ( tmp60 != null ) {
                                        tmp60.release();
                                    }
                                    TJC.releaseObjv(interp, objv59, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: catch {unset options_map}
                        int code62 = TCL.OK;
                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: unset options_map
                            TclObject[] objv63 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: unset
                                objv63[0] = const8;
                                // Arg 1 constant: options_map
                                objv63[1] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv63, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv63, 2);
                            }
                        } // End Invoke: unset
                        } catch (TclException ex) {
                            code62 = ex.getCompletionCode();
                        }
                        interp.resetResult();
                        interp.setResult(code62);
                    } // End Invoke: catch
                    { // Invoke: if {$debug} ...
                        TclObject tmp64 = getVarScalar(interp, "debug", compiledLocals, 0);
                        boolean tmp65 = TJC.getBoolean(interp, tmp64);
                        if ( tmp65 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv66 = TJC.grabObjv(interp, 2);
                                TclObject tmp67;
                                try {
                                    // Arg 0 constant: puts
                                    objv66[0] = const1;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp68 = new StringBuffer(64);
                                    sbtmp68.append("options is ");
                                    sbtmp68.append("{");
                                    tmp67 = getVarScalar(interp, "options", compiledLocals, 1);
                                    sbtmp68.append(tmp67.toString());
                                    sbtmp68.append("}");
                                    tmp67 = TclString.newInstance(sbtmp68);
                                    tmp67.preserve();
                                    objv66[1] = tmp67;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv66, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp67 = objv66[1];
                                    if ( tmp67 != null ) {
                                        tmp67.release();
                                    }
                                    TJC.releaseObjv(interp, objv66, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: array set options_map $options
                        TclObject[] objv69 = TJC.grabObjv(interp, 4);
                        TclObject tmp70;
                        try {
                            // Arg 0 constant: array
                            objv69[0] = const10;
                            // Arg 1 constant: set
                            objv69[1] = const11;
                            // Arg 2 constant: options_map
                            objv69[2] = const9;
                            // Arg 3 variable: $options
                            tmp70 = getVarScalar(interp, "options", compiledLocals, 1);
                            tmp70.preserve();
                            objv69[3] = tmp70;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv69, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp70 = objv69[3];
                            if ( tmp70 != null ) {
                                tmp70.release();
                            }
                            TJC.releaseObjv(interp, objv69, 4);
                        }
                    } // End Invoke: array
                    { // Invoke: if {$debug} ...
                        TclObject tmp71 = getVarScalar(interp, "debug", compiledLocals, 0);
                        boolean tmp72 = TJC.getBoolean(interp, tmp71);
                        if ( tmp72 ) {
                            { // Invoke: parray options_map
                                TclObject[] objv73 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: parray
                                    objv73[0] = const12;
                                    // Arg 1 constant: options_map
                                    objv73[1] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv73, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv73, 2);
                                }
                            } // End Invoke: parray
                        }
                    } // End Invoke: if
                    { // Invoke: set cp_options [...]
                        TclObject tmp74;
                        { // Invoke: list
                            TclObject tmp75 = TclList.newInstance();
                            interp.setResult(tmp75);
                        } // End Invoke: list
                        tmp74 = interp.getResult();
                        setVarScalar(interp, "cp_options", tmp74, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: foreach {op val} $p_options ...
                        TclObject tmp76 = null;
                        try {
                            tmp76 = getVarScalar(interp, "p_options", compiledLocals, 11);
                            tmp76.preserve();
                            final int tmp76_length = TclList.getLength(interp, tmp76);

                            for ( int index77 = 0 ; index77 < tmp76_length ; index77 += 2 ) {
                                TclObject tmp78 = null;
                                if ( index77 < tmp76_length ) {
                                    tmp78 = TclList.index(interp, tmp76, index77);
                                }
                                TclObject tmp79 = null;
                                if ( index77 + 1 < tmp76_length ) {
                                    tmp79 = TclList.index(interp, tmp76, index77 + 1);
                                }
                                try {
                                    if ( tmp78 == null ) {
                                        setVarScalar(interp, "op", "", compiledLocals, 6);
                                    } else {
                                        setVarScalar(interp, "op", tmp78, compiledLocals, 6);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "op");
                                }
                                try {
                                    if ( tmp79 == null ) {
                                        setVarScalar(interp, "val", "", compiledLocals, 7);
                                    } else {
                                        setVarScalar(interp, "val", tmp79, compiledLocals, 7);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "val");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: if ... ...
                                    { // Invoke: info exists options_map($op)
                                        TclObject[] objv80 = TJC.grabObjv(interp, 3);
                                        TclObject tmp81;
                                        try {
                                            // Arg 0 constant: info
                                            objv80[0] = const13;
                                            // Arg 1 constant: exists
                                            objv80[1] = const14;
                                            // Arg 2 word: options_map($op)
                                            StringBuffer sbtmp82 = new StringBuffer(64);
                                            sbtmp82.append("options_map(");
                                            tmp81 = getVarScalar(interp, "op", compiledLocals, 6);
                                            sbtmp82.append(tmp81.toString());
                                            sbtmp82.append(")");
                                            tmp81 = TclString.newInstance(sbtmp82);
                                            tmp81.preserve();
                                            objv80[2] = tmp81;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv80, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp81 = objv80[2];
                                            if ( tmp81 != null ) {
                                                tmp81.release();
                                            }
                                            TJC.releaseObjv(interp, objv80, 3);
                                        }
                                    } // End Invoke: info
                                    TclObject tmp83 = interp.getResult();
                                    ExprValue tmp84 = evs0;
                                    TJC.exprInitValue(interp, tmp84, tmp83);
                                    boolean tmp85 = tmp84.getBooleanValue(interp);
                                    if ( tmp85 ) {
                                        { // Invoke: unset options_map($op)
                                            TclObject[] objv86 = TJC.grabObjv(interp, 2);
                                            TclObject tmp87;
                                            try {
                                                // Arg 0 constant: unset
                                                objv86[0] = const8;
                                                // Arg 1 word: options_map($op)
                                                StringBuffer sbtmp88 = new StringBuffer(64);
                                                sbtmp88.append("options_map(");
                                                tmp87 = getVarScalar(interp, "op", compiledLocals, 6);
                                                sbtmp88.append(tmp87.toString());
                                                sbtmp88.append(")");
                                                tmp87 = TclString.newInstance(sbtmp88);
                                                tmp87.preserve();
                                                objv86[1] = tmp87;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv86, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp87 = objv86[1];
                                                if ( tmp87 != null ) {
                                                    tmp87.release();
                                                }
                                                TJC.releaseObjv(interp, objv86, 2);
                                            }
                                        } // End Invoke: unset
                                    }
                                } // End Invoke: if
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp76 != null ) {
                                tmp76.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: set cp_options [...]
                        TclObject tmp89;
                        { // Invoke: list
                            TclObject tmp90 = TclList.newInstance();
                            interp.setResult(tmp90);
                        } // End Invoke: list
                        tmp89 = interp.getResult();
                        setVarScalar(interp, "cp_options", tmp89, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: foreach {op val} $options ...
                        TclObject tmp91 = null;
                        try {
                            tmp91 = getVarScalar(interp, "options", compiledLocals, 1);
                            tmp91.preserve();
                            final int tmp91_length = TclList.getLength(interp, tmp91);

                            for ( int index92 = 0 ; index92 < tmp91_length ; index92 += 2 ) {
                                TclObject tmp93 = null;
                                if ( index92 < tmp91_length ) {
                                    tmp93 = TclList.index(interp, tmp91, index92);
                                }
                                TclObject tmp94 = null;
                                if ( index92 + 1 < tmp91_length ) {
                                    tmp94 = TclList.index(interp, tmp91, index92 + 1);
                                }
                                try {
                                    if ( tmp93 == null ) {
                                        setVarScalar(interp, "op", "", compiledLocals, 6);
                                    } else {
                                        setVarScalar(interp, "op", tmp93, compiledLocals, 6);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "op");
                                }
                                try {
                                    if ( tmp94 == null ) {
                                        setVarScalar(interp, "val", "", compiledLocals, 7);
                                    } else {
                                        setVarScalar(interp, "val", tmp94, compiledLocals, 7);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "val");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: if ... ...
                                    { // Invoke: info exists options_map($op)
                                        TclObject[] objv95 = TJC.grabObjv(interp, 3);
                                        TclObject tmp96;
                                        try {
                                            // Arg 0 constant: info
                                            objv95[0] = const13;
                                            // Arg 1 constant: exists
                                            objv95[1] = const14;
                                            // Arg 2 word: options_map($op)
                                            StringBuffer sbtmp97 = new StringBuffer(64);
                                            sbtmp97.append("options_map(");
                                            tmp96 = getVarScalar(interp, "op", compiledLocals, 6);
                                            sbtmp97.append(tmp96.toString());
                                            sbtmp97.append(")");
                                            tmp96 = TclString.newInstance(sbtmp97);
                                            tmp96.preserve();
                                            objv95[2] = tmp96;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv95, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp96 = objv95[2];
                                            if ( tmp96 != null ) {
                                                tmp96.release();
                                            }
                                            TJC.releaseObjv(interp, objv95, 3);
                                        }
                                    } // End Invoke: info
                                    TclObject tmp98 = interp.getResult();
                                    ExprValue tmp99 = evs0;
                                    TJC.exprInitValue(interp, tmp99, tmp98);
                                    boolean tmp100 = tmp99.getBooleanValue(interp);
                                    if ( tmp100 ) {
                                        { // Invoke: lappend cp_options $op $options_map($op)
                                            TclObject[] objv101 = TJC.grabObjv(interp, 2);
                                            TclObject tmp102;
                                            try {
                                                // Arg 2 variable: $op
                                                tmp102 = getVarScalar(interp, "op", compiledLocals, 6);
                                                tmp102.preserve();
                                                objv101[0] = tmp102;
                                                // Arg 3 variable: $options_map($op)
                                                tmp102 = getVarScalar(interp, "op", compiledLocals, 6);
                                                tmp102 = getVarArray(interp, "options_map", tmp102.toString(), compiledLocals, 13);
                                                tmp102.preserve();
                                                objv101[1] = tmp102;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "cp_options", objv101, compiledLocals, 12);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv101, 2);
                                            }
                                        } // End Invoke: lappend
                                    }
                                } // End Invoke: if
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp91 != null ) {
                                tmp91.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: foreach {op val} $p_options ...
                        TclObject tmp103 = null;
                        try {
                            tmp103 = getVarScalar(interp, "p_options", compiledLocals, 11);
                            tmp103.preserve();
                            final int tmp103_length = TclList.getLength(interp, tmp103);

                            for ( int index104 = 0 ; index104 < tmp103_length ; index104 += 2 ) {
                                TclObject tmp105 = null;
                                if ( index104 < tmp103_length ) {
                                    tmp105 = TclList.index(interp, tmp103, index104);
                                }
                                TclObject tmp106 = null;
                                if ( index104 + 1 < tmp103_length ) {
                                    tmp106 = TclList.index(interp, tmp103, index104 + 1);
                                }
                                try {
                                    if ( tmp105 == null ) {
                                        setVarScalar(interp, "op", "", compiledLocals, 6);
                                    } else {
                                        setVarScalar(interp, "op", tmp105, compiledLocals, 6);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "op");
                                }
                                try {
                                    if ( tmp106 == null ) {
                                        setVarScalar(interp, "val", "", compiledLocals, 7);
                                    } else {
                                        setVarScalar(interp, "val", tmp106, compiledLocals, 7);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "val");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: lappend cp_options $op $val
                                    TclObject[] objv107 = TJC.grabObjv(interp, 2);
                                    TclObject tmp108;
                                    try {
                                        // Arg 2 variable: $op
                                        tmp108 = getVarScalar(interp, "op", compiledLocals, 6);
                                        tmp108.preserve();
                                        objv107[0] = tmp108;
                                        // Arg 3 variable: $val
                                        tmp108 = getVarScalar(interp, "val", compiledLocals, 7);
                                        tmp108.preserve();
                                        objv107[1] = tmp108;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "cp_options", objv107, compiledLocals, 12);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv107, 2);
                                    }
                                } // End Invoke: lappend
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp103 != null ) {
                                tmp103.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: set len [...]
                        TclObject tmp109;
                        { // Invoke: llength $cp_options
                            TclObject tmp110 = getVarScalar(interp, "cp_options", compiledLocals, 12);
                            int tmp111 = TclList.getLength(interp, tmp110);
                            interp.setResult(tmp111);
                        } // End Invoke: llength
                        tmp109 = interp.getResult();
                        setVarScalar(interp, "len", tmp109, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: if {($len % 2) != 0} ...
                        // Binary operator: () != 0
                        // Binary operator: $len % 2
                        TclObject tmp112 = getVarScalar(interp, "len", compiledLocals, 2);
                        ExprValue tmp113 = evs0;
                        TJC.exprInitValue(interp, tmp113, tmp112);
                        ExprValue tmp114 = evs1;
                        tmp114.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp113, tmp114);
                        // End Binary operator: %
                        ExprValue tmp115 = evs1;
                        tmp115.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp113, tmp115);
                        // End Binary operator: !=
                        boolean tmp116 = ( tmp113.getIntValue() != 0 );
                        if ( tmp116 ) {
                            { // Invoke: error "..."
                                TclObject[] objv117 = TJC.grabObjv(interp, 2);
                                TclObject tmp118;
                                try {
                                    // Arg 0 constant: error
                                    objv117[0] = const5;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp119 = new StringBuffer(64);
                                    sbtmp119.append("expected even num options, got ");
                                    tmp118 = getVarScalar(interp, "len", compiledLocals, 2);
                                    sbtmp119.append(tmp118.toString());
                                    tmp118 = TclString.newInstance(sbtmp119);
                                    tmp118.preserve();
                                    objv117[1] = tmp118;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv117, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp118 = objv117[1];
                                    if ( tmp118 != null ) {
                                        tmp118.release();
                                    }
                                    TJC.releaseObjv(interp, objv117, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set num_options [...]
                        TclObject tmp120;
                        { // Invoke: expr {$len / 2}
                            // Binary operator: $len / 2
                            TclObject tmp121 = getVarScalar(interp, "len", compiledLocals, 2);
                            ExprValue tmp122 = evs0;
                            TJC.exprInitValue(interp, tmp122, tmp121);
                            ExprValue tmp123 = evs1;
                            tmp123.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_DIVIDE, tmp122, tmp123);
                            // End Binary operator: /
                            TJC.exprSetResult(interp, tmp122);
                        } // End Invoke: expr
                        tmp120 = interp.getResult();
                        setVarScalar(interp, "num_options", tmp120, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set index 0
                        setVarScalar(interp, "index", const0, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: for {set i 0} {$i < $len} {incr i 2} ...
                        { // Invoke: set i 0
                            setVarScalar(interp, "i", const0, compiledLocals, 5);
                        } // End Invoke: set
                        for ( boolean skip129 = true ; true ; ) {
                            if ( skip129 ) {
                                skip129 = false;
                            } else {
                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: incr i 2
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 2, compiledLocals, 5);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }

                            // Binary operator: $i < $len
                            TclObject tmp124 = getVarScalar(interp, "i", compiledLocals, 5);
                            ExprValue tmp125 = evs0;
                            TJC.exprInitValue(interp, tmp125, tmp124);
                            TclObject tmp126 = getVarScalar(interp, "len", compiledLocals, 2);
                            ExprValue tmp127 = evs1;
                            TJC.exprInitValue(interp, tmp127, tmp126);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp125, tmp127);
                            // End Binary operator: <
                            boolean tmp128 = ( tmp125.getIntValue() != 0 );
                            if ( ! tmp128 ) { break; }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set op [...]
                                TclObject tmp130;
                                { // Invoke: lindex $cp_options $i
                                    TclObject tmp131 = null;
                                    TclObject tmp132;
                                    try {
                                        tmp131 = getVarScalar(interp, "cp_options", compiledLocals, 12);
                                        tmp131.preserve();
                                        tmp132 = getVarScalar(interp, "i", compiledLocals, 5);
                                        TJC.lindexNonconst(interp, tmp131, tmp132);
                                    } finally {
                                        if ( tmp131 != null ) {
                                            tmp131.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                tmp130 = interp.getResult();
                                setVarScalar(interp, "op", tmp130, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set val [...]
                                TclObject tmp133;
                                { // Invoke: lindex $cp_options [...]
                                    TclObject tmp134 = null;
                                    TclObject tmp135;
                                    try {
                                        tmp134 = getVarScalar(interp, "cp_options", compiledLocals, 12);
                                        tmp134.preserve();
                                        { // Invoke: expr {$i + 1}
                                            // Binary operator: $i + 1
                                            TclObject tmp136 = getVarScalar(interp, "i", compiledLocals, 5);
                                            ExprValue tmp137 = evs0;
                                            TJC.exprInitValue(interp, tmp137, tmp136);
                                            ExprValue tmp138 = evs1;
                                            tmp138.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp137, tmp138);
                                            // End Binary operator: +
                                            TJC.exprSetResult(interp, tmp137);
                                        } // End Invoke: expr
                                        tmp135 = interp.getResult();
                                        TJC.lindexNonconst(interp, tmp134, tmp135);
                                    } finally {
                                        if ( tmp134 != null ) {
                                            tmp134.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                tmp133 = interp.getResult();
                                setVarScalar(interp, "val", tmp133, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: incr index
                                interp.resetResult();
                                incrVarScalar(interp, "index", 1, compiledLocals, 4);
                            } // End Invoke: incr
                            { // Invoke: ... $op $val $index $num_options $cp_options
                                TclObject[] objv139 = TJC.grabObjv(interp, 6);
                                TclObject tmp140;
                                try {
                                    // Arg 0 constant: ...
                                    objv139[0] = const6;
                                    // Arg 1 variable: $op
                                    tmp140 = getVarScalar(interp, "op", compiledLocals, 6);
                                    tmp140.preserve();
                                    objv139[1] = tmp140;
                                    // Arg 2 variable: $val
                                    tmp140 = getVarScalar(interp, "val", compiledLocals, 7);
                                    tmp140.preserve();
                                    objv139[2] = tmp140;
                                    // Arg 3 variable: $index
                                    tmp140 = getVarScalar(interp, "index", compiledLocals, 4);
                                    tmp140.preserve();
                                    objv139[3] = tmp140;
                                    // Arg 4 variable: $num_options
                                    tmp140 = getVarScalar(interp, "num_options", compiledLocals, 3);
                                    tmp140.preserve();
                                    objv139[4] = tmp140;
                                    // Arg 5 variable: $cp_options
                                    tmp140 = getVarScalar(interp, "cp_options", compiledLocals, 12);
                                    tmp140.preserve();
                                    objv139[5] = tmp140;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv139, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    objv139[0] = null;
                                    TJC.releaseObjvElems(interp, objv139, 6);
                                }
                            } // End Invoke: ...
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } // End Invoke: for
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
                interp.resetResult();
            } finally {
                if ( tmp44 != null ) {
                    tmp44.release();
                }
            }
        } // End Invoke: foreach
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_options_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("module_options_validate");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("module_query");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("OPTIONS");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("module_option_validate");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("PROC_OPTIONS");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("unset");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("options_map");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("array");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("set");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("parray");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("info");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("exists");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "module_query";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "module_option_validate";
                break;
            }
            case 5: {
                cmdName = "unset";
                break;
            }
            case 6: {
                cmdName = "array";
                break;
            }
            case 7: {
                cmdName = "parray";
                break;
            }
            case 8: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "debug",
        "options",
        "len",
        "num_options",
        "index",
        "i",
        "op",
        "val",
        "proc_options",
        "pair",
        "p_name",
        "p_options",
        "cp_options",
        "options_map"
    };
} // end class ModuleOptionsValidateCmd

