// TJC implementation of procedure module_parse_validate
package tjc;
import tcl.lang.*;

public class ModuleParseValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 0);
        } // End Invoke: global
        { // Invoke: set pkg [...]
            TclObject tmp0;
            { // Invoke: module_query PACKAGE
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv1[0] = const0;
                    // Arg 1 constant: PACKAGE
                    objv1[1] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: module_query
            tmp0 = interp.getResult();
            setVarScalar(interp, "pkg", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$pkg == ""} ...
            // Binary operator: $pkg == ""
            TclObject tmp2 = getVarScalar(interp, "pkg", compiledLocals, 1);
            ExprValue tmp3 = evs0;
            TJC.exprEqualsEmptyString(tmp3, tmp2, false);
            // End Binary operator: ==
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error ...
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const2;
                        // Arg 1 constant: ...
                        objv5[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set contains_keyword 0
            setVarScalar(interp, "contains_keyword", const4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: foreach elem [...] ...
            TclObject tmp6 = null;
            try {
                { // Invoke: split $pkg "."
                    TclObject[] objv7 = TJC.grabObjv(interp, 3);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: split
                        objv7[0] = const5;
                        // Arg 1 variable: $pkg
                        tmp8 = getVarScalar(interp, "pkg", compiledLocals, 1);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        // Arg 2 constant: "."
                        objv7[2] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv7, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 3);
                    }
                } // End Invoke: split
                tmp6 = interp.getResult();
                tmp6.preserve();
                final int tmp6_length = TclList.getLength(interp, tmp6);

                for ( int index9 = 0 ; index9 < tmp6_length ; index9++ ) {
                    TclObject tmp10 = TclList.index(interp, tmp6, index9);
                    try {
                        setVarScalar(interp, "elem", tmp10, compiledLocals, 3);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "elem");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        { // Invoke: ... $elem
                            TclObject[] objv11 = TJC.grabObjv(interp, 2);
                            TclObject tmp12;
                            try {
                                // Arg 0 constant: ...
                                objv11[0] = const7;
                                // Arg 1 variable: $elem
                                tmp12 = getVarScalar(interp, "elem", compiledLocals, 3);
                                tmp12.preserve();
                                objv11[1] = tmp12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv11, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp12 = objv11[1];
                                if ( tmp12 != null ) {
                                    tmp12.release();
                                }
                                TJC.releaseObjv(interp, objv11, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp13 = interp.getResult();
                        ExprValue tmp14 = evs0;
                        TJC.exprInitValue(interp, tmp14, tmp13);
                        boolean tmp15 = tmp14.getBooleanValue(interp);
                        if ( tmp15 ) {
                            { // Invoke: set contains_keyword 1
                                setVarScalar(interp, "contains_keyword", const8, compiledLocals, 2);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp6 != null ) {
                    tmp6.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$pkg == "default"} ...
            // Binary operator: $pkg == "default"
            TclObject tmp16 = getVarScalar(interp, "pkg", compiledLocals, 1);
            boolean tmp17 = tmp16.toString().equals("default");
            ExprValue tmp18 = evs0;
            tmp18.setIntValue(tmp17);
            // End Binary operator: ==
            boolean tmp19 = ( tmp18.getIntValue() != 0 );
            if ( tmp19 ) {
                { // Invoke: set contains_keyword 0
                    setVarScalar(interp, "contains_keyword", const4, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$contains_keyword} ...
            TclObject tmp20 = getVarScalar(interp, "contains_keyword", compiledLocals, 2);
            boolean tmp21 = TJC.getBoolean(interp, tmp20);
            if ( tmp21 ) {
                { // Invoke: error ...
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv22[0] = const2;
                        // Arg 1 constant: ...
                        objv22[1] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv22, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exist _module(source)
                TclObject[] objv23 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv23[0] = const10;
                    // Arg 1 constant: exist
                    objv23[1] = const11;
                    // Arg 2 constant: _module(source)
                    objv23[2] = const12;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv23, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv23, 3);
                }
            } // End Invoke: info
            TclObject tmp24 = interp.getResult();
            ExprValue tmp25 = evs0;
            if ( tmp24.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp25, tmp24);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp25, tmp24);
            }
            // End Unary operator: !
            boolean tmp26 = ( tmp25.getIntValue() != 0 );
            if ( tmp26 ) {
                { // Invoke: error ...
                    TclObject[] objv27 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv27[0] = const2;
                        // Arg 1 constant: ...
                        objv27[1] = const13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv27, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv27, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exist _module(init_source)
                TclObject[] objv28 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv28[0] = const10;
                    // Arg 1 constant: exist
                    objv28[1] = const11;
                    // Arg 2 constant: _module(init_source)
                    objv28[2] = const14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv28, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv28, 3);
                }
            } // End Invoke: info
            TclObject tmp29 = interp.getResult();
            ExprValue tmp30 = evs0;
            if ( tmp29.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp30, tmp29);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp30, tmp29);
            }
            // End Unary operator: !
            boolean tmp31 = ( tmp30.getIntValue() != 0 );
            if ( tmp31 ) {
                { // Invoke: error ...
                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv32[0] = const2;
                        // Arg 1 constant: ...
                        objv32[1] = const15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv32, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv32, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp33;
            { // Invoke: module_expand SOURCE
                TclObject[] objv34 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_expand
                    objv34[0] = const16;
                    // Arg 1 constant: SOURCE
                    objv34[1] = const17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv34, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv34, 2);
                }
            } // End Invoke: module_expand
            tmp33 = interp.getResult();
            setVarScalar(interp, "expanded_source_files", tmp33, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $...
                TclObject tmp35 = getVarScalar(interp, "expanded_source_files", compiledLocals, 4);
                int tmp36 = TclList.getLength(interp, tmp35);
                interp.setResult(tmp36);
            } // End Invoke: llength
            TclObject tmp37 = interp.getResult();
            ExprValue tmp38 = evs0;
            TJC.exprInitValue(interp, tmp38, tmp37);
            ExprValue tmp39 = evs1;
            tmp39.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp38, tmp39);
            // End Binary operator: ==
            boolean tmp40 = ( tmp38.getIntValue() != 0 );
            if ( tmp40 ) {
                { // Invoke: error ...
                    TclObject[] objv41 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv41[0] = const2;
                        // Arg 1 constant: ...
                        objv41[1] = const18;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv41, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv41, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: foreach file $... ...
            TclObject tmp42 = null;
            try {
                tmp42 = getVarScalar(interp, "expanded_source_files", compiledLocals, 4);
                tmp42.preserve();
                final int tmp42_length = TclList.getLength(interp, tmp42);

                for ( int index43 = 0 ; index43 < tmp42_length ; index43++ ) {
                    TclObject tmp44 = TclList.index(interp, tmp42, index43);
                    try {
                        setVarScalar(interp, "file", tmp44, compiledLocals, 5);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tail [...]
                        TclObject tmp45;
                        { // Invoke: file tail $file
                            TclObject[] objv46 = TJC.grabObjv(interp, 3);
                            TclObject tmp47;
                            try {
                                // Arg 0 constant: file
                                objv46[0] = const19;
                                // Arg 1 constant: tail
                                objv46[1] = const20;
                                // Arg 2 variable: $file
                                tmp47 = getVarScalar(interp, "file", compiledLocals, 5);
                                tmp47.preserve();
                                objv46[2] = tmp47;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv46, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp47 = objv46[2];
                                if ( tmp47 != null ) {
                                    tmp47.release();
                                }
                                TJC.releaseObjv(interp, objv46, 3);
                            }
                        } // End Invoke: file
                        tmp45 = interp.getResult();
                        setVarScalar(interp, "tail", tmp45, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        { // Invoke: info exists source_tails($tail)
                            TclObject[] objv48 = TJC.grabObjv(interp, 3);
                            TclObject tmp49;
                            try {
                                // Arg 0 constant: info
                                objv48[0] = const10;
                                // Arg 1 constant: exists
                                objv48[1] = const21;
                                // Arg 2 word: source_tails($tail)
                                StringBuffer sbtmp50 = new StringBuffer(64);
                                sbtmp50.append("source_tails(");
                                tmp49 = getVarScalar(interp, "tail", compiledLocals, 6);
                                sbtmp50.append(tmp49.toString());
                                sbtmp50.append(")");
                                tmp49 = TclString.newInstance(sbtmp50);
                                tmp49.preserve();
                                objv48[2] = tmp49;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv48, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp49 = objv48[2];
                                if ( tmp49 != null ) {
                                    tmp49.release();
                                }
                                TJC.releaseObjv(interp, objv48, 3);
                            }
                        } // End Invoke: info
                        TclObject tmp51 = interp.getResult();
                        ExprValue tmp52 = evs0;
                        TJC.exprInitValue(interp, tmp52, tmp51);
                        boolean tmp53 = tmp52.getBooleanValue(interp);
                        if ( tmp53 ) {
                            { // Invoke: error "..."
                                TclObject[] objv54 = TJC.grabObjv(interp, 2);
                                TclObject tmp55;
                                try {
                                    // Arg 0 constant: error
                                    objv54[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp56 = new StringBuffer(64);
                                    sbtmp56.append("SOURCE declaration contains more than 1 file named ");
                                    sbtmp56.append("\"");
                                    tmp55 = getVarScalar(interp, "tail", compiledLocals, 6);
                                    sbtmp56.append(tmp55.toString());
                                    sbtmp56.append("\"");
                                    tmp55 = TclString.newInstance(sbtmp56);
                                    tmp55.preserve();
                                    objv54[1] = tmp55;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv54, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp55 = objv54[1];
                                    if ( tmp55 != null ) {
                                        tmp55.release();
                                    }
                                    TJC.releaseObjv(interp, objv54, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set source_tails($tail) $file
                        TclObject tmp57;
                        tmp57 = getVarScalar(interp, "tail", compiledLocals, 6);
                        String tmp58 = tmp57.toString();
                        tmp57 = getVarScalar(interp, "file", compiledLocals, 5);
                        tmp57 = setVarArray(interp, "source_tails", tmp58, tmp57, compiledLocals, 7);
                    } // End Invoke: set
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp42 != null ) {
                    tmp42.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set init_file [...]
            TclObject tmp59;
            { // Invoke: module_query INIT_SOURCE
                TclObject[] objv60 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: module_query
                    objv60[0] = const0;
                    // Arg 1 constant: INIT_SOURCE
                    objv60[1] = const22;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv60, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv60, 2);
                }
            } // End Invoke: module_query
            tmp59 = interp.getResult();
            setVarScalar(interp, "init_file", tmp59, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: ... $init_file
                TclObject[] objv61 = TJC.grabObjv(interp, 2);
                TclObject tmp62;
                try {
                    // Arg 0 constant: ...
                    objv61[0] = const23;
                    // Arg 1 variable: $init_file
                    tmp62 = getVarScalar(interp, "init_file", compiledLocals, 8);
                    tmp62.preserve();
                    objv61[1] = tmp62;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv61, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp62 = objv61[1];
                    if ( tmp62 != null ) {
                        tmp62.release();
                    }
                    TJC.releaseObjv(interp, objv61, 2);
                }
            } // End Invoke: ...
            TclObject tmp63 = interp.getResult();
            ExprValue tmp64 = evs0;
            TJC.exprInitValue(interp, tmp64, tmp63);
            boolean tmp65 = tmp64.getBooleanValue(interp);
            if ( tmp65 ) {
                { // Invoke: error "..."
                    TclObject[] objv66 = TJC.grabObjv(interp, 2);
                    TclObject tmp67;
                    try {
                        // Arg 0 constant: error
                        objv66[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp68 = new StringBuffer(64);
                        sbtmp68.append("INIT_SOURCE ");
                        sbtmp68.append("\"");
                        tmp67 = getVarScalar(interp, "init_file", compiledLocals, 8);
                        sbtmp68.append(tmp67.toString());
                        sbtmp68.append("\"");
                        sbtmp68.append(" is a glob pattern, must be a filename");
                        tmp67 = TclString.newInstance(sbtmp68);
                        tmp67.preserve();
                        objv66[1] = tmp67;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv66, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp67 = objv66[1];
                        if ( tmp67 != null ) {
                            tmp67.release();
                        }
                        TJC.releaseObjv(interp, objv66, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set tail [...]
            TclObject tmp69;
            { // Invoke: file tail $init_file
                TclObject[] objv70 = TJC.grabObjv(interp, 3);
                TclObject tmp71;
                try {
                    // Arg 0 constant: file
                    objv70[0] = const19;
                    // Arg 1 constant: tail
                    objv70[1] = const20;
                    // Arg 2 variable: $init_file
                    tmp71 = getVarScalar(interp, "init_file", compiledLocals, 8);
                    tmp71.preserve();
                    objv70[2] = tmp71;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv70, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp71 = objv70[2];
                    if ( tmp71 != null ) {
                        tmp71.release();
                    }
                    TJC.releaseObjv(interp, objv70, 3);
                }
            } // End Invoke: file
            tmp69 = interp.getResult();
            setVarScalar(interp, "tail", tmp69, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists source_tails($tail)
                TclObject[] objv72 = TJC.grabObjv(interp, 3);
                TclObject tmp73;
                try {
                    // Arg 0 constant: info
                    objv72[0] = const10;
                    // Arg 1 constant: exists
                    objv72[1] = const21;
                    // Arg 2 word: source_tails($tail)
                    StringBuffer sbtmp74 = new StringBuffer(64);
                    sbtmp74.append("source_tails(");
                    tmp73 = getVarScalar(interp, "tail", compiledLocals, 6);
                    sbtmp74.append(tmp73.toString());
                    sbtmp74.append(")");
                    tmp73 = TclString.newInstance(sbtmp74);
                    tmp73.preserve();
                    objv72[2] = tmp73;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv72, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp73 = objv72[2];
                    if ( tmp73 != null ) {
                        tmp73.release();
                    }
                    TJC.releaseObjv(interp, objv72, 3);
                }
            } // End Invoke: info
            TclObject tmp75 = interp.getResult();
            ExprValue tmp76 = evs0;
            if ( tmp75.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp76, tmp75);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp76, tmp75);
            }
            // End Unary operator: !
            boolean tmp77 = ( tmp76.getIntValue() != 0 );
            if ( tmp77 ) {
                { // Invoke: error "..."
                    TclObject[] objv78 = TJC.grabObjv(interp, 2);
                    TclObject tmp79;
                    try {
                        // Arg 0 constant: error
                        objv78[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp80 = new StringBuffer(64);
                        sbtmp80.append("INIT_SOURCE file ");
                        sbtmp80.append("\"");
                        tmp79 = getVarScalar(interp, "tail", compiledLocals, 6);
                        sbtmp80.append(tmp79.toString());
                        sbtmp80.append("\"");
                        sbtmp80.append(" does not appear in SOURCE declaration");
                        tmp79 = TclString.newInstance(sbtmp80);
                        tmp79.preserve();
                        objv78[1] = tmp79;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv78, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp79 = objv78[1];
                        if ( tmp79 != null ) {
                            tmp79.release();
                        }
                        TJC.releaseObjv(interp, objv78, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: foreach file [...] ...
            TclObject tmp81 = null;
            try {
                { // Invoke: module_expand INCLUDE_SOURCE
                    TclObject[] objv82 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: module_expand
                        objv82[0] = const16;
                        // Arg 1 constant: INCLUDE_SOURCE
                        objv82[1] = const24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv82, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv82, 2);
                    }
                } // End Invoke: module_expand
                tmp81 = interp.getResult();
                tmp81.preserve();
                final int tmp81_length = TclList.getLength(interp, tmp81);

                for ( int index83 = 0 ; index83 < tmp81_length ; index83++ ) {
                    TclObject tmp84 = TclList.index(interp, tmp81, index83);
                    try {
                        setVarScalar(interp, "file", tmp84, compiledLocals, 5);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tail [...]
                        TclObject tmp85;
                        { // Invoke: file tail $file
                            TclObject[] objv86 = TJC.grabObjv(interp, 3);
                            TclObject tmp87;
                            try {
                                // Arg 0 constant: file
                                objv86[0] = const19;
                                // Arg 1 constant: tail
                                objv86[1] = const20;
                                // Arg 2 variable: $file
                                tmp87 = getVarScalar(interp, "file", compiledLocals, 5);
                                tmp87.preserve();
                                objv86[2] = tmp87;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv86, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp87 = objv86[2];
                                if ( tmp87 != null ) {
                                    tmp87.release();
                                }
                                TJC.releaseObjv(interp, objv86, 3);
                            }
                        } // End Invoke: file
                        tmp85 = interp.getResult();
                        setVarScalar(interp, "tail", tmp85, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: info exists source_tails($tail)
                            TclObject[] objv88 = TJC.grabObjv(interp, 3);
                            TclObject tmp89;
                            try {
                                // Arg 0 constant: info
                                objv88[0] = const10;
                                // Arg 1 constant: exists
                                objv88[1] = const21;
                                // Arg 2 word: source_tails($tail)
                                StringBuffer sbtmp90 = new StringBuffer(64);
                                sbtmp90.append("source_tails(");
                                tmp89 = getVarScalar(interp, "tail", compiledLocals, 6);
                                sbtmp90.append(tmp89.toString());
                                sbtmp90.append(")");
                                tmp89 = TclString.newInstance(sbtmp90);
                                tmp89.preserve();
                                objv88[2] = tmp89;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv88, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp89 = objv88[2];
                                if ( tmp89 != null ) {
                                    tmp89.release();
                                }
                                TJC.releaseObjv(interp, objv88, 3);
                            }
                        } // End Invoke: info
                        TclObject tmp91 = interp.getResult();
                        ExprValue tmp92 = evs0;
                        if ( tmp91.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp92, tmp91);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp92, tmp91);
                        }
                        // End Unary operator: !
                        boolean tmp93 = ( tmp92.getIntValue() != 0 );
                        if ( tmp93 ) {
                            { // Invoke: error "..."
                                TclObject[] objv94 = TJC.grabObjv(interp, 2);
                                TclObject tmp95;
                                try {
                                    // Arg 0 constant: error
                                    objv94[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp96 = new StringBuffer(64);
                                    sbtmp96.append("INCLUDE_SOURCE file ");
                                    sbtmp96.append("\"");
                                    tmp95 = getVarScalar(interp, "tail", compiledLocals, 6);
                                    sbtmp96.append(tmp95.toString());
                                    sbtmp96.append("\"");
                                    sbtmp96.append(" does not appear in SOURCE declaration");
                                    tmp95 = TclString.newInstance(sbtmp96);
                                    tmp95.preserve();
                                    objv94[1] = tmp95;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv94, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp95 = objv94[1];
                                    if ( tmp95 != null ) {
                                        tmp95.release();
                                    }
                                    TJC.releaseObjv(interp, objv94, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp81 != null ) {
                    tmp81.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_parse_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("module_query");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("PACKAGE");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("PACKAGE statement not found");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("split");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(".");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_is_java_keyword");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("PACKAGE must not contain a Java keyword");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("info");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("exist");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("_module(source)");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("No SOURCE declaration found in module config");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("_module(init_source)");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("No INIT_SOURCE declaration found in module config");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("module_expand");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("SOURCE");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("SOURCE declaration expanded to zero files");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("file");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("tail");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("exists");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("INIT_SOURCE");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("module_looks_like_glob");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("INCLUDE_SOURCE");
        const24.preserve(); const24.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "module_query";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "split";
                break;
            }
            case 4: {
                cmdName = "emitter_is_java_keyword";
                break;
            }
            case 5: {
                cmdName = "info";
                break;
            }
            case 6: {
                cmdName = "module_expand";
                break;
            }
            case 7: {
                cmdName = "file";
                break;
            }
            case 8: {
                cmdName = "module_looks_like_glob";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_module",
        "pkg",
        "contains_keyword",
        "elem",
        "expanded_source_files",
        "file",
        "tail",
        "source_tails",
        "init_file"
    };
} // end class ModuleParseValidateCmd

