// TJC implementation of procedure module_space_split
package tjc;
import tcl.lang.*;

public class ModuleSpaceSplitCmd2 extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "str");
        }
        setVarScalar(interp, "str", objv[1], compiledLocals, 0);
        { // Invoke: set pat {[^ ]+}
            setVarScalar(interp, "pat", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set results [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "results", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: foreach match [...] ...
            TclObject tmp2 = null;
            try {
                { // Invoke: regexp -all -inline $pat $str
                    TclObject[] objv3 = TJC.grabObjv(interp, 5);
                    TclObject tmp4;
                    try {
                        // Arg 0 constant: regexp
                        objv3[0] = const1;
                        // Arg 1 constant: -all
                        objv3[1] = const2;
                        // Arg 2 constant: -inline
                        objv3[2] = const3;
                        // Arg 3 variable: $pat
                        tmp4 = getVarScalar(interp, "pat", compiledLocals, 1);
                        tmp4.preserve();
                        objv3[3] = tmp4;
                        // Arg 4 variable: $str
                        tmp4 = getVarScalar(interp, "str", compiledLocals, 0);
                        tmp4.preserve();
                        objv3[4] = tmp4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp4 = objv3[3];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        tmp4 = objv3[4];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 5);
                    }
                } // End Invoke: regexp
                tmp2 = interp.getResult();
                tmp2.preserve();
                final int tmp2_length = TclList.getLength(interp, tmp2);

                for ( int index5 = 0 ; index5 < tmp2_length ; index5++ ) {
                    TclObject tmp6 = TclList.index(interp, tmp2, index5);
                    try {
                        setVarScalar(interp, "match", tmp6, compiledLocals, 3);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "match");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: lappend results $match
                        TclObject[] objv7 = TJC.grabObjv(interp, 1);
                        TclObject tmp8;
                        try {
                            // Arg 2 variable: $match
                            tmp8 = getVarScalar(interp, "match", compiledLocals, 3);
                            tmp8.preserve();
                            objv7[0] = tmp8;
                            interp.resetResult();
                            lappendVarScalar(interp, "results", objv7, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv7, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp2 != null ) {
                    tmp2.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $results
            TclObject tmp9 = getVarScalar(interp, "results", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp9);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_space_split");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("[^ ]+");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("-all");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("-inline");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "str",
        "pat",
        "results",
        "match"
    };
} // end class ModuleSpaceSplitCmd2

