// TJC implementation of procedure nameproc_class_name
package tjc;
import tcl.lang.*;

public class NameprocClassNameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "proc_name ?dup?");
        }
        setVarScalar(interp, "proc_name", objv[1], compiledLocals, 0);
        setVarScalar(interp, "dup", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set cname ""
            setVarScalar(interp, "cname", const2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set cap 1
            setVarScalar(interp, "cap", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp0;
            { // Invoke: string length $proc_name
                TclObject tmp1 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                int tmp2 = tmp1.toString().length();
                interp.setResult(tmp2);
            } // End Invoke: string
            tmp0 = interp.getResult();
            setVarScalar(interp, "len", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const1, compiledLocals, 6);
            } // End Invoke: set
            for ( boolean skip8 = true ; true ; ) {
                if ( skip8 ) {
                    skip8 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 6);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp3 = getVarScalar(interp, "i", compiledLocals, 6);
                ExprValue tmp4 = evs0;
                TJC.exprInitValue(interp, tmp4, tmp3);
                TclObject tmp5 = getVarScalar(interp, "len", compiledLocals, 5);
                ExprValue tmp6 = evs1;
                TJC.exprInitValue(interp, tmp6, tmp5);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp4, tmp6);
                // End Binary operator: <
                boolean tmp7 = ( tmp4.getIntValue() != 0 );
                if ( ! tmp7 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set c [...]
                    TclObject tmp9;
                    { // Invoke: string index $proc_name $i
                        TclObject tmp10 = getVarScalar(interp, "proc_name", compiledLocals, 0);
                        String tmp11 = tmp10.toString();
                        TclObject tmp12 = getVarScalar(interp, "i", compiledLocals, 6);
                        TclObject tmp13 = TJC.stringIndex(interp, tmp11, tmp12);
                        interp.setResult(tmp13);
                    } // End Invoke: string
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "c", tmp9, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp14 = getVarScalar(interp, "debug", compiledLocals, 2);
                    boolean tmp15 = TJC.getBoolean(interp, tmp14);
                    if ( tmp15 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv16 = TJC.grabObjv(interp, 2);
                            TclObject tmp17;
                            try {
                                // Arg 0 constant: puts
                                objv16[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp18 = new StringBuffer(64);
                                sbtmp18.append("c for index ");
                                tmp17 = getVarScalar(interp, "i", compiledLocals, 6);
                                sbtmp18.append(tmp17.toString());
                                sbtmp18.append(" is '");
                                tmp17 = getVarScalar(interp, "c", compiledLocals, 7);
                                sbtmp18.append(tmp17.toString());
                                sbtmp18.append("'");
                                tmp17 = TclString.newInstance(sbtmp18);
                                tmp17.preserve();
                                objv16[1] = tmp17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv16, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp17 = objv16[1];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                TJC.releaseObjv(interp, objv16, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: switch -regexp -- $c {^[A-Z|a-z|0-9]$} ... default ...
                    TclObject tmp19 = getVarScalar(interp, "c", compiledLocals, 7);
                    String tmp20 = tmp19.toString();
                    int tmp21;
                    TclObject[] objv22 = TJC.grabObjv(interp, 4);
                    try {
                        TclObject tmp23;
                        // Pattern {^[A-Z|a-z|0-9]$}
                        tmp23 = const4;
                        tmp23.preserve();
                        objv22[0] = tmp23;
                        // Pattern default
                        tmp23 = const5;
                        tmp23.preserve();
                        objv22[2] = tmp23;
                        tmp21 = TJC.invokeSwitch(interp, objv22, 0,
                            tmp20, TJC.SWITCH_MODE_REGEXP);
                    } finally {
                        TJC.releaseObjvElems(interp, objv22, 4);
                    }
                    interp.resetResult();
                    if ( tmp21 == -1 ) {
                        // No match
                    } else if ( tmp21 == 1 ) {
                        // Pattern {^[A-Z|a-z|0-9]$}
                        { // Invoke: if {$cap} ...
                            TclObject tmp24 = getVarScalar(interp, "cap", compiledLocals, 4);
                            boolean tmp25 = TJC.getBoolean(interp, tmp24);
                            if ( tmp25 ) {
                                { // Invoke: set c [...]
                                    TclObject tmp26;
                                    { // Invoke: string toupper $c
                                        TclObject[] objv27 = TJC.grabObjv(interp, 3);
                                        TclObject tmp28;
                                        try {
                                            // Arg 0 constant: string
                                            objv27[0] = const6;
                                            // Arg 1 constant: toupper
                                            objv27[1] = const7;
                                            // Arg 2 variable: $c
                                            tmp28 = getVarScalar(interp, "c", compiledLocals, 7);
                                            tmp28.preserve();
                                            objv27[2] = tmp28;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv27, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp28 = objv27[2];
                                            if ( tmp28 != null ) {
                                                tmp28.release();
                                            }
                                            TJC.releaseObjv(interp, objv27, 3);
                                        }
                                    } // End Invoke: string
                                    tmp26 = interp.getResult();
                                    setVarScalar(interp, "c", tmp26, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set cap 0
                                    setVarScalar(interp, "cap", const1, compiledLocals, 4);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: append cname $c
                            TclObject[] objv29 = TJC.grabObjv(interp, 1);
                            TclObject tmp30;
                            try {
                                // Arg 2 variable: $c
                                tmp30 = getVarScalar(interp, "c", compiledLocals, 7);
                                tmp30.preserve();
                                objv29[0] = tmp30;
                                interp.resetResult();
                                appendVarScalar(interp, "cname", objv29, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjvElems(interp, objv29, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp21 == 3 ) {
                        // Pattern default
                        { // Invoke: set cap 1
                            setVarScalar(interp, "cap", const0, compiledLocals, 4);
                        } // End Invoke: set
                    } else {
                        throw new TclRuntimeError("bad switch body offset " +
                            String.valueOf(tmp21));
                    }
                } // End Invoke: switch
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append cname "Cmd"
            TclObject[] objv31 = TJC.grabObjv(interp, 1);
            TclObject tmp32;
            try {
                // Arg 2 constant: "Cmd"
                objv31[0] = const8;
                interp.resetResult();
                appendVarScalar(interp, "cname", objv31, compiledLocals, 3);
            } finally {
                TJC.releaseObjv(interp, objv31, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$dup > 1} ...
            // Binary operator: $dup > 1
            TclObject tmp33 = getVarScalar(interp, "dup", compiledLocals, 1);
            ExprValue tmp34 = evs0;
            TJC.exprInitValue(interp, tmp34, tmp33);
            ExprValue tmp35 = evs1;
            tmp35.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp34, tmp35);
            // End Binary operator: >
            boolean tmp36 = ( tmp34.getIntValue() != 0 );
            if ( tmp36 ) {
                { // Invoke: append cname $dup
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    TclObject tmp38;
                    try {
                        // Arg 2 variable: $dup
                        tmp38 = getVarScalar(interp, "dup", compiledLocals, 1);
                        tmp38.preserve();
                        objv37[0] = tmp38;
                        interp.resetResult();
                        appendVarScalar(interp, "cname", objv37, compiledLocals, 3);
                    } finally {
                        TJC.releaseObjvElems(interp, objv37, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $cname
            TclObject tmp39 = getVarScalar(interp, "cname", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp39);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "nameproc_class_name");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("puts");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("^[A-Z|a-z|0-9]$");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("default");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("string");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("toupper");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("Cmd");
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_name",
        "dup",
        "debug",
        "cname",
        "cap",
        "len",
        "i",
        "c"
    };
} // end class NameprocClassNameCmd

