// TJC implementation of procedure parse_expr_iterate
package tjc;
import tcl.lang.*;

public class ParseExprIterateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 28, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "in_script in_etree in_cmd");
        }
        setVarScalar(interp, "in_script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "in_etree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "in_cmd", objv[3], compiledLocals, 2);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 3);
        } // End Invoke: global
        { // Invoke: set ... [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarArray(interp, "_parse", "parse_expr_iterate_result", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp2;
            { // Invoke: list
                TclObject tmp3 = TclList.newInstance();
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: ... $in_script $in_etree $in_cmd
            TclObject[] objv4 = TJC.grabObjv(interp, 4);
            TclObject tmp5;
            try {
                // Arg 0 constant: ...
                objv4[0] = const0;
                // Arg 1 variable: $in_script
                tmp5 = getVarScalar(interp, "in_script", compiledLocals, 0);
                tmp5.preserve();
                objv4[1] = tmp5;
                // Arg 2 variable: $in_etree
                tmp5 = getVarScalar(interp, "in_etree", compiledLocals, 1);
                tmp5.preserve();
                objv4[2] = tmp5;
                // Arg 3 variable: $in_cmd
                tmp5 = getVarScalar(interp, "in_cmd", compiledLocals, 2);
                tmp5.preserve();
                objv4[3] = tmp5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv4, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                tmp5 = objv4[1];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                tmp5 = objv4[2];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                tmp5 = objv4[3];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                TJC.releaseObjv(interp, objv4, 4);
            }
        } // End Invoke: ...
        { // Invoke: set cmdlist $...
            TclObject tmp6;
            tmp6 = getVarArray(interp, "_parse", "parse_expr_iterate_result", compiledLocals, 3);
            setVarScalar(interp, "cmdlist", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp7;
            { // Invoke: list
                TclObject tmp8 = TclList.newInstance();
                interp.setResult(tmp8);
            } // End Invoke: list
            tmp7 = interp.getResult();
            setVarArray(interp, "_parse", "parse_expr_iterate_result", tmp7, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp9;
            { // Invoke: list
                TclObject tmp10 = TclList.newInstance();
                interp.setResult(tmp10);
            } // End Invoke: list
            tmp9 = interp.getResult();
            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $cmdlist
                TclObject tmp11 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                int tmp12 = TclList.getLength(interp, tmp11);
                interp.setResult(tmp12);
            } // End Invoke: llength
            TclObject tmp13 = interp.getResult();
            ExprValue tmp14 = evs0;
            TJC.exprInitValue(interp, tmp14, tmp13);
            ExprValue tmp15 = evs1;
            tmp15.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp14, tmp15);
            // End Binary operator: ==
            boolean tmp16 = ( tmp14.getIntValue() != 0 );
            if ( tmp16 ) {
                { // Invoke: error "empty cmdlist"
                    TclObject[] objv17 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv17[0] = const1;
                        // Arg 1 constant: "empty cmdlist"
                        objv17[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv17, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set subexpr_stack [...]
            TclObject tmp18;
            { // Invoke: list
                TclObject tmp19 = TclList.newInstance();
                interp.setResult(tmp19);
            } // End Invoke: list
            tmp18 = interp.getResult();
            setVarScalar(interp, "subexpr_stack", tmp18, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: for ... {$i < $len} {} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const3, compiledLocals, 6);
            } // End Invoke: set
            { // Invoke: set len [...]
                TclObject tmp20;
                { // Invoke: llength $cmdlist
                    TclObject tmp21 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                    int tmp22 = TclList.getLength(interp, tmp21);
                    interp.setResult(tmp22);
                } // End Invoke: llength
                tmp20 = interp.getResult();
                setVarScalar(interp, "len", tmp20, compiledLocals, 7);
            } // End Invoke: set
            for ( ; true ; ) {
                // Binary operator: $i < $len
                TclObject tmp23 = getVarScalar(interp, "i", compiledLocals, 6);
                ExprValue tmp24 = evs0;
                TJC.exprInitValue(interp, tmp24, tmp23);
                TclObject tmp25 = getVarScalar(interp, "len", compiledLocals, 7);
                ExprValue tmp26 = evs1;
                TJC.exprInitValue(interp, tmp26, tmp25);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp24, tmp26);
                // End Binary operator: <
                boolean tmp27 = ( tmp24.getIntValue() != 0 );
                if ( ! tmp27 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set cmdlist_elem [...]
                    TclObject tmp28;
                    { // Invoke: lindex $cmdlist $i
                        TclObject tmp29 = null;
                        TclObject tmp30;
                        try {
                            tmp29 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                            tmp29.preserve();
                            tmp30 = getVarScalar(interp, "i", compiledLocals, 6);
                            TJC.lindexNonconst(interp, tmp29, tmp30);
                        } finally {
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "cmdlist_elem", tmp28, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set elem_type [...]
                    TclObject tmp31;
                    { // Invoke: lindex $cmdlist_elem 0
                        TclObject tmp32 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                        tmp32 = TclList.index(interp, tmp32, 0);
                        if ( tmp32 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp32);
                        }
                    } // End Invoke: lindex
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "elem_type", tmp31, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: switch -exact -- $elem_type {operator} ... {value} ... default ...
                    TclObject tmp33 = getVarScalar(interp, "elem_type", compiledLocals, 9);
                    String tmp34 = tmp33.toString();
                    int tmp34_length = tmp34.length();
                    char tmp34_first = '\n';
                    if ( tmp34_length > 0 ) {
                        tmp34_first = tmp34.charAt(0);
                    }
                    if ( tmp34_length == 8 && tmp34_first == 'o'
                            && tmp34.compareTo("operator") == 0 ) {
                        // Pattern {operator}
                        { // Invoke: set script [...]
                            TclObject tmp35;
                            { // Invoke: lindex $cmdlist_elem 1
                                TclObject tmp36 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp36 = TclList.index(interp, tmp36, 1);
                                if ( tmp36 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp36);
                                }
                            } // End Invoke: lindex
                            tmp35 = interp.getResult();
                            setVarScalar(interp, "script", tmp35, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set etree [...]
                            TclObject tmp37;
                            { // Invoke: lindex $cmdlist_elem 2
                                TclObject tmp38 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp38 = TclList.index(interp, tmp38, 2);
                                if ( tmp38 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp38);
                                }
                            } // End Invoke: lindex
                            tmp37 = interp.getResult();
                            setVarScalar(interp, "etree", tmp37, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: set num_operands [...]
                            TclObject tmp39;
                            { // Invoke: lindex $cmdlist_elem 3
                                TclObject tmp40 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp40 = TclList.index(interp, tmp40, 3);
                                if ( tmp40 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp40);
                                }
                            } // End Invoke: lindex
                            tmp39 = interp.getResult();
                            setVarScalar(interp, "num_operands", tmp39, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set operator [...]
                            TclObject tmp41;
                            { // Invoke: lindex $cmdlist_elem 4
                                TclObject tmp42 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp42 = TclList.index(interp, tmp42, 4);
                                if ( tmp42 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp42);
                                }
                            } // End Invoke: lindex
                            tmp41 = interp.getResult();
                            setVarScalar(interp, "operator", tmp41, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set ranges [...]
                            TclObject tmp43;
                            { // Invoke: lindex $cmdlist_elem 5
                                TclObject tmp44 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp44 = TclList.index(interp, tmp44, 5);
                                if ( tmp44 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp44);
                                }
                            } // End Invoke: lindex
                            tmp43 = interp.getResult();
                            setVarScalar(interp, "ranges", tmp43, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: set operands [...]
                            TclObject tmp45;
                            { // Invoke: list
                                TclObject tmp46 = TclList.newInstance();
                                interp.setResult(tmp46);
                            } // End Invoke: list
                            tmp45 = interp.getResult();
                            setVarScalar(interp, "operands", tmp45, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: set subexpr_found 0
                            setVarScalar(interp, "subexpr_found", const3, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set jstart [...]
                            TclObject tmp47;
                            { // Invoke: expr {$i + 1}
                                // Binary operator: $i + 1
                                TclObject tmp48 = getVarScalar(interp, "i", compiledLocals, 6);
                                ExprValue tmp49 = evs0;
                                TJC.exprInitValue(interp, tmp49, tmp48);
                                ExprValue tmp50 = evs1;
                                tmp50.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp49, tmp50);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp49);
                            } // End Invoke: expr
                            tmp47 = interp.getResult();
                            setVarScalar(interp, "jstart", tmp47, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: set jend [...]
                            TclObject tmp51;
                            { // Invoke: expr ...
                                // Binary operator: () + $num_operands
                                // Binary operator: $i + 1
                                TclObject tmp52 = getVarScalar(interp, "i", compiledLocals, 6);
                                ExprValue tmp53 = evs0;
                                TJC.exprInitValue(interp, tmp53, tmp52);
                                ExprValue tmp54 = evs1;
                                tmp54.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp53, tmp54);
                                // End Binary operator: +
                                TclObject tmp55 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                                ExprValue tmp56 = evs1;
                                TJC.exprInitValue(interp, tmp56, tmp55);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp53, tmp56);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp53);
                            } // End Invoke: expr
                            tmp51 = interp.getResult();
                            setVarScalar(interp, "jend", tmp51, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: for {set j $jstart} {$j < $jend} {incr j} ...
                            { // Invoke: set j $jstart
                                TclObject tmp57;
                                tmp57 = getVarScalar(interp, "jstart", compiledLocals, 17);
                                setVarScalar(interp, "j", tmp57, compiledLocals, 19);
                            } // End Invoke: set
                            for ( boolean skip63 = true ; true ; ) {
                                if ( skip63 ) {
                                    skip63 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr j
                                        interp.resetResult();
                                        incrVarScalar(interp, "j", 1, compiledLocals, 19);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $j < $jend
                                TclObject tmp58 = getVarScalar(interp, "j", compiledLocals, 19);
                                ExprValue tmp59 = evs0;
                                TJC.exprInitValue(interp, tmp59, tmp58);
                                TclObject tmp60 = getVarScalar(interp, "jend", compiledLocals, 18);
                                ExprValue tmp61 = evs1;
                                TJC.exprInitValue(interp, tmp61, tmp60);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp59, tmp61);
                                // End Binary operator: <
                                boolean tmp62 = ( tmp59.getIntValue() != 0 );
                                if ( ! tmp62 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set operand_cmdlist_elem [...]
                                    TclObject tmp64;
                                    { // Invoke: lindex $cmdlist $j
                                        TclObject tmp65 = null;
                                        TclObject tmp66;
                                        try {
                                            tmp65 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                                            tmp65.preserve();
                                            tmp66 = getVarScalar(interp, "j", compiledLocals, 19);
                                            TJC.lindexNonconst(interp, tmp65, tmp66);
                                        } finally {
                                            if ( tmp65 != null ) {
                                                tmp65.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp64 = interp.getResult();
                                    setVarScalar(interp, "operand_cmdlist_elem", tmp64, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: set ... [...]
                                    TclObject tmp67;
                                    { // Invoke: lindex $... 0
                                        TclObject tmp68 = getVarScalar(interp, "operand_cmdlist_elem", compiledLocals, 20);
                                        tmp68 = TclList.index(interp, tmp68, 0);
                                        if ( tmp68 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp68);
                                        }
                                    } // End Invoke: lindex
                                    tmp67 = interp.getResult();
                                    setVarScalar(interp, "operand_cmdlist_elem_type", tmp67, compiledLocals, 21);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: $operand_cmdlist_elem_type == "subexpr"
                                    TclObject tmp69 = getVarScalar(interp, "operand_cmdlist_elem_type", compiledLocals, 21);
                                    boolean tmp70 = tmp69.toString().equals("subexpr");
                                    ExprValue tmp71 = evs0;
                                    tmp71.setIntValue(tmp70);
                                    // End Binary operator: ==
                                    boolean tmp72 = ( tmp71.getIntValue() != 0 );
                                    if ( tmp72 ) {
                                        { // Invoke: incr subexpr_found
                                            interp.resetResult();
                                            incrVarScalar(interp, "subexpr_found", 1, compiledLocals, 16);
                                        } // End Invoke: incr
                                        { // Invoke: if {$subexpr_found > 3} ...
                                            // Binary operator: $subexpr_found > 3
                                            TclObject tmp73 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                                            ExprValue tmp74 = evs0;
                                            TJC.exprInitValue(interp, tmp74, tmp73);
                                            ExprValue tmp75 = evs1;
                                            tmp75.setIntValue(3);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp74, tmp75);
                                            // End Binary operator: >
                                            boolean tmp76 = ( tmp74.getIntValue() != 0 );
                                            if ( tmp76 ) {
                                                { // Invoke: error "..."
                                                    TclObject[] objv77 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp78;
                                                    try {
                                                        // Arg 0 constant: error
                                                        objv77[0] = const1;
                                                        // Arg 1 word: "..."
                                                        StringBuffer sbtmp79 = new StringBuffer(64);
                                                        sbtmp79.append("max of 3 subexpressions supported, subexpr_found is ");
                                                        tmp78 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                                                        sbtmp79.append(tmp78.toString());
                                                        tmp78 = TclString.newInstance(sbtmp79);
                                                        tmp78.preserve();
                                                        objv77[1] = tmp78;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv77, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        tmp78 = objv77[1];
                                                        if ( tmp78 != null ) {
                                                            tmp78.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv77, 2);
                                                    }
                                                } // End Invoke: error
                                            }
                                        } // End Invoke: if
                                    }
                                } // End Invoke: if
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                        { // Invoke: set stack_size [...]
                            TclObject tmp80;
                            { // Invoke: llength $subexpr_stack
                                TclObject tmp81 = getVarScalar(interp, "subexpr_stack", compiledLocals, 5);
                                int tmp82 = TclList.getLength(interp, tmp81);
                                interp.setResult(tmp82);
                            } // End Invoke: llength
                            tmp80 = interp.getResult();
                            setVarScalar(interp, "stack_size", tmp80, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: $subexpr_found > $stack_size
                            TclObject tmp83 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                            ExprValue tmp84 = evs0;
                            TJC.exprInitValue(interp, tmp84, tmp83);
                            TclObject tmp85 = getVarScalar(interp, "stack_size", compiledLocals, 22);
                            ExprValue tmp86 = evs1;
                            TJC.exprInitValue(interp, tmp86, tmp85);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp84, tmp86);
                            // End Binary operator: >
                            boolean tmp87 = ( tmp84.getIntValue() != 0 );
                            if ( tmp87 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv88 = TJC.grabObjv(interp, 2);
                                    TclObject tmp89;
                                    try {
                                        // Arg 0 constant: error
                                        objv88[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp90 = new StringBuffer(64);
                                        sbtmp90.append("attempt to pop ");
                                        tmp89 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                                        sbtmp90.append(tmp89.toString());
                                        sbtmp90.append(" expressions off stack of size ");
                                        tmp89 = getVarScalar(interp, "stack_size", compiledLocals, 22);
                                        sbtmp90.append(tmp89.toString());
                                        tmp89 = TclString.newInstance(sbtmp90);
                                        tmp89.preserve();
                                        objv88[1] = tmp89;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv88, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp89 = objv88[1];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        TJC.releaseObjv(interp, objv88, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set subexpr_list [...]
                            TclObject tmp91;
                            { // Invoke: list
                                TclObject tmp92 = TclList.newInstance();
                                interp.setResult(tmp92);
                            } // End Invoke: list
                            tmp91 = interp.getResult();
                            setVarScalar(interp, "subexpr_list", tmp91, compiledLocals, 23);
                        } // End Invoke: set
                        { // Invoke: for {set j 0} ... {incr j} ...
                            { // Invoke: set j 0
                                setVarScalar(interp, "j", const3, compiledLocals, 19);
                            } // End Invoke: set
                            for ( boolean skip98 = true ; true ; ) {
                                if ( skip98 ) {
                                    skip98 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr j
                                        interp.resetResult();
                                        incrVarScalar(interp, "j", 1, compiledLocals, 19);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $j < $subexpr_found
                                TclObject tmp93 = getVarScalar(interp, "j", compiledLocals, 19);
                                ExprValue tmp94 = evs0;
                                TJC.exprInitValue(interp, tmp94, tmp93);
                                TclObject tmp95 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                                ExprValue tmp96 = evs1;
                                TJC.exprInitValue(interp, tmp96, tmp95);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp94, tmp96);
                                // End Binary operator: <
                                boolean tmp97 = ( tmp94.getIntValue() != 0 );
                                if ( ! tmp97 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set subexpr_list [...]
                                    TclObject tmp99;
                                    { // Invoke: linsert $subexpr_list 0 [...]
                                        TclObject[] objv100 = TJC.grabObjv(interp, 4);
                                        TclObject tmp101;
                                        try {
                                            // Arg 0 constant: linsert
                                            objv100[0] = const4;
                                            // Arg 1 variable: $subexpr_list
                                            tmp101 = getVarScalar(interp, "subexpr_list", compiledLocals, 23);
                                            tmp101.preserve();
                                            objv100[1] = tmp101;
                                            // Arg 2 constant: 0
                                            objv100[2] = const3;
                                            // Arg 3 command: [...]
                                            { // Invoke: lindex $subexpr_stack 0
                                                TclObject tmp102 = getVarScalar(interp, "subexpr_stack", compiledLocals, 5);
                                                tmp102 = TclList.index(interp, tmp102, 0);
                                                if ( tmp102 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp102);
                                                }
                                            } // End Invoke: lindex
                                            tmp101 = interp.getResult();
                                            tmp101.preserve();
                                            objv100[3] = tmp101;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv100, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            tmp101 = objv100[1];
                                            if ( tmp101 != null ) {
                                                tmp101.release();
                                            }
                                            tmp101 = objv100[3];
                                            if ( tmp101 != null ) {
                                                tmp101.release();
                                            }
                                            TJC.releaseObjv(interp, objv100, 4);
                                        }
                                    } // End Invoke: linsert
                                    tmp99 = interp.getResult();
                                    setVarScalar(interp, "subexpr_list", tmp99, compiledLocals, 23);
                                } // End Invoke: set
                                { // Invoke: set subexpr_stack [...]
                                    TclObject tmp103;
                                    { // Invoke: lrange $subexpr_stack 1 end
                                        TclObject[] objv104 = TJC.grabObjv(interp, 4);
                                        TclObject tmp105;
                                        try {
                                            // Arg 0 constant: lrange
                                            objv104[0] = const5;
                                            // Arg 1 variable: $subexpr_stack
                                            tmp105 = getVarScalar(interp, "subexpr_stack", compiledLocals, 5);
                                            tmp105.preserve();
                                            objv104[1] = tmp105;
                                            // Arg 2 constant: 1
                                            objv104[2] = const6;
                                            // Arg 3 constant: end
                                            objv104[3] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv104, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp105 = objv104[1];
                                            if ( tmp105 != null ) {
                                                tmp105.release();
                                            }
                                            TJC.releaseObjv(interp, objv104, 4);
                                        }
                                    } // End Invoke: lrange
                                    tmp103 = interp.getResult();
                                    setVarScalar(interp, "subexpr_stack", tmp103, compiledLocals, 5);
                                } // End Invoke: set
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                        { // Invoke: set subexpr_found 0
                            setVarScalar(interp, "subexpr_found", const3, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: for {set j $jstart} {$j < $jend} {incr j} ...
                            { // Invoke: set j $jstart
                                TclObject tmp106;
                                tmp106 = getVarScalar(interp, "jstart", compiledLocals, 17);
                                setVarScalar(interp, "j", tmp106, compiledLocals, 19);
                            } // End Invoke: set
                            for ( boolean skip112 = true ; true ; ) {
                                if ( skip112 ) {
                                    skip112 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr j
                                        interp.resetResult();
                                        incrVarScalar(interp, "j", 1, compiledLocals, 19);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $j < $jend
                                TclObject tmp107 = getVarScalar(interp, "j", compiledLocals, 19);
                                ExprValue tmp108 = evs0;
                                TJC.exprInitValue(interp, tmp108, tmp107);
                                TclObject tmp109 = getVarScalar(interp, "jend", compiledLocals, 18);
                                ExprValue tmp110 = evs1;
                                TJC.exprInitValue(interp, tmp110, tmp109);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp108, tmp110);
                                // End Binary operator: <
                                boolean tmp111 = ( tmp108.getIntValue() != 0 );
                                if ( ! tmp111 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set operand_cmdlist_elem [...]
                                    TclObject tmp113;
                                    { // Invoke: lindex $cmdlist $j
                                        TclObject tmp114 = null;
                                        TclObject tmp115;
                                        try {
                                            tmp114 = getVarScalar(interp, "cmdlist", compiledLocals, 4);
                                            tmp114.preserve();
                                            tmp115 = getVarScalar(interp, "j", compiledLocals, 19);
                                            TJC.lindexNonconst(interp, tmp114, tmp115);
                                        } finally {
                                            if ( tmp114 != null ) {
                                                tmp114.release();
                                            }
                                        }
                                    } // End Invoke: lindex
                                    tmp113 = interp.getResult();
                                    setVarScalar(interp, "operand_cmdlist_elem", tmp113, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: set ... [...]
                                    TclObject tmp116;
                                    { // Invoke: lindex $... 0
                                        TclObject tmp117 = getVarScalar(interp, "operand_cmdlist_elem", compiledLocals, 20);
                                        tmp117 = TclList.index(interp, tmp117, 0);
                                        if ( tmp117 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp117);
                                        }
                                    } // End Invoke: lindex
                                    tmp116 = interp.getResult();
                                    setVarScalar(interp, "operand_cmdlist_elem_type", tmp116, compiledLocals, 21);
                                } // End Invoke: set
                                { // Invoke: if ... ... elseif ... ... else ...
                                    // Binary operator: $operand_cmdlist_elem_type == "subexpr"
                                    TclObject tmp118 = getVarScalar(interp, "operand_cmdlist_elem_type", compiledLocals, 21);
                                    boolean tmp119 = tmp118.toString().equals("subexpr");
                                    ExprValue tmp120 = evs0;
                                    tmp120.setIntValue(tmp119);
                                    // End Binary operator: ==
                                    boolean tmp121 = ( tmp120.getIntValue() != 0 );
                                    if ( tmp121 ) {
                                        { // Invoke: set type_val [...]
                                            TclObject tmp122;
                                            { // Invoke: lindex $subexpr_list $subexpr_found
                                                TclObject tmp123 = null;
                                                TclObject tmp124;
                                                try {
                                                    tmp123 = getVarScalar(interp, "subexpr_list", compiledLocals, 23);
                                                    tmp123.preserve();
                                                    tmp124 = getVarScalar(interp, "subexpr_found", compiledLocals, 16);
                                                    TJC.lindexNonconst(interp, tmp123, tmp124);
                                                } finally {
                                                    if ( tmp123 != null ) {
                                                        tmp123.release();
                                                    }
                                                }
                                            } // End Invoke: lindex
                                            tmp122 = interp.getResult();
                                            setVarScalar(interp, "type_val", tmp122, compiledLocals, 24);
                                        } // End Invoke: set
                                        { // Invoke: ... $... $in_cmd
                                            TclObject[] objv125 = TJC.grabObjv(interp, 3);
                                            TclObject tmp126;
                                            try {
                                                // Arg 0 constant: ...
                                                objv125[0] = const8;
                                                // Arg 1 variable: $...
                                                tmp126 = getVarScalar(interp, "operand_cmdlist_elem", compiledLocals, 20);
                                                tmp126.preserve();
                                                objv125[1] = tmp126;
                                                // Arg 2 variable: $in_cmd
                                                tmp126 = getVarScalar(interp, "in_cmd", compiledLocals, 2);
                                                tmp126.preserve();
                                                objv125[2] = tmp126;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv125, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp126 = objv125[1];
                                                if ( tmp126 != null ) {
                                                    tmp126.release();
                                                }
                                                tmp126 = objv125[2];
                                                if ( tmp126 != null ) {
                                                    tmp126.release();
                                                }
                                                TJC.releaseObjv(interp, objv125, 3);
                                            }
                                        } // End Invoke: ...
                                        { // Invoke: incr subexpr_found
                                            interp.resetResult();
                                            incrVarScalar(interp, "subexpr_found", 1, compiledLocals, 16);
                                        } // End Invoke: incr
                                        { // Invoke: lappend operands $type_val
                                            TclObject[] objv127 = TJC.grabObjv(interp, 1);
                                            TclObject tmp128;
                                            try {
                                                // Arg 2 variable: $type_val
                                                tmp128 = getVarScalar(interp, "type_val", compiledLocals, 24);
                                                tmp128.preserve();
                                                objv127[0] = tmp128;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "operands", objv127, compiledLocals, 15);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv127, 1);
                                            }
                                        } // End Invoke: lappend
                                    } else {
                                        // Binary operator: $operand_cmdlist_elem_type == "value"
                                        TclObject tmp129 = getVarScalar(interp, "operand_cmdlist_elem_type", compiledLocals, 21);
                                        boolean tmp130 = tmp129.toString().equals("value");
                                        ExprValue tmp131 = evs0;
                                        tmp131.setIntValue(tmp130);
                                        // End Binary operator: ==
                                        boolean tmp132 = ( tmp131.getIntValue() != 0 );
                                        if ( tmp132 ) {
                                            { // Invoke: lappend operands [...]
                                                TclObject[] objv133 = TJC.grabObjv(interp, 1);
                                                TclObject tmp134;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $...
                                                        TclObject[] objv135 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp136;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv135[0] = const9;
                                                            // Arg 1 variable: $...
                                                            tmp136 = getVarScalar(interp, "operand_cmdlist_elem", compiledLocals, 20);
                                                            tmp136.preserve();
                                                            objv135[1] = tmp136;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                                ? cmdcache6.cmd : null), objv135, 0);
                                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                                updateCmdCache(interp, 6);
                                                            }
                                                        } finally {
                                                            tmp136 = objv135[1];
                                                            if ( tmp136 != null ) {
                                                                tmp136.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv135, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp134 = interp.getResult();
                                                    tmp134.preserve();
                                                    objv133[0] = tmp134;
                                                    interp.resetResult();
                                                    lappendVarScalar(interp, "operands", objv133, compiledLocals, 15);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv133, 1);
                                                }
                                            } // End Invoke: lappend
                                        } else {
                                            { // Invoke: error "..."
                                                TclObject[] objv137 = TJC.grabObjv(interp, 2);
                                                TclObject tmp138;
                                                try {
                                                    // Arg 0 constant: error
                                                    objv137[0] = const1;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp139 = new StringBuffer(64);
                                                    sbtmp139.append("unknown type ");
                                                    sbtmp139.append("\"");
                                                    tmp138 = getVarScalar(interp, "operand_cmdlist_elem_type", compiledLocals, 21);
                                                    sbtmp139.append(tmp138.toString());
                                                    sbtmp139.append("\"");
                                                    sbtmp139.append(" in ");
                                                    sbtmp139.append("{");
                                                    tmp138 = getVarScalar(interp, "operand_cmdlist_elem", compiledLocals, 20);
                                                    sbtmp139.append(tmp138.toString());
                                                    sbtmp139.append("}");
                                                    sbtmp139.append(" at index ");
                                                    tmp138 = getVarScalar(interp, "j", compiledLocals, 19);
                                                    sbtmp139.append(tmp138.toString());
                                                    tmp138 = TclString.newInstance(sbtmp139);
                                                    tmp138.preserve();
                                                    objv137[1] = tmp138;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                        ? cmdcache2.cmd : null), objv137, 0);
                                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                        updateCmdCache(interp, 2);
                                                    }
                                                } finally {
                                                    tmp138 = objv137[1];
                                                    if ( tmp138 != null ) {
                                                        tmp138.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv137, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    }
                                } // End Invoke: if
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                        { // Invoke: if ... ... elseif {$num_operands == 1} ... elseif {$num_operands == 2} ... elseif {$num_operands == 3} ... else ...
                            { // Invoke: ... $operator
                                TclObject[] objv140 = TJC.grabObjv(interp, 2);
                                TclObject tmp141;
                                try {
                                    // Arg 0 constant: ...
                                    objv140[0] = const10;
                                    // Arg 1 variable: $operator
                                    tmp141 = getVarScalar(interp, "operator", compiledLocals, 13);
                                    tmp141.preserve();
                                    objv140[1] = tmp141;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv140, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp141 = objv140[1];
                                    if ( tmp141 != null ) {
                                        tmp141.release();
                                    }
                                    TJC.releaseObjv(interp, objv140, 2);
                                }
                            } // End Invoke: ...
                            TclObject tmp142 = interp.getResult();
                            ExprValue tmp143 = evs0;
                            TJC.exprInitValue(interp, tmp143, tmp142);
                            boolean tmp144 = tmp143.getBooleanValue(interp);
                            if ( tmp144 ) {
                                { // Invoke: set type {math function}
                                    setVarScalar(interp, "type", const11, compiledLocals, 25);
                                } // End Invoke: set
                            } else {
                                // Binary operator: $num_operands == 1
                                TclObject tmp145 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                                ExprValue tmp146 = evs0;
                                TJC.exprInitValue(interp, tmp146, tmp145);
                                ExprValue tmp147 = evs1;
                                tmp147.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp146, tmp147);
                                // End Binary operator: ==
                                boolean tmp148 = ( tmp146.getIntValue() != 0 );
                                if ( tmp148 ) {
                                    { // Invoke: set type {unary operator}
                                        setVarScalar(interp, "type", const12, compiledLocals, 25);
                                    } // End Invoke: set
                                } else {
                                    // Binary operator: $num_operands == 2
                                    TclObject tmp149 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                                    ExprValue tmp150 = evs0;
                                    TJC.exprInitValue(interp, tmp150, tmp149);
                                    ExprValue tmp151 = evs1;
                                    tmp151.setIntValue(2);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp150, tmp151);
                                    // End Binary operator: ==
                                    boolean tmp152 = ( tmp150.getIntValue() != 0 );
                                    if ( tmp152 ) {
                                        { // Invoke: set type {binary operator}
                                            setVarScalar(interp, "type", const13, compiledLocals, 25);
                                        } // End Invoke: set
                                    } else {
                                        // Binary operator: $num_operands == 3
                                        TclObject tmp153 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                                        ExprValue tmp154 = evs0;
                                        TJC.exprInitValue(interp, tmp154, tmp153);
                                        ExprValue tmp155 = evs1;
                                        tmp155.setIntValue(3);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp154, tmp155);
                                        // End Binary operator: ==
                                        boolean tmp156 = ( tmp154.getIntValue() != 0 );
                                        if ( tmp156 ) {
                                            { // Invoke: set type {ternary operator}
                                                setVarScalar(interp, "type", const14, compiledLocals, 25);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: error "..."
                                                TclObject[] objv157 = TJC.grabObjv(interp, 2);
                                                TclObject tmp158;
                                                try {
                                                    // Arg 0 constant: error
                                                    objv157[0] = const1;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp159 = new StringBuffer(64);
                                                    sbtmp159.append("unsupported num_operands ");
                                                    tmp158 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                                                    sbtmp159.append(tmp158.toString());
                                                    sbtmp159.append(" in ");
                                                    sbtmp159.append("{");
                                                    tmp158 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                                    sbtmp159.append(tmp158.toString());
                                                    sbtmp159.append("}");
                                                    tmp158 = TclString.newInstance(sbtmp159);
                                                    tmp158.preserve();
                                                    objv157[1] = tmp158;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                        ? cmdcache2.cmd : null), objv157, 0);
                                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                        updateCmdCache(interp, 2);
                                                    }
                                                } finally {
                                                    tmp158 = objv157[1];
                                                    if ( tmp158 != null ) {
                                                        tmp158.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv157, 2);
                                                }
                                            } // End Invoke: error
                                        }
                                    }
                                }
                            }
                        } // End Invoke: if
                        { // Invoke: set values [...]
                            TclObject tmp160;
                            { // Invoke: list $operator $operands
                                TclObject tmp161 = TclList.newInstance();
                                TclObject tmp162;
                                try {
                                    tmp162 = getVarScalar(interp, "operator", compiledLocals, 13);
                                    TclList.append(interp, tmp161, tmp162);
                                    tmp162 = getVarScalar(interp, "operands", compiledLocals, 15);
                                    TclList.append(interp, tmp161, tmp162);
                                } catch (TclException ex) {
                                    tmp161.release();
                                    throw ex;
                                }
                                interp.setResult(tmp161);
                            } // End Invoke: list
                            tmp160 = interp.getResult();
                            setVarScalar(interp, "values", tmp160, compiledLocals, 26);
                        } // End Invoke: set
                        { // Invoke: set ... {}
                            setVarArray(interp, "_parse", "parse_expr_iterate_type_value", const15, compiledLocals, 3);
                        } // End Invoke: set
                        { // Invoke: set cmd [...]
                            TclObject tmp163;
                            { // Invoke: list $in_cmd $script $etree $type $values $ranges
                                TclObject tmp164 = TclList.newInstance();
                                TclObject tmp165;
                                try {
                                    tmp165 = getVarScalar(interp, "in_cmd", compiledLocals, 2);
                                    TclList.append(interp, tmp164, tmp165);
                                    tmp165 = getVarScalar(interp, "script", compiledLocals, 10);
                                    TclList.append(interp, tmp164, tmp165);
                                    tmp165 = getVarScalar(interp, "etree", compiledLocals, 11);
                                    TclList.append(interp, tmp164, tmp165);
                                    tmp165 = getVarScalar(interp, "type", compiledLocals, 25);
                                    TclList.append(interp, tmp164, tmp165);
                                    tmp165 = getVarScalar(interp, "values", compiledLocals, 26);
                                    TclList.append(interp, tmp164, tmp165);
                                    tmp165 = getVarScalar(interp, "ranges", compiledLocals, 14);
                                    TclList.append(interp, tmp164, tmp165);
                                } catch (TclException ex) {
                                    tmp164.release();
                                    throw ex;
                                }
                                interp.setResult(tmp164);
                            } // End Invoke: list
                            tmp163 = interp.getResult();
                            setVarScalar(interp, "cmd", tmp163, compiledLocals, 27);
                        } // End Invoke: set
                        { // Invoke: namespace eval :: $cmd
                            TclObject[] objv166 = TJC.grabObjv(interp, 4);
                            TclObject tmp167;
                            try {
                                // Arg 0 constant: namespace
                                objv166[0] = const16;
                                // Arg 1 constant: eval
                                objv166[1] = const17;
                                // Arg 2 constant: ::
                                objv166[2] = const18;
                                // Arg 3 variable: $cmd
                                tmp167 = getVarScalar(interp, "cmd", compiledLocals, 27);
                                tmp167.preserve();
                                objv166[3] = tmp167;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv166, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp167 = objv166[3];
                                if ( tmp167 != null ) {
                                    tmp167.release();
                                }
                                TJC.releaseObjv(interp, objv166, 4);
                            }
                        } // End Invoke: namespace
                        { // Invoke: set type_val $...
                            TclObject tmp168;
                            tmp168 = getVarArray(interp, "_parse", "parse_expr_iterate_type_value", compiledLocals, 3);
                            setVarScalar(interp, "type_val", tmp168, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set subexpr_stack [...]
                            TclObject tmp169;
                            { // Invoke: linsert $subexpr_stack 0 $type_val
                                TclObject[] objv170 = TJC.grabObjv(interp, 4);
                                TclObject tmp171;
                                try {
                                    // Arg 0 constant: linsert
                                    objv170[0] = const4;
                                    // Arg 1 variable: $subexpr_stack
                                    tmp171 = getVarScalar(interp, "subexpr_stack", compiledLocals, 5);
                                    tmp171.preserve();
                                    objv170[1] = tmp171;
                                    // Arg 2 constant: 0
                                    objv170[2] = const3;
                                    // Arg 3 variable: $type_val
                                    tmp171 = getVarScalar(interp, "type_val", compiledLocals, 24);
                                    tmp171.preserve();
                                    objv170[3] = tmp171;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv170, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp171 = objv170[1];
                                    if ( tmp171 != null ) {
                                        tmp171.release();
                                    }
                                    tmp171 = objv170[3];
                                    if ( tmp171 != null ) {
                                        tmp171.release();
                                    }
                                    TJC.releaseObjv(interp, objv170, 4);
                                }
                            } // End Invoke: linsert
                            tmp169 = interp.getResult();
                            setVarScalar(interp, "subexpr_stack", tmp169, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: incr i $num_operands
                            TclObject tmp172 = getVarScalar(interp, "num_operands", compiledLocals, 12);
                            int tmp173 = TclInteger.get(interp, tmp172);
                            interp.resetResult();
                            incrVarScalar(interp, "i", tmp173, compiledLocals, 6);
                        } // End Invoke: incr
                        { // Invoke: incr i
                            interp.resetResult();
                            incrVarScalar(interp, "i", 1, compiledLocals, 6);
                        } // End Invoke: incr
                    } else if ( tmp34_length == 5 && tmp34_first == 'v'
                            && tmp34.compareTo("value") == 0 ) {
                        // Pattern {value}
                        { // Invoke: ... $cmdlist_elem
                            TclObject[] objv174 = TJC.grabObjv(interp, 2);
                            TclObject tmp175;
                            try {
                                // Arg 0 constant: ...
                                objv174[0] = const9;
                                // Arg 1 variable: $cmdlist_elem
                                tmp175 = getVarScalar(interp, "cmdlist_elem", compiledLocals, 8);
                                tmp175.preserve();
                                objv174[1] = tmp175;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv174, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp175 = objv174[1];
                                if ( tmp175 != null ) {
                                    tmp175.release();
                                }
                                TJC.releaseObjv(interp, objv174, 2);
                            }
                        } // End Invoke: ...
                        { // Invoke: incr i
                            interp.resetResult();
                            incrVarScalar(interp, "i", 1, compiledLocals, 6);
                        } // End Invoke: incr
                    } else {
                        // Pattern default
                        { // Invoke: error "..."
                            TclObject[] objv176 = TJC.grabObjv(interp, 2);
                            TclObject tmp177;
                            try {
                                // Arg 0 constant: error
                                objv176[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp178 = new StringBuffer(64);
                                sbtmp178.append("unknown elem type ");
                                sbtmp178.append("\"");
                                tmp177 = getVarScalar(interp, "elem_type", compiledLocals, 9);
                                sbtmp178.append(tmp177.toString());
                                sbtmp178.append("\"");
                                tmp177 = TclString.newInstance(sbtmp178);
                                tmp177.preserve();
                                objv176[1] = tmp177;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv176, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp177 = objv176[1];
                                if ( tmp177 != null ) {
                                    tmp177.release();
                                }
                                TJC.releaseObjv(interp, objv176, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: switch
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set type {value}
            setVarScalar(interp, "type", const19, compiledLocals, 25);
        } // End Invoke: set
        { // Invoke: set values [...]
            TclObject tmp179;
            { // Invoke: list $...
                TclObject tmp180 = TclList.newInstance();
                TclObject tmp181;
                tmp181 = getVarArray(interp, "_parse", "parse_expr_iterate_type_value", compiledLocals, 3);
                TclList.append(interp, tmp180, tmp181);
                interp.setResult(tmp180);
            } // End Invoke: list
            tmp179 = interp.getResult();
            setVarScalar(interp, "values", tmp179, compiledLocals, 26);
        } // End Invoke: set
        { // Invoke: set ranges {}
            setVarScalar(interp, "ranges", const15, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set cmd [...]
            TclObject tmp182;
            { // Invoke: list $in_cmd $in_script $in_etree $type $values $ranges
                TclObject tmp183 = TclList.newInstance();
                TclObject tmp184;
                try {
                    tmp184 = getVarScalar(interp, "in_cmd", compiledLocals, 2);
                    TclList.append(interp, tmp183, tmp184);
                    tmp184 = getVarScalar(interp, "in_script", compiledLocals, 0);
                    TclList.append(interp, tmp183, tmp184);
                    tmp184 = getVarScalar(interp, "in_etree", compiledLocals, 1);
                    TclList.append(interp, tmp183, tmp184);
                    tmp184 = getVarScalar(interp, "type", compiledLocals, 25);
                    TclList.append(interp, tmp183, tmp184);
                    tmp184 = getVarScalar(interp, "values", compiledLocals, 26);
                    TclList.append(interp, tmp183, tmp184);
                    tmp184 = getVarScalar(interp, "ranges", compiledLocals, 14);
                    TclList.append(interp, tmp183, tmp184);
                } catch (TclException ex) {
                    tmp183.release();
                    throw ex;
                }
                interp.setResult(tmp183);
            } // End Invoke: list
            tmp182 = interp.getResult();
            setVarScalar(interp, "cmd", tmp182, compiledLocals, 27);
        } // End Invoke: set
        { // Invoke: namespace eval :: $cmd
            TclObject[] objv185 = TJC.grabObjv(interp, 4);
            TclObject tmp186;
            try {
                // Arg 0 constant: namespace
                objv185[0] = const16;
                // Arg 1 constant: eval
                objv185[1] = const17;
                // Arg 2 constant: ::
                objv185[2] = const18;
                // Arg 3 variable: $cmd
                tmp186 = getVarScalar(interp, "cmd", compiledLocals, 27);
                tmp186.preserve();
                objv185[3] = tmp186;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                    ? cmdcache8.cmd : null), objv185, 0);
                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                    updateCmdCache(interp, 8);
                }
            } finally {
                tmp186 = objv185[3];
                if ( tmp186 != null ) {
                    tmp186.release();
                }
                TJC.releaseObjv(interp, objv185, 4);
            }
        } // End Invoke: namespace
        { // Invoke: return $...
            TclObject tmp187 = getVarArray(interp, "_parse", "parse_expr_iterate_type_value", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp187);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_expr_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("_parse_expr_iterate_descend");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("empty cmdlist");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("linsert");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lrange");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(1);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("end");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("_parse_expr_iterate_subexpr");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("_parse_expr_iterate_evaluate_value");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("_parse_expr_iterate_is_math_function");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("math function");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("unary operator");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("binary operator");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("ternary operator");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("namespace");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("eval");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("::");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("value");
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "_parse_expr_iterate_descend";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "linsert";
                break;
            }
            case 4: {
                cmdName = "lrange";
                break;
            }
            case 5: {
                cmdName = "_parse_expr_iterate_subexpr";
                break;
            }
            case 6: {
                cmdName = "_parse_expr_iterate_evaluate_value";
                break;
            }
            case 7: {
                cmdName = "_parse_expr_iterate_is_math_function";
                break;
            }
            case 8: {
                cmdName = "namespace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "in_script",
        "in_etree",
        "in_cmd",
        "_parse",
        "cmdlist",
        "subexpr_stack",
        "i",
        "len",
        "cmdlist_elem",
        "elem_type",
        "script",
        "etree",
        "num_operands",
        "operator",
        "ranges",
        "operands",
        "subexpr_found",
        "jstart",
        "jend",
        "j",
        "operand_cmdlist_elem",
        "operand_cmdlist_elem_type",
        "stack_size",
        "subexpr_list",
        "type_val",
        "type",
        "values",
        "cmd"
    };
} // end class ParseExprIterateCmd

