// TJC implementation of procedure parse_get_variable
package tjc;
import tcl.lang.*;

public class ParseGetVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "script stree ?rtype?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "rtype", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: if ... ... elseif {$rtype == "text"} ... else ...
            // Binary operator: $rtype == "variable"
            TclObject tmp0 = getVarScalar(interp, "rtype", compiledLocals, 2);
            boolean tmp1 = tmp0.toString().equals("variable");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set range [...]
                    TclObject tmp4;
                    { // Invoke: lindex $stree 1
                        TclObject tmp5 = getVarScalar(interp, "stree", compiledLocals, 1);
                        tmp5 = TclList.index(interp, tmp5, 1);
                        if ( tmp5 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp5);
                        }
                    } // End Invoke: lindex
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "range", tmp4, compiledLocals, 3);
                } // End Invoke: set
            } else {
                // Binary operator: $rtype == "text"
                TclObject tmp6 = getVarScalar(interp, "rtype", compiledLocals, 2);
                boolean tmp7 = tmp6.toString().equals("text");
                ExprValue tmp8 = evs0;
                tmp8.setIntValue(tmp7);
                // End Binary operator: ==
                boolean tmp9 = ( tmp8.getIntValue() != 0 );
                if ( tmp9 ) {
                    { // Invoke: set variable_subtree [...]
                        TclObject tmp10;
                        { // Invoke: lindex $stree 2
                            TclObject tmp11 = getVarScalar(interp, "stree", compiledLocals, 1);
                            tmp11 = TclList.index(interp, tmp11, 2);
                            if ( tmp11 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp11);
                            }
                        } // End Invoke: lindex
                        tmp10 = interp.getResult();
                        setVarScalar(interp, "variable_subtree", tmp10, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        // Binary operator: [...] == 1
                        { // Invoke: llength $variable_subtree
                            TclObject tmp12 = getVarScalar(interp, "variable_subtree", compiledLocals, 4);
                            int tmp13 = TclList.getLength(interp, tmp12);
                            interp.setResult(tmp13);
                        } // End Invoke: llength
                        TclObject tmp14 = interp.getResult();
                        ExprValue tmp15 = evs0;
                        TJC.exprInitValue(interp, tmp15, tmp14);
                        ExprValue tmp16 = evs1;
                        tmp16.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp15, tmp16);
                        // End Binary operator: ==
                        boolean tmp17 = ( tmp15.getIntValue() != 0 );
                        if ( tmp17 ) {
                            { // Invoke: set range [...]
                                TclObject tmp18;
                                { // Invoke: lindex $variable_subtree 0 1
                                    TclObject[] objv19 = TJC.grabObjv(interp, 4);
                                    TclObject tmp20;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv19[0] = const1;
                                        // Arg 1 variable: $variable_subtree
                                        tmp20 = getVarScalar(interp, "variable_subtree", compiledLocals, 4);
                                        tmp20.preserve();
                                        objv19[1] = tmp20;
                                        // Arg 2 constant: 0
                                        objv19[2] = const2;
                                        // Arg 3 constant: 1
                                        objv19[3] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv19, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp20 = objv19[1];
                                        if ( tmp20 != null ) {
                                            tmp20.release();
                                        }
                                        TJC.releaseObjv(interp, objv19, 4);
                                    }
                                } // End Invoke: lindex
                                tmp18 = interp.getResult();
                                setVarScalar(interp, "range", tmp18, compiledLocals, 3);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set r1 [...]
                                TclObject tmp21;
                                { // Invoke: lindex $variable_subtree 0 1
                                    TclObject[] objv22 = TJC.grabObjv(interp, 4);
                                    TclObject tmp23;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv22[0] = const1;
                                        // Arg 1 variable: $variable_subtree
                                        tmp23 = getVarScalar(interp, "variable_subtree", compiledLocals, 4);
                                        tmp23.preserve();
                                        objv22[1] = tmp23;
                                        // Arg 2 constant: 0
                                        objv22[2] = const2;
                                        // Arg 3 constant: 1
                                        objv22[3] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv22, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp23 = objv22[1];
                                        if ( tmp23 != null ) {
                                            tmp23.release();
                                        }
                                        TJC.releaseObjv(interp, objv22, 4);
                                    }
                                } // End Invoke: lindex
                                tmp21 = interp.getResult();
                                setVarScalar(interp, "r1", tmp21, compiledLocals, 5);
                            } // End Invoke: set
                            { // Invoke: set r2 [...]
                                TclObject tmp24;
                                { // Invoke: lindex $variable_subtree end 1
                                    TclObject[] objv25 = TJC.grabObjv(interp, 4);
                                    TclObject tmp26;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv25[0] = const1;
                                        // Arg 1 variable: $variable_subtree
                                        tmp26 = getVarScalar(interp, "variable_subtree", compiledLocals, 4);
                                        tmp26.preserve();
                                        objv25[1] = tmp26;
                                        // Arg 2 constant: end
                                        objv25[2] = const4;
                                        // Arg 3 constant: 1
                                        objv25[3] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv25, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp26 = objv25[1];
                                        if ( tmp26 != null ) {
                                            tmp26.release();
                                        }
                                        TJC.releaseObjv(interp, objv25, 4);
                                    }
                                } // End Invoke: lindex
                                tmp24 = interp.getResult();
                                setVarScalar(interp, "r2", tmp24, compiledLocals, 6);
                            } // End Invoke: set
                            { // Invoke: set range [...]
                                TclObject tmp27;
                                { // Invoke: list
                                    TclObject tmp28 = TclList.newInstance();
                                    interp.setResult(tmp28);
                                } // End Invoke: list
                                tmp27 = interp.getResult();
                                setVarScalar(interp, "range", tmp27, compiledLocals, 3);
                            } // End Invoke: set
                            { // Invoke: lappend range [...]
                                TclObject[] objv29 = TJC.grabObjv(interp, 1);
                                TclObject tmp30;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: lindex $r1 0
                                        TclObject tmp31 = getVarScalar(interp, "r1", compiledLocals, 5);
                                        tmp31 = TclList.index(interp, tmp31, 0);
                                        if ( tmp31 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp31);
                                        }
                                    } // End Invoke: lindex
                                    tmp30 = interp.getResult();
                                    tmp30.preserve();
                                    objv29[0] = tmp30;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "range", objv29, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv29, 1);
                                }
                            } // End Invoke: lappend
                            { // Invoke: set r2_start [...]
                                TclObject tmp32;
                                { // Invoke: lindex $r2 0
                                    TclObject tmp33 = getVarScalar(interp, "r2", compiledLocals, 6);
                                    tmp33 = TclList.index(interp, tmp33, 0);
                                    if ( tmp33 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp33);
                                    }
                                } // End Invoke: lindex
                                tmp32 = interp.getResult();
                                setVarScalar(interp, "r2_start", tmp32, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: set r2_len [...]
                                TclObject tmp34;
                                { // Invoke: lindex $r2 1
                                    TclObject tmp35 = getVarScalar(interp, "r2", compiledLocals, 6);
                                    tmp35 = TclList.index(interp, tmp35, 1);
                                    if ( tmp35 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp35);
                                    }
                                } // End Invoke: lindex
                                tmp34 = interp.getResult();
                                setVarScalar(interp, "r2_len", tmp34, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: lappend range [...]
                                TclObject[] objv36 = TJC.grabObjv(interp, 1);
                                TclObject tmp37;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: expr ...
                                        // Binary operator: () - [...]
                                        // Binary operator: () + 1
                                        // Binary operator: $r2_start + $r2_len
                                        TclObject tmp38 = getVarScalar(interp, "r2_start", compiledLocals, 7);
                                        ExprValue tmp39 = evs0;
                                        TJC.exprInitValue(interp, tmp39, tmp38);
                                        TclObject tmp40 = getVarScalar(interp, "r2_len", compiledLocals, 8);
                                        ExprValue tmp41 = evs1;
                                        TJC.exprInitValue(interp, tmp41, tmp40);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp39, tmp41);
                                        // End Binary operator: +
                                        ExprValue tmp42 = evs1;
                                        tmp42.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp39, tmp42);
                                        // End Binary operator: +
                                        { // Invoke: lindex $r1 0
                                            TclObject tmp43 = getVarScalar(interp, "r1", compiledLocals, 5);
                                            tmp43 = TclList.index(interp, tmp43, 0);
                                            if ( tmp43 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp43);
                                            }
                                        } // End Invoke: lindex
                                        TclObject tmp44 = interp.getResult();
                                        ExprValue tmp45 = evs1;
                                        TJC.exprInitValue(interp, tmp45, tmp44);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp39, tmp45);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp39);
                                    } // End Invoke: expr
                                    tmp37 = interp.getResult();
                                    tmp37.preserve();
                                    objv36[0] = tmp37;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "range", objv36, compiledLocals, 3);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv36, 1);
                                }
                            } // End Invoke: lappend
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv46 = TJC.grabObjv(interp, 2);
                        TclObject tmp47;
                        try {
                            // Arg 0 constant: error
                            objv46[0] = const5;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp48 = new StringBuffer(64);
                            sbtmp48.append("unknown rtype ");
                            sbtmp48.append("\"");
                            tmp47 = getVarScalar(interp, "rtype", compiledLocals, 2);
                            sbtmp48.append(tmp47.toString());
                            sbtmp48.append("\"");
                            tmp47 = TclString.newInstance(sbtmp48);
                            tmp47.preserve();
                            objv46[1] = tmp47;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv46, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp47 = objv46[1];
                            if ( tmp47 != null ) {
                                tmp47.release();
                            }
                            TJC.releaseObjv(interp, objv46, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: parse getstring $script $range
                TclObject[] objv49 = TJC.grabObjv(interp, 4);
                TclObject tmp50;
                try {
                    // Arg 0 constant: parse
                    objv49[0] = const6;
                    // Arg 1 constant: getstring
                    objv49[1] = const7;
                    // Arg 2 variable: $script
                    tmp50 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp50.preserve();
                    objv49[2] = tmp50;
                    // Arg 3 variable: $range
                    tmp50 = getVarScalar(interp, "range", compiledLocals, 3);
                    tmp50.preserve();
                    objv49[3] = tmp50;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv49, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp50 = objv49[2];
                    if ( tmp50 != null ) {
                        tmp50.release();
                    }
                    tmp50 = objv49[3];
                    if ( tmp50 != null ) {
                        tmp50.release();
                    }
                    TJC.releaseObjv(interp, objv49, 4);
                }
            } // End Invoke: parse
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("variable");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lindex");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("end");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("parse");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("getstring");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "rtype",
        "range",
        "variable_subtree",
        "r1",
        "r2",
        "r2_start",
        "r2_len"
    };
} // end class ParseGetVariableCmd

