// TJC implementation of procedure parse_range_of_tree
package tjc;
import tcl.lang.*;

public class ParseRangeOfTreeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "stree ?first? ?last?");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        setVarScalar(interp, "first", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        setVarScalar(interp, "last", 
            ((objv.length <= 3) ? const1 : objv[3]), compiledLocals, 2);
        { // Invoke: set rstart [...]
            TclObject tmp0;
            { // Invoke: lindex $stree $first 1
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: lindex
                    objv1[0] = const2;
                    // Arg 1 variable: $stree
                    tmp2 = getVarScalar(interp, "stree", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $first
                    tmp2 = getVarScalar(interp, "first", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 constant: 1
                    objv1[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "rstart", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set rend [...]
            TclObject tmp3;
            { // Invoke: lindex $stree $last 1
                TclObject[] objv4 = TJC.grabObjv(interp, 4);
                TclObject tmp5;
                try {
                    // Arg 0 constant: lindex
                    objv4[0] = const2;
                    // Arg 1 variable: $stree
                    tmp5 = getVarScalar(interp, "stree", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 variable: $last
                    tmp5 = getVarScalar(interp, "last", compiledLocals, 2);
                    tmp5.preserve();
                    objv4[2] = tmp5;
                    // Arg 3 constant: 1
                    objv4[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    tmp5 = objv4[2];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "rend", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp6;
            { // Invoke: list
                TclObject tmp7 = TclList.newInstance();
                interp.setResult(tmp7);
            } // End Invoke: list
            tmp6 = interp.getResult();
            setVarScalar(interp, "range", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set rstart_start [...]
            TclObject tmp8;
            { // Invoke: lindex $rstart 0
                TclObject tmp9 = getVarScalar(interp, "rstart", compiledLocals, 3);
                tmp9 = TclList.index(interp, tmp9, 0);
                if ( tmp9 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp9);
                }
            } // End Invoke: lindex
            tmp8 = interp.getResult();
            setVarScalar(interp, "rstart_start", tmp8, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: lappend range $rstart_start
            TclObject[] objv10 = TJC.grabObjv(interp, 1);
            TclObject tmp11;
            try {
                // Arg 2 variable: $rstart_start
                tmp11 = getVarScalar(interp, "rstart_start", compiledLocals, 6);
                tmp11.preserve();
                objv10[0] = tmp11;
                interp.resetResult();
                lappendVarScalar(interp, "range", objv10, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv10, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set rend_start [...]
            TclObject tmp12;
            { // Invoke: lindex $rend 0
                TclObject tmp13 = getVarScalar(interp, "rend", compiledLocals, 4);
                tmp13 = TclList.index(interp, tmp13, 0);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            tmp12 = interp.getResult();
            setVarScalar(interp, "rend_start", tmp12, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set rend_len [...]
            TclObject tmp14;
            { // Invoke: lindex $rend 1
                TclObject tmp15 = getVarScalar(interp, "rend", compiledLocals, 4);
                tmp15 = TclList.index(interp, tmp15, 1);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "rend_len", tmp14, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: lappend range [...]
            TclObject[] objv16 = TJC.grabObjv(interp, 1);
            TclObject tmp17;
            try {
                // Arg 2 command: [...]
                { // Invoke: expr ...
                    // Binary operator: () - $rstart_start
                    // Binary operator: $rend_start + $rend_len
                    TclObject tmp18 = getVarScalar(interp, "rend_start", compiledLocals, 7);
                    ExprValue tmp19 = evs0;
                    TJC.exprInitValue(interp, tmp19, tmp18);
                    TclObject tmp20 = getVarScalar(interp, "rend_len", compiledLocals, 8);
                    ExprValue tmp21 = evs1;
                    TJC.exprInitValue(interp, tmp21, tmp20);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp19, tmp21);
                    // End Binary operator: +
                    TclObject tmp22 = getVarScalar(interp, "rstart_start", compiledLocals, 6);
                    ExprValue tmp23 = evs1;
                    TJC.exprInitValue(interp, tmp23, tmp22);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp19, tmp23);
                    // End Binary operator: -
                    TJC.exprSetResult(interp, tmp19);
                } // End Invoke: expr
                tmp17 = interp.getResult();
                tmp17.preserve();
                objv16[0] = tmp17;
                interp.resetResult();
                lappendVarScalar(interp, "range", objv16, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv16, 1);
            }
        } // End Invoke: lappend
        { // Invoke: return $range
            TclObject tmp24 = getVarScalar(interp, "range", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp24);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_range_of_tree");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("end");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("lindex");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "stree",
        "first",
        "last",
        "rstart",
        "rend",
        "range",
        "rstart_start",
        "rend_start",
        "rend_len"
    };
} // end class ParseRangeOfTreeCmd

