// TJC implementation of procedure _parse_variable_iterate
package tjc;
import tcl.lang.*;

public class ParseVariableIterateCmd2 extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 36, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "script stree cmd private");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "cmd", objv[3], compiledLocals, 2);
        setVarScalar(interp, "private", objv[4], compiledLocals, 3);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 4);
        } // End Invoke: global
        { // Invoke: set iterating_word [...]
            TclObject tmp0;
            { // Invoke: lindex $private 0
                TclObject tmp1 = getVarScalar(interp, "private", compiledLocals, 3);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "iterating_word", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set key [...]
            TclObject tmp2;
            { // Invoke: lindex $private 1
                TclObject tmp3 = getVarScalar(interp, "private", compiledLocals, 3);
                tmp3 = TclList.index(interp, tmp3, 1);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "key", tmp2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set cmdlist $_parse($key)
            TclObject tmp4;
            tmp4 = getVarScalar(interp, "key", compiledLocals, 6);
            tmp4 = getVarArray(interp, "_parse", tmp4.toString(), compiledLocals, 4);
            setVarScalar(interp, "cmdlist", tmp4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set cmdindex 0
            setVarScalar(interp, "cmdindex", const0, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp5;
            { // Invoke: lindex $stree 0
                TclObject tmp6 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp6 = TclList.index(interp, tmp6, 0);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "type", tmp5, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $type != "variable"
            TclObject tmp7 = getVarScalar(interp, "type", compiledLocals, 9);
            boolean tmp8 = ! tmp7.toString().equals("variable");
            ExprValue tmp9 = evs0;
            tmp9.setIntValue(tmp8);
            // End Binary operator: !=
            boolean tmp10 = ( tmp9.getIntValue() != 0 );
            if ( tmp10 ) {
                { // Invoke: error "..."
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    TclObject tmp12;
                    try {
                        // Arg 0 constant: error
                        objv11[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp13 = new StringBuffer(64);
                        sbtmp13.append("expected ");
                        sbtmp13.append("\"");
                        sbtmp13.append("variable");
                        sbtmp13.append("\"");
                        sbtmp13.append(" type, got ");
                        sbtmp13.append("\"");
                        tmp12 = getVarScalar(interp, "type", compiledLocals, 9);
                        sbtmp13.append(tmp12.toString());
                        sbtmp13.append("\"");
                        tmp12 = TclString.newInstance(sbtmp13);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv11, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp14;
            { // Invoke: lindex $stree 1
                TclObject tmp15 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp15 = TclList.index(interp, tmp15, 1);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "range", tmp14, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: llength $range
                TclObject tmp16 = getVarScalar(interp, "range", compiledLocals, 10);
                int tmp17 = TclList.getLength(interp, tmp16);
                interp.setResult(tmp17);
            } // End Invoke: llength
            TclObject tmp18 = interp.getResult();
            ExprValue tmp19 = evs0;
            TJC.exprInitValue(interp, tmp19, tmp18);
            ExprValue tmp20 = evs1;
            tmp20.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp19, tmp20);
            // End Binary operator: !=
            boolean tmp21 = ( tmp19.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: error "..."
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    TclObject tmp23;
                    try {
                        // Arg 0 constant: error
                        objv22[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp24 = new StringBuffer(64);
                        sbtmp24.append("expected range of length 2, got ");
                        sbtmp24.append("{");
                        tmp23 = getVarScalar(interp, "range", compiledLocals, 10);
                        sbtmp24.append(tmp23.toString());
                        sbtmp24.append("}");
                        tmp23 = TclString.newInstance(sbtmp24);
                        tmp23.preserve();
                        objv22[1] = tmp23;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv22, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp23 = objv22[1];
                        if ( tmp23 != null ) {
                            tmp23.release();
                        }
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set inner_tree [...]
            TclObject tmp25;
            { // Invoke: lindex $stree 2
                TclObject tmp26 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp26 = TclList.index(interp, tmp26, 2);
                if ( tmp26 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp26);
                }
            } // End Invoke: lindex
            tmp25 = interp.getResult();
            setVarScalar(interp, "inner_tree", tmp25, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set inner_tree_types [...]
            TclObject tmp27;
            { // Invoke: ... $inner_tree
                TclObject[] objv28 = TJC.grabObjv(interp, 2);
                TclObject tmp29;
                try {
                    // Arg 0 constant: ...
                    objv28[0] = const2;
                    // Arg 1 variable: $inner_tree
                    tmp29 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                    tmp29.preserve();
                    objv28[1] = tmp29;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv28, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp29 = objv28[1];
                    if ( tmp29 != null ) {
                        tmp29.release();
                    }
                    TJC.releaseObjv(interp, objv28, 2);
                }
            } // End Invoke: ...
            tmp27 = interp.getResult();
            setVarScalar(interp, "inner_tree_types", tmp27, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: $inner_tree_types == ""
            TclObject tmp30 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
            ExprValue tmp31 = evs0;
            TJC.exprEqualsEmptyString(tmp31, tmp30, false);
            // End Binary operator: ==
            boolean tmp32 = ( tmp31.getIntValue() != 0 );
            if ( tmp32 ) {
                { // Invoke: error "..."
                    TclObject[] objv33 = TJC.grabObjv(interp, 2);
                    TclObject tmp34;
                    try {
                        // Arg 0 constant: error
                        objv33[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp35 = new StringBuffer(64);
                        sbtmp35.append("empty inner tree types for stree ");
                        sbtmp35.append("{");
                        tmp34 = getVarScalar(interp, "stree", compiledLocals, 1);
                        sbtmp35.append(tmp34.toString());
                        sbtmp35.append("}");
                        tmp34 = TclString.newInstance(sbtmp35);
                        tmp34.preserve();
                        objv33[1] = tmp34;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv33, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp34 = objv33[1];
                        if ( tmp34 != null ) {
                            tmp34.release();
                        }
                        TJC.releaseObjv(interp, objv33, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: $inner_tree_types == "text"
                TclObject tmp36 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                boolean tmp37 = tmp36.toString().equals("text");
                ExprValue tmp38 = evs0;
                tmp38.setIntValue(tmp37);
                // End Binary operator: ==
                boolean tmp39 = ( tmp38.getIntValue() != 0 );
                if ( tmp39 ) {
                    { // Invoke: set inner_range [...]
                        TclObject tmp40;
                        { // Invoke: lindex $inner_tree 0 1
                            TclObject[] objv41 = TJC.grabObjv(interp, 4);
                            TclObject tmp42;
                            try {
                                // Arg 0 constant: lindex
                                objv41[0] = const3;
                                // Arg 1 variable: $inner_tree
                                tmp42 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                tmp42.preserve();
                                objv41[1] = tmp42;
                                // Arg 2 constant: 0
                                objv41[2] = const0;
                                // Arg 3 constant: 1
                                objv41[3] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv41, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp42 = objv41[1];
                                if ( tmp42 != null ) {
                                    tmp42.release();
                                }
                                TJC.releaseObjv(interp, objv41, 4);
                            }
                        } // End Invoke: lindex
                        tmp40 = interp.getResult();
                        setVarScalar(interp, "inner_range", tmp40, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: set varname [...]
                        TclObject tmp43;
                        { // Invoke: parse getstring $script $inner_range
                            TclObject[] objv44 = TJC.grabObjv(interp, 4);
                            TclObject tmp45;
                            try {
                                // Arg 0 constant: parse
                                objv44[0] = const5;
                                // Arg 1 constant: getstring
                                objv44[1] = const6;
                                // Arg 2 variable: $script
                                tmp45 = getVarScalar(interp, "script", compiledLocals, 0);
                                tmp45.preserve();
                                objv44[2] = tmp45;
                                // Arg 3 variable: $inner_range
                                tmp45 = getVarScalar(interp, "inner_range", compiledLocals, 13);
                                tmp45.preserve();
                                objv44[3] = tmp45;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv44, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp45 = objv44[2];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                tmp45 = objv44[3];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                TJC.releaseObjv(interp, objv44, 4);
                            }
                        } // End Invoke: parse
                        tmp43 = interp.getResult();
                        setVarScalar(interp, "varname", tmp43, compiledLocals, 14);
                    } // End Invoke: set
                    { // Invoke: if {!$iterating_word} ... else ...
                        // Unary operator: ! $iterating_word
                        TclObject tmp46 = getVarScalar(interp, "iterating_word", compiledLocals, 5);
                        ExprValue tmp47 = evs0;
                        if ( tmp46.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp47, tmp46);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp47, tmp46);
                        }
                        // End Unary operator: !
                        boolean tmp48 = ( tmp47.getIntValue() != 0 );
                        if ( tmp48 ) {
                            { // Invoke: set atype {scalar}
                                setVarScalar(interp, "atype", const7, compiledLocals, 15);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set atype {word scalar}
                                setVarScalar(interp, "atype", const8, compiledLocals, 15);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: set avalues [...]
                        TclObject tmp49;
                        { // Invoke: list $varname
                            TclObject tmp50 = TclList.newInstance();
                            TclObject tmp51;
                            tmp51 = getVarScalar(interp, "varname", compiledLocals, 14);
                            TclList.append(interp, tmp50, tmp51);
                            interp.setResult(tmp50);
                        } // End Invoke: list
                        tmp49 = interp.getResult();
                        setVarScalar(interp, "avalues", tmp49, compiledLocals, 16);
                    } // End Invoke: set
                    { // Invoke: set aranges [...]
                        TclObject tmp52;
                        { // Invoke: list $inner_range
                            TclObject tmp53 = TclList.newInstance();
                            TclObject tmp54;
                            tmp54 = getVarScalar(interp, "inner_range", compiledLocals, 13);
                            TclList.append(interp, tmp53, tmp54);
                            interp.setResult(tmp53);
                        } // End Invoke: list
                        tmp52 = interp.getResult();
                        setVarScalar(interp, "aranges", tmp52, compiledLocals, 17);
                    } // End Invoke: set
                    { // Invoke: lappend cmdlist [...]
                        TclObject[] objv55 = TJC.grabObjv(interp, 1);
                        TclObject tmp56;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                TclObject tmp57 = TclList.newInstance();
                                TclObject tmp58;
                                try {
                                    tmp58 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                    TclList.append(interp, tmp57, tmp58);
                                    tmp58 = getVarScalar(interp, "script", compiledLocals, 0);
                                    TclList.append(interp, tmp57, tmp58);
                                    tmp58 = getVarScalar(interp, "stree", compiledLocals, 1);
                                    TclList.append(interp, tmp57, tmp58);
                                    tmp58 = getVarScalar(interp, "atype", compiledLocals, 15);
                                    TclList.append(interp, tmp57, tmp58);
                                    tmp58 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                    TclList.append(interp, tmp57, tmp58);
                                    tmp58 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                    TclList.append(interp, tmp57, tmp58);
                                } catch (TclException ex) {
                                    tmp57.release();
                                    throw ex;
                                }
                                interp.setResult(tmp57);
                            } // End Invoke: list
                            tmp56 = interp.getResult();
                            tmp56.preserve();
                            objv55[0] = tmp56;
                            interp.resetResult();
                            lappendVarScalar(interp, "cmdlist", objv55, compiledLocals, 7);
                        } finally {
                            TJC.releaseObjvElems(interp, objv55, 1);
                        }
                    } // End Invoke: lappend
                } else {
                    // Binary operator: $inner_tree_types == "text text"
                    TclObject tmp59 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                    boolean tmp60 = tmp59.toString().equals("text text");
                    ExprValue tmp61 = evs0;
                    tmp61.setIntValue(tmp60);
                    // End Binary operator: ==
                    boolean tmp62 = ( tmp61.getIntValue() != 0 );
                    if ( tmp62 ) {
                        { // Invoke: set arrayname_range [...]
                            TclObject tmp63;
                            { // Invoke: lindex $inner_tree 0 1
                                TclObject[] objv64 = TJC.grabObjv(interp, 4);
                                TclObject tmp65;
                                try {
                                    // Arg 0 constant: lindex
                                    objv64[0] = const3;
                                    // Arg 1 variable: $inner_tree
                                    tmp65 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                    tmp65.preserve();
                                    objv64[1] = tmp65;
                                    // Arg 2 constant: 0
                                    objv64[2] = const0;
                                    // Arg 3 constant: 1
                                    objv64[3] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv64, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp65 = objv64[1];
                                    if ( tmp65 != null ) {
                                        tmp65.release();
                                    }
                                    TJC.releaseObjv(interp, objv64, 4);
                                }
                            } // End Invoke: lindex
                            tmp63 = interp.getResult();
                            setVarScalar(interp, "arrayname_range", tmp63, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: set arrayname [...]
                            TclObject tmp66;
                            { // Invoke: parse getstring $script $arrayname_range
                                TclObject[] objv67 = TJC.grabObjv(interp, 4);
                                TclObject tmp68;
                                try {
                                    // Arg 0 constant: parse
                                    objv67[0] = const5;
                                    // Arg 1 constant: getstring
                                    objv67[1] = const6;
                                    // Arg 2 variable: $script
                                    tmp68 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp68.preserve();
                                    objv67[2] = tmp68;
                                    // Arg 3 variable: $arrayname_range
                                    tmp68 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                    tmp68.preserve();
                                    objv67[3] = tmp68;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv67, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp68 = objv67[2];
                                    if ( tmp68 != null ) {
                                        tmp68.release();
                                    }
                                    tmp68 = objv67[3];
                                    if ( tmp68 != null ) {
                                        tmp68.release();
                                    }
                                    TJC.releaseObjv(interp, objv67, 4);
                                }
                            } // End Invoke: parse
                            tmp66 = interp.getResult();
                            setVarScalar(interp, "arrayname", tmp66, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: set key_range [...]
                            TclObject tmp69;
                            { // Invoke: lindex $inner_tree 1 1
                                TclObject[] objv70 = TJC.grabObjv(interp, 4);
                                TclObject tmp71;
                                try {
                                    // Arg 0 constant: lindex
                                    objv70[0] = const3;
                                    // Arg 1 variable: $inner_tree
                                    tmp71 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                    tmp71.preserve();
                                    objv70[1] = tmp71;
                                    // Arg 2 constant: 1
                                    objv70[2] = const4;
                                    // Arg 3 constant: 1
                                    objv70[3] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv70, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp71 = objv70[1];
                                    if ( tmp71 != null ) {
                                        tmp71.release();
                                    }
                                    TJC.releaseObjv(interp, objv70, 4);
                                }
                            } // End Invoke: lindex
                            tmp69 = interp.getResult();
                            setVarScalar(interp, "key_range", tmp69, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set key_string [...]
                            TclObject tmp72;
                            { // Invoke: parse getstring $script $key_range
                                TclObject[] objv73 = TJC.grabObjv(interp, 4);
                                TclObject tmp74;
                                try {
                                    // Arg 0 constant: parse
                                    objv73[0] = const5;
                                    // Arg 1 constant: getstring
                                    objv73[1] = const6;
                                    // Arg 2 variable: $script
                                    tmp74 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp74.preserve();
                                    objv73[2] = tmp74;
                                    // Arg 3 variable: $key_range
                                    tmp74 = getVarScalar(interp, "key_range", compiledLocals, 20);
                                    tmp74.preserve();
                                    objv73[3] = tmp74;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv73, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp74 = objv73[2];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    tmp74 = objv73[3];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    TJC.releaseObjv(interp, objv73, 4);
                                }
                            } // End Invoke: parse
                            tmp72 = interp.getResult();
                            setVarScalar(interp, "key_string", tmp72, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: if {!$iterating_word} ... else ...
                            // Unary operator: ! $iterating_word
                            TclObject tmp75 = getVarScalar(interp, "iterating_word", compiledLocals, 5);
                            ExprValue tmp76 = evs0;
                            if ( tmp75.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp76, tmp75);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp76, tmp75);
                            }
                            // End Unary operator: !
                            boolean tmp77 = ( tmp76.getIntValue() != 0 );
                            if ( tmp77 ) {
                                { // Invoke: set atype {array text}
                                    setVarScalar(interp, "atype", const9, compiledLocals, 15);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set atype {word array text}
                                    setVarScalar(interp, "atype", const10, compiledLocals, 15);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set avalues [...]
                            TclObject tmp78;
                            { // Invoke: list $arrayname $key_string
                                TclObject tmp79 = TclList.newInstance();
                                TclObject tmp80;
                                try {
                                    tmp80 = getVarScalar(interp, "arrayname", compiledLocals, 19);
                                    TclList.append(interp, tmp79, tmp80);
                                    tmp80 = getVarScalar(interp, "key_string", compiledLocals, 21);
                                    TclList.append(interp, tmp79, tmp80);
                                } catch (TclException ex) {
                                    tmp79.release();
                                    throw ex;
                                }
                                interp.setResult(tmp79);
                            } // End Invoke: list
                            tmp78 = interp.getResult();
                            setVarScalar(interp, "avalues", tmp78, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set aranges [...]
                            TclObject tmp81;
                            { // Invoke: list $arrayname_range $key_range
                                TclObject tmp82 = TclList.newInstance();
                                TclObject tmp83;
                                try {
                                    tmp83 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                    TclList.append(interp, tmp82, tmp83);
                                    tmp83 = getVarScalar(interp, "key_range", compiledLocals, 20);
                                    TclList.append(interp, tmp82, tmp83);
                                } catch (TclException ex) {
                                    tmp82.release();
                                    throw ex;
                                }
                                interp.setResult(tmp82);
                            } // End Invoke: list
                            tmp81 = interp.getResult();
                            setVarScalar(interp, "aranges", tmp81, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: lappend cmdlist [...]
                            TclObject[] objv84 = TJC.grabObjv(interp, 1);
                            TclObject tmp85;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                    TclObject tmp86 = TclList.newInstance();
                                    TclObject tmp87;
                                    try {
                                        tmp87 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                        TclList.append(interp, tmp86, tmp87);
                                        tmp87 = getVarScalar(interp, "script", compiledLocals, 0);
                                        TclList.append(interp, tmp86, tmp87);
                                        tmp87 = getVarScalar(interp, "stree", compiledLocals, 1);
                                        TclList.append(interp, tmp86, tmp87);
                                        tmp87 = getVarScalar(interp, "atype", compiledLocals, 15);
                                        TclList.append(interp, tmp86, tmp87);
                                        tmp87 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                        TclList.append(interp, tmp86, tmp87);
                                        tmp87 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                        TclList.append(interp, tmp86, tmp87);
                                    } catch (TclException ex) {
                                        tmp86.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp86);
                                } // End Invoke: list
                                tmp85 = interp.getResult();
                                tmp85.preserve();
                                objv84[0] = tmp85;
                                interp.resetResult();
                                lappendVarScalar(interp, "cmdlist", objv84, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv84, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        // Binary operator: $inner_tree_types == "text {variable text}"
                        TclObject tmp88 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                        boolean tmp89 = tmp88.toString().equals("text {variable text}");
                        ExprValue tmp90 = evs0;
                        tmp90.setIntValue(tmp89);
                        // End Binary operator: ==
                        boolean tmp91 = ( tmp90.getIntValue() != 0 );
                        if ( tmp91 ) {
                            { // Invoke: set arrayname_range [...]
                                TclObject tmp92;
                                { // Invoke: lindex $inner_tree 0 1
                                    TclObject[] objv93 = TJC.grabObjv(interp, 4);
                                    TclObject tmp94;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv93[0] = const3;
                                        // Arg 1 variable: $inner_tree
                                        tmp94 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                        tmp94.preserve();
                                        objv93[1] = tmp94;
                                        // Arg 2 constant: 0
                                        objv93[2] = const0;
                                        // Arg 3 constant: 1
                                        objv93[3] = const4;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv93, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp94 = objv93[1];
                                        if ( tmp94 != null ) {
                                            tmp94.release();
                                        }
                                        TJC.releaseObjv(interp, objv93, 4);
                                    }
                                } // End Invoke: lindex
                                tmp92 = interp.getResult();
                                setVarScalar(interp, "arrayname_range", tmp92, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set arrayname [...]
                                TclObject tmp95;
                                { // Invoke: parse getstring $script $arrayname_range
                                    TclObject[] objv96 = TJC.grabObjv(interp, 4);
                                    TclObject tmp97;
                                    try {
                                        // Arg 0 constant: parse
                                        objv96[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv96[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp97 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp97.preserve();
                                        objv96[2] = tmp97;
                                        // Arg 3 variable: $arrayname_range
                                        tmp97 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                        tmp97.preserve();
                                        objv96[3] = tmp97;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv96, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp97 = objv96[2];
                                        if ( tmp97 != null ) {
                                            tmp97.release();
                                        }
                                        tmp97 = objv96[3];
                                        if ( tmp97 != null ) {
                                            tmp97.release();
                                        }
                                        TJC.releaseObjv(interp, objv96, 4);
                                    }
                                } // End Invoke: parse
                                tmp95 = interp.getResult();
                                setVarScalar(interp, "arrayname", tmp95, compiledLocals, 19);
                            } // End Invoke: set
                            { // Invoke: set varname_range [...]
                                TclObject tmp98;
                                { // Invoke: lindex $inner_tree 1 2 0 1
                                    TclObject[] objv99 = TJC.grabObjv(interp, 6);
                                    TclObject tmp100;
                                    try {
                                        // Arg 0 constant: lindex
                                        objv99[0] = const3;
                                        // Arg 1 variable: $inner_tree
                                        tmp100 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                        tmp100.preserve();
                                        objv99[1] = tmp100;
                                        // Arg 2 constant: 1
                                        objv99[2] = const4;
                                        // Arg 3 constant: 2
                                        objv99[3] = const11;
                                        // Arg 4 constant: 0
                                        objv99[4] = const0;
                                        // Arg 5 constant: 1
                                        objv99[5] = const4;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv99, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp100 = objv99[1];
                                        if ( tmp100 != null ) {
                                            tmp100.release();
                                        }
                                        TJC.releaseObjv(interp, objv99, 6);
                                    }
                                } // End Invoke: lindex
                                tmp98 = interp.getResult();
                                setVarScalar(interp, "varname_range", tmp98, compiledLocals, 22);
                            } // End Invoke: set
                            { // Invoke: set varname [...]
                                TclObject tmp101;
                                { // Invoke: parse getstring $script $varname_range
                                    TclObject[] objv102 = TJC.grabObjv(interp, 4);
                                    TclObject tmp103;
                                    try {
                                        // Arg 0 constant: parse
                                        objv102[0] = const5;
                                        // Arg 1 constant: getstring
                                        objv102[1] = const6;
                                        // Arg 2 variable: $script
                                        tmp103 = getVarScalar(interp, "script", compiledLocals, 0);
                                        tmp103.preserve();
                                        objv102[2] = tmp103;
                                        // Arg 3 variable: $varname_range
                                        tmp103 = getVarScalar(interp, "varname_range", compiledLocals, 22);
                                        tmp103.preserve();
                                        objv102[3] = tmp103;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv102, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp103 = objv102[2];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        tmp103 = objv102[3];
                                        if ( tmp103 != null ) {
                                            tmp103.release();
                                        }
                                        TJC.releaseObjv(interp, objv102, 4);
                                    }
                                } // End Invoke: parse
                                tmp101 = interp.getResult();
                                setVarScalar(interp, "varname", tmp101, compiledLocals, 14);
                            } // End Invoke: set
                            { // Invoke: if {!$iterating_word} ... else ...
                                // Unary operator: ! $iterating_word
                                TclObject tmp104 = getVarScalar(interp, "iterating_word", compiledLocals, 5);
                                ExprValue tmp105 = evs0;
                                if ( tmp104.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp105, tmp104);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp105, tmp104);
                                }
                                // End Unary operator: !
                                boolean tmp106 = ( tmp105.getIntValue() != 0 );
                                if ( tmp106 ) {
                                    { // Invoke: set atype {array scalar}
                                        setVarScalar(interp, "atype", const12, compiledLocals, 15);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set atype {word array scalar}
                                        setVarScalar(interp, "atype", const13, compiledLocals, 15);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: set avalues [...]
                                TclObject tmp107;
                                { // Invoke: list $arrayname $varname
                                    TclObject tmp108 = TclList.newInstance();
                                    TclObject tmp109;
                                    try {
                                        tmp109 = getVarScalar(interp, "arrayname", compiledLocals, 19);
                                        TclList.append(interp, tmp108, tmp109);
                                        tmp109 = getVarScalar(interp, "varname", compiledLocals, 14);
                                        TclList.append(interp, tmp108, tmp109);
                                    } catch (TclException ex) {
                                        tmp108.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp108);
                                } // End Invoke: list
                                tmp107 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp107, compiledLocals, 16);
                            } // End Invoke: set
                            { // Invoke: set aranges [...]
                                TclObject tmp110;
                                { // Invoke: list $arrayname_range $varname_range
                                    TclObject tmp111 = TclList.newInstance();
                                    TclObject tmp112;
                                    try {
                                        tmp112 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                        TclList.append(interp, tmp111, tmp112);
                                        tmp112 = getVarScalar(interp, "varname_range", compiledLocals, 22);
                                        TclList.append(interp, tmp111, tmp112);
                                    } catch (TclException ex) {
                                        tmp111.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp111);
                                } // End Invoke: list
                                tmp110 = interp.getResult();
                                setVarScalar(interp, "aranges", tmp110, compiledLocals, 17);
                            } // End Invoke: set
                            { // Invoke: lappend cmdlist [...]
                                TclObject[] objv113 = TJC.grabObjv(interp, 1);
                                TclObject tmp114;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                        TclObject tmp115 = TclList.newInstance();
                                        TclObject tmp116;
                                        try {
                                            tmp116 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            TclList.append(interp, tmp115, tmp116);
                                            tmp116 = getVarScalar(interp, "script", compiledLocals, 0);
                                            TclList.append(interp, tmp115, tmp116);
                                            tmp116 = getVarScalar(interp, "stree", compiledLocals, 1);
                                            TclList.append(interp, tmp115, tmp116);
                                            tmp116 = getVarScalar(interp, "atype", compiledLocals, 15);
                                            TclList.append(interp, tmp115, tmp116);
                                            tmp116 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                            TclList.append(interp, tmp115, tmp116);
                                            tmp116 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                            TclList.append(interp, tmp115, tmp116);
                                        } catch (TclException ex) {
                                            tmp115.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp115);
                                    } // End Invoke: list
                                    tmp114 = interp.getResult();
                                    tmp114.preserve();
                                    objv113[0] = tmp114;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "cmdlist", objv113, compiledLocals, 7);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv113, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            // Binary operator: $inner_tree_types == "text command"
                            TclObject tmp117 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                            boolean tmp118 = tmp117.toString().equals("text command");
                            ExprValue tmp119 = evs0;
                            tmp119.setIntValue(tmp118);
                            // End Binary operator: ==
                            boolean tmp120 = ( tmp119.getIntValue() != 0 );
                            if ( tmp120 ) {
                                { // Invoke: set arrayname_range [...]
                                    TclObject tmp121;
                                    { // Invoke: lindex $inner_tree 0 1
                                        TclObject[] objv122 = TJC.grabObjv(interp, 4);
                                        TclObject tmp123;
                                        try {
                                            // Arg 0 constant: lindex
                                            objv122[0] = const3;
                                            // Arg 1 variable: $inner_tree
                                            tmp123 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                            tmp123.preserve();
                                            objv122[1] = tmp123;
                                            // Arg 2 constant: 0
                                            objv122[2] = const0;
                                            // Arg 3 constant: 1
                                            objv122[3] = const4;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv122, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            tmp123 = objv122[1];
                                            if ( tmp123 != null ) {
                                                tmp123.release();
                                            }
                                            TJC.releaseObjv(interp, objv122, 4);
                                        }
                                    } // End Invoke: lindex
                                    tmp121 = interp.getResult();
                                    setVarScalar(interp, "arrayname_range", tmp121, compiledLocals, 18);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: $arrayname_range == ""
                                    TclObject tmp124 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                    ExprValue tmp125 = evs0;
                                    TJC.exprEqualsEmptyString(tmp125, tmp124, false);
                                    // End Binary operator: ==
                                    boolean tmp126 = ( tmp125.getIntValue() != 0 );
                                    if ( tmp126 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv127 = TJC.grabObjv(interp, 2);
                                            TclObject tmp128;
                                            try {
                                                // Arg 0 constant: error
                                                objv127[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp129 = new StringBuffer(64);
                                                sbtmp129.append("empty range at index 0 1 in inner_tree ");
                                                sbtmp129.append("{");
                                                tmp128 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                sbtmp129.append(tmp128.toString());
                                                sbtmp129.append("}");
                                                tmp128 = TclString.newInstance(sbtmp129);
                                                tmp128.preserve();
                                                objv127[1] = tmp128;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv127, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp128 = objv127[1];
                                                if ( tmp128 != null ) {
                                                    tmp128.release();
                                                }
                                                TJC.releaseObjv(interp, objv127, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set arrayname [...]
                                    TclObject tmp130;
                                    { // Invoke: parse getstring $script $arrayname_range
                                        TclObject[] objv131 = TJC.grabObjv(interp, 4);
                                        TclObject tmp132;
                                        try {
                                            // Arg 0 constant: parse
                                            objv131[0] = const5;
                                            // Arg 1 constant: getstring
                                            objv131[1] = const6;
                                            // Arg 2 variable: $script
                                            tmp132 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp132.preserve();
                                            objv131[2] = tmp132;
                                            // Arg 3 variable: $arrayname_range
                                            tmp132 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                            tmp132.preserve();
                                            objv131[3] = tmp132;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv131, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp132 = objv131[2];
                                            if ( tmp132 != null ) {
                                                tmp132.release();
                                            }
                                            tmp132 = objv131[3];
                                            if ( tmp132 != null ) {
                                                tmp132.release();
                                            }
                                            TJC.releaseObjv(interp, objv131, 4);
                                        }
                                    } // End Invoke: parse
                                    tmp130 = interp.getResult();
                                    setVarScalar(interp, "arrayname", tmp130, compiledLocals, 19);
                                } // End Invoke: set
                                { // Invoke: set command_range [...]
                                    TclObject tmp133;
                                    { // Invoke: lindex $inner_tree 1 1
                                        TclObject[] objv134 = TJC.grabObjv(interp, 4);
                                        TclObject tmp135;
                                        try {
                                            // Arg 0 constant: lindex
                                            objv134[0] = const3;
                                            // Arg 1 variable: $inner_tree
                                            tmp135 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                            tmp135.preserve();
                                            objv134[1] = tmp135;
                                            // Arg 2 constant: 1
                                            objv134[2] = const4;
                                            // Arg 3 constant: 1
                                            objv134[3] = const4;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv134, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            tmp135 = objv134[1];
                                            if ( tmp135 != null ) {
                                                tmp135.release();
                                            }
                                            TJC.releaseObjv(interp, objv134, 4);
                                        }
                                    } // End Invoke: lindex
                                    tmp133 = interp.getResult();
                                    setVarScalar(interp, "command_range", tmp133, compiledLocals, 23);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: $command_range == ""
                                    TclObject tmp136 = getVarScalar(interp, "command_range", compiledLocals, 23);
                                    ExprValue tmp137 = evs0;
                                    TJC.exprEqualsEmptyString(tmp137, tmp136, false);
                                    // End Binary operator: ==
                                    boolean tmp138 = ( tmp137.getIntValue() != 0 );
                                    if ( tmp138 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv139 = TJC.grabObjv(interp, 2);
                                            TclObject tmp140;
                                            try {
                                                // Arg 0 constant: error
                                                objv139[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp141 = new StringBuffer(64);
                                                sbtmp141.append("empty range at index 1 1 in inner_tree ");
                                                sbtmp141.append("{");
                                                tmp140 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                sbtmp141.append(tmp140.toString());
                                                sbtmp141.append("}");
                                                tmp140 = TclString.newInstance(sbtmp141);
                                                tmp140.preserve();
                                                objv139[1] = tmp140;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv139, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp140 = objv139[1];
                                                if ( tmp140 != null ) {
                                                    tmp140.release();
                                                }
                                                TJC.releaseObjv(interp, objv139, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set commandtext_range [...]
                                    TclObject tmp142;
                                    { // Invoke: ... $script $command_range
                                        TclObject[] objv143 = TJC.grabObjv(interp, 3);
                                        TclObject tmp144;
                                        try {
                                            // Arg 0 constant: ...
                                            objv143[0] = const14;
                                            // Arg 1 variable: $script
                                            tmp144 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp144.preserve();
                                            objv143[1] = tmp144;
                                            // Arg 2 variable: $command_range
                                            tmp144 = getVarScalar(interp, "command_range", compiledLocals, 23);
                                            tmp144.preserve();
                                            objv143[2] = tmp144;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv143, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp144 = objv143[1];
                                            if ( tmp144 != null ) {
                                                tmp144.release();
                                            }
                                            tmp144 = objv143[2];
                                            if ( tmp144 != null ) {
                                                tmp144.release();
                                            }
                                            TJC.releaseObjv(interp, objv143, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp142 = interp.getResult();
                                    setVarScalar(interp, "commandtext_range", tmp142, compiledLocals, 24);
                                } // End Invoke: set
                                { // Invoke: set commandtext [...]
                                    TclObject tmp145;
                                    { // Invoke: parse getstring $script $commandtext_range
                                        TclObject[] objv146 = TJC.grabObjv(interp, 4);
                                        TclObject tmp147;
                                        try {
                                            // Arg 0 constant: parse
                                            objv146[0] = const5;
                                            // Arg 1 constant: getstring
                                            objv146[1] = const6;
                                            // Arg 2 variable: $script
                                            tmp147 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp147.preserve();
                                            objv146[2] = tmp147;
                                            // Arg 3 variable: $commandtext_range
                                            tmp147 = getVarScalar(interp, "commandtext_range", compiledLocals, 24);
                                            tmp147.preserve();
                                            objv146[3] = tmp147;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv146, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp147 = objv146[2];
                                            if ( tmp147 != null ) {
                                                tmp147.release();
                                            }
                                            tmp147 = objv146[3];
                                            if ( tmp147 != null ) {
                                                tmp147.release();
                                            }
                                            TJC.releaseObjv(interp, objv146, 4);
                                        }
                                    } // End Invoke: parse
                                    tmp145 = interp.getResult();
                                    setVarScalar(interp, "commandtext", tmp145, compiledLocals, 25);
                                } // End Invoke: set
                                { // Invoke: if {!$iterating_word} ... else ...
                                    // Unary operator: ! $iterating_word
                                    TclObject tmp148 = getVarScalar(interp, "iterating_word", compiledLocals, 5);
                                    ExprValue tmp149 = evs0;
                                    if ( tmp148.isIntType() ) {
                                        TJC.exprUnaryNotOperatorKnownInt(tmp149, tmp148);
                                    } else {
                                        TJC.exprUnaryNotOperator(interp, tmp149, tmp148);
                                    }
                                    // End Unary operator: !
                                    boolean tmp150 = ( tmp149.getIntValue() != 0 );
                                    if ( tmp150 ) {
                                        { // Invoke: set atype {array command}
                                            setVarScalar(interp, "atype", const15, compiledLocals, 15);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set atype {word array command}
                                            setVarScalar(interp, "atype", const16, compiledLocals, 15);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: set avalues [...]
                                    TclObject tmp151;
                                    { // Invoke: list $arrayname $commandtext
                                        TclObject tmp152 = TclList.newInstance();
                                        TclObject tmp153;
                                        try {
                                            tmp153 = getVarScalar(interp, "arrayname", compiledLocals, 19);
                                            TclList.append(interp, tmp152, tmp153);
                                            tmp153 = getVarScalar(interp, "commandtext", compiledLocals, 25);
                                            TclList.append(interp, tmp152, tmp153);
                                        } catch (TclException ex) {
                                            tmp152.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp152);
                                    } // End Invoke: list
                                    tmp151 = interp.getResult();
                                    setVarScalar(interp, "avalues", tmp151, compiledLocals, 16);
                                } // End Invoke: set
                                { // Invoke: set aranges [...]
                                    TclObject tmp154;
                                    { // Invoke: list $arrayname_range $commandtext_range
                                        TclObject tmp155 = TclList.newInstance();
                                        TclObject tmp156;
                                        try {
                                            tmp156 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                            TclList.append(interp, tmp155, tmp156);
                                            tmp156 = getVarScalar(interp, "commandtext_range", compiledLocals, 24);
                                            TclList.append(interp, tmp155, tmp156);
                                        } catch (TclException ex) {
                                            tmp155.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp155);
                                    } // End Invoke: list
                                    tmp154 = interp.getResult();
                                    setVarScalar(interp, "aranges", tmp154, compiledLocals, 17);
                                } // End Invoke: set
                                { // Invoke: lappend cmdlist [...]
                                    TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                    TclObject tmp158;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                            TclObject tmp159 = TclList.newInstance();
                                            TclObject tmp160;
                                            try {
                                                tmp160 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                TclList.append(interp, tmp159, tmp160);
                                                tmp160 = getVarScalar(interp, "script", compiledLocals, 0);
                                                TclList.append(interp, tmp159, tmp160);
                                                tmp160 = getVarScalar(interp, "stree", compiledLocals, 1);
                                                TclList.append(interp, tmp159, tmp160);
                                                tmp160 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                TclList.append(interp, tmp159, tmp160);
                                                tmp160 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                TclList.append(interp, tmp159, tmp160);
                                                tmp160 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                TclList.append(interp, tmp159, tmp160);
                                            } catch (TclException ex) {
                                                tmp159.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp159);
                                        } // End Invoke: list
                                        tmp158 = interp.getResult();
                                        tmp158.preserve();
                                        objv157[0] = tmp158;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "cmdlist", objv157, compiledLocals, 7);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv157, 1);
                                    }
                                } // End Invoke: lappend
                            } else {
                                // Binary operator: [...] == "text"
                                { // Invoke: lindex $inner_tree_types 0
                                    TclObject tmp161 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                                    tmp161 = TclList.index(interp, tmp161, 0);
                                    if ( tmp161 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp161);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp162 = interp.getResult();
                                boolean tmp163 = tmp162.toString().equals("text");
                                ExprValue tmp164 = evs0;
                                tmp164.setIntValue(tmp163);
                                // End Binary operator: ==
                                boolean tmp165 = ( tmp164.getIntValue() != 0 );
                                if ( tmp165 ) {
                                    { // Invoke: set inner_cmdlist [...]
                                        TclObject tmp166;
                                        { // Invoke: list
                                            TclObject tmp167 = TclList.newInstance();
                                            interp.setResult(tmp167);
                                        } // End Invoke: list
                                        tmp166 = interp.getResult();
                                        setVarScalar(interp, "inner_cmdlist", tmp166, compiledLocals, 26);
                                    } // End Invoke: set
                                    { // Invoke: set inner_key "..."
                                        TclObject tmp168;
                                        StringBuffer sbtmp169 = new StringBuffer(64);
                                        sbtmp169.append("key");
                                        tmp168 = getVarArray(interp, "_parse", "parse_variable_iterate_key", compiledLocals, 4);
                                        sbtmp169.append(tmp168.toString());
                                        tmp168 = TclString.newInstance(sbtmp169);
                                        setVarScalar(interp, "inner_key", tmp168, compiledLocals, 27);
                                    } // End Invoke: set
                                    { // Invoke: set _parse($inner_key) $inner_cmdlist
                                        TclObject tmp170;
                                        tmp170 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                        String tmp171 = tmp170.toString();
                                        tmp170 = getVarScalar(interp, "inner_cmdlist", compiledLocals, 26);
                                        tmp170 = setVarArray(interp, "_parse", tmp171, tmp170, compiledLocals, 4);
                                    } // End Invoke: set
                                    { // Invoke: incr ...
                                        interp.resetResult();
                                        incrVarArray(interp, "_parse", "parse_variable_iterate_key", 1, compiledLocals, 4);
                                    } // End Invoke: incr
                                    { // Invoke: set ... [...]
                                        TclObject tmp172;
                                        { // Invoke: linsert $... 0 $inner_key
                                            TclObject[] objv173 = TJC.grabObjv(interp, 4);
                                            TclObject tmp174;
                                            try {
                                                // Arg 0 constant: linsert
                                                objv173[0] = const17;
                                                // Arg 1 variable: $...
                                                tmp174 = getVarArray(interp, "_parse", "parse_variable_iterate_stack", compiledLocals, 4);
                                                tmp174.preserve();
                                                objv173[1] = tmp174;
                                                // Arg 2 constant: 0
                                                objv173[2] = const0;
                                                // Arg 3 variable: $inner_key
                                                tmp174 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                                tmp174.preserve();
                                                objv173[3] = tmp174;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                    ? cmdcache6.cmd : null), objv173, 0);
                                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                    updateCmdCache(interp, 6);
                                                }
                                            } finally {
                                                tmp174 = objv173[1];
                                                if ( tmp174 != null ) {
                                                    tmp174.release();
                                                }
                                                tmp174 = objv173[3];
                                                if ( tmp174 != null ) {
                                                    tmp174.release();
                                                }
                                                TJC.releaseObjv(interp, objv173, 4);
                                            }
                                        } // End Invoke: linsert
                                        tmp172 = interp.getResult();
                                        setVarArray(interp, "_parse", "parse_variable_iterate_stack", tmp172, compiledLocals, 4);
                                    } // End Invoke: set
                                    { // Invoke: set atype {word begin}
                                        setVarScalar(interp, "atype", const18, compiledLocals, 15);
                                    } // End Invoke: set
                                    { // Invoke: set avalues {}
                                        setVarScalar(interp, "avalues", const19, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: set aranges {}
                                        setVarScalar(interp, "aranges", const19, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: lappend inner_cmdlist [...]
                                        TclObject[] objv175 = TJC.grabObjv(interp, 1);
                                        TclObject tmp176;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                                TclObject tmp177 = TclList.newInstance();
                                                TclObject tmp178;
                                                try {
                                                    tmp178 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                    TclList.append(interp, tmp177, tmp178);
                                                    tmp178 = getVarScalar(interp, "script", compiledLocals, 0);
                                                    TclList.append(interp, tmp177, tmp178);
                                                    tmp178 = getVarScalar(interp, "stree", compiledLocals, 1);
                                                    TclList.append(interp, tmp177, tmp178);
                                                    tmp178 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                    TclList.append(interp, tmp177, tmp178);
                                                    tmp178 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                    TclList.append(interp, tmp177, tmp178);
                                                    tmp178 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                    TclList.append(interp, tmp177, tmp178);
                                                } catch (TclException ex) {
                                                    tmp177.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp177);
                                            } // End Invoke: list
                                            tmp176 = interp.getResult();
                                            tmp176.preserve();
                                            objv175[0] = tmp176;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "inner_cmdlist", objv175, compiledLocals, 26);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv175, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: for {set i 1} ... {incr i} ...
                                        { // Invoke: set i 1
                                            setVarScalar(interp, "i", const4, compiledLocals, 28);
                                        } // End Invoke: set
                                        for ( boolean skip186 = true ; true ; ) {
                                            if ( skip186 ) {
                                                skip186 = false;
                                            } else {
                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: incr i
                                                    interp.resetResult();
                                                    incrVarScalar(interp, "i", 1, compiledLocals, 28);
                                                } // End Invoke: incr
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }

                                            // Binary operator: $i < [...]
                                            TclObject tmp179 = getVarScalar(interp, "i", compiledLocals, 28);
                                            ExprValue tmp180 = evs0;
                                            TJC.exprInitValue(interp, tmp180, tmp179);
                                            { // Invoke: llength $inner_tree
                                                TclObject tmp181 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                int tmp182 = TclList.getLength(interp, tmp181);
                                                interp.setResult(tmp182);
                                            } // End Invoke: llength
                                            TclObject tmp183 = interp.getResult();
                                            ExprValue tmp184 = evs1;
                                            TJC.exprInitValue(interp, tmp184, tmp183);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp180, tmp184);
                                            // End Binary operator: <
                                            boolean tmp185 = ( tmp180.getIntValue() != 0 );
                                            if ( ! tmp185 ) { break; }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: set itl_type [...]
                                                TclObject tmp187;
                                                { // Invoke: lindex $inner_tree_types $i 0
                                                    TclObject[] objv188 = TJC.grabObjv(interp, 4);
                                                    TclObject tmp189;
                                                    try {
                                                        // Arg 0 constant: lindex
                                                        objv188[0] = const3;
                                                        // Arg 1 variable: $inner_tree_types
                                                        tmp189 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                                                        tmp189.preserve();
                                                        objv188[1] = tmp189;
                                                        // Arg 2 variable: $i
                                                        tmp189 = getVarScalar(interp, "i", compiledLocals, 28);
                                                        tmp189.preserve();
                                                        objv188[2] = tmp189;
                                                        // Arg 3 constant: 0
                                                        objv188[3] = const0;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                            ? cmdcache3.cmd : null), objv188, 0);
                                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                            updateCmdCache(interp, 3);
                                                        }
                                                    } finally {
                                                        tmp189 = objv188[1];
                                                        if ( tmp189 != null ) {
                                                            tmp189.release();
                                                        }
                                                        tmp189 = objv188[2];
                                                        if ( tmp189 != null ) {
                                                            tmp189.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv188, 4);
                                                    }
                                                } // End Invoke: lindex
                                                tmp187 = interp.getResult();
                                                setVarScalar(interp, "itl_type", tmp187, compiledLocals, 29);
                                            } // End Invoke: set
                                            { // Invoke: set inner_stree [...]
                                                TclObject tmp190;
                                                { // Invoke: lindex $inner_tree $i
                                                    TclObject tmp191 = null;
                                                    TclObject tmp192;
                                                    try {
                                                        tmp191 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                        tmp191.preserve();
                                                        tmp192 = getVarScalar(interp, "i", compiledLocals, 28);
                                                        TJC.lindexNonconst(interp, tmp191, tmp192);
                                                    } finally {
                                                        if ( tmp191 != null ) {
                                                            tmp191.release();
                                                        }
                                                    }
                                                } // End Invoke: lindex
                                                tmp190 = interp.getResult();
                                                setVarScalar(interp, "inner_stree", tmp190, compiledLocals, 30);
                                            } // End Invoke: set
                                            { // Invoke: switch -exact -- $itl_type {command} ... {text} ... {variable} ... default ...
                                                TclObject tmp193 = getVarScalar(interp, "itl_type", compiledLocals, 29);
                                                String tmp194 = tmp193.toString();
                                                int tmp194_length = tmp194.length();
                                                char tmp194_first = '\n';
                                                if ( tmp194_length > 0 ) {
                                                    tmp194_first = tmp194.charAt(0);
                                                }
                                                if ( tmp194_length == 7 && tmp194_first == 'c'
                                                        && tmp194.compareTo("command") == 0 ) {
                                                    // Pattern {command}
                                                    { // Invoke: set atype {word command}
                                                        setVarScalar(interp, "atype", const20, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    { // Invoke: set command_range [...]
                                                        TclObject tmp195;
                                                        { // Invoke: lindex $inner_stree 1
                                                            TclObject tmp196 = getVarScalar(interp, "inner_stree", compiledLocals, 30);
                                                            tmp196 = TclList.index(interp, tmp196, 1);
                                                            if ( tmp196 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp196);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp195 = interp.getResult();
                                                        setVarScalar(interp, "command_range", tmp195, compiledLocals, 23);
                                                    } // End Invoke: set
                                                    { // Invoke: set commandtext_range [...]
                                                        TclObject tmp197;
                                                        { // Invoke: ... $script $command_range
                                                            TclObject[] objv198 = TJC.grabObjv(interp, 3);
                                                            TclObject tmp199;
                                                            try {
                                                                // Arg 0 constant: ...
                                                                objv198[0] = const14;
                                                                // Arg 1 variable: $script
                                                                tmp199 = getVarScalar(interp, "script", compiledLocals, 0);
                                                                tmp199.preserve();
                                                                objv198[1] = tmp199;
                                                                // Arg 2 variable: $command_range
                                                                tmp199 = getVarScalar(interp, "command_range", compiledLocals, 23);
                                                                tmp199.preserve();
                                                                objv198[2] = tmp199;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                                    ? cmdcache5.cmd : null), objv198, 0);
                                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                                    updateCmdCache(interp, 5);
                                                                }
                                                            } finally {
                                                                tmp199 = objv198[1];
                                                                if ( tmp199 != null ) {
                                                                    tmp199.release();
                                                                }
                                                                tmp199 = objv198[2];
                                                                if ( tmp199 != null ) {
                                                                    tmp199.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv198, 3);
                                                            }
                                                        } // End Invoke: ...
                                                        tmp197 = interp.getResult();
                                                        setVarScalar(interp, "commandtext_range", tmp197, compiledLocals, 24);
                                                    } // End Invoke: set
                                                    { // Invoke: set commandtext [...]
                                                        TclObject tmp200;
                                                        { // Invoke: parse getstring $script $commandtext_range
                                                            TclObject[] objv201 = TJC.grabObjv(interp, 4);
                                                            TclObject tmp202;
                                                            try {
                                                                // Arg 0 constant: parse
                                                                objv201[0] = const5;
                                                                // Arg 1 constant: getstring
                                                                objv201[1] = const6;
                                                                // Arg 2 variable: $script
                                                                tmp202 = getVarScalar(interp, "script", compiledLocals, 0);
                                                                tmp202.preserve();
                                                                objv201[2] = tmp202;
                                                                // Arg 3 variable: $commandtext_range
                                                                tmp202 = getVarScalar(interp, "commandtext_range", compiledLocals, 24);
                                                                tmp202.preserve();
                                                                objv201[3] = tmp202;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                                    ? cmdcache4.cmd : null), objv201, 0);
                                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                                    updateCmdCache(interp, 4);
                                                                }
                                                            } finally {
                                                                tmp202 = objv201[2];
                                                                if ( tmp202 != null ) {
                                                                    tmp202.release();
                                                                }
                                                                tmp202 = objv201[3];
                                                                if ( tmp202 != null ) {
                                                                    tmp202.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv201, 4);
                                                            }
                                                        } // End Invoke: parse
                                                        tmp200 = interp.getResult();
                                                        setVarScalar(interp, "commandtext", tmp200, compiledLocals, 25);
                                                    } // End Invoke: set
                                                    { // Invoke: set avalues [...]
                                                        TclObject tmp203;
                                                        { // Invoke: list $commandtext
                                                            TclObject tmp204 = TclList.newInstance();
                                                            TclObject tmp205;
                                                            tmp205 = getVarScalar(interp, "commandtext", compiledLocals, 25);
                                                            TclList.append(interp, tmp204, tmp205);
                                                            interp.setResult(tmp204);
                                                        } // End Invoke: list
                                                        tmp203 = interp.getResult();
                                                        setVarScalar(interp, "avalues", tmp203, compiledLocals, 16);
                                                    } // End Invoke: set
                                                    { // Invoke: set aranges [...]
                                                        TclObject tmp206;
                                                        { // Invoke: list $commandtext_range
                                                            TclObject tmp207 = TclList.newInstance();
                                                            TclObject tmp208;
                                                            tmp208 = getVarScalar(interp, "commandtext_range", compiledLocals, 24);
                                                            TclList.append(interp, tmp207, tmp208);
                                                            interp.setResult(tmp207);
                                                        } // End Invoke: list
                                                        tmp206 = interp.getResult();
                                                        setVarScalar(interp, "aranges", tmp206, compiledLocals, 17);
                                                    } // End Invoke: set
                                                    { // Invoke: lappend inner_cmdlist [...]
                                                        TclObject[] objv209 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp210;
                                                        try {
                                                            // Arg 2 command: [...]
                                                            { // Invoke: list $cmd $script $inner_stree $atype $avalues $aranges
                                                                TclObject tmp211 = TclList.newInstance();
                                                                TclObject tmp212;
                                                                try {
                                                                    tmp212 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                    tmp212 = getVarScalar(interp, "script", compiledLocals, 0);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                    tmp212 = getVarScalar(interp, "inner_stree", compiledLocals, 30);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                    tmp212 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                    tmp212 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                    tmp212 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                                    TclList.append(interp, tmp211, tmp212);
                                                                } catch (TclException ex) {
                                                                    tmp211.release();
                                                                    throw ex;
                                                                }
                                                                interp.setResult(tmp211);
                                                            } // End Invoke: list
                                                            tmp210 = interp.getResult();
                                                            tmp210.preserve();
                                                            objv209[0] = tmp210;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "inner_cmdlist", objv209, compiledLocals, 26);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv209, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                } else if ( tmp194_length == 4 && tmp194_first == 't'
                                                        && tmp194.compareTo("text") == 0 ) {
                                                    // Pattern {text}
                                                    { // Invoke: set atype {word text}
                                                        setVarScalar(interp, "atype", const21, compiledLocals, 15);
                                                    } // End Invoke: set
                                                    { // Invoke: set text_range [...]
                                                        TclObject tmp213;
                                                        { // Invoke: lindex $inner_stree 1
                                                            TclObject tmp214 = getVarScalar(interp, "inner_stree", compiledLocals, 30);
                                                            tmp214 = TclList.index(interp, tmp214, 1);
                                                            if ( tmp214 == null ) {
                                                                interp.resetResult();
                                                            } else {
                                                                interp.setResult(tmp214);
                                                            }
                                                        } // End Invoke: lindex
                                                        tmp213 = interp.getResult();
                                                        setVarScalar(interp, "text_range", tmp213, compiledLocals, 31);
                                                    } // End Invoke: set
                                                    { // Invoke: set text [...]
                                                        TclObject tmp215;
                                                        { // Invoke: parse getstring $script $text_range
                                                            TclObject[] objv216 = TJC.grabObjv(interp, 4);
                                                            TclObject tmp217;
                                                            try {
                                                                // Arg 0 constant: parse
                                                                objv216[0] = const5;
                                                                // Arg 1 constant: getstring
                                                                objv216[1] = const6;
                                                                // Arg 2 variable: $script
                                                                tmp217 = getVarScalar(interp, "script", compiledLocals, 0);
                                                                tmp217.preserve();
                                                                objv216[2] = tmp217;
                                                                // Arg 3 variable: $text_range
                                                                tmp217 = getVarScalar(interp, "text_range", compiledLocals, 31);
                                                                tmp217.preserve();
                                                                objv216[3] = tmp217;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                                    ? cmdcache4.cmd : null), objv216, 0);
                                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                                    updateCmdCache(interp, 4);
                                                                }
                                                            } finally {
                                                                tmp217 = objv216[2];
                                                                if ( tmp217 != null ) {
                                                                    tmp217.release();
                                                                }
                                                                tmp217 = objv216[3];
                                                                if ( tmp217 != null ) {
                                                                    tmp217.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv216, 4);
                                                            }
                                                        } // End Invoke: parse
                                                        tmp215 = interp.getResult();
                                                        setVarScalar(interp, "text", tmp215, compiledLocals, 32);
                                                    } // End Invoke: set
                                                    { // Invoke: set avalues [...]
                                                        TclObject tmp218;
                                                        { // Invoke: list $text
                                                            TclObject tmp219 = TclList.newInstance();
                                                            TclObject tmp220;
                                                            tmp220 = getVarScalar(interp, "text", compiledLocals, 32);
                                                            TclList.append(interp, tmp219, tmp220);
                                                            interp.setResult(tmp219);
                                                        } // End Invoke: list
                                                        tmp218 = interp.getResult();
                                                        setVarScalar(interp, "avalues", tmp218, compiledLocals, 16);
                                                    } // End Invoke: set
                                                    { // Invoke: set aranges [...]
                                                        TclObject tmp221;
                                                        { // Invoke: list $text_range
                                                            TclObject tmp222 = TclList.newInstance();
                                                            TclObject tmp223;
                                                            tmp223 = getVarScalar(interp, "text_range", compiledLocals, 31);
                                                            TclList.append(interp, tmp222, tmp223);
                                                            interp.setResult(tmp222);
                                                        } // End Invoke: list
                                                        tmp221 = interp.getResult();
                                                        setVarScalar(interp, "aranges", tmp221, compiledLocals, 17);
                                                    } // End Invoke: set
                                                    { // Invoke: lappend inner_cmdlist [...]
                                                        TclObject[] objv224 = TJC.grabObjv(interp, 1);
                                                        TclObject tmp225;
                                                        try {
                                                            // Arg 2 command: [...]
                                                            { // Invoke: list $cmd $script $inner_stree $atype $avalues $aranges
                                                                TclObject tmp226 = TclList.newInstance();
                                                                TclObject tmp227;
                                                                try {
                                                                    tmp227 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                    tmp227 = getVarScalar(interp, "script", compiledLocals, 0);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                    tmp227 = getVarScalar(interp, "inner_stree", compiledLocals, 30);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                    tmp227 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                    tmp227 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                    tmp227 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                                    TclList.append(interp, tmp226, tmp227);
                                                                } catch (TclException ex) {
                                                                    tmp226.release();
                                                                    throw ex;
                                                                }
                                                                interp.setResult(tmp226);
                                                            } // End Invoke: list
                                                            tmp225 = interp.getResult();
                                                            tmp225.preserve();
                                                            objv224[0] = tmp225;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "inner_cmdlist", objv224, compiledLocals, 26);
                                                        } finally {
                                                            TJC.releaseObjvElems(interp, objv224, 1);
                                                        }
                                                    } // End Invoke: lappend
                                                } else if ( tmp194_length == 8 && tmp194_first == 'v'
                                                        && tmp194.compareTo("variable") == 0 ) {
                                                    // Pattern {variable}
                                                    { // Invoke: set _parse($inner_key) $inner_cmdlist
                                                        TclObject tmp228;
                                                        tmp228 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                                        String tmp229 = tmp228.toString();
                                                        tmp228 = getVarScalar(interp, "inner_cmdlist", compiledLocals, 26);
                                                        tmp228 = setVarArray(interp, "_parse", tmp229, tmp228, compiledLocals, 4);
                                                    } // End Invoke: set
                                                    { // Invoke: set private [...]
                                                        TclObject tmp230;
                                                        { // Invoke: list 1 $inner_key
                                                            TclObject tmp231 = TclList.newInstance();
                                                            TclObject tmp232;
                                                            try {
                                                                TclList.append(interp, tmp231, const4);
                                                                tmp232 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                                                TclList.append(interp, tmp231, tmp232);
                                                            } catch (TclException ex) {
                                                                tmp231.release();
                                                                throw ex;
                                                            }
                                                            interp.setResult(tmp231);
                                                        } // End Invoke: list
                                                        tmp230 = interp.getResult();
                                                        setVarScalar(interp, "private", tmp230, compiledLocals, 3);
                                                    } // End Invoke: set
                                                    { // Invoke: ... $script $inner_stree $cmd $private
                                                        TclObject[] objv233 = TJC.grabObjv(interp, 5);
                                                        TclObject tmp234;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv233[0] = const22;
                                                            // Arg 1 variable: $script
                                                            tmp234 = getVarScalar(interp, "script", compiledLocals, 0);
                                                            tmp234.preserve();
                                                            objv233[1] = tmp234;
                                                            // Arg 2 variable: $inner_stree
                                                            tmp234 = getVarScalar(interp, "inner_stree", compiledLocals, 30);
                                                            tmp234.preserve();
                                                            objv233[2] = tmp234;
                                                            // Arg 3 variable: $cmd
                                                            tmp234 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                            tmp234.preserve();
                                                            objv233[3] = tmp234;
                                                            // Arg 4 variable: $private
                                                            tmp234 = getVarScalar(interp, "private", compiledLocals, 3);
                                                            tmp234.preserve();
                                                            objv233[4] = tmp234;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                ? cmdcache7.cmd : null), objv233, 0);
                                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                updateCmdCache(interp, 7);
                                                            }
                                                        } finally {
                                                            tmp234 = objv233[1];
                                                            if ( tmp234 != null ) {
                                                                tmp234.release();
                                                            }
                                                            tmp234 = objv233[2];
                                                            if ( tmp234 != null ) {
                                                                tmp234.release();
                                                            }
                                                            tmp234 = objv233[3];
                                                            if ( tmp234 != null ) {
                                                                tmp234.release();
                                                            }
                                                            tmp234 = objv233[4];
                                                            if ( tmp234 != null ) {
                                                                tmp234.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv233, 5);
                                                        }
                                                    } // End Invoke: ...
                                                    { // Invoke: set prev_inner_cmdlist $inner_cmdlist
                                                        TclObject tmp235;
                                                        tmp235 = getVarScalar(interp, "inner_cmdlist", compiledLocals, 26);
                                                        setVarScalar(interp, "prev_inner_cmdlist", tmp235, compiledLocals, 33);
                                                    } // End Invoke: set
                                                    { // Invoke: set inner_cmdlist $_parse($inner_key)
                                                        TclObject tmp236;
                                                        tmp236 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                                        tmp236 = getVarArray(interp, "_parse", tmp236.toString(), compiledLocals, 4);
                                                        setVarScalar(interp, "inner_cmdlist", tmp236, compiledLocals, 26);
                                                    } // End Invoke: set
                                                    { // Invoke: unset prev_inner_cmdlist
                                                        TclObject[] objv237 = TJC.grabObjv(interp, 2);
                                                        try {
                                                            // Arg 0 constant: unset
                                                            objv237[0] = const23;
                                                            // Arg 1 constant: prev_inner_cmdlist
                                                            objv237[1] = const24;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                                ? cmdcache8.cmd : null), objv237, 0);
                                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                                updateCmdCache(interp, 8);
                                                            }
                                                        } finally {
                                                            TJC.releaseObjv(interp, objv237, 2);
                                                        }
                                                    } // End Invoke: unset
                                                } else {
                                                    // Pattern default
                                                    { // Invoke: error "..."
                                                        TclObject[] objv238 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp239;
                                                        try {
                                                            // Arg 0 constant: error
                                                            objv238[0] = const1;
                                                            // Arg 1 word: "..."
                                                            StringBuffer sbtmp240 = new StringBuffer(64);
                                                            sbtmp240.append("unknown inner type ");
                                                            sbtmp240.append("{");
                                                            tmp239 = getVarScalar(interp, "itl_type", compiledLocals, 29);
                                                            sbtmp240.append(tmp239.toString());
                                                            sbtmp240.append("}");
                                                            sbtmp240.append(" for stree ");
                                                            sbtmp240.append("{");
                                                            tmp239 = getVarScalar(interp, "stree", compiledLocals, 1);
                                                            sbtmp240.append(tmp239.toString());
                                                            sbtmp240.append("}");
                                                            tmp239 = TclString.newInstance(sbtmp240);
                                                            tmp239.preserve();
                                                            objv238[1] = tmp239;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                                ? cmdcache1.cmd : null), objv238, 0);
                                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                                updateCmdCache(interp, 1);
                                                            }
                                                        } finally {
                                                            tmp239 = objv238[1];
                                                            if ( tmp239 != null ) {
                                                                tmp239.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv238, 2);
                                                        }
                                                    } // End Invoke: error
                                                }
                                            } // End Invoke: switch
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } // End Invoke: for
                                    { // Invoke: set atype {word end}
                                        setVarScalar(interp, "atype", const25, compiledLocals, 15);
                                    } // End Invoke: set
                                    { // Invoke: set avalues {}
                                        setVarScalar(interp, "avalues", const19, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: set aranges {}
                                        setVarScalar(interp, "aranges", const19, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: lappend inner_cmdlist [...]
                                        TclObject[] objv241 = TJC.grabObjv(interp, 1);
                                        TclObject tmp242;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                                TclObject tmp243 = TclList.newInstance();
                                                TclObject tmp244;
                                                try {
                                                    tmp244 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                    TclList.append(interp, tmp243, tmp244);
                                                    tmp244 = getVarScalar(interp, "script", compiledLocals, 0);
                                                    TclList.append(interp, tmp243, tmp244);
                                                    tmp244 = getVarScalar(interp, "stree", compiledLocals, 1);
                                                    TclList.append(interp, tmp243, tmp244);
                                                    tmp244 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                    TclList.append(interp, tmp243, tmp244);
                                                    tmp244 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                    TclList.append(interp, tmp243, tmp244);
                                                    tmp244 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                    TclList.append(interp, tmp243, tmp244);
                                                } catch (TclException ex) {
                                                    tmp243.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp243);
                                            } // End Invoke: list
                                            tmp242 = interp.getResult();
                                            tmp242.preserve();
                                            objv241[0] = tmp242;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "inner_cmdlist", objv241, compiledLocals, 26);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv241, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: set _parse($inner_key) $inner_cmdlist
                                        TclObject tmp245;
                                        tmp245 = getVarScalar(interp, "inner_key", compiledLocals, 27);
                                        String tmp246 = tmp245.toString();
                                        tmp245 = getVarScalar(interp, "inner_cmdlist", compiledLocals, 26);
                                        tmp245 = setVarArray(interp, "_parse", tmp246, tmp245, compiledLocals, 4);
                                    } // End Invoke: set
                                    { // Invoke: set arrayname_range [...]
                                        TclObject tmp247;
                                        { // Invoke: lindex $inner_tree 0 1
                                            TclObject[] objv248 = TJC.grabObjv(interp, 4);
                                            TclObject tmp249;
                                            try {
                                                // Arg 0 constant: lindex
                                                objv248[0] = const3;
                                                // Arg 1 variable: $inner_tree
                                                tmp249 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                tmp249.preserve();
                                                objv248[1] = tmp249;
                                                // Arg 2 constant: 0
                                                objv248[2] = const0;
                                                // Arg 3 constant: 1
                                                objv248[3] = const4;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv248, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp249 = objv248[1];
                                                if ( tmp249 != null ) {
                                                    tmp249.release();
                                                }
                                                TJC.releaseObjv(interp, objv248, 4);
                                            }
                                        } // End Invoke: lindex
                                        tmp247 = interp.getResult();
                                        setVarScalar(interp, "arrayname_range", tmp247, compiledLocals, 18);
                                    } // End Invoke: set
                                    { // Invoke: set arrayname [...]
                                        TclObject tmp250;
                                        { // Invoke: parse getstring $script $arrayname_range
                                            TclObject[] objv251 = TJC.grabObjv(interp, 4);
                                            TclObject tmp252;
                                            try {
                                                // Arg 0 constant: parse
                                                objv251[0] = const5;
                                                // Arg 1 constant: getstring
                                                objv251[1] = const6;
                                                // Arg 2 variable: $script
                                                tmp252 = getVarScalar(interp, "script", compiledLocals, 0);
                                                tmp252.preserve();
                                                objv251[2] = tmp252;
                                                // Arg 3 variable: $arrayname_range
                                                tmp252 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                                tmp252.preserve();
                                                objv251[3] = tmp252;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv251, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp252 = objv251[2];
                                                if ( tmp252 != null ) {
                                                    tmp252.release();
                                                }
                                                tmp252 = objv251[3];
                                                if ( tmp252 != null ) {
                                                    tmp252.release();
                                                }
                                                TJC.releaseObjv(interp, objv251, 4);
                                            }
                                        } // End Invoke: parse
                                        tmp250 = interp.getResult();
                                        setVarScalar(interp, "arrayname", tmp250, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: set word_range [...]
                                        TclObject tmp253;
                                        { // Invoke: parse_range_of_tree $inner_tree 1
                                            TclObject[] objv254 = TJC.grabObjv(interp, 3);
                                            TclObject tmp255;
                                            try {
                                                // Arg 0 constant: parse_range_of_tree
                                                objv254[0] = const26;
                                                // Arg 1 variable: $inner_tree
                                                tmp255 = getVarScalar(interp, "inner_tree", compiledLocals, 11);
                                                tmp255.preserve();
                                                objv254[1] = tmp255;
                                                // Arg 2 constant: 1
                                                objv254[2] = const4;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                    ? cmdcache9.cmd : null), objv254, 0);
                                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                    updateCmdCache(interp, 9);
                                                }
                                            } finally {
                                                tmp255 = objv254[1];
                                                if ( tmp255 != null ) {
                                                    tmp255.release();
                                                }
                                                TJC.releaseObjv(interp, objv254, 3);
                                            }
                                        } // End Invoke: parse_range_of_tree
                                        tmp253 = interp.getResult();
                                        setVarScalar(interp, "word_range", tmp253, compiledLocals, 34);
                                    } // End Invoke: set
                                    { // Invoke: set word_value $...
                                        TclObject tmp256;
                                        tmp256 = getVarArray(interp, "_parse", "parse_variable_iterate_word_value", compiledLocals, 4);
                                        setVarScalar(interp, "word_value", tmp256, compiledLocals, 35);
                                    } // End Invoke: set
                                    { // Invoke: if {!$iterating_word} ... else ...
                                        // Unary operator: ! $iterating_word
                                        TclObject tmp257 = getVarScalar(interp, "iterating_word", compiledLocals, 5);
                                        ExprValue tmp258 = evs0;
                                        if ( tmp257.isIntType() ) {
                                            TJC.exprUnaryNotOperatorKnownInt(tmp258, tmp257);
                                        } else {
                                            TJC.exprUnaryNotOperator(interp, tmp258, tmp257);
                                        }
                                        // End Unary operator: !
                                        boolean tmp259 = ( tmp258.getIntValue() != 0 );
                                        if ( tmp259 ) {
                                            { // Invoke: set atype {array word}
                                                setVarScalar(interp, "atype", const27, compiledLocals, 15);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: set atype {word array word}
                                                setVarScalar(interp, "atype", const28, compiledLocals, 15);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                    { // Invoke: set avalues [...]
                                        TclObject tmp260;
                                        { // Invoke: list $arrayname __WORD_VALUE__
                                            TclObject tmp261 = TclList.newInstance();
                                            TclObject tmp262;
                                            try {
                                                tmp262 = getVarScalar(interp, "arrayname", compiledLocals, 19);
                                                TclList.append(interp, tmp261, tmp262);
                                                TclList.append(interp, tmp261, const29);
                                            } catch (TclException ex) {
                                                tmp261.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp261);
                                        } // End Invoke: list
                                        tmp260 = interp.getResult();
                                        setVarScalar(interp, "avalues", tmp260, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: set aranges [...]
                                        TclObject tmp263;
                                        { // Invoke: list $arrayname_range $word_range
                                            TclObject tmp264 = TclList.newInstance();
                                            TclObject tmp265;
                                            try {
                                                tmp265 = getVarScalar(interp, "arrayname_range", compiledLocals, 18);
                                                TclList.append(interp, tmp264, tmp265);
                                                tmp265 = getVarScalar(interp, "word_range", compiledLocals, 34);
                                                TclList.append(interp, tmp264, tmp265);
                                            } catch (TclException ex) {
                                                tmp264.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp264);
                                        } // End Invoke: list
                                        tmp263 = interp.getResult();
                                        setVarScalar(interp, "aranges", tmp263, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: lappend cmdlist [...]
                                        TclObject[] objv266 = TJC.grabObjv(interp, 1);
                                        TclObject tmp267;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: list $cmd $script $stree $atype $avalues $aranges
                                                TclObject tmp268 = TclList.newInstance();
                                                TclObject tmp269;
                                                try {
                                                    tmp269 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                                    TclList.append(interp, tmp268, tmp269);
                                                    tmp269 = getVarScalar(interp, "script", compiledLocals, 0);
                                                    TclList.append(interp, tmp268, tmp269);
                                                    tmp269 = getVarScalar(interp, "stree", compiledLocals, 1);
                                                    TclList.append(interp, tmp268, tmp269);
                                                    tmp269 = getVarScalar(interp, "atype", compiledLocals, 15);
                                                    TclList.append(interp, tmp268, tmp269);
                                                    tmp269 = getVarScalar(interp, "avalues", compiledLocals, 16);
                                                    TclList.append(interp, tmp268, tmp269);
                                                    tmp269 = getVarScalar(interp, "aranges", compiledLocals, 17);
                                                    TclList.append(interp, tmp268, tmp269);
                                                } catch (TclException ex) {
                                                    tmp268.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp268);
                                            } // End Invoke: list
                                            tmp267 = interp.getResult();
                                            tmp267.preserve();
                                            objv266[0] = tmp267;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "cmdlist", objv266, compiledLocals, 7);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv266, 1);
                                        }
                                    } // End Invoke: lappend
                                } else {
                                    { // Invoke: error "..."
                                        TclObject[] objv270 = TJC.grabObjv(interp, 2);
                                        TclObject tmp271;
                                        try {
                                            // Arg 0 constant: error
                                            objv270[0] = const1;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp272 = new StringBuffer(64);
                                            sbtmp272.append("unmatched inner_tree_types ");
                                            sbtmp272.append("{");
                                            tmp271 = getVarScalar(interp, "inner_tree_types", compiledLocals, 12);
                                            sbtmp272.append(tmp271.toString());
                                            sbtmp272.append("}");
                                            tmp271 = TclString.newInstance(sbtmp272);
                                            tmp271.preserve();
                                            objv270[1] = tmp271;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv270, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            tmp271 = objv270[1];
                                            if ( tmp271 != null ) {
                                                tmp271.release();
                                            }
                                            TJC.releaseObjv(interp, objv270, 2);
                                        }
                                    } // End Invoke: error
                                }
                            }
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: set _parse($key) $cmdlist
            TclObject tmp273;
            tmp273 = getVarScalar(interp, "key", compiledLocals, 6);
            String tmp274 = tmp273.toString();
            tmp273 = getVarScalar(interp, "cmdlist", compiledLocals, 7);
            tmp273 = setVarArray(interp, "_parse", tmp274, tmp273, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_variable_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_parse_variable_subtree_types");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("lindex");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("getstring");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("scalar");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("word scalar");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("array text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("word array text");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(2);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("array scalar");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("word array scalar");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("parse_range_without_brackets");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("array command");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("word array command");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("linsert");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("word begin");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("word command");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("word text");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("_parse_variable_iterate");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("unset");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("prev_inner_cmdlist");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("word end");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("parse_range_of_tree");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("array word");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("word array word");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("__WORD_VALUE__");
        const29.preserve(); const29.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "_parse_variable_subtree_types";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            case 4: {
                cmdName = "parse";
                break;
            }
            case 5: {
                cmdName = "parse_range_without_brackets";
                break;
            }
            case 6: {
                cmdName = "linsert";
                break;
            }
            case 7: {
                cmdName = "_parse_variable_iterate";
                break;
            }
            case 8: {
                cmdName = "unset";
                break;
            }
            case 9: {
                cmdName = "parse_range_of_tree";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "cmd",
        "private",
        "_parse",
        "iterating_word",
        "key",
        "cmdlist",
        "cmdindex",
        "type",
        "range",
        "inner_tree",
        "inner_tree_types",
        "inner_range",
        "varname",
        "atype",
        "avalues",
        "aranges",
        "arrayname_range",
        "arrayname",
        "key_range",
        "key_string",
        "varname_range",
        "command_range",
        "commandtext_range",
        "commandtext",
        "inner_cmdlist",
        "inner_key",
        "i",
        "itl_type",
        "inner_stree",
        "text_range",
        "text",
        "prev_inner_cmdlist",
        "word_range",
        "word_value"
    };
} // end class ParseVariableIterateCmd2

