// TJC implementation of procedure parseproc_start
package tjc;
import tcl.lang.*;

public class ParseprocStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "inscript ?filename?");
        }
        setVarScalar(interp, "inscript", objv[1], compiledLocals, 0);
        setVarScalar(interp, "filename", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: global _parseproc
            TJC.makeGlobalLinkVar(interp, "_parseproc", "_parseproc", 2);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const1, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 3);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("parseproc_start: filename is ");
                        tmp3 = getVarScalar(interp, "filename", compiledLocals, 1);
                        sbtmp4.append(tmp3.toString());
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: puts
                        objv5[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("script is");
                        sbtmp7.append("\n");
                        sbtmp7.append("->");
                        tmp6 = getVarScalar(interp, "script", compiledLocals, 4);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("<-");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv5, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set _parseproc(filename) $filename
            TclObject tmp8;
            tmp8 = getVarScalar(interp, "filename", compiledLocals, 1);
            setVarArray(interp, "_parseproc", "filename", tmp8, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set _parseproc(inscript) $inscript
            TclObject tmp9;
            tmp9 = getVarScalar(interp, "inscript", compiledLocals, 0);
            setVarArray(interp, "_parseproc", "inscript", tmp9, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: ... ... start
            TclObject[] objv10 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: ...
                objv10[0] = const3;
                // Arg 1 constant: ...
                objv10[1] = const4;
                // Arg 2 constant: start
                objv10[2] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv10, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv10, 3);
            }
        } // End Invoke: ...
        { // Invoke: ... ... finish
            TclObject[] objv11 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: ...
                objv11[0] = const3;
                // Arg 1 constant: ...
                objv11[1] = const6;
                // Arg 2 constant: finish
                objv11[2] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv11, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv11, 3);
            }
        } // End Invoke: ...
        { // Invoke: descend_start $inscript
            TclObject[] objv12 = TJC.grabObjv(interp, 2);
            TclObject tmp13;
            try {
                // Arg 0 constant: descend_start
                objv12[0] = const8;
                // Arg 1 variable: $inscript
                tmp13 = getVarScalar(interp, "inscript", compiledLocals, 0);
                tmp13.preserve();
                objv12[1] = tmp13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv12, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp13 = objv12[1];
                if ( tmp13 != null ) {
                    tmp13.release();
                }
                TJC.releaseObjv(interp, objv12, 2);
            }
        } // End Invoke: descend_start
        { // Invoke: if {$debug} ...
            TclObject tmp14 = getVarScalar(interp, "debug", compiledLocals, 3);
            boolean tmp15 = TJC.getBoolean(interp, tmp14);
            if ( tmp15 ) {
                { // Invoke: puts ...
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv16[0] = const2;
                        // Arg 1 constant: ...
                        objv16[1] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv16, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: $_parseproc(...) == 0
            TclObject tmp17 = getVarArray(interp, "_parseproc", "procs_parsed", compiledLocals, 2);
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp18, tmp19);
            // End Binary operator: ==
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: return [...]
                    { // Invoke: list $inscript {}
                        TclObject tmp21 = TclList.newInstance();
                        TclObject tmp22;
                        try {
                            tmp22 = getVarScalar(interp, "inscript", compiledLocals, 0);
                            TclList.append(interp, tmp21, tmp22);
                            TclList.append(interp, tmp21, const0);
                        } catch (TclException ex) {
                            tmp21.release();
                            throw ex;
                        }
                        interp.setResult(tmp21);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: set inscript_start [...]
                    TclObject tmp23;
                    { // Invoke: lindex $... 0
                        TclObject tmp24 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                        tmp24 = TclList.index(interp, tmp24, 0);
                        if ( tmp24 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp24);
                        }
                    } // End Invoke: lindex
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "inscript_start", tmp23, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set inscript_len [...]
                    TclObject tmp25;
                    { // Invoke: lindex $... 1
                        TclObject tmp26 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                        tmp26 = TclList.index(interp, tmp26, 1);
                        if ( tmp26 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp26);
                        }
                    } // End Invoke: lindex
                    tmp25 = interp.getResult();
                    setVarScalar(interp, "inscript_len", tmp25, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set range [...]
                    TclObject tmp27;
                    { // Invoke: parse getrange $inscript
                        TclObject[] objv28 = TJC.grabObjv(interp, 3);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: parse
                            objv28[0] = const10;
                            // Arg 1 constant: getrange
                            objv28[1] = const11;
                            // Arg 2 variable: $inscript
                            tmp29 = getVarScalar(interp, "inscript", compiledLocals, 0);
                            tmp29.preserve();
                            objv28[2] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv28, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp29 = objv28[2];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 3);
                        }
                    } // End Invoke: parse
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "range", tmp27, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set range_start [...]
                    TclObject tmp30;
                    { // Invoke: lindex $range 0
                        TclObject tmp31 = getVarScalar(interp, "range", compiledLocals, 7);
                        tmp31 = TclList.index(interp, tmp31, 0);
                        if ( tmp31 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp31);
                        }
                    } // End Invoke: lindex
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "range_start", tmp30, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set range_len [...]
                    TclObject tmp32;
                    { // Invoke: lindex $range 1
                        TclObject tmp33 = getVarScalar(interp, "range", compiledLocals, 7);
                        tmp33 = TclList.index(interp, tmp33, 1);
                        if ( tmp33 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp33);
                        }
                    } // End Invoke: lindex
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "range_len", tmp32, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $inscript_start != $range_start
                    TclObject tmp34 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                    ExprValue tmp35 = evs0;
                    TJC.exprInitValue(interp, tmp35, tmp34);
                    TclObject tmp36 = getVarScalar(interp, "range_start", compiledLocals, 8);
                    ExprValue tmp37 = evs1;
                    TJC.exprInitValue(interp, tmp37, tmp36);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp35, tmp37);
                    // End Binary operator: !=
                    boolean tmp38 = ( tmp35.getIntValue() != 0 );
                    if ( tmp38 ) {
                        { // Invoke: error "..."
                            TclObject[] objv39 = TJC.grabObjv(interp, 2);
                            TclObject tmp40;
                            try {
                                // Arg 0 constant: error
                                objv39[0] = const12;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp41 = new StringBuffer(64);
                                sbtmp41.append("expected inscript_start == range_start, ");
                                tmp40 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                                sbtmp41.append(tmp40.toString());
                                sbtmp41.append(" != ");
                                tmp40 = getVarScalar(interp, "range_start", compiledLocals, 8);
                                sbtmp41.append(tmp40.toString());
                                tmp40 = TclString.newInstance(sbtmp41);
                                tmp40.preserve();
                                objv39[1] = tmp40;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv39, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp40 = objv39[1];
                                if ( tmp40 != null ) {
                                    tmp40.release();
                                }
                                TJC.releaseObjv(interp, objv39, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: if {$debug} ...
                    TclObject tmp42 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp43 = TJC.getBoolean(interp, tmp42);
                    if ( tmp43 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv44 = TJC.grabObjv(interp, 2);
                            TclObject tmp45;
                            try {
                                // Arg 0 constant: puts
                                objv44[0] = const2;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp46 = new StringBuffer(64);
                                sbtmp46.append("comparing inscript_range ");
                                sbtmp46.append("{");
                                tmp45 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append(" ");
                                tmp45 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append("}");
                                sbtmp46.append(" to ");
                                sbtmp46.append("{");
                                tmp45 = getVarScalar(interp, "range", compiledLocals, 7);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append("}");
                                tmp45 = TclString.newInstance(sbtmp46);
                                tmp45.preserve();
                                objv44[1] = tmp45;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv44, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp45 = objv44[1];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                TJC.releaseObjv(interp, objv44, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    // Binary operator: $inscript_len < $range_len
                    TclObject tmp47 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                    ExprValue tmp48 = evs0;
                    TJC.exprInitValue(interp, tmp48, tmp47);
                    TclObject tmp49 = getVarScalar(interp, "range_len", compiledLocals, 9);
                    ExprValue tmp50 = evs1;
                    TJC.exprInitValue(interp, tmp50, tmp49);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp48, tmp50);
                    // End Binary operator: <
                    boolean tmp51 = ( tmp48.getIntValue() != 0 );
                    if ( tmp51 ) {
                        { // Invoke: set rest_start $inscript_len
                            TclObject tmp52;
                            tmp52 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                            setVarScalar(interp, "rest_start", tmp52, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set rest_len [...]
                            TclObject tmp53;
                            { // Invoke: expr ...
                                // Binary operator: $range_len - $inscript_len
                                TclObject tmp54 = getVarScalar(interp, "range_len", compiledLocals, 9);
                                ExprValue tmp55 = evs0;
                                TJC.exprInitValue(interp, tmp55, tmp54);
                                TclObject tmp56 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                                ExprValue tmp57 = evs1;
                                TJC.exprInitValue(interp, tmp57, tmp56);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp55, tmp57);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp55);
                            } // End Invoke: expr
                            tmp53 = interp.getResult();
                            setVarScalar(interp, "rest_len", tmp53, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: set rest [...]
                            TclObject tmp58;
                            { // Invoke: list $rest_start $rest_len
                                TclObject tmp59 = TclList.newInstance();
                                TclObject tmp60;
                                try {
                                    tmp60 = getVarScalar(interp, "rest_start", compiledLocals, 10);
                                    TclList.append(interp, tmp59, tmp60);
                                    tmp60 = getVarScalar(interp, "rest_len", compiledLocals, 11);
                                    TclList.append(interp, tmp59, tmp60);
                                } catch (TclException ex) {
                                    tmp59.release();
                                    throw ex;
                                }
                                interp.setResult(tmp59);
                            } // End Invoke: list
                            tmp58 = interp.getResult();
                            setVarScalar(interp, "rest", tmp58, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set rest_string [...]
                            TclObject tmp61;
                            { // Invoke: parse getstring $inscript $rest
                                TclObject[] objv62 = TJC.grabObjv(interp, 4);
                                TclObject tmp63;
                                try {
                                    // Arg 0 constant: parse
                                    objv62[0] = const10;
                                    // Arg 1 constant: getstring
                                    objv62[1] = const13;
                                    // Arg 2 variable: $inscript
                                    tmp63 = getVarScalar(interp, "inscript", compiledLocals, 0);
                                    tmp63.preserve();
                                    objv62[2] = tmp63;
                                    // Arg 3 variable: $rest
                                    tmp63 = getVarScalar(interp, "rest", compiledLocals, 12);
                                    tmp63.preserve();
                                    objv62[3] = tmp63;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv62, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp63 = objv62[2];
                                    if ( tmp63 != null ) {
                                        tmp63.release();
                                    }
                                    tmp63 = objv62[3];
                                    if ( tmp63 != null ) {
                                        tmp63.release();
                                    }
                                    TJC.releaseObjv(interp, objv62, 4);
                                }
                            } // End Invoke: parse
                            tmp61 = interp.getResult();
                            setVarScalar(interp, "rest_string", tmp61, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp64 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp65 = TJC.getBoolean(interp, tmp64);
                            if ( tmp65 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv66 = TJC.grabObjv(interp, 2);
                                    TclObject tmp67;
                                    try {
                                        // Arg 0 constant: puts
                                        objv66[0] = const2;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp68 = new StringBuffer(64);
                                        sbtmp68.append("inscript_len is ");
                                        tmp67 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                                        sbtmp68.append(tmp67.toString());
                                        sbtmp68.append(", range_len is ");
                                        tmp67 = getVarScalar(interp, "range_len", compiledLocals, 9);
                                        sbtmp68.append(tmp67.toString());
                                        tmp67 = TclString.newInstance(sbtmp68);
                                        tmp67.preserve();
                                        objv66[1] = tmp67;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv66, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp67 = objv66[1];
                                        if ( tmp67 != null ) {
                                            tmp67.release();
                                        }
                                        TJC.releaseObjv(interp, objv66, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv69 = TJC.grabObjv(interp, 2);
                                    TclObject tmp70;
                                    try {
                                        // Arg 0 constant: puts
                                        objv69[0] = const2;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp71 = new StringBuffer(64);
                                        sbtmp71.append("rest range is ");
                                        sbtmp71.append("{");
                                        tmp70 = getVarScalar(interp, "rest", compiledLocals, 12);
                                        sbtmp71.append(tmp70.toString());
                                        sbtmp71.append("}");
                                        tmp70 = TclString.newInstance(sbtmp71);
                                        tmp70.preserve();
                                        objv69[1] = tmp70;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv69, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp70 = objv69[1];
                                        if ( tmp70 != null ) {
                                            tmp70.release();
                                        }
                                        TJC.releaseObjv(interp, objv69, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                    TclObject tmp73;
                                    try {
                                        // Arg 0 constant: puts
                                        objv72[0] = const2;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp74 = new StringBuffer(64);
                                        sbtmp74.append("appending rest_string ");
                                        sbtmp74.append("\"");
                                        tmp73 = getVarScalar(interp, "rest_string", compiledLocals, 13);
                                        sbtmp74.append(tmp73.toString());
                                        sbtmp74.append("\"");
                                        sbtmp74.append(" to outscript");
                                        tmp73 = TclString.newInstance(sbtmp74);
                                        tmp73.preserve();
                                        objv72[1] = tmp73;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv72, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp73 = objv72[1];
                                        if ( tmp73 != null ) {
                                            tmp73.release();
                                        }
                                        TJC.releaseObjv(interp, objv72, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: append ... $rest_string
                            TclObject[] objv75 = TJC.grabObjv(interp, 1);
                            TclObject tmp76;
                            try {
                                // Arg 2 variable: $rest_string
                                tmp76 = getVarScalar(interp, "rest_string", compiledLocals, 13);
                                tmp76.preserve();
                                objv75[0] = tmp76;
                                interp.resetResult();
                                appendVarArray(interp, "_parseproc", "outscript", objv75, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv75, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: if {$debug} ...
                            TclObject tmp77 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp78 = TJC.getBoolean(interp, tmp77);
                            if ( tmp78 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv79 = TJC.grabObjv(interp, 2);
                                    TclObject tmp80;
                                    try {
                                        // Arg 0 constant: puts
                                        objv79[0] = const2;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp81 = new StringBuffer(64);
                                        sbtmp81.append("after rest_string append: outscript is ");
                                        sbtmp81.append("\"");
                                        tmp80 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                                        sbtmp81.append(tmp80.toString());
                                        sbtmp81.append("\"");
                                        tmp80 = TclString.newInstance(sbtmp81);
                                        tmp80.preserve();
                                        objv79[1] = tmp80;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv79, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp80 = objv79[1];
                                        if ( tmp80 != null ) {
                                            tmp80.release();
                                        }
                                        TJC.releaseObjv(interp, objv79, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: return [...]
                    { // Invoke: list $... $...
                        TclObject tmp82 = TclList.newInstance();
                        TclObject tmp83;
                        try {
                            tmp83 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                            TclList.append(interp, tmp82, tmp83);
                            tmp83 = getVarArray(interp, "_parseproc", "proclist", compiledLocals, 2);
                            TclList.append(interp, tmp82, tmp83);
                        } catch (TclException ex) {
                            tmp82.release();
                            throw ex;
                        }
                        interp.setResult(tmp82);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_start");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("puts");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_report_command_callback");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parseproc_command_callback");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("start");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("parseproc_command_finish_callback");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("finish");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_start");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("done descending in descend_start");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("parse");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("getrange");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("error");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("getstring");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "descend_report_command_callback";
                break;
            }
            case 3: {
                cmdName = "descend_start";
                break;
            }
            case 4: {
                cmdName = "parse";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "inscript",
        "filename",
        "_parseproc",
        "debug",
        "script",
        "inscript_start",
        "inscript_len",
        "range",
        "range_start",
        "range_len",
        "rest_start",
        "rest_len",
        "rest",
        "rest_string"
    };
} // end class ParseprocStartCmd

