// TJC implementation of procedure processJavaSource
package tjc;
import tcl.lang.*;

public class ProcessJavaSourceCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "filename javasrc");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "javasrc", objv[2], compiledLocals, 1);
        { // Invoke: global JAVA_INIT JAVA_CMD
            TJC.makeGlobalLinkVar(interp, "JAVA_INIT", "JAVA_INIT", 2);
            TJC.makeGlobalLinkVar(interp, "JAVA_CMD", "JAVA_CMD", 3);
        } // End Invoke: global
        { // Invoke: if {!$JAVA_INIT} ...
            // Unary operator: ! $JAVA_INIT
            TclObject tmp0 = getVarScalar(interp, "JAVA_INIT", compiledLocals, 2);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: initJavaCompiler
                    TclObject[] objv3 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: initJavaCompiler
                        objv3[0] = const0;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 1);
                    }
                } // End Invoke: initJavaCompiler
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: $JAVA_CMD $filename $javasrc
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 variable: $JAVA_CMD
                    tmp5 = getVarScalar(interp, "JAVA_CMD", compiledLocals, 3);
                    tmp5.preserve();
                    objv4[0] = tmp5;
                    // Arg 1 variable: $filename
                    tmp5 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 variable: $javasrc
                    tmp5 = getVarScalar(interp, "javasrc", compiledLocals, 1);
                    tmp5.preserve();
                    objv4[2] = tmp5;
                    TJC.invoke(interp, null, objv4, 0);
                } finally {
                    TJC.releaseObjvElems(interp, objv4, 3);
                }
            } // End Invoke: ...
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "processJavaSource");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("initJavaCompiler");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "initJavaCompiler";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "javasrc",
        "JAVA_INIT",
        "JAVA_CMD"
    };
} // end class ProcessJavaSourceCmd

